SystemOrganization addCategory: #'OpalCompiler-Core'!
SystemOrganization addCategory: 'OpalCompiler-Core-Bytecode'!
SystemOrganization addCategory: 'OpalCompiler-Core-Encoders'!
SystemOrganization addCategory: 'OpalCompiler-Core-Exception'!
SystemOrganization addCategory: 'OpalCompiler-Core-Extras'!
SystemOrganization addCategory: 'OpalCompiler-Core-FrontEnd'!
SystemOrganization addCategory: 'OpalCompiler-Core-IR-Manipulation'!
SystemOrganization addCategory: 'OpalCompiler-Core-IR-Nodes'!
SystemOrganization addCategory: 'OpalCompiler-Core-Semantics'!
SystemOrganization addCategory: 'OpalCompiler-Core-Translator'!

!Pragma methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 5/23/2013 08:39'!
method: aCompiledMethod

	 method := aCompiledMethod! !

!BlockClosure methodsFor: '*OpalCompiler-Core' stamp: 'DamienCassou 10/5/2015 15:23'!
sourceNode
	"Return an instance of RBBlockNode representing the receiver's AST."

	"the bytecode just before the first bytecode of the block is a bytecode that creates the complete block"

	^ self method sourceNodeForPC: self startpc - 1! !

!Association methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 5/5/2015 13:26'!
emitStore: methodBuilder

	methodBuilder storeIntoLiteralVariable: self.

! !

!Association methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 5/5/2015 13:26'!
emitValue: methodBuilder

	methodBuilder pushLiteralVariable: self.! !

!InstructionStream class methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 7/22/2013 16:09'!
compiler
	"The JIT compiler needs to trap all reads to instance variables of contexts. As this check is costly, it is only done
	in the long form of the bytecodes, which are not used often. In this hierarchy we force the compiler to alwasy generate
	long bytecodes"
	^super compiler options: #(+ optionLongIvarAccessBytecodes)! !

!Symbol methodsFor: '*opalcompiler-core' stamp: 'md 8/13/2014 10:29'!
asMethodPreamble
	self numArgs = 0
		ifTrue: [ ^ self asString ].
	^ String
		streamContents: [ :str | 
			self keywords
				doWithIndex: [ :each :index | 
					str
						nextPutAll: each;
						nextPutAll: ' var';
						nextPutAll: index asString ] ]! !

!Symbol methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 6/21/2012 11:18'!
asOneArgSelector
	^ String streamContents: [:str|
		| parts |
		parts := (self findTokens: ':)').
			str nextPutAll: parts first.
			parts allButFirst do: [:each | str nextPutAll: each capitalized]	.
			str nextPutAll: ':']! !

!SequenceableCollection methodsFor: '*opalcompiler-core' stamp: 'kwl 6/25/2006 19:07'!
literalIndexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of anElement within the receiver. If the receiver does 
	not contain anElement, answer the result of evaluating the argument, 
	exceptionBlock."
	1 to: self size do:
		[:i | ((self at: i) literalEqual: anElement) ifTrue: [^ i]].
	^ exceptionBlock value! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 8/7/2015 23:39'!
isInlineAndOr
	self methodCompilationContextOrNil ifNotNil:[:c | c optionInlineAndOr ifFalse: [ ^false ]]. 
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(and: or:) includes: self selector) ifFalse: [^ false].
	(self arguments allSatisfy: [ :each | each isBlock ])  ifFalse: [^ false].
	(self arguments allSatisfy: [ :each | each arguments isEmpty ]) ifFalse: [^ false ].
	^ true! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 8/7/2015 23:39'!
isInlineCase
	self methodCompilationContextOrNil ifNotNil:[:c | c optionInlineCase ifFalse: [ ^false ]]. 
	self isCascaded ifTrue: [^ false].
	(#(caseOf: caseOf:otherwise:) includes: self selector) ifFalse: [^ false].
	self arguments size = 2 ifTrue: [  "otherwise block"
		self arguments last isBlock ifFalse: [^ false]].
	self arguments first isArray ifFalse: [^ false].
	self arguments first statements do: [:assoc |
		(assoc isMessage and: [assoc selector == #->]) ifFalse: [^ false].
		assoc receiver isBlock ifFalse: [^ false].
		assoc receiver arguments isEmpty ifFalse: [^ false].
		assoc arguments first isBlock ifFalse: [^ false].
	].
	^ true! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 8/28/2015 14:48'!
isInlineIf
	self methodCompilationContextOrNil ifNotNil:[:c | c optionInlineIf ifFalse: [ ^false ]]. 
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue:) includes: self selector) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	self arguments do: [:block | block arguments isEmpty ifFalse: [^ false
		]
	].
	^ true! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 8/7/2015 23:40'!
isInlineIfNil

	| assertNone assertOneOrNone |
	
	self methodCompilationContextOrNil ifNotNil:[:c | c optionInlineIfNil ifFalse: [ ^false ]]. 
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifNil: ifNotNil: ifNil:ifNotNil: ifNotNil:ifNil:) includes: self selector) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	assertNone := [:block | 
		block arguments isEmpty ifFalse: [^ false]
	].
	assertOneOrNone := [:block | 
		block arguments size > 1 ifTrue: [^ false]
	].
	self selector == #ifNil: 	
		ifTrue: [assertNone value: self arguments first].
	self selector == #ifNil:ifNotNil: 
		ifTrue: [assertNone value: self arguments first.  assertOneOrNone value: self arguments last].
	self selector == #ifNotNil: 
		ifTrue: [assertOneOrNone value: self arguments first].
	self selector == #ifNotNil:ifNil: 
		ifTrue: [assertOneOrNone value: self arguments first. assertNone value: self arguments last].
	^ true! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 8/7/2015 23:40'!
isInlineRepeat
	self methodCompilationContextOrNil ifNotNil:[:c | c optionInlineRepeat
		ifFalse: [ ^ false ]].
	self receiver isBlock
		ifFalse: [ ^ false ].
	self receiver arguments size isZero
		ifFalse: [ ^ false ].
	self isCascaded
		ifTrue: [ ^ false ].
	#repeat = self selector
		ifFalse: [ ^ false ].
	^ true! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 8/7/2015 23:40'!
isInlineTimesRepeat

	| block |
	self methodCompilationContextOrNil ifNotNil:[:c | c optionInlineTimesRepeat ifFalse: [ ^false ]]. 

	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	#timesRepeat: = self selector ifFalse: [^ false].
	block := self arguments last.
	block isBlock ifFalse: [^ false].
	block arguments size isZero ifFalse: [^ false].
	^ true! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 8/7/2015 23:40'!
isInlineToDo

	| block step |
	self methodCompilationContextOrNil ifNotNil:[:c | c optionInlineToDo ifFalse: [ ^false ]]. 

	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(to:do: to:by:do:) includes: self selector) ifFalse: [^ false].
	block := self arguments last.
	block isBlock ifFalse: [^ false].
	block arguments size = 1 ifFalse: [^ false].
	self arguments first isVariable ifTrue: [ 
		(RBParseTreeSearcher new
			matches: self arguments first name , ' := `@object' do: [:n :a | true];
			executeTree: block initialAnswer: false) ifTrue: [^ false].
	].
	self arguments size = 3 "to:by:do:" ifTrue: [
		step := self arguments second.
		step isLiteralNode ifFalse: [^ false].
		step value = 0 ifTrue: [^ false].
	].
	^ true! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 8/7/2015 23:40'!
isInlineWhile
	
	self methodCompilationContextOrNil ifNotNil:[:c | c optionInlineWhile ifFalse: [ ^false ]]. 
	self isCascaded ifTrue: [^ false].
	(#(whileFalse: whileTrue: whileFalse whileTrue) includes: self selector) ifFalse: [^ false].
	self receiver isBlock ifFalse: [^ false].
	self receiver arguments isEmpty ifFalse: [self notify: 'while receiver block must have no arguments'. ^ false].
	self arguments isEmpty ifFalse: [
		self arguments first isBlock ifFalse: [^ false].
		self arguments first arguments isEmpty ifFalse: [^ false].
	].
	^ true! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 8/7/2015 23:39'!
isInlined 
	self methodCompilationContextOrNil ifNotNil:[:c | c optionInlineNone ifTrue: [ ^false ]]. 
	self isInlineIf ifTrue: [^true].
	self isInlineIfNil  ifTrue: [^true]. 
	self isInlineAndOr  ifTrue: [^true].
	self isInlineWhile ifTrue: [^true].
	self isInlineToDo  ifTrue: [^true].
	self isInlineCase  ifTrue: [^true].
	self isInlineTimesRepeat ifTrue: [^true].
	self isInlineRepeat ifTrue: [^true].
	^false.! !

!RBMessageNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 8/7/2015 23:38'!
methodCompilationContextOrNil
	^ self methodNode ifNotNil: [ :node | node compilationContext ]! !

Notification subclass: #OCSemanticWarning
	instanceVariableNames: 'compilationContext node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Exception'!

!OCSemanticWarning commentStamp: 'ajh 7/7/2004 17:36' prior: 0!
If a variable is not found or some other problem occurs during checking (ASTChecker) than a particular subclass instance of me is signal, usually causing a notification to the user. If not handled, the default handling is done, and compiling continues.!

!OCSemanticWarning methodsFor: 'accessing' stamp: 'MarcusDenker 6/25/2014 16:47'!
compilationContext
	^ compilationContext ! !

!OCSemanticWarning methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 12:41'!
compilationContext: anObject
	compilationContext := anObject! !

!OCSemanticWarning methodsFor: 'correcting' stamp: 'MarcusDenker 12/4/2015 16:30'!
defaultAction
	
	compilationContext interactive ifFalse: [ ^nil ].
	^self openMenuIn: 
		[:labels :lines :caption | 
		UIManager default chooseFrom: labels lines: lines title: caption]! !

!OCSemanticWarning methodsFor: 'accessing - compatibility' stamp: 'CamilloBruni 7/17/2013 15:37'!
errorCode
	self requestor ifNil: [
		^ self node methodNode asString ].
	^ self requestor contents! !

!OCSemanticWarning methodsFor: 'accessing - compatibility' stamp: 'CamilloBruni 7/10/2013 16:19'!
errorMessage
	^ self messageText! !

!OCSemanticWarning methodsFor: 'accessing - compatibility' stamp: 'CamilloBruni 7/10/2013 16:18'!
location
	^ self node sourceInterval first! !

!OCSemanticWarning methodsFor: 'correcting' stamp: 'MarcusDenker 5/17/2013 16:25'!
methodClass
	^node methodNode methodClass! !

!OCSemanticWarning methodsFor: 'correcting' stamp: 'MarcusDenker 5/17/2013 16:25'!
methodNode
	^node methodNode! !

!OCSemanticWarning methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 16:31'!
node
	^node ! !

!OCSemanticWarning methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 16:26'!
node: anObject
	node := anObject! !

!OCSemanticWarning methodsFor: 'correcting' stamp: 'MarcusDenker 5/23/2013 10:35'!
notify: aString at: location
	"Refer to the comment in Object|notify:."

	^self requestor 
		ifNil: [SyntaxErrorNotification
					inClass: self methodClass 
					category: self methodClass category
					withCode: self methodNode source
					doitFlag: false
					errorMessage: aString
					location: location]
		ifNotNil: [self requestor
					notify: aString , ' ->'
					at: location
					in: self requestor text]! !

!OCSemanticWarning methodsFor: 'correcting' stamp: 'MarcusDenker 5/18/2013 16:26'!
openMenuIn: aBlock
	self subclassResponsibility! !

!OCSemanticWarning methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 14:45'!
requestor
	^ compilationContext requestor! !

OCSemanticWarning subclass: #OCShadowVariableWarning
	instanceVariableNames: 'shadowedVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Exception'!

!OCShadowVariableWarning commentStamp: 'ajh 3/24/2003 22:21' prior: 0!
I get signalled when a variable in a block or method scope shadows a variable of the same name in an outer scope.  The default action is to allow it.!

!OCShadowVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 5/17/2013 16:29'!
defaultAction 

	^ self resume: (self variable: self node shadows: self shadowedVar)
	! !

!OCShadowVariableWarning methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 16:27'!
node: aVariableNode

	super node: aVariableNode.
	messageText := 'Temp shadows: ', aVariableNode name.
! !

!OCShadowVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 5/18/2013 16:43'!
openMenuIn: aBlock
	self error: 'should not be called'! !

!OCShadowVariableWarning methodsFor: 'accessing' stamp: 'ajh 3/19/2003 13:32'!
shadowedVar

	^ shadowedVar! !

!OCShadowVariableWarning methodsFor: 'accessing' stamp: 'MarcusDenker 10/11/2010 16:08'!
shadowedVar: aVar

	shadowedVar := aVar! !

!OCShadowVariableWarning methodsFor: 'accessing' stamp: 'MarcusDenker 5/23/2013 10:41'!
stringMessage
	^ 'Name already defined'! !

!OCShadowVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 10/7/2014 18:07'!
variable: varNode shadows: semVar
	compilationContext interactive
		ifTrue: [ 
			OCSemanticError new
				node: node;
				compilationContext: compilationContext;
				messageText: self stringMessage;
				signal ]
		ifFalse: [ 
			Transcript
				cr;
				show: self methodClass name;
				show: '>>';
				show: varNode methodNode selector;
				show: '(';
				show: varNode name;
				show: ' is shadowed)']! !

OCSemanticWarning subclass: #OCUndeclaredVariableWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Exception'!

!OCUndeclaredVariableWarning commentStamp: '<historical>' prior: 0!
I get signalled when a temporary variable is used that is not defined.  My default action is to create an Undeclared binding and add it to the Undeclared dictionary.!

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 7/25/2014 17:04'!
declareClassVar

	self methodClass theNonMetaClass
		addClassVarNamed: node name asSymbol.
	^ self lookUpVariable! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 7/25/2014 17:05'!
declareGlobal

	Smalltalk at: node name asSymbol put: nil.
	^self lookUpVariable! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 7/25/2014 17:05'!
declareInstVar: name
	"Declare an instance variable."
	self methodClass addInstVarNamed: name.
	"We are changing a class after the scope hierarchy was created, so we need to update the
	Instance Scope"
	self methodNode scope instanceScope slots: self methodClass allSlots.
	^ self lookUpVariable! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'NicolaiHess 9/10/2014 12:05'!
declareTempAndPaste: name
	| insertion delta theTextString characterBeforeMark tempsMark newMethodNode |

	"Below we are getting the text that is actually seen in the morph. This is rather ugly. Maybe there is a better way to do this."
	theTextString := self requestor textMorph editor paragraph text.

	"We parse again the method displayed in the morph. The variable methodNode has the first version of the method, without temporary declarations. "
	newMethodNode := RBParser parseMethod: theTextString.
	
	"We check if there is a declaration of temporary variables"
	tempsMark :=  newMethodNode body  rightBar ifNil: [ self methodNode body start ].	
	
	characterBeforeMark := theTextString at: tempsMark-1 ifAbsent: [$ ].

	(theTextString at: tempsMark) = $| ifTrue:  [
  		"Paste it before the second vertical bar"
		insertion := name, ' '.
		
		characterBeforeMark isSeparator ifFalse: [insertion := ' ', insertion].
		delta := 0.
	] ifFalse: [
		"No bars - insert some with CR, tab"
		insertion := '| ' , name , ' |',String cr.
		delta := 2.	"the bar and CR"
		characterBeforeMark = Character tab ifTrue: [
			insertion := insertion , String tab.
			delta := delta + 1.	"the tab" ]
		].
	tempsMark := tempsMark +
		(self substituteWord: insertion
			wordInterval: (tempsMark to: tempsMark-1)
			offset: 0) - delta.
	" we can not guess at this point where the tempvar should be stored,
	tempvars vs. tempvector therefore -> reparse"
	(OCSourceCodeChanged new newSourceCode: self requestor text) signal! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 7/9/2013 13:27'!
defaultAction
	| varName className selector |
	
 	className  :=  self methodClass name .
	selector := self methodNode selector. 
	varName := node name.

	self methodNode selector ifNotNil: [self crTrace: className, '>>', selector, ' ']
			ifNil: [self traceCr:''].
	self traceCr: '(' , varName , ' is Undeclared) '.

	^super defaultAction ifNil: [
		Undeclared at: varName asSymbol put: nil.
		OCUndeclaredVariable new name: varName asSymbol]! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 4/6/2016 16:20'!
defineClass: className 
	"Prompts the user to define a new class."
	
	| classSymbol systemCategory classDefinition |
	classSymbol := className asSymbol.
	systemCategory := self methodClass category
		ifNil: [ 'Unknown' ].
	classDefinition := 'Object subclass: #' , classSymbol , '
		instanceVariableNames: '''' 
		classVariableNames: ''''
		category: ''' , systemCategory , ''''.
	classDefinition := UIManager default 
		multiLineRequest: 'Edit class definition:'
		initialAnswer: classDefinition
		answerHeight: 150.
	(classDefinition isNil or: [ classDefinition isEmpty ])
		ifTrue: [ ^ Abort signal ].
	self class compiler
		source: classDefinition;
		logged: true;
		evaluate.
	^ (node owningScope lookupVar: className)
		ifNil: [self error: 'should be not happen']! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 7/25/2014 17:04'!
lookUpVariable
	^ (node owningScope lookupVar: node name)
		ifNil: [self error: 'should be found']! !

!OCUndeclaredVariableWarning methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 16:27'!
node: aVariableNode

	super node: aVariableNode.
	messageText := 'Undeclared temp: ', aVariableNode name.
! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'KevinLanvin 7/10/2015 13:06'!
openMenuIn: aBlock
	| alternatives labels actions lines caption choice name interval |
	interval := node sourceInterval.
	name := node name.
	alternatives := self possibleVariablesFor: name.
	labels := OrderedCollection new.
	actions := OrderedCollection new.
	lines := OrderedCollection new.
	name first isLowercase
		ifTrue: [ 
			labels add: 'Declare new temporary variable'.
			actions add: [ self declareTempAndPaste: name ].
			labels add: 'Declare new instance variable'.
			actions add: [ self declareInstVar: name ] ]
		ifFalse: [ 
			labels add: 'Define new class'.
			actions
				add: [ 
					[ self defineClass: name ]
						on: Abort
						do: [ self openMenuIn: aBlock ] ].
			labels add: 'Declare new global'.
			actions add: [ self declareGlobal ].
			labels add: 'Declare new class variable'.
			actions add: [ self declareClassVar ] ].
	lines add: labels size.
	alternatives
		do: [ :each | 
			labels add: each.
			actions
				add: [ 
					self substituteVariable: each atInterval: interval.
					(OCSourceCodeChanged new newSourceCode: self requestor text) signal ] ].
	lines add: labels size.
	labels add: 'Cancel'.
	caption := 'Unknown variable: ' , name , ' please correct, or cancel:'.
	choice := aBlock value: labels value: lines value: caption.
	choice ifNotNil: [ self resume: (actions at: choice ifAbsent: [ compilationContext failBlock value ]) value ]! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 5/17/2013 16:25'!
possibleVariablesFor: proposedVariable 
	| results class |
	class := node methodNode methodClass .
	
	results := proposedVariable correctAgainst: node temporaryVariables
								continuedFrom: nil.
	proposedVariable first canBeGlobalVarInitial ifTrue:
		[ results := class possibleVariablesFor: proposedVariable
						continuedFrom: results ].
	^ proposedVariable correctAgainst: nil continuedFrom: results.
! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'BenComan 3/3/2014 14:28'!
substituteVariable: varName atInterval: anInterval 
	self 
		substituteWord: varName
		wordInterval: anInterval
		offset: 0.
	self methodNode source: self requestor text.
	node replaceWith:((RBVariableNode named: varName) binding: (node owningScope lookupVar: varName)).
	^ (node owningScope lookupVar: varName)
		ifNil: [self error: 'should be found'].! !

!OCUndeclaredVariableWarning methodsFor: 'correcting' stamp: 'MarcusDenker 5/17/2013 14:45'!
substituteWord: correctWord wordInterval: spot offset: o
	"Substitute the correctSelector into the (presuamed interactive) receiver."

	self requestor correctFrom: (spot first + o)
					to: (spot last + o)
					with: correctWord.

	^ o + correctWord size - spot size! !

Notification subclass: #OCSourceCodeChanged
	instanceVariableNames: 'newSourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Exception'!

!OCSourceCodeChanged commentStamp: 'BenComan 3/6/2014 02:40' prior: 0!
An OCSourceCodeChanged is used to pass corrected source code from OCUndeclaredVariableWarning back to OpalCompiler>>compile  so that parsing can be restarted,. Introduced to resolve Case 12954.!

!OCSourceCodeChanged methodsFor: 'accessing' stamp: 'BenComan 3/3/2014 09:06'!
newSourceCode
	^newSourceCode! !

!OCSourceCodeChanged methodsFor: 'accessing' stamp: 'BenComan 3/3/2014 09:06'!
newSourceCode: aString
	newSourceCode := aString! !

Notification subclass: #ReparseAfterSourceEditing
	instanceVariableNames: 'newSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Exception'!

!ReparseAfterSourceEditing commentStamp: 'TorstenBergmann 1/31/2014 11:19' prior: 0!
Notify about the need to reparse after source code was edited!

!ReparseAfterSourceEditing class methodsFor: 'signaling' stamp: 'IgorStasenko 8/28/2013 10:32'!
signalWithNewSource: aSourceCode

	^ self new
		newSource: aSourceCode;
		signal! !

!ReparseAfterSourceEditing methodsFor: 'accessing' stamp: 'IgorStasenko 8/28/2013 10:31'!
newSource
	
	^ newSource! !

!ReparseAfterSourceEditing methodsFor: 'accessing' stamp: 'IgorStasenko 8/28/2013 10:31'!
newSource: anObject
	
	newSource := anObject! !

Notification subclass: #SyntaxErrorNotification
	instanceVariableNames: 'inClass code category doitFlag location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Exception'!

!SyntaxErrorNotification class methodsFor: 'exceptionInstantiator' stamp: 'eem 9/23/2008 14:19'!
inClass: aClass category: aCategory withCode: codeString doitFlag: doitFlag errorMessage: errorString location: location
	^ (self new
		setClass: aClass
		category: aCategory 
		code: codeString
		doitFlag: doitFlag
		errorMessage: errorString
		location: location) signal! !

!SyntaxErrorNotification methodsFor: 'accessing' stamp: 'ar 9/27/2005 19:17'!
category
	^category! !

!SyntaxErrorNotification methodsFor: 'exceptiondescription' stamp: 'pavel.krivanek 6/17/2010 10:00'!
defaultAction

	^ UIManager default syntaxErrorNotificationDefaultAction: self! !

!SyntaxErrorNotification methodsFor: 'accessing' stamp: 'ar 9/27/2005 19:11'!
doitFlag
	^doitFlag! !

!SyntaxErrorNotification methodsFor: 'accessing' stamp: 'ar 9/27/2005 19:10'!
errorClass
	^inClass! !

!SyntaxErrorNotification methodsFor: 'accessing' stamp: 'ar 9/27/2005 19:10'!
errorCode
	^code! !

!SyntaxErrorNotification methodsFor: 'accessing' stamp: 'MarcusDenker 6/20/2014 09:51'!
errorMessage
	^messageText! !

!SyntaxErrorNotification methodsFor: 'accessing' stamp: 'eem 9/23/2008 14:23'!
location
	^location! !

!SyntaxErrorNotification methodsFor: 'accessing' stamp: 'ar 9/27/2005 19:14'!
messageText
	^ super messageText
		ifNil: [messageText := code]! !

!SyntaxErrorNotification methodsFor: 'accessing' stamp: 'MarcusDenker 6/20/2014 09:51'!
setClass: aClass category: aCategory code: codeString doitFlag: aBoolean errorMessage: errorString location: anInteger
	inClass := aClass.
	category := aCategory.
	code := codeString.
	doitFlag := aBoolean.
	messageText := errorString.
	location := anInteger! !

Error subclass: #OCSemanticError
	instanceVariableNames: 'compilationContext node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Exception'!

!OCSemanticError commentStamp: '<historical>' prior: 0!
Raises a semantic error during semantic analysis!

!OCSemanticError methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 11:41'!
compilationContext
	^ compilationContext! !

!OCSemanticError methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 11:41'!
compilationContext: anObject
	compilationContext := anObject! !

!OCSemanticError methodsFor: 'exceptiondescription' stamp: 'MarcusDenker 5/17/2013 16:33'!
defaultAction
	^self notify:  messageText at: node start.! !

!OCSemanticError methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 11:44'!
methodClass
	^self methodNode methodClass! !

!OCSemanticError methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 16:33'!
methodNode
	^node methodNode! !

!OCSemanticError methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 16:33'!
node
	^ node! !

!OCSemanticError methodsFor: 'accessing' stamp: 'MarcusDenker 5/17/2013 16:33'!
node: aNode
	node := aNode! !

!OCSemanticError methodsFor: 'error handling' stamp: 'MarcusDenker 5/23/2013 10:35'!
notify: aString at: location
	"Refer to the comment in Object|notify:."

	^compilationContext requestor 
		ifNil: [SyntaxErrorNotification
					inClass: self methodClass 
					category: self methodClass  category
					withCode: self methodNode source
					doitFlag: false
					errorMessage: aString
					location: location]
		ifNotNil: [compilationContext requestor
					notify: aString , ' ->'
					at: location
					in: compilationContext requestor text]! !

OCSemanticError subclass: #OCStoreIntoReadOnlyVariableError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Exception'!

!OCStoreIntoReadOnlyVariableError commentStamp: 'NicolaiHess 10/3/2014 21:25' prior: 0!
Error when trying to assign to a non writeble Variable.
(method arguments). For backward compatibility this error does not signal if the compilation context is not  interactive.!

!OCStoreIntoReadOnlyVariableError methodsFor: 'accessing' stamp: 'NicolaiHess 10/3/2014 21:24'!
description
	"Return a textual description of the exception."

	^ String
		streamContents: [ :stream | 
			stream << super description asString.
			stream cr.
			stream << self methodClass asString.
			stream cr.
			stream << self methodNode asString ]! !

!OCStoreIntoReadOnlyVariableError methodsFor: 'signaling' stamp: 'NicolaiHess 10/3/2014 21:24'!
signal
	compilationContext interactive
		ifFalse: [ ^ self crTrace ].
	^ super signal! !

OCSemanticError subclass: #OCStoreIntoSpecialVariableError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Exception'!

!OCStoreIntoSpecialVariableError commentStamp: 'NicolaiHess 10/3/2014 21:24' prior: 0!
Error when trying to assign to a special Variable.
(like self ).!

!TClass methodsFor: '*OpalCompiler-Core' stamp: 'CamilleTeruel 9/2/2014 12:58'!
classSideCompiler
	"Redefine this method if you want to customize the compiler for class-side methods"
	^self classSideCompilerClass new
		environment: self classSide environment;
		class: self classSide! !

!TClass methodsFor: '*OpalCompiler-Core' stamp: 'CamilleTeruel 9/1/2014 15:59'!
classSideCompilerClass 
	"Redefine this method if you want to customize the compiler class for class-side methods"
	^ Smalltalk compilerClass! !

RBProgramNodeVisitor subclass: #OCASTClosureAnalyzer
	instanceVariableNames: 'scope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCASTClosureAnalyzer commentStamp: 'MarcusDenker 8/11/2014 10:10' prior: 0!
I visit the AST of method a second time (after OCASTSemanticAnalyzer) to analyze temps related to closures.!

!OCASTClosureAnalyzer methodsFor: 'variables' stamp: 'JorgeRessia 9/23/2010 15:59'!
doCopying
	| copying |
	copying := scope tempVars select: [ :each | each isEscapingRead].	
	copying do: [ :each | scope addCopyingTemp: each]! !

!OCASTClosureAnalyzer methodsFor: 'variables' stamp: 'JorgeRessia 9/22/2010 16:16'!
doRemotes
	| remotes |
	remotes := scope tempVars select: [ :each | each isEscapingWrite].
	remotes do: [ :each | scope moveToVectorTemp: each].	
	! !

!OCASTClosureAnalyzer methodsFor: 'visiting' stamp: 'DenisKudryashov 12/18/2015 15:07'!
visitArgumentNode: aVariableNode

	aVariableNode adaptToSemanticNode! !

!OCASTClosureAnalyzer methodsFor: 'visiting' stamp: 'NicolaiHess 12/9/2015 17:00'!
visitBlockNode: aBlockNode
	"here look at the temps and make copying vars / tempVector out of them"
	self visitArgumentNodes: aBlockNode arguments.
	scope := aBlockNode scope.	
	self doRemotes; doCopying.
	self visitNode: aBlockNode body.
	scope := scope popScope.! !

!OCASTClosureAnalyzer methodsFor: 'visiting' stamp: 'NicolaiHess 12/9/2015 16:51'!
visitMethodNode: aMethodNode
	"here look at the temps and make copying vars / tempVector out of them"
	self visitArgumentNodes: aMethodNode arguments.
	scope := aMethodNode scope.	
	self doRemotes; doCopying.
	self visitNode: aMethodNode body.
	scope := scope popScope.! !

!OCASTClosureAnalyzer methodsFor: 'visiting' stamp: 'DenisKudryashov 12/18/2015 15:12'!
visitVariableNode: aVariableNode
	"re-lookup the temorary variables..."
	
	| var |
	aVariableNode adaptToSemanticNode.
	aVariableNode isTemp ifFalse: [^self].
	var := scope lookupVar: aVariableNode name.
	aVariableNode binding: var.
	var isTempVectorTemp ifTrue: [scope addCopyingTempToAllScopesUpToDefVector: var vectorName].
	var isCopying ifTrue: [scope addCopyingTempToAllScopesUpToDefTemp: var].! !

RBProgramNodeVisitor subclass: #OCASTSemanticAnalyzer
	instanceVariableNames: 'scope blockcounter compilationContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCASTSemanticAnalyzer commentStamp: '<historical>' prior: 0!
I visit each node in the abstract syntax tree while growing and shrinking a scope chain. Each method and block node is linked with its corresponding scope object, and each variable def and ref is linked with its corresponding OCVariable. Exceptions are raised for undefined variable references and so on (see subclasses of OCSemanticWarning).
!

!OCASTSemanticAnalyzer methodsFor: 'api' stamp: 'MarcusDenker 7/10/2013 15:55'!
analyze: aNode
	self visitNode: aNode.
	OCASTClosureAnalyzer new visitNode: aNode! !

!OCASTSemanticAnalyzer methodsFor: 'accessing' stamp: 'MarcusDenker 5/18/2013 10:23'!
blockcounter
	^blockcounter ifNil: [0]! !

!OCASTSemanticAnalyzer methodsFor: 'accessing' stamp: 'ClementBera 5/16/2013 13:59'!
compilationContext
	^ compilationContext! !

!OCASTSemanticAnalyzer methodsFor: 'accessing' stamp: 'MarcusDenker 5/7/2013 08:56'!
compilationContext: aCompilationContext
	compilationContext := aCompilationContext! !

!OCASTSemanticAnalyzer methodsFor: 'variables' stamp: 'DenisKudryashov 12/18/2015 16:13'!
declareArgumentNode: aVariableNode
	^self declareVariableNode: aVariableNode as: OCArgumentVariable new! !

!OCASTSemanticAnalyzer methodsFor: 'variables' stamp: 'DenisKudryashov 12/18/2015 16:12'!
declareVariableNode: aVariableNode
	^self declareVariableNode: aVariableNode as: OCTempVariable new! !

!OCASTSemanticAnalyzer methodsFor: 'variables' stamp: 'DenisKudryashov 12/18/2015 16:12'!
declareVariableNode: aVariableNode as: anOCTempVariable
	| name var |
	name := aVariableNode name.
	var := scope lookupVarForDeclaration: name.
	var
		ifNotNil: [ 
			self variable: aVariableNode shadows: var.
			(var scope ~= scope)
				ifTrue: [ 
					"Create new var that shadows outer one"
					var := scope addTemp: anOCTempVariable withName: name ]
				]
		ifNil: [ 
			"new var"
			var := scope addTemp: anOCTempVariable withName: name ].
	aVariableNode binding: var.
	^ var! !

!OCASTSemanticAnalyzer methodsFor: 'variables' stamp: 'MarcusDenker 5/18/2013 10:32'!
lookupVariableForRead: aVariableNode

	| var |
	var := scope lookupVar: aVariableNode name.
	var ifNil: [^var].
	(var isTemp and: [var scope outerNotOptimizedScope ~= scope outerNotOptimizedScope] )  "only escaping when they will end up in different closures"
		ifTrue: [var markEscapingRead].
	^var! !

!OCASTSemanticAnalyzer methodsFor: 'variables' stamp: 'MarcusDenker 10/6/2014 10:39'!
lookupVariableForWrite: aVariableNode

	| var |
	
	var := scope lookupVar: aVariableNode name.

	var ifNil: [^var].
	var isSpecialVariable ifTrue: [ self storeIntoSpecialVariable: aVariableNode ].
	var isWritable ifFalse: [ self storeIntoReadOnlyVariable: aVariableNode ].
	
	var isTemp ifTrue: [
		(var scope outerNotOptimizedScope ~= scope outerNotOptimizedScope) "only escaping when they will end up in different closures"
			ifTrue: [ var markEscapingWrite]].
	^var! !

!OCASTSemanticAnalyzer methodsFor: 'initialize-release' stamp: 'MarcusDenker 9/4/2010 09:53'!
scope: aSemScope
	scope := aSemScope! !

!OCASTSemanticAnalyzer methodsFor: 'error handling' stamp: 'NicolaiHess 4/25/2016 16:42'!
storeIntoReadOnlyVariable: variableNode
	compilationContext forSyntaxHighlighting
		ifTrue: [ ^ self ].
		
	^ OCStoreIntoReadOnlyVariableError new
		node: variableNode;
		compilationContext: compilationContext;
		messageText: 'Cannot store into';
		signal! !

!OCASTSemanticAnalyzer methodsFor: 'error handling' stamp: 'NicolaiHess 4/25/2016 16:42'!
storeIntoSpecialVariable: variableNode
	compilationContext forSyntaxHighlighting
		ifTrue: [ ^ self ].
	^ OCStoreIntoSpecialVariableError new
		node: variableNode;
		compilationContext: compilationContext;
		messageText: 'Cannot store into';
		signal! !

!OCASTSemanticAnalyzer methodsFor: 'error handling' stamp: 'MarcusDenker 11/4/2015 12:45'!
undeclaredVariable: variableNode
	compilationContext forSyntaxHighlighting 
		ifTrue: [ ^OCUndeclaredVariable new name: variableNode name ].
	^ OCUndeclaredVariableWarning new
		node: variableNode;
		compilationContext: compilationContext;
		signal! !

!OCASTSemanticAnalyzer methodsFor: 'error handling' stamp: 'MarcusDenker 11/27/2015 09:51'!
uninitializedVariable: variableNode
	variableNode binding markRead.
	variableNode propertyAt: #semanticWarning put: #unitialized.! !

!OCASTSemanticAnalyzer methodsFor: 'error handling' stamp: 'johanfabry 11/27/2015 12:27'!
unusedVariable: variableNode

	variableNode propertyAt: #semanticWarning put: 'unused variable'! !

!OCASTSemanticAnalyzer methodsFor: 'error handling' stamp: 'MarcusDenker 5/17/2013 16:26'!
variable: variableNode shadows: semVar

	^ OCShadowVariableWarning new
		node: variableNode;
		shadowedVar: semVar;
		compilationContext: compilationContext;
		signal! !

!OCASTSemanticAnalyzer methodsFor: 'visitor' stamp: 'NicolaiHess 10/24/2014 00:30'!
visitAssignmentNode: anAssignmentNode
	| var |
	self visitNode: anAssignmentNode value.
	var := (self lookupVariableForWrite: anAssignmentNode variable)
		ifNil: [ self undeclaredVariable: anAssignmentNode variable ].
	scope isInsideOptimizedLoop
		ifTrue: [ var markRepeatedWrite ]
		ifFalse: [ var markWrite ].
	anAssignmentNode variable binding: var! !

!OCASTSemanticAnalyzer methodsFor: 'visitor' stamp: 'DenisKudryashov 12/18/2015 16:22'!
visitBlockNode: aBlockNode
	blockcounter := self blockcounter + 1.

	aBlockNode isInlined ifTrue: [^ self visitInlinedBlockNode: aBlockNode ].	
	scope := scope newBlockScope: blockcounter. 
	aBlockNode scope: scope. scope node: aBlockNode.
	
	aBlockNode arguments do: [:node | self declareArgumentNode: node ].
	self visitNode: aBlockNode body.
	scope := scope popScope.! !

!OCASTSemanticAnalyzer methodsFor: 'visitor' stamp: 'DenisKudryashov 12/18/2015 16:22'!
visitInlinedBlockNode: aBlockNode
	scope := scope newOptimizedBlockScope: blockcounter.
	aBlockNode isInlinedLoop ifTrue: [scope markInlinedLoop]. 
	aBlockNode scope: scope. scope node: aBlockNode.
	aBlockNode arguments do: [:node | self declareArgumentNode: node ].
	self visitNode: aBlockNode body.
	scope := scope popScope.! !

!OCASTSemanticAnalyzer methodsFor: 'visitor' stamp: 'MarcusDenker 2/10/2016 16:02'!
visitMethodNode: aMethodNode

	scope := compilationContext scope newMethodScope. 
	aMethodNode scope: scope.  scope node: aMethodNode.
	aMethodNode arguments do: [:node | self declareArgumentNode: node ].
	aMethodNode pragmas do: [:each | self visitNode: each].
	self visitNode: aMethodNode body.
	scope := scope outerScope.
! !

!OCASTSemanticAnalyzer methodsFor: 'visitor' stamp: 'MarcusDenker 7/23/2015 16:05'!
visitPragmaNode: aPragmaNode
	super visitPragmaNode: aPragmaNode.
	(aPragmaNode selector = #compilerOptions:)
		ifTrue: [ aPragmaNode asPragma sendTo: aPragmaNode methodNode compilationContext ].! !

!OCASTSemanticAnalyzer methodsFor: 'visitor' stamp: 'CamilloBruni 2/26/2014 16:45'!
visitSequenceNode: aSequenceNode
	
	aSequenceNode temporaries do: [ :node | self declareVariableNode: node ].
	aSequenceNode parent isMethod
		ifTrue: [ 
			aSequenceNode parent pragmas
				detect: [ :pragma | pragma isPrimitiveError ]
				ifFound: [ :pragma | 
					self declareVariableNode: (RBVariableNode named: (pragma argumentAt: #error:) value asString) ] ].
	aSequenceNode statements do: [ :each | self visitNode: each ].
	aSequenceNode temporaries
		reverseDo: [ :node | 
			node binding isUnused
				ifTrue: [ self unusedVariable: node ] ]! !

!OCASTSemanticAnalyzer methodsFor: 'visitor' stamp: 'NicolaiHess 10/24/2014 00:30'!
visitVariableNode: aVariableNode
	| var |
	var := (self lookupVariableForRead: aVariableNode) ifNil: [(self undeclaredVariable: aVariableNode)].
	(var isTemp and: [var isEscaping and: [scope outerScope isInsideOptimizedLoop]])
		ifTrue: [
			 "only variables written within the loop needs to be marked as escaping write"
			var isRepeatedWrite ifTrue: [var markEscapingWrite].
			var isRead ifTrue: [var markEscapingRead]].
	aVariableNode binding: var.
	var isUninitialized ifTrue: [self uninitializedVariable: aVariableNode].! !

RBProgramNodeVisitor subclass: #OCASTSemanticCleaner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCASTSemanticCleaner commentStamp: 'MarcusDenker 2/10/2016 16:41' prior: 0!
I am cleaning the semantic analysis of the AST.

-> scopes of Blocks and Methpd
-> binding from Variables!

!OCASTSemanticCleaner class methodsFor: 'api' stamp: 'MarcusDenker 2/10/2016 16:46'!
clean: aMethodNode
	self new visitNode: aMethodNode.
	^aMethodNode! !

!OCASTSemanticCleaner methodsFor: 'visiting' stamp: 'MarcusDenker 2/10/2016 16:42'!
visitBlockNode: aBlockNode
	aBlockNode removeProperty: #scope ifAbsent: [ ].
	super visitBlockNode: aBlockNode.
	! !

!OCASTSemanticCleaner methodsFor: 'visiting' stamp: 'MarcusDenker 2/10/2016 16:42'!
visitMethodNode: aMethodNode
	aMethodNode removeProperty: #scope ifAbsent: [ ].
	super visitMethodNode: aMethodNode! !

!OCASTSemanticCleaner methodsFor: 'visiting' stamp: 'MarcusDenker 2/10/2016 16:59'!
visitVariableNode: aVariableNode
	aVariableNode removeProperty: #binding ifAbsent: [].
	aVariableNode primitiveChangeClassTo: RBVariableNode new.! !

RBProgramNodeVisitor subclass: #OCASTTranslator
	instanceVariableNames: 'methodBuilder effectTranslator valueTranslator'
	classVariableNames: 'OptimizedMessages'
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Translator'!

!OCASTTranslator commentStamp: 'ajh 3/24/2003 22:19' prior: 0!
I visit an abstract syntax tree and generate IR (intermediate representation) instructions for each node by sending the appropriate message to my methodBuilder (an IRBuilder).  I hold onto my two subclasses one for generating instructions for value, the other for generating instructions for effect.!

!OCASTTranslator class methodsFor: 'initialize' stamp: 'KevinLanvin 7/17/2015 14:28'!
initialize
	"OCASTTranslator initialize"
	
	super initialize.
	
	OptimizedMessages := { 
	#caseOf: -> #emitCaseOf: .
	#caseOf:otherwise: -> #emitCaseOfOtherwise: .
	#ifFalse: -> #emitIfFalse: .
	#ifFalse:ifTrue: -> #emitIfFalseIfTrue: .
	#ifNil: -> #emitIfNil: .
	#ifNil:ifNotNil: -> #emitIfNilIfNotNil: .
	#ifNotNil: -> #emitIfNotNil: .
	#ifNotNil:ifNil: -> #emitIfNotNilIfNil: .
	#ifTrue: -> #emitIfTrue: .
	#ifTrue:ifFalse: -> #emitIfTrueIfFalse: .
	#or: -> #emitOr: .
	#and: -> #emitAnd: .
	#timesRepeat: -> #emitTimesRepeat: .
	#repeat -> #emitRepeat: .
	#to:by:do: -> #emitToByDo: .
	#to:do: -> #emitToDo: .
	#whileFalse: -> #emitWhileFalse: .
	#whileTrue: -> #emitWhileTrue: .
	#whileFalse -> #emitWhileFalse: .
	#whileTrue -> #emitWhileTrue:
	 } asDictionary! !

OCASTTranslator initialize!

!OCASTTranslator methodsFor: 'errors' stamp: 'MarcusDenker 5/15/2013 14:49'!
backendError: aMessage forNode: aNode
		
	SyntaxErrorNotification 	
		inClass: Object
		category: nil
		withCode: aNode methodNode source
		doitFlag: false
		errorMessage: aMessage
		location: aNode startWithoutParentheses! !

!OCASTTranslator methodsFor: 'initialization' stamp: 'MarcusDenker 6/23/2015 17:31'!
classForEffect
	^OCASTTranslatorForEffect! !

!OCASTTranslator methodsFor: 'initialization' stamp: 'MarcusDenker 6/23/2015 17:32'!
classForValue
	^OCASTTranslatorForValue! !

!OCASTTranslator methodsFor: 'accessing' stamp: 'MarcusDenker 5/18/2013 17:38'!
compilationContext
	^methodBuilder compilationContext ! !

!OCASTTranslator methodsFor: 'inline messages factored' stamp: 'ClementBera 7/10/2013 15:04'!
emitAllButLastCases: cases

	|  assocMessageNode  |
	
	1 to: cases size - 1 do: [:i |
		methodBuilder pushDup.
		assocMessageNode := cases at: i.
		valueTranslator visitInlinedBlockNode: assocMessageNode receiver.
		methodBuilder send: #=.
		methodBuilder jumpAheadTo: #next if: false.
		methodBuilder popTop.
		self visitInlinedBlockNode: assocMessageNode arguments first.
		methodBuilder jumpAheadTo: #end.
		methodBuilder jumpAheadTarget: #next.
	]! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2014 16:26'!
emitAnd: aMessageNode

	valueTranslator visitNode: aMessageNode receiver.
	methodBuilder jumpAheadTo: #else if: false.
	valueTranslator visitInlinedBlockNode: aMessageNode arguments first.
	methodBuilder jumpAheadTo: #end.
	methodBuilder jumpAheadTarget: #else.
	methodBuilder pushLiteral: false. 
	methodBuilder jumpAheadTarget: #end.! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 5/26/2015 15:14'!
emitCaseOf: aMessageNode

	self 
		emitCaseOf: aMessageNode 
		otherwiseBlock: [ 
			methodBuilder pushReceiver.
			methodBuilder send: #caseError ]! !

!OCASTTranslator methodsFor: 'inline messages factored' stamp: 'ClementBera 5/26/2015 15:14'!
emitCaseOf: aMessageNode otherwiseBlock: aBlock

	| cases assocMessageNode  |
	
	cases := aMessageNode arguments first statements.
	cases ifEmpty: [ self backendError: 'At least one case required' forNode: aMessageNode ].
	valueTranslator visitNode: aMessageNode receiver.
	valueTranslator emitAllButLastCases: cases.
	
	"last case with otherwise"
	assocMessageNode := cases last.
	valueTranslator visitInlinedBlockNode: assocMessageNode receiver.
	methodBuilder send: #=.
	methodBuilder jumpAheadTo: #next if: false.
	valueTranslator visitInlinedBlockNode: assocMessageNode arguments first.
	methodBuilder jumpAheadTo: #end.
	methodBuilder jumpAheadTarget: #next.
	aBlock value.

	cases size timesRepeat: [methodBuilder jumpAheadTarget: #end].
	
	aMessageNode lastIsReturn 
		ifTrue: [
			(aMessageNode owningScope) isBlockScope 
				ifTrue: [methodBuilder blockReturnTop] 
				ifFalse: [methodBuilder returnTop]] 
		ifFalse: [self isEffectTranslator ifTrue: [methodBuilder popTop]].! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 5/26/2015 15:14'!
emitCaseOfOtherwise: aMessageNode

	self 
		emitCaseOf: aMessageNode 
		otherwiseBlock: [ valueTranslator visitInlinedBlockNode: aMessageNode arguments last ]! !

!OCASTTranslator methodsFor: 'inline messages factored' stamp: 'ClementBera 6/26/2014 17:46'!
emitCondition: args boolean: aBoolean
	"emits the jumps so that one of the 2 blocks in args is evaluated depending on boolean"
	
	methodBuilder jumpAheadTo: #else if: aBoolean.
	self visitInlinedBlockNode: args first.
	methodBuilder jumpAheadTo: #end.
	methodBuilder jumpAheadTarget: #else.
	self visitInlinedBlockNode: args last.
	methodBuilder jumpAheadTarget: #end.! !

!OCASTTranslator methodsFor: 'inline messages factored' stamp: 'ClementBera 6/26/2014 17:42'!
emitIf: aMessageNode boolean: aBoolean

	valueTranslator visitNode: aMessageNode receiver.
	
	self emitCondition: aMessageNode arguments boolean: aBoolean! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2013 14:13'!
emitIfFalse: aMessageNode

	self shouldBeSentToValueOrEffectTranslator! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2013 14:33'!
emitIfFalseIfTrue: aMessageNode

	self emitIf: aMessageNode boolean: true! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'MarcusDenker 4/11/2013 15:12'!
emitIfNil: aMessageNode

	valueTranslator visitNode: aMessageNode receiver.
	self isValueTranslator ifTrue: [ methodBuilder pushDup ].
	methodBuilder pushLiteral: nil.
	methodBuilder send: #==.
	methodBuilder jumpAheadTo: #else if: false.
	self isValueTranslator ifTrue: [ methodBuilder popTop ].
	self visitInlinedBlockNode: aMessageNode arguments first.
	methodBuilder jumpAheadTarget: #else.
! !

!OCASTTranslator methodsFor: 'inline messages factored' stamp: 'ClementBera 6/26/2014 17:45'!
emitIfNil: aMessageNode boolean: aBoolean
	| args notNilBlock |
	
	valueTranslator visitNode: aMessageNode receiver.
	
	"emits the == nil code and push correct value on stack if the ifNotNil block has an argument"
	args := aMessageNode arguments.
	notNilBlock := aBoolean ifTrue: [args first] ifFalse: [args last].
	notNilBlock arguments ifNotEmpty: [ notNilBlock arguments first binding emitStore: methodBuilder ].
	methodBuilder pushLiteral: nil.
	methodBuilder send: #==.
	
	self emitCondition: args boolean: aBoolean! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 6/26/2014 17:41'!
emitIfNilIfNotNil: aMessageNode
	self emitIfNil: aMessageNode boolean: false! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'nice 5/1/2013 21:01'!
emitIfNotNil: aMessageNode

	self shouldBeSentToValueOrEffectTranslator! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 6/26/2014 17:41'!
emitIfNotNilIfNil: aMessageNode
	self emitIfNil: aMessageNode boolean: true! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2013 14:13'!
emitIfTrue: aMessageNode

	self shouldBeSentToValueOrEffectTranslator! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2013 14:33'!
emitIfTrueIfFalse: aMessageNode
	
	self emitIf: aMessageNode boolean: false! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 5/18/2013 17:41'!
emitMessageNode: aMessageNode

	aMessageNode isCascaded ifFalse: [
		valueTranslator visitNode: aMessageNode receiver].
	aMessageNode arguments do: [:each | 
		valueTranslator visitNode: each].
	aMessageNode isSuperSend
		ifTrue: [methodBuilder send: aMessageNode selector toSuperOf: self compilationContext getClass]
		ifFalse: [methodBuilder send: aMessageNode selector].
! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2014 16:26'!
emitOr: aMessageNode

	valueTranslator visitNode: aMessageNode receiver.
	methodBuilder jumpAheadTo: #else if: false.
	methodBuilder pushLiteral: true. 
	methodBuilder jumpAheadTo: #end.
	methodBuilder jumpAheadTarget: #else.
	valueTranslator visitInlinedBlockNode: aMessageNode arguments first.
	methodBuilder jumpAheadTarget: #end.! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'KevinLanvin 7/17/2015 14:30'!
emitRepeat: aMessageNode
	| block |
	block := aMessageNode receiver.
	methodBuilder jumpBackTarget: #start.
	effectTranslator visitInlinedBlockNode: block.
	methodBuilder jumpBackTo: #start.
	self isValueTranslator ifTrue: [ methodBuilder pushLiteral: nil ]! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/26/2013 14:05'!
emitTimesRepeat: aMessageNode 
	| limit block limitEmit |
	
	limit := aMessageNode receiver.
	block := aMessageNode arguments last.
	
	limitEmit := [valueTranslator visitNode: limit].
	limit isLiteral | limit isSelf | limit isSuper ifFalse: [
		valueTranslator visitNode: limit.
		methodBuilder addTemp: #limit.
		methodBuilder storeTemp: #limit.
		methodBuilder popTop.
		limitEmit := [methodBuilder pushTemp: #limit]].

	"push start. allocate and initialize iterator"
	self isValueTranslator ifTrue: [ limitEmit value ].
	methodBuilder pushLiteral: 1.
	methodBuilder addTemp: #iterator.
	methodBuilder storeTemp: #iterator.
	methodBuilder popTop. 
	methodBuilder jumpBackTarget: #start.
	methodBuilder pushTemp: #iterator.
	limitEmit value.
	methodBuilder send: #<=.
	methodBuilder jumpAheadTo: #done if: false.

	effectTranslator visitInlinedBlockNode: block.
	methodBuilder pushTemp: #iterator.
	methodBuilder pushLiteral: 1.
	methodBuilder send: #+.
	methodBuilder storeTemp: #iterator.
	methodBuilder popTop.
	methodBuilder jumpBackTo: #start.
	methodBuilder jumpAheadTarget: #done.! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'MarcusDenker 9/20/2013 15:04'!
emitToByDo: aMessageNode 

	| step |
	
	step := aMessageNode arguments second.
	step isLiteralNode ifFalse: [self error: 'should not have been inlined'].
	step := step value.

	self emitToDo: aMessageNode step: step! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2013 14:08'!
emitToDo: aMessageNode 
	
	self emitToDo: aMessageNode step: 1! !

!OCASTTranslator methodsFor: 'inline messages factored' stamp: 'NicolaiHess 11/22/2015 20:07'!
emitToDo: aMessageNode step: step
	| limit block iterator limitEmit |
	
	limit := aMessageNode arguments first.
	block := aMessageNode arguments last.
	iterator := block arguments first binding.
	
	limitEmit := [valueTranslator visitNode: limit].
	limit isLiteralNode | limit isSelf | limit isSuper | limit isArgument ifFalse: [
		valueTranslator visitNode: limit.
		methodBuilder addTemp: (iterator name, #limit).
		methodBuilder storeTemp: (iterator name, #limit).
		methodBuilder popTop.
		limitEmit := [methodBuilder pushTemp: (iterator name, #limit)]].

	"push start. allocate and initialize iterator"
	valueTranslator visitNode: aMessageNode receiver.
	iterator emitStore: methodBuilder.	
	self isEffectTranslator ifTrue: [methodBuilder popTop]. 
	methodBuilder jumpBackTarget: #start.
	iterator emitValue: methodBuilder.	
	limitEmit value.
	methodBuilder send: (step > 0 ifTrue: [#<=] ifFalse: [#>=]).
	methodBuilder jumpAheadTo: #done if: false.

	effectTranslator visitInlinedBlockNode: block.
	iterator emitValue: methodBuilder.
	methodBuilder pushLiteral: step.
	methodBuilder send: #+.
	iterator emitStore: methodBuilder.
	methodBuilder popTop.
	methodBuilder jumpBackTo: #start.
	methodBuilder jumpAheadTarget: #done.! !

!OCASTTranslator methodsFor: 'inline messages factored' stamp: 'ClementBera 7/10/2013 14:10'!
emitWhile: aMessageNode boolean: aBoolean

	methodBuilder jumpBackTarget: #begin.
	valueTranslator visitInlinedBlockNode: aMessageNode receiver.
	methodBuilder jumpAheadTo: #end if: aBoolean.
	aMessageNode arguments ifNotEmpty: [ 
			effectTranslator visitInlinedBlockNode: aMessageNode arguments first].
	methodBuilder jumpBackTo: #begin.
	methodBuilder jumpAheadTarget: #end.! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2013 14:11'!
emitWhileFalse: aMessageNode

	self emitWhile: aMessageNode boolean: true! !

!OCASTTranslator methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2013 14:11'!
emitWhileTrue: aMessageNode

	self emitWhile: aMessageNode boolean: false! !

!OCASTTranslator methodsFor: 'initialization' stamp: 'MarcusDenker 6/23/2015 17:32'!
initialize

	methodBuilder := IRBuilder new.
	effectTranslator := self as: self classForEffect.
	valueTranslator := self as: self classForValue.
	effectTranslator instVarNamed: #effectTranslator put: effectTranslator.
	effectTranslator instVarNamed: #valueTranslator put: valueTranslator.
	valueTranslator instVarNamed: #valueTranslator put: valueTranslator.
! !

!OCASTTranslator methodsFor: 'accessing' stamp: 'ajh 3/10/2003 17:59'!
ir

	^ methodBuilder ir! !

!OCASTTranslator methodsFor: 'testing' stamp: 'pmm 7/19/2006 11:54'!
isEffectTranslator
	^self == effectTranslator! !

!OCASTTranslator methodsFor: 'testing' stamp: 'pmm 7/19/2006 11:52'!
isValueTranslator
	^self == valueTranslator! !

!OCASTTranslator methodsFor: 'errors' stamp: 'nice 5/1/2013 18:03'!
shouldBeSentToValueOrEffectTranslator
	self error: 'should be sent only to valueTranslator or effectTranslator'! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 7/10/2013 16:20'!
visitArrayNode: anArrayNode 

	| elementNodes |
	
	anArrayNode statements size > 32 ifTrue: [^ self visitLargeArrayNode: anArrayNode ].
	
	elementNodes := anArrayNode children.
	elementNodes do: [:node | valueTranslator visitNode: node].
	methodBuilder pushConsArray: elementNodes size.! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 6/11/2013 15:52'!
visitAssignmentNode: anAssignmentNode 

	valueTranslator visitNode: anAssignmentNode value.
	anAssignmentNode variable binding emitStore: methodBuilder
! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 7/28/2015 15:01'!
visitBlockNode: aBlockNode
	| tempNames argumentNames copiedNames |
	aBlockNode arguments size >15 ifTrue: [self backendError: 'Too many arguments' forNode: aBlockNode ].
	
	aBlockNode isInlined ifTrue: [^ self visitInlinedBlockNode: aBlockNode ].
		
	argumentNames := aBlockNode argumentNames asArray.
	tempNames := (aBlockNode scope tempVars asArray collect: [ :each | each name]) copyWithoutAll: argumentNames.
	copiedNames := (aBlockNode scope  inComingCopiedVars asArray collect: [:each | each name]).
	methodBuilder
			pushClosureCopyCopiedValues: copiedNames
			args: argumentNames
			jumpTo:  #block.
	 
	aBlockNode scope tempVector ifNotEmpty: [
		methodBuilder 
			createTempVectorNamed: aBlockNode scope tempVectorName 
			withVars: (aBlockNode scope tempVector collect: [:each| each name]) asArray.
	].
	methodBuilder addTemps: tempNames.
	valueTranslator visitNode: aBlockNode body.
	methodBuilder addBlockReturnTopIfRequired.
	self flag: 'why dont we just add a blockReturnTop here... it could be removed or ignored in IRTranslator'.
	methodBuilder jumpAheadTarget: #block.		

! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'nice 5/1/2013 16:13'!
visitCascadeNode: aCascadeNode 

	valueTranslator visitNode: aCascadeNode receiver.
	aCascadeNode messages allButLastDo: [:node |
		methodBuilder pushDup.
		effectTranslator visitNode: node.
	].
	self visitNode: aCascadeNode messages last.
! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 4/11/2013 15:12'!
visitInlinedBlockNode: anOptimizedBlockNode

	"We are visiting a scope that is not a block, but inlined in the outer context.
	This means: 
			- we do not create a Block
			- we call IRBuilder to add temps
	"
	
	| argumentNames tempNames  copiedNames  |
	argumentNames := anOptimizedBlockNode argumentNames asArray.
	tempNames := (anOptimizedBlockNode scope tempVars collect: [ :each | each name asSymbol]) copyWithoutAll: argumentNames.
	copiedNames := (anOptimizedBlockNode scope inComingCopiedVars collect: [:each | each name]) asArray.
	
	
	anOptimizedBlockNode scope tempVector ifNotEmpty: [
		methodBuilder 
			createTempVectorNamed: anOptimizedBlockNode scope tempVectorName 
			withVars: (anOptimizedBlockNode scope tempVector collect: [:each| each name]) asArray.
	].
	
	methodBuilder addTemps: tempNames.
	methodBuilder addTemps: copiedNames.
	methodBuilder addTemps: argumentNames.
	anOptimizedBlockNode isInlinedLoop ifTrue: [
		tempNames do: [ :tempName |
			methodBuilder pushLiteral: nil.
			methodBuilder storeTemp: tempName.
			methodBuilder popTop.
		 ]].
	
	self visitNode: anOptimizedBlockNode body.! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'ClementBera 7/19/2013 14:24'!
visitLargeArrayNode: aRBArrayNode 
	"Long form: generates (Array braceStream: N) nextPut: a; nextPut: b; ...; braceArray"
	methodBuilder pushLiteralVariable: Array binding.
	methodBuilder pushLiteral: aRBArrayNode statements size.
	methodBuilder send: #braceStream:.
	aRBArrayNode statements do: [ :each |
		methodBuilder pushDup.
		valueTranslator visitNode: each.
		methodBuilder send: #nextPut:.
		methodBuilder popTop.
		].
	methodBuilder send: #braceArray.
				! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 4/11/2013 15:12'!
visitLiteralArrayNode: aRBLiteralArrayNode 
	 
	methodBuilder pushLiteral: aRBLiteralArrayNode value.
! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 4/11/2013 15:12'!
visitLiteralNode: aLiteralNode

	methodBuilder pushLiteral: aLiteralNode value.
! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'ClementBera 11/20/2013 19:36'!
visitMessageNode: aMessageNode
	aMessageNode isInlined ifTrue: [
		methodBuilder addLiteral: aMessageNode selector. "so searching for senders will work"
		^self 
			perform: (OptimizedMessages at: aMessageNode selector)
			with: aMessageNode].
	^ self emitMessageNode: aMessageNode! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'cb 6/27/2013 16:53'!
visitMethodNode: aMethodNode
	
	aMethodNode arguments size > 15 ifTrue: [self backendError: 'Too many arguments' forNode: aMethodNode ].

	methodBuilder compilationContext: aMethodNode compilationContext.
	methodBuilder addTemps: aMethodNode scope tempVarNames.
		
	methodBuilder properties: aMethodNode properties.
	methodBuilder irPrimitive: aMethodNode primitiveFromPragma.
	aMethodNode pragmas do: [:each | self visitPragmaNode: each].
	methodBuilder numArgs: aMethodNode arguments size.
	
	aMethodNode scope tempVector ifNotEmpty: [
		methodBuilder 
			createTempVectorNamed: aMethodNode scope tempVectorName 
			withVars: (aMethodNode scope tempVector collect: [:each| each name]) asArray.
	].
	effectTranslator visitNode: aMethodNode body.
	aMethodNode body lastIsReturn ifFalse:  [methodBuilder pushReceiver; returnTop]! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 5/6/2010 10:00'!
visitNode: aNode
	methodBuilder mapToNode: aNode.
	super visitNode: aNode.
	methodBuilder popMap.
! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 5/9/2015 12:33'!
visitParseErrorNode: anErrorNode  
	methodBuilder 
		pushLiteralVariable: #error -> anErrorNode asSyntaxErrorNotification;
		send: #signal.

! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 4/11/2013 15:12'!
visitReturnNode: aReturnNode 

	valueTranslator visitNode: aReturnNode value.
	methodBuilder returnTop.
		
! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'nice 5/2/2013 00:22'!
visitSequenceNode: aSequenceNode 

	self shouldBeSentToValueOrEffectTranslator! !

!OCASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 5/22/2013 16:50'!
visitVariableNode: aVariableNode
	aVariableNode binding emitValue: methodBuilder
	
	! !

OCASTTranslator subclass: #OCASTTranslatorForEffect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Translator'!

!OCASTTranslatorForEffect commentStamp: 'ajh 3/24/2003 22:20' prior: 0!
I override some methods in my super to generate instructions for effect only.!

!OCASTTranslatorForEffect methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2014 16:26'!
emitAnd: aMessageNode
	
	super emitAnd: aMessageNode.
	methodBuilder popTop.! !

!OCASTTranslatorForEffect methodsFor: 'inline messages' stamp: 'MarcusDenker 4/11/2013 15:12'!
emitIfFalse: aMessageNode

	valueTranslator visitNode: aMessageNode receiver.
	methodBuilder jumpAheadTo: #else if: true.
		self visitInlinedBlockNode: aMessageNode arguments first.
	methodBuilder jumpAheadTarget: #else.
! !

!OCASTTranslatorForEffect methodsFor: 'inline messages' stamp: 'MarcusDenker 5/22/2013 16:50'!
emitIfNotNil: aMessageNode
	| args |
	valueTranslator visitNode: aMessageNode receiver.
	args := aMessageNode arguments.
	args first arguments ifNotEmpty: [ args first arguments first binding emitStore: methodBuilder ].
	methodBuilder pushLiteral: nil.
	methodBuilder send: #==.
	methodBuilder jumpAheadTo: #end if: true.
	self visitInlinedBlockNode: args first.
	methodBuilder jumpAheadTarget: #end.
	! !

!OCASTTranslatorForEffect methodsFor: 'inline messages' stamp: 'MarcusDenker 4/11/2013 15:12'!
emitIfTrue: aMessageNode

	valueTranslator visitNode: aMessageNode receiver.
	methodBuilder jumpAheadTo: #else if: false.	
		self visitInlinedBlockNode: aMessageNode arguments first.
	methodBuilder jumpAheadTarget: #else.! !

!OCASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 10/14/2010 15:50'!
emitMessageNode: aMessageNode 

	super emitMessageNode: aMessageNode.
	methodBuilder popTop.
! !

!OCASTTranslatorForEffect methodsFor: 'inline messages' stamp: 'ClementBera 7/10/2014 16:26'!
emitOr: aMessageNode

	super emitOr: aMessageNode.
	methodBuilder popTop.! !

!OCASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'ClementBera 10/22/2013 13:09'!
visitArrayNode: anArrayNode 
	"An arrayNode may have side effect, for example: '{self foo}'. So we cannot just generate nothing for this node."

	super visitArrayNode: anArrayNode.
	methodBuilder popTop.
! !

!OCASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 4/11/2013 15:12'!
visitAssignmentNode: anAssignmentNode 

	super visitAssignmentNode: anAssignmentNode .
	methodBuilder popTop. ! !

!OCASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'ClementBera 10/22/2013 13:04'!
visitBlockNode: aBlockNode 

	"A block has no side effect, so a block translated for effect just doesn't generate anything" 
! !

!OCASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'ClementBera 7/8/2014 16:27'!
visitLiteralArrayNode: aLiteralNode
	"when visiting a literal array for effect, we could push it and then pop it, but we do nothing"
	methodBuilder addLiteral: aLiteralNode value! !

!OCASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'ClementBera 7/8/2014 16:27'!
visitLiteralNode: aLiteralNode
	"when visiting a literal for effect, we could push it and then pop it, but we do nothing"
	methodBuilder addLiteral: aLiteralNode value! !

!OCASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'MarcusDenker 5/9/2015 12:18'!
visitParseErrorNode: anErrorNode  

	super visitParseErrorNode: anErrorNode.
	methodBuilder popTop.
! !

!OCASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'nice 5/2/2013 00:21'!
visitSequenceNode: aSequenceNode 
	aSequenceNode statements do: [:each | self visitNode: each].! !

!OCASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'ClementBera 7/8/2014 16:30'!
visitVariableNode: aVariableNode
	"when visiting a variable for effect, we could push it and then pop it, but we do nothing"
	| binding |
	binding := aVariableNode binding.
	(binding isLiteralVariable or: [ binding isUndeclared ])
		ifTrue: [ methodBuilder addLiteral: binding assoc ]! !

OCASTTranslator subclass: #OCASTTranslatorForValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Translator'!

!OCASTTranslatorForValue commentStamp: 'ajh 3/24/2003 22:20' prior: 0!
I override some methods in my super to generate instructions for effect and value only.!

!OCASTTranslatorForValue methodsFor: 'inline messages' stamp: 'nice 5/1/2013 23:02'!
emitIfFalse: aMessageNode
	
	self visitNode: aMessageNode receiver.
	methodBuilder jumpAheadTo: #false if: false.
		methodBuilder pushLiteral: nil.
		methodBuilder jumpAheadTo: #end.
		methodBuilder jumpAheadTarget: #false.
	self visitInlinedBlockNode: aMessageNode arguments first.
	methodBuilder jumpAheadTarget: #end.! !

!OCASTTranslatorForValue methodsFor: 'inline messages' stamp: 'MarcusDenker 6/11/2013 15:52'!
emitIfNotNil: aMessageNode
	| args |
	self visitNode: aMessageNode receiver.
	args := aMessageNode arguments.
	args first arguments ifNotEmpty: [ args first arguments first binding emitStore: methodBuilder ].
	methodBuilder pushDup.
	methodBuilder pushLiteral: nil.
	methodBuilder send: #==.
	methodBuilder jumpAheadTo: #end if: true.
	methodBuilder popTop.
	self visitInlinedBlockNode: args first.
	methodBuilder jumpAheadTarget: #end.! !

!OCASTTranslatorForValue methodsFor: 'inline messages' stamp: 'nice 5/1/2013 23:03'!
emitIfTrue: aMessageNode
	
	self visitNode: aMessageNode receiver.
	methodBuilder jumpAheadTo: #else if: false.
	self visitInlinedBlockNode:  aMessageNode arguments first.
	methodBuilder jumpAheadTo: #end.
	methodBuilder jumpAheadTarget: #else.
	methodBuilder pushLiteral: nil.
	methodBuilder jumpAheadTarget: #end.! !

!OCASTTranslatorForValue methodsFor: 'inline messages' stamp: 'MarcusDenker 6/23/2012 12:09'!
emitWhileFalse: aMessageNode

	super emitWhileFalse: aMessageNode.
	methodBuilder pushLiteral: nil.
! !

!OCASTTranslatorForValue methodsFor: 'inline messages' stamp: 'MarcusDenker 6/23/2012 12:09'!
emitWhileTrue: aMessageNode

	super emitWhileTrue: aMessageNode.
	methodBuilder pushLiteral: nil.
! !

!OCASTTranslatorForValue methodsFor: 'visitor-double dispatching' stamp: 'nice 5/2/2013 00:21'!
visitSequenceNode: aSequenceNode 
	| statements |
	statements := aSequenceNode statements.
	statements ifEmpty: [
		methodBuilder pushLiteral: nil.
		^self].
	statements allButLastDo: [:each | effectTranslator visitNode: each].
	self visitNode: statements last.! !

!TApplyingOnClassSide methodsFor: '*OpalCompiler-Core' stamp: 'CamilleTeruel 9/1/2014 16:05'!
compiler
	"The compiler is defined on instance-side to be able to customize it for *one* metaclass"
	^ self instanceSide classSideCompiler! !

!TApplyingOnClassSide methodsFor: '*OpalCompiler-Core' stamp: 'CamilleTeruel 9/1/2014 16:05'!
compilerClass
	"The compiler class is defined on instance-side to be able to customize it for *one* metaclass"
	^ self instanceSide classSideCompilerClass! !

InstructionClient subclass: #IRBytecodeDecompiler
	instanceVariableNames: 'instructionStream irBuilder newTempVector scopeStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Bytecode'!

!IRBytecodeDecompiler commentStamp: 'ajh 3/25/2003 00:26' prior: 0!
I interpret bytecode instructions, sending the appropriate instruction messages to my IRBuilder, resulting in an IRMethod.!

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'MarcusDenker 6/8/2012 13:50'!
blockReturnTop
	self popScope.
	irBuilder blockReturnTop.! !

!IRBytecodeDecompiler methodsFor: 'private' stamp: 'ToonVerwaest 3/24/2011 23:22'!
checkIfJumpTarget
	irBuilder testJumpAheadTarget: instructionStream pc! !

!IRBytecodeDecompiler methodsFor: 'public access' stamp: 'MarcusDenker 10/3/2014 14:53'!
decompile: aCompiledMethod
	instructionStream := InstructionStream on: aCompiledMethod.
	irBuilder := IRReconstructor new.
	scopeStack := Stack new.
	self pushScope: #() numArgs: aCompiledMethod numArgs.
	irBuilder irPrimitive: aCompiledMethod irPrimitive.
	
	aCompiledMethod hasProperties ifTrue: [irBuilder properties: aCompiledMethod properties copy].
	irBuilder numArgs: aCompiledMethod numArgs.
	irBuilder addTemps: self scope args.
	aCompiledMethod isQuick
		ifTrue: [self quickMethod]
		ifFalse: [self interpret].
	self popScope.
	"just add all literals of the compiledMethod as additional literals.
	 duplicates will be filtered out, but we keep the optimized ones"
	irBuilder additionalLiterals: (aCompiledMethod literals allButLast: 2).
	"when compiling methods of context classes, force long form for iVar access by getting the correct context"
	irBuilder compilationContext: aCompiledMethod methodClass compiler compilationContext.
	^ irBuilder ir.! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 15:40'!
doDup
	irBuilder pushDup! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:08'!
doPop
	irBuilder popTop! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'MarcusDenker 6/13/2012 17:07'!
interpret
	| endPC |
	endPC := instructionStream method endPC.
	[instructionStream pc > endPC ] 
		whileFalse: [
			self checkIfJumpTarget.
			irBuilder mapToByteIndex: instructionStream pc.
			instructionStream interpretNextInstructionFor: self.]! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'MarcusDenker 6/19/2012 11:41'!
jump: dist
	| index seq instr newSeq seqs |
	index := instructionStream pc + dist .

	dist >= 0 ifTrue: [
		"jump forward"
		^ irBuilder jumpAheadTo: index ].
	"jump to the jump instuction itself"
	dist >= -2 ifTrue: 
		[	irBuilder jumpBackTarget: index.
			irBuilder jumpBackTo: index.
		^self].
	"jump backward"
	seqs := irBuilder ir allSequences.
	seq := seqs findLast: [:s | s notEmpty and: [s first bytecodeIndex <= index]].
	seq := seqs at: seq.
	seq first bytecodeIndex = index
		ifTrue: [ newSeq := seq ]
		ifFalse: [
			instr := seq detect: [:i | (seq after: i) bytecodeIndex = index].
			newSeq := seq splitAfter: instr ].
	irBuilder addJumpBackTarget: index to: newSeq.
	"if we have split the currentSequence of the irBuilder, make sure to set it
	to the newSeq".	
	irBuilder currentSequence = seq ifTrue: [irBuilder currentSequence: newSeq].
	irBuilder jumpBackTo: index.

! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:08'!
jump: dist if: bool
	| index |
	index := instructionStream pc + dist .

	dist >= 0 ifTrue: [
		"conditional jump forward"
		^ irBuilder jumpAheadTo: index if: bool ].

	self error: 'Should not do this'! !

!IRBytecodeDecompiler methodsFor: 'private' stamp: 'MarcusDenker 4/29/2013 17:39'!
methodClass
	^ instructionStream  method methodClass! !

!IRBytecodeDecompiler methodsFor: 'quick methods' stamp: 'ToonVerwaest 3/24/2011 23:08'!
methodReturnConstant: value
	self pushConstant: value.
	self methodReturnTop.! !

!IRBytecodeDecompiler methodsFor: 'quick methods' stamp: 'MarcusDenker 6/19/2012 11:48'!
methodReturnReceiver
	self pushReceiver.
	self methodReturnTop.! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'MarcusDenker 6/13/2012 13:33'!
methodReturnTop
	irBuilder isLastClosureInstruction
		ifTrue: [
			self popScope.
			irBuilder fixPushNilsForTemps.
			irBuilder returnTop.
			irBuilder popScope. ]
		ifFalse: [ irBuilder returnTop ]! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:09'!
popIntoLiteralVariable: offset
	self storeIntoLiteralVariable: offset.
	self doPop.! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:09'!
popIntoReceiverVariable: offset
	self storeIntoReceiverVariable: offset.
	self doPop.! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:09'!
popIntoRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex
	self storeIntoRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex.
	self doPop.
	! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/27/2011 15:25'!
popIntoTemporaryVariable: offset
	newTempVector
		ifNil: [
			self storeIntoTemporaryVariable: offset.
			self doPop. ]
		ifNotNil: [
			self scope newTempVector: newTempVector at: offset.
			" Keep offset for remapping in popScope "
			newTempVector index: offset.
			irBuilder createTempVectorNamed: newTempVector withVars: newTempVector.
			newTempVector := nil ]! !

!IRBytecodeDecompiler methodsFor: 'scope' stamp: 'ToonVerwaest 3/31/2011 14:54'!
popScope
	| scope tempIndex |
	scope := self scope.
	
	irBuilder addTemps: scope temps.
	
	" Remap your own temp vectors "
	scope ownTempVectors do: [ :tempVector |
		irBuilder
			remapTemp: (scope -> tempVector index)
			toRemote: tempVector ].
	
	" Remap the copied values "
	tempIndex := scope numArgs.
	scope copiedValues do: [ :copiedValue |
		irBuilder
			remapTemp: (scope -> tempIndex)
			toRemote: copiedValue.
		tempIndex := tempIndex + 1. ].
	
	^ scopeStack pop! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:09'!
pushActiveContext
	irBuilder pushThisContext! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'MarcusDenker 6/13/2012 13:23'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs blockSize: blockSize 
	| closureEnd copiedValues |
	copiedValues := irBuilder removeLast: numCopied.
	self pushScope: copiedValues numArgs: numArgs.
	closureEnd := instructionStream pc + blockSize.
	
	irBuilder
		pushClosureCopyCopiedValues: copiedValues
		args: self scope args
		jumpTo: closureEnd.! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:09'!
pushConsArrayWithElements: numElements 
	irBuilder pushConsArray: numElements
! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/28/2011 18:21'!
pushConstant: value
	irBuilder pushLiteral: value! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/28/2011 18:19'!
pushLiteralVariable: assoc
	irBuilder pushLiteralVariable: assoc.! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'MarcusDenker 7/16/2012 16:06'!
pushNewArrayOfSize: size
	newTempVector := IRRemoteArray new size: size! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:09'!
pushReceiver
	irBuilder pushReceiver! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:10'!
pushReceiverVariable: offset
	irBuilder pushInstVar: offset + 1.
! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/25/2011 17:13'!
pushRemoteTemp: remoteIndex inVectorAt: tempIndex 
	|  remoteArray remoteTempName |
	remoteArray := self scope tempAt: tempIndex.
	remoteTempName := self scope tempAt: remoteIndex inRemote: remoteArray.
	irBuilder pushRemoteTemp: remoteTempName inVector: remoteArray.! !

!IRBytecodeDecompiler methodsFor: 'scope' stamp: 'MarcusDenker 7/16/2012 16:05'!
pushScope: copiedValues numArgs: numArgs
	|scope |
	scope := IRBytecodeScope new numArgs: numArgs.
	scopeStack push: scope.
	scope copiedValues: copiedValues.! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/27/2011 01:29'!
pushTemporaryVariable: offset
	irBuilder pushTemp: (self scope tempAt: offset)! !

!IRBytecodeDecompiler methodsFor: 'quick methods' stamp: 'ClementBera 1/28/2015 09:24'!
quickMethod

	instructionStream method primitive = 256 ifTrue: [
		^ self methodReturnReceiver
	]. 
	instructionStream method isReturnSpecial ifTrue: [
		^ self methodReturnConstant: (instructionStream method encoderClass specialLiterals at: instructionStream method primitive - 256)
	].
	instructionStream method isReturnField ifTrue: [
		self pushReceiverVariable: instructionStream method returnField.
		^ self methodReturnTop
	].
	self error: 'quick method inconsistency'! !

!IRBytecodeDecompiler methodsFor: 'scope' stamp: 'ToonVerwaest 3/24/2011 21:17'!
scope
	^ scopeStack top! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'MarcusDenker 11/11/2011 15:51'!
send: selector super: superFlag numArgs: numArgs
	superFlag
		ifTrue: [irBuilder send: selector toSuperOf: self methodClass]
		ifFalse: [irBuilder send: selector]! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:10'!
storeIntoLiteralVariable: value
	irBuilder storeIntoLiteralVariable: value! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:10'!
storeIntoReceiverVariable: offset
	irBuilder storeInstVar: offset + 1.
! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/25/2011 17:13'!
storeIntoRemoteTemp: remoteIndex inVectorAt: tempIndex 
	|  remoteArray remoteTempName |
	remoteArray := self scope tempAt: tempIndex.
	remoteTempName := self scope tempAt: remoteIndex inRemote: remoteArray.	
	irBuilder storeRemoteTemp: remoteTempName inVector: remoteArray.
	! !

!IRBytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ToonVerwaest 3/24/2011 23:10'!
storeIntoTemporaryVariable: offset
	irBuilder storeTemp: (self scope tempAt: offset)! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'SebastianTleye 7/9/2013 17:52'!
compile: code 
	"Compile the argument, code, as source code in the context of the 
	receiver. Create an error notification if the code can not be compiled. 
	The argument is either a string or an object that converts to a string or a 
	PositionableStream on an object that converts to a string."

	^self compile: code notifying: nil! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'MartinDias 6/16/2015 16:34'!
compile: code notifying: requestor 
	"Compile the argument, code, as source code in the context of the 
	receiver and insEtall the result in the receiver's method dictionary. The 
	second argument, requestor, is to be notified if an error occurs. The 
	argument code is either a string or an object that converts to a string or 
	a PositionableStream. This method also saves the source code."
	
	| method |
	method  := self compiler
		source: code;
		requestor: requestor;
		failBlock: [ ^nil ];
		compile.
		
	method putSource: code
			withPreamble: [:f | f cr; nextPut: $!!; nextChunkPut: 'Behavior method'; cr].
	self addSelector: method selector withMethod: method notifying: requestor.
	^ method selector! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'SebastianTleye 7/9/2013 17:52'!
compileAll
	^ self compileAllFrom: self! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 11/3/2013 11:37'!
compileAllFrom: oldClass
	"Compile all the methods in the receiver's method dictionary.
	This validates sourceCode and variable references and forces
	all methods to use the current bytecode set"
	
	oldClass localSelectors do: [:sel | self recompile: sel from: oldClass].
	! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'SebastianTleye 7/9/2013 17:52'!
compiler
	"Answer a compiler appropriate for source methods of this class."

	^self compilerClass new
		environment: self environment;
		class: self! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'SebastianTleye 7/9/2013 17:52'!
compilerClass
	"Answer a compiler class appropriate for source methods of this class."

	^Smalltalk compilerClass! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'SebastianTleye 7/9/2013 17:52'!
evaluate: aString
	^self compiler evaluate: aString! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 10/1/2013 14:15'!
recompile
	self compileAll! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'SebastianTleye 7/9/2013 17:52'!
recompile: selector
	"Compile the method associated with selector in the receiver's method dictionary."
	^self recompile: selector from: self! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'SebastianTleye 7/16/2013 17:05'!
recompile: selector from: oldClass
	^self explicitRequirement.! !

!TBehavior methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 8/10/2014 09:39'!
sourceCodeTemplate
	"Answer an expression to be edited and evaluated in order to define 
	methods in this class or trait."

	^ 'messageSelectorAndArgumentNames
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!Context methodsFor: '*OpalCompiler-Core' stamp: 'CamilleTeruel 2/14/2014 15:16'!
isBlockReturn: aPC
	^ (self method at: aPC) = 125! !

!Context methodsFor: '*OpalCompiler-Core' stamp: 'CamilleTeruel 2/14/2014 15:21'!
isPushLiteralNil: aPC
	^ (self method at: aPC) = 115! !

!Context methodsFor: '*OpalCompiler-Core' stamp: 'CamilleTeruel 2/14/2014 15:42'!
isPushTemp: aPC
	^ (self method at: aPC) between: 16 and: 31! !

!Context methodsFor: '*OpalCompiler-Core' stamp: 'CamilleTeruel 2/14/2014 16:04'!
neighborPCWithCorrectMapping
	"Answer a pc inside the enclosing block or mathod that is correctly mapped to an AST node"
	"This is an ugly and temporary fix for Pharo 3. 
	Must be removed as soon as mappings are fixed"
	| neighborPC |
	neighborPC := self isDead 
		ifTrue: [ self startpc ]
		ifFalse: [ pc ].
	"There is a pushLiteral: nil bytecode for each temps in a block. 
	There is a 'pushTemp:' bytecode for each copied value of a block.
	These bytecodes are not mapped to any IR.
	We skip both"
	[ self isPushLiteralNil: neighborPC ] whileTrue: [ neighborPC := neighborPC + 1 ].
	[ self isPushTemp: neighborPC ] whileTrue: [ neighborPC := neighborPC + 1 ].
	"The block return ir instruction is mapped to the block instead of the sequence AST node. So we go just before it"
	(self isBlockReturn: neighborPC) ifTrue: [ neighborPC := neighborPC - 1 ].
	^ neighborPC! !

!Context methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 8/30/2015 12:02'!
previousPcWithCorrectMapping
	"Answer a pc inside the enclosing block or mathod that is correctly mapped to an AST node"
	"This is an ugly and temporary fix for Pharo 3. 
	Must be removed as soon as mappings are fixed"
	| neighborPC |
	neighborPC := self isDead 
		ifTrue: [ self startpc ]
		ifFalse: [ self previousPc ].
	"There is a pushLiteral: nil bytecode for each temps in a block. 
	There is a 'pushTemp:' bytecode for each copied value of a block.
	These bytecodes are not mapped to any IR.
	We skip both"
	[ self isPushLiteralNil: neighborPC ] whileTrue: [ neighborPC := neighborPC + 1 ].
	[ self isPushTemp: neighborPC ] whileTrue: [ neighborPC := neighborPC + 1 ].
	"The block return ir instruction is mapped to the block instead of the sequence AST node. So we go just before it"
	(self isBlockReturn: neighborPC) ifTrue: [ neighborPC := neighborPC - 1 ].
	^ neighborPC! !

!Context methodsFor: '*OpalCompiler-Core' stamp: 'CamilleTeruel 2/14/2014 16:15'!
sourceNode
	"Return the source node of the method or the block corresponding to the receiver"
	^ (method sourceNodeForPC: self neighborPCWithCorrectMapping) enclosingMethodOrBlockNode
	"Uncomment the following once the pc->AST mapping is fixed"
	"^ (method sourceNodeForPC: (pc ifNil: [ self startpc ])) enclosingMethodOrBlockNode"! !

!Context methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 8/30/2015 12:03'!
sourceNodeExecuted
	"When down in the stack, I return the node that executed"
	^ (method sourceNodeForPC: self previousPcWithCorrectMapping) 
	"Uncomment the following once the pc->AST mapping is fixed"
	"^ (method sourceNodeForPC: (previousPc ifNil: [ self startpc ])) "! !

!RBSequenceNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 10/16/2015 11:11'!
transformLastToReturn
	| last |
	statements ifEmpty: [ ^self].
	last := statements last.
	last isReturn ifFalse: [self replaceNode: last withNode: (RBReturnNode return: last start value: last )]! !

!UndefinedObject methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 4/22/2013 16:56'!
allTempNames
	^#()! !

!SystemDictionary methodsFor: '*OpalCompiler-Core' stamp: 'IgorStasenko 11/11/2014 11:59'!
findVariable: lookupBlock ifNone: notFoundBlock
 
	self associationsDo: [ :assoc | | var |
		var := OCLiteralVariable new 
			assoc: assoc; 
			scope: self; 
			yourself.
		(lookupBlock value: var) ifTrue: [ ^ var ].
		 ].
	^ notFoundBlock value! !

PackageManifest subclass: #ManifestOpalCompilerCore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core'!

!ManifestOpalCompilerCore commentStamp: 'MarcusDenker 8/11/2014 10:13' prior: 0!
This is the Manifest for Opal for recording false positive of the code critique tool!

!ManifestOpalCompilerCore class methodsFor: 'meta-data - dependency analyser' stamp: 'ChristopheDemarey 4/28/2016 15:19'!
ignoredDependencies
	^ #(#Compiler #'Morphic-Base' #'System-Settings')! !

!ManifestOpalCompilerCore class methodsFor: 'meta-data - dependency analyser' stamp: 'ChristopheDemarey 4/28/2016 15:18'!
manuallyResolvedDependencies
	^ #(#Compiler #'System-Settings' #CodeExport #'System-Announcements' #'System-Sources' #'Morphic-Base')! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'MarcusDenker 5/23/2013 08:43'!
rejectRules
^ #('SearchingLiteralRule' 'ExcessiveArgumentsRule' 'LongMethodsRule' 'ClassInstVarNotInitializedRule' 'UsesAddRule' 'ExcessiveMethodsRule' 'MissingYourselfRule' 'ExcessiveVariablesRule' 'TempsReadBeforeWrittenRule' 'AbstractClassRule' 'IfTrueReturnsRule')! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'MarcusDenker 12/18/2012 17:43'!
ruleAssignmentInIfTrueRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#OpalCompiler #from:class:context:notifying: #false)) #'2012-12-18T17:43:24.703000001+01:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'MarcusDenker 5/23/2013 08:43'!
ruleBadMessageRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#OCASTTranslator #initialize #false)) #'2013-05-23T08:43:44.793471+02:00') #(#(#RGMethodDefinition #(#OCASTTranslator #emitCaseOf: #false)) #'2013-05-23T08:43:44.793471+02:00') #(#(#RGMethodDefinition #(#OpalCompiler #evaluate #false)) #'2013-05-23T08:43:44.793471+02:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'GuillermoPolito 8/17/2015 13:55'!
ruleClassNotReferencedRuleV1FalsePositive
	^ #(#(#(#RGClassDefinition #(#OpalEncoderForLongFormV3PlusClosures)) #'2015-08-17T13:55:18.528985+02:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'GuillermoPolito 8/17/2015 13:55'!
ruleConsistencyCheckRuleV1FalsePositive
	^ #(#(#(#RGMethodDefinition #(#OpalEncoderForV3 #isSpecialLiteralForPush: #false)) #'2015-08-17T13:55:18.679379+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #isSpecialLiteralForPush: #false)) #'2015-08-17T13:55:18.679442+02:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'GuillermoPolito 8/17/2015 13:56'!
ruleEqualsTrueRuleV1FalsePositive
	^ #(#(#(#RGMethodDefinition #(#IRSqueakV3PlusClosuresBytecodeGenerator #returnConstant: #false)) #'2012-12-18T17:44:03.941+01:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #isSpecialLiteralForPush: #false)) #'2015-08-17T13:55:18.512238+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #isSpecialLiteralForPush: #false)) #'2015-08-17T13:55:18.511888+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #isSpecialLiteralForPush: #false)) #'2015-08-17T13:56:21.542702+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #isSpecialLiteralForPush: #false)) #'2015-08-17T13:56:21.542781+02:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'GuillermoPolito 8/17/2015 13:56'!
ruleImplementedNotSentRuleV1FalsePositive
	^ #(#(#(#RGMethodDefinition #(#OCASTTranslatorForEffect #emitIfFalse: #false)) #'2012-12-18T17:41:36.969+01:00') #(#(#RGMethodDefinition #(#OCASTTranslatorForEffect #emitIfTrue: #false)) #'2012-12-18T17:41:39.446+01:00') #(#(#RGMethodDefinition #(#OCASTTranslatorForEffect #emitIfNotNil: #false)) #'2012-12-18T17:41:41.777+01:00') #(#(#RGMethodDefinition #(#OCASTTranslator #emitCaseOf: #false)) #'2012-12-18T17:42:01.724+01:00') #(#(#RGMethodDefinition #(#OCASTTranslator #emitToByDo: #false)) #'2012-12-18T17:42:03.557+01:00') #(#(#RGMethodDefinition #(#OCASTTranslator #emitToDo: #false)) #'2012-12-18T17:42:05.34+01:00') #(#(#RGMethodDefinition #(#OCASTTranslator #emitIfNotNil: #false)) #'2012-12-18T17:42:07.349+01:00') #(#(#RGMethodDefinition #(#OCASTTranslator #emitIfNil: #false)) #'2012-12-18T17:42:09.472+01:00') #(#(#RGMethodDefinition #(#OCASTTranslator #emitCaseOfOtherwise: #false)) #'2012-12-18T17:42:11.795+01:00') #(#(#RGMethodDefinition #(#OpalBytecodeEncoder #sizeCallPrimitive: #false)) #'2015-08-17T13:56:21.549128+02:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'MarcusDenker 9/20/2013 15:19'!
ruleMethodHasNoTimeStampRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#OCSemanticWarning #correctIn: #false)) #'2012-12-18T17:43:05.023+01:00') #(#(#RGMethodDefinition #(#OCAbstractLocalVariable #isUninitialized #false)) #'2012-12-18T17:43:10.236+01:00') #(#(#RGMethodDefinition #(#IRPrinter #pushRemoteTemp:inVector: #false)) #'2012-12-19T08:07:38.013+01:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'GuillermoPolito 8/17/2015 13:56'!
ruleMissingSubclassResponsibilityRuleV1FalsePositive
	^ #(#(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushSpecialLiteral: #false)) #'2015-08-17T13:55:18.590702+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genSendSuper:numArgs: #false)) #'2015-08-17T13:55:18.591015+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushLiteral: #false)) #'2015-08-17T13:55:18.590638+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStoreTemp: #false)) #'2015-08-17T13:55:18.590957+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushLiteral: #false)) #'2015-08-17T13:55:18.59136+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStorePopInstVar: #false)) #'2015-08-17T13:55:18.590898+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStorePopTemp: #false)) #'2015-08-17T13:55:18.591681+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushLiteralVar: #false)) #'2015-08-17T13:55:18.591191+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushInstVarLong: #false)) #'2015-08-17T13:55:18.591619+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStorePopTemp: #false)) #'2015-08-17T13:55:18.591931+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStorePopTemp: #false)) #'2015-08-17T13:55:18.592243+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStoreInstVarLong: #false)) #'2015-08-17T13:55:18.591869+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genReturnSpecialLiteral: #false)) #'2015-08-17T13:55:18.59218+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genJump: #false)) #'2015-08-17T13:55:18.590616+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushTemp: #false)) #'2015-08-17T13:55:18.590937+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushReceiver #false)) #'2015-08-17T13:55:18.590549+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genReturnReceiver #false)) #'2015-08-17T13:55:18.591335+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStoreInstVar: #false)) #'2015-08-17T13:55:18.590878+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStorePopInstVarLong: #false)) #'2015-08-17T13:55:18.591171+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushTemp: #false)) #'2015-08-17T13:55:18.591598+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStorePopInstVar: #false)) #'2015-08-17T13:55:18.591113+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStorePopLiteralVar: #false)) #'2015-08-17T13:55:18.59191+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushReceiver #false)) #'2015-08-17T13:55:18.591536+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPop #false)) #'2015-08-17T13:55:18.592222+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genDup #false)) #'2015-08-17T13:55:18.591848+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genReturnTopToCaller #false)) #'2015-08-17T13:55:18.59216+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStoreLiteralVar: #false)) #'2015-08-17T13:55:18.592098+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genReturnTop #false)) #'2015-08-17T13:55:18.590595+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStorePopInstVar: #false)) #'2015-08-17T13:55:18.590918+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genJump: #false)) #'2015-08-17T13:55:18.590519+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushSpecialLiteral: #false)) #'2015-08-17T13:55:18.59085+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStoreLiteralVar: #false)) #'2015-08-17T13:55:18.591152+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushThisContext #false)) #'2015-08-17T13:55:18.590786+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genReturnReceiver #false)) #'2015-08-17T13:55:18.591578+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushSpecialLiteral: #false)) #'2015-08-17T13:55:18.591093+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushReceiver #false)) #'2015-08-17T13:55:18.59189+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genSendSuper:numArgs: #false)) #'2015-08-17T13:55:18.591515+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStoreInstVar: #false)) #'2015-08-17T13:55:18.591827+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genSend:numArgs: #false)) #'2015-08-17T13:55:18.592139+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPop #false)) #'2015-08-17T13:55:18.591765+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genReturnReceiver #false)) #'2015-08-17T13:55:18.592077+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushLiteralVar: #false)) #'2015-08-17T13:55:18.590574+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStoreInstVarLong: #false)) #'2015-08-17T13:55:18.590489+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genSend:numArgs: #false)) #'2015-08-17T13:55:18.590829+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genReturnTopToCaller #false)) #'2015-08-17T13:55:18.591132+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genSend:numArgs: #false)) #'2015-08-17T13:55:18.590765+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPop #false)) #'2015-08-17T13:55:18.591557+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genReturnTop #false)) #'2015-08-17T13:55:18.591074+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genJumpLong: #false)) #'2015-08-17T13:55:18.591494+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStorePopInstVarLong: #false)) #'2015-08-17T13:55:18.591807+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genJumpLong: #false)) #'2015-08-17T13:55:18.591431+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushThisContext #false)) #'2015-08-17T13:55:18.592118+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushInstVar: #false)) #'2015-08-17T13:55:18.591744+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genBranchPopFalse: #false)) #'2015-08-17T13:55:18.592056+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genBranchPopTrue: #false)) #'2015-08-17T13:55:18.591994+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genDup #false)) #'2015-08-17T13:55:18.590453+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStoreInstVarLong: #false)) #'2015-08-17T13:55:18.592306+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStoreLiteralVar: #false)) #'2015-08-17T13:55:18.590807+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStoreTemp: #false)) #'2015-08-17T13:55:18.590744+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genSendSuper:numArgs: #false)) #'2015-08-17T13:55:18.591054+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushThisContext #false)) #'2015-08-17T13:55:18.59068+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStorePopInstVarLong: #false)) #'2015-08-17T13:55:18.591473+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genDup #false)) #'2015-08-17T13:55:18.590996+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushLiteralVar: #false)) #'2015-08-17T13:55:18.591786+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genReturnSpecialLiteral: #false)) #'2015-08-17T13:55:18.59141+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStoreTemp: #false)) #'2015-08-17T13:55:18.591723+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushInstVarLong: #false)) #'2015-08-17T13:55:18.592035+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genJumpLong: #false)) #'2015-08-17T13:55:18.591661+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushInstVar: #false)) #'2015-08-17T13:55:18.591973+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genBranchPopTrue: #false)) #'2015-08-17T13:55:18.590391+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushInstVar: #false)) #'2015-08-17T13:55:18.592285+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genReturnTopToCaller #false)) #'2015-08-17T13:55:18.590723+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genReturnTop #false)) #'2015-08-17T13:55:18.591035+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genBranchPopFalse: #false)) #'2015-08-17T13:55:18.590659+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genBranchPopFalse: #false)) #'2015-08-17T13:55:18.591452+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStoreInstVar: #false)) #'2015-08-17T13:55:18.590976+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStorePopLiteralVar: #false)) #'2015-08-17T13:55:18.591389+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genBranchPopTrue: #false)) #'2015-08-17T13:55:18.591702+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStorePopLiteralVar: #false)) #'2015-08-17T13:55:18.591221+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushInstVarLong: #false)) #'2015-08-17T13:55:18.592014+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushLiteral: #false)) #'2015-08-17T13:55:18.59164+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushTemp: #false)) #'2015-08-17T13:55:18.591952+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genJump: #false)) #'2015-08-17T13:55:18.592264+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genReturnSpecialLiteral: #false)) #'2015-08-17T13:55:18.592201+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStorePopInstVar: #false)) #'2015-08-17T13:56:21.519517+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushLiteral: #false)) #'2015-08-17T13:56:21.518463+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genBranchPopFalse: #false)) #'2015-08-17T13:56:21.518979+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushLiteralVar: #false)) #'2015-08-17T13:56:21.518905+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genReturnSpecialLiteral: #false)) #'2015-08-17T13:56:21.518831+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genReturnReceiver #false)) #'2015-08-17T13:56:21.51837+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushInstVar: #false)) #'2015-08-17T13:56:21.519352+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStorePopLiteralVar: #false)) #'2015-08-17T13:56:21.518286+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushThisContext #false)) #'2015-08-17T13:56:21.519278+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genSend:numArgs: #false)) #'2015-08-17T13:56:21.51874+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genBranchPopTrue: #false)) #'2015-08-17T13:56:21.518665+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genSendSuper:numArgs: #false)) #'2015-08-17T13:56:21.519645+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStorePopInstVar: #false)) #'2015-08-17T13:56:21.518592+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStoreTemp: #false)) #'2015-08-17T13:56:21.519112+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStorePopLiteralVar: #false)) #'2015-08-17T13:56:21.519039+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genReturnTop #false)) #'2015-08-17T13:56:21.518961+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genSendSuper:numArgs: #false)) #'2015-08-17T13:56:21.5185+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushLiteralVar: #false)) #'2015-08-17T13:56:21.51948+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genBranchPopFalse: #false)) #'2015-08-17T13:56:21.518426+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genJumpLong: #false)) #'2015-08-17T13:56:21.519407+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genBranchPopTrue: #false)) #'2015-08-17T13:56:21.51835+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushReceiver #false)) #'2015-08-17T13:56:21.518868+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushInstVar: #false)) #'2015-08-17T13:56:21.518795+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genJumpLong: #false)) #'2015-08-17T13:56:21.518721+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genBranchPopTrue: #false)) #'2015-08-17T13:56:21.518208+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStoreLiteralVar: #false)) #'2015-08-17T13:56:21.519241+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushReceiver #false)) #'2015-08-17T13:56:21.519168+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushTemp: #false)) #'2015-08-17T13:56:21.519682+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushThisContext #false)) #'2015-08-17T13:56:21.518628+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStorePopTemp: #false)) #'2015-08-17T13:56:21.519608+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genReturnTopToCaller #false)) #'2015-08-17T13:56:21.518555+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushLiteralVar: #false)) #'2015-08-17T13:56:21.519535+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStoreInstVar: #false)) #'2015-08-17T13:56:21.518481+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genReturnReceiver #false)) #'2015-08-17T13:56:21.519001+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStoreTemp: #false)) #'2015-08-17T13:56:21.518924+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStoreInstVarLong: #false)) #'2015-08-17T13:56:21.519444+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genJumpLong: #false)) #'2015-08-17T13:56:21.518388+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushTemp: #false)) #'2015-08-17T13:56:21.51937+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStoreInstVar: #false)) #'2015-08-17T13:56:21.518306+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPop #false)) #'2015-08-17T13:56:21.519297+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genJump: #false)) #'2015-08-17T13:56:21.517987+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genBranchPopFalse: #false)) #'2015-08-17T13:56:21.518758+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStoreLiteralVar: #false)) #'2015-08-17T13:56:21.518683+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushInstVarLong: #false)) #'2015-08-17T13:56:21.519663+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStorePopInstVarLong: #false)) #'2015-08-17T13:56:21.519204+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStorePopTemp: #false)) #'2015-08-17T13:56:21.519131+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushLiteral: #false)) #'2015-08-17T13:56:21.519057+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushInstVarLong: #false)) #'2015-08-17T13:56:21.519572+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genSend:numArgs: #false)) #'2015-08-17T13:56:21.518518+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genReturnSpecialLiteral: #false)) #'2015-08-17T13:56:21.519499+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushInstVarLong: #false)) #'2015-08-17T13:56:21.518444+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genReturnSpecialLiteral: #false)) #'2015-08-17T13:56:21.519425+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStorePopInstVar: #false)) #'2015-08-17T13:56:21.518887+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStorePopTemp: #false)) #'2015-08-17T13:56:21.518813+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStoreInstVar: #false)) #'2015-08-17T13:56:21.519334+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genDup #false)) #'2015-08-17T13:56:21.518255+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushTemp: #false)) #'2015-08-17T13:56:21.519259+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushLiteral: #false)) #'2015-08-17T13:56:21.519186+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genReturnReceiver #false)) #'2015-08-17T13:56:21.5197+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStorePopInstVarLong: #false)) #'2015-08-17T13:56:21.518647+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStoreLiteralVar: #false)) #'2015-08-17T13:56:21.519627+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genJump: #false)) #'2015-08-17T13:56:21.518573+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genReturnTop #false)) #'2015-08-17T13:56:21.519554+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genReturnTopToCaller #false)) #'2015-08-17T13:56:21.519094+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStoreTemp: #false)) #'2015-08-17T13:56:21.519021+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genPushReceiver #false)) #'2015-08-17T13:56:21.518942+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genStoreInstVarLong: #false)) #'2015-08-17T13:56:21.519462+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genSend:numArgs: #false)) #'2015-08-17T13:56:21.518407+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genReturnTopToCaller #false)) #'2015-08-17T13:56:21.519389+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForLongFormV3 #genStorePopInstVarLong: #false)) #'2015-08-17T13:56:21.518325+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genReturnTop #false)) #'2015-08-17T13:56:21.519316+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPushThisContext #false)) #'2015-08-17T13:56:21.51885+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStoreInstVarLong: #false)) #'2015-08-17T13:56:21.518776+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPushInstVar: #false)) #'2015-08-17T13:56:21.51771+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genJump: #false)) #'2015-08-17T13:56:21.518702+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genDup #false)) #'2015-08-17T13:56:21.519223+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genPop #false)) #'2015-08-17T13:56:21.519149+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genDup #false)) #'2015-08-17T13:56:21.519076+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genPop #false)) #'2015-08-17T13:56:21.51861+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForSistaV1 #genStorePopLiteralVar: #false)) #'2015-08-17T13:56:21.51959+02:00') #(#(#RGMethodDefinition #(#OpalEncoderForV3 #genSendSuper:numArgs: #false)) #'2015-08-17T13:56:21.518536+02:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'MarcusDenker 12/19/2012 08:10'!
ruleTempsReadBeforeWrittenRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#IRSequence #absorbJumpToSingleInstr: #false)) #'2012-12-19T08:10:39.177+01:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'MarcusDenker 12/19/2012 08:17'!
ruleToDoCollectRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#IRBytecodeScope #args #false)) #'2012-12-19T08:16:58.474000001+01:00') #(#(#RGMethodDefinition #(#IRBytecodeScope #temps #false)) #'2012-12-19T08:17:19.677+01:00') )! !

!ManifestOpalCompilerCore class methodsFor: 'code-critics' stamp: 'MarcusDenker 12/19/2012 08:13'!
ruleVariableAssignedLiteralRuleV1FalsePositive
^ #(#(#(#RGClassDefinition #(#IRMethod)) #'2012-12-19T08:13:54.508+01:00') )! !

Object subclass: #AbstractCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-FrontEnd'!

!AbstractCompiler commentStamp: '<historical>' prior: 0!
I define the public API of compilers that can be used as system compilers (e.g. overriding #compiler on the class side).!

!AbstractCompiler class methodsFor: 'settings' stamp: 'GuillermoPolito 4/25/2016 15:40'!
compilerSettingsOn: aBuilder
	<systemsettings>
	(aBuilder group: #compiler)
		label: 'Compiler';
		description: 'All Compiler Settings';
		with: [ 
					(aBuilder pickOne: #compilerClass)
						target: SmalltalkImage;
						label: 'Default Compiler';
						domainValues: AbstractCompiler subclasses.
					(aBuilder pickOne: #bytecodeBackend)
						target: CompilationContext;
						label: 'Bytecode Backend';
						domainValues:
								{#V3PlusClosures -> OpalEncoderForV3PlusClosures.
								#SistaV1 -> OpalEncoderForSistaV1 }]! !

!AbstractCompiler methodsFor: 'plugins' stamp: 'MarcusDenker 2/28/2015 15:32'!
addPlugin: aClass 
	"do nothing"! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:08'!
category: aCategory
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:08'!
class: aClass
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:08'!
compilationContext
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:09'!
compilationContext: anObject
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:09'!
compilationContextClass
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:09'!
compilationContextClass: aClass
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:33'!
compile
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
compile: textOrStream in: aClass classified: aCategory notifying: aRequestor ifFail:  aFailBlock 

	^self 
		source: textOrStream;
		class: aClass;
		requestor: aRequestor;
		category: aCategory;
		failBlock: aFailBlock;
		translate! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
compile: textOrStream in: aClass notifying: aRequestor ifFail: aFailBlock 

	^self 
		source: textOrStream;
		class: aClass;
		requestor: aRequestor;
		failBlock: aFailBlock;
		translate
	
! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
compileNoPattern: textOrStream in: aClass context: aContext notifying: aRequestor ifFail: aFailBlock

	^self 
		source: textOrStream;
		class: aClass;
		context: aContext;
		requestor: aRequestor;
		noPattern: true;
		failBlock: aFailBlock;
		translate! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:09'!
compiledMethodTrailer: aClass
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:09'!
context: aContext
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:25'!
decompileMethod: aCompiledMethod
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:09'!
environment: anSmallTalkImage
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:33'!
evaluate
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:32'!
evaluate: textOrString 
	
	^self
		source: textOrString;
		evaluate! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
evaluate: textOrString for: anObject logged: logFlag 

	^self
		source: textOrString;
		logged: logFlag;
		receiver: anObject;
		evaluate! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
evaluate: textOrString for: anObject notifying: aController logged: logFlag

	^ self 
		source: textOrString;
		logged: logFlag;
		receiver: anObject;
		requestor: aController;
		evaluate
	
			! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
evaluate: aString in: aContext to: aReceiver
	
	^self
		source: aString;
		context: aContext;
		receiver: aReceiver;
		failBlock: [^ #failedDoit];
		evaluate! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
evaluate: textOrStream in: aContext to: aReceiver notifying: aRequestor ifFail: aFailBlock 
	
	^self
		source: textOrStream;
		context: aContext;
		receiver: aReceiver;
		requestor: aRequestor;
		failBlock: aFailBlock;
		evaluate! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
evaluate: textOrStream in: aContext to: aReceiver notifying: aRequestor ifFail: aFailBlock logged: logFlag
	
	^self
		source: textOrStream;
		context: aContext;
		receiver: aReceiver;
		requestor: aRequestor;
		failBlock: aFailBlock;
		logged: logFlag;
		evaluate! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
evaluate: textOrString logged: logFlag 

	^ self
		source: textOrString;
		logged: logFlag;
		evaluate
	
			! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
evaluate: textOrString notifying: aController logged: logFlag 

	^ self
		source: textOrString;
		logged: logFlag;
		requestor: aController;
		evaluate
	! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:09'!
failBlock: aBlock
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:33'!
format
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
format: textOrStream in: aClass notifying: aRequestor
	^self
		source: textOrStream;
		class: aClass;
		requestor: aRequestor;
		format
		! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:10'!
logged: aBoolean
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:10'!
noPattern: aBoolean
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:33'!
options: anArray
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:34'!
parse
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
parse: aString class: aClass
	^self 
		source: aString;
		class: aClass;
		parse! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
parse: aString class: aClass noPattern: aBoolean context: aContext notifying: req ifFail: aBlock
	"Backwards compatibilty"
	
	^self 
		source: aString;
		class: aClass;
		noPattern: aBoolean;
		context: aContext;
		requestor: req;
		failBlock: aBlock;
		translate.! !

!AbstractCompiler methodsFor: 'old - public' stamp: 'MarcusDenker 7/28/2013 15:06'!
parse: textOrStream in: aClass notifying: req

	^self 
		source: textOrStream;
		class: aClass;
		requestor: req;
		translate.! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:34'!
parseLiterals: aString
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:34'!
parseSelector: aString 
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:10'!
receiver: anObject
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:10'!
requestor: aRequestor
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/28/2013 15:10'!
source: aString
	self subclassResponsibility! !

!AbstractCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/27/2013 19:34'!
translate
	self subclassResponsibility! !

AbstractCompiler subclass: #OpalCompiler
	instanceVariableNames: 'ast source context receiver compilationContext compilationContextClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-FrontEnd'!

!OpalCompiler commentStamp: '<historical>' prior: 0!
I provide the API of the whole Compiler Package.

-> parsing: just parse
-> translate: parse and generate code so we get all error messages
-> compile: translate but return the CompiledMethod 

!

!OpalCompiler class methodsFor: 'public' stamp: 'MarcusDenker 11/16/2012 15:35'!
debuggerMethodMapForMethod: aMethod
	^ DebuggerMethodMapOpal forMethod: aMethod! !

!OpalCompiler class methodsFor: 'options' stamp: 'MarcusDenker 7/21/2015 11:19'!
defaultOptions
	^ #(
	"by default we inline all optimized constructs"
	+ optionInlineIf
	+ optionInlineIfNil
	+ optionInlineAndOr
	+ optionInlineWhile
	+ optionInlineToDo
	+ optionInlineCase
	- optionInlineTimesRepeat
	- optionInlineRepeat
	
	- optionInlineNone "to turn off all. Overrides the others" 	
	- optionLongIvarAccessBytecodes "special for Contexts"
	+ optionOptimizeIR 
	
	- optionParseErrors "parse syntactically wrong code"
	)! !

!OpalCompiler class methodsFor: 'old - public' stamp: 'MarcusDenker 4/30/2013 10:28'!
evaluate: textOrString 
	
	^self new
		source: textOrString;
		evaluate! !

!OpalCompiler class methodsFor: 'old - public' stamp: 'MarcusDenker 4/27/2013 21:29'!
evaluate: textOrString for: anObject logged: logFlag 
	"See Compiler|evaluate:for:notifying:logged:. If a compilation error occurs, 
	a Syntax Error view is created rather than notifying any requestor."

	^self new
		source: textOrString;
		logged: logFlag;
		receiver: anObject;
		evaluate! !

!OpalCompiler class methodsFor: 'old - public' stamp: 'MarcusDenker 4/27/2013 22:23'!
evaluate: textOrString for: anObject notifying: aController logged: logFlag
	"Compile and execute the argument, textOrString with respect to the class 
	of anObject. If a compilation error occurs, notify aController. If both 
	compilation and execution are successful then, if logFlag is true, log 
	(write) the text onto a system changes file so that it can be replayed if 
	necessary."

	^ self new
		source: textOrString;
		logged: logFlag;
		receiver: anObject;
		requestor: aController;
		evaluate
	
			! !

!OpalCompiler class methodsFor: 'old - public' stamp: 'MarcusDenker 4/27/2013 22:23'!
evaluate: textOrString logged: logFlag 
	"See Compiler|evaluate:for:notifying:logged:. If a compilation error occurs, 
	a Syntax Error view is created rather than notifying any requestor. 
	Compilation is carried out with respect to nil, i.e., no object."

	^ self new
		source: textOrString;
		logged: logFlag;
		evaluate
	
			! !

!OpalCompiler class methodsFor: 'old - public' stamp: 'MarcusDenker 4/27/2013 22:23'!
evaluate: textOrString notifying: aController logged: logFlag 
	"See Compiler|evaluate:for:notifying:logged:. Compilation is carried out 
	with respect to nil, i.e., no object."

	^ self new
		source: textOrString;
		logged: logFlag;
		requestor: aController;
		evaluate
	
			! !

!OpalCompiler class methodsFor: 'old - public' stamp: 'MarcusDenker 4/27/2013 21:27'!
format: textOrStream in: aClass notifying: aRequestor
	^self new
		source: textOrStream;
		class: aClass;
		requestor: aRequestor;
		format
		! !

!OpalCompiler class methodsFor: 'public' stamp: 'MarcusDenker 5/23/2013 07:47'!
isActive
	^Smalltalk compilerClass == self! !

!OpalCompiler class methodsFor: 'public' stamp: 'MarcusDenker 10/1/2013 14:22'!
recompileAll
	"Recompile all classes and traits in the system."

	Smalltalk image recompile


! !

!OpalCompiler methodsFor: 'plugins' stamp: 'MarcusDenker 2/28/2015 15:33'!
addPlugin: aClass 
	compilationContext addASTTransformationPlugin: aClass! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 5/5/2015 13:29'!
bindings: aDictionary
	"for now we abuse the requestor infrastructure...we should rewrite the requestor to use bindings
	instead"
	self compilationContext 
		requestor: aDictionary;
		interactive: false.! !

!OpalCompiler methodsFor: 'private' stamp: 'MarcusDenker 2/28/2015 16:05'!
callPlugins
	| plugins  |
	plugins := compilationContext astTransformPlugins ifEmpty: [ ^self ].
	plugins sort: [:a :b | a priority > b priority]. "priority 0 is sorted last"
	ast := ast copy.
	plugins do: [ :each | ast := each transform: ast]. ! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:49'!
category: aCategory
	self compilationContext category: aCategory.! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 7/5/2013 15:41'!
class: aClass
	self compilationContext class: aClass.! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 6/17/2013 12:51'!
compilationContext
	^ compilationContext ifNil: [ compilationContext := self compilationContextClass default ]! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 5/13/2013 14:36'!
compilationContext: anObject
	compilationContext := anObject! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:36'!
compilationContextClass
	^compilationContextClass ifNil: [ CompilationContext  ]! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:53'!
compilationContextClass: aClass
	compilationContextClass := aClass.! !

!OpalCompiler methodsFor: 'public access' stamp: 'NickPapoulias 10/2/2016 13:59'!
compile
	| cm |
	[ 	[	ast := self parse.
			ast class = RBMethodNode ifFalse: [ ast := ast asReturn methodNode].
			"Transcript show: '>>'; cr; show: ast; cr; show: self compilationContext getClass; cr;cr."
			self doSemanticAnalysis. 
			self callPlugins.  
		] 	on: OCSourceCodeChanged 
			do: 
			[  	:notification | 
				self source: notification newSourceCode. 
				notification retry. 
			]. 
		cm := ast generate: self compilationContext compiledMethodTrailer 
	]	on: SyntaxErrorNotification 
		do: [ :exception | 
			self compilationContext requestor
                ifNotNil: [
						self compilationContext requestor 
							notify: exception errorMessage , ' ->'
							at: exception location
							in: exception errorCode.
                    ^ self compilationContext failBlock value ]
                ifNil: [ exception pass ]].
	^cm! !

!OpalCompiler methodsFor: 'public access' stamp: 'MarcusDenker 9/5/2013 15:35'!
compile: textOrString 
	
	^self
		source: textOrString;
		compile.! !

!OpalCompiler methodsFor: 'accessing' stamp: 'ClementBera 6/7/2013 09:58'!
compiledMethodTrailer: bytes
	self compilationContext compiledMethodTrailer: bytes! !

!OpalCompiler methodsFor: 'accessing' stamp: 'ClementBera 6/7/2013 09:59'!
context: aContext
	context  := aContext! !

!OpalCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/21/2015 16:55'!
decompileMethod: aCompiledMethod
	^ Smalltalk globals 
		at: #FBDDecompiler  
		ifPresent: [ :decompilerClass | [ decompilerClass new decompile: aCompiledMethod ]
			on: Error 
			do: [ RBMethodNode errorMethodNode: aCompiledMethod selector errorMessage: 'Decompilation failed'.  ] ]
		ifAbsent: [ RBMethodNode errorMethodNode: aCompiledMethod selector errorMessage: 'No decompiler available'. ]

! !

!OpalCompiler methodsFor: 'private' stamp: 'ClementBera 6/7/2013 09:49'!
doSemanticAnalysis
	^[ast doSemanticAnalysisInContext: self compilationContext] 
		on: OCSemanticError 
		do: [ :ex | ex defaultAction. ^ self compilationContext failBlock value ]! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:50'!
environment: anSmallTalkImage
	self compilationContext environment: anSmallTalkImage ! !

!OpalCompiler methodsFor: 'public access' stamp: 'ClementBera 11/18/2014 11:22'!
evaluate
	"Compiles the sourceStream into a parse tree, then generates code into
	 a method. If aContext is not nil, the text can refer to temporaries in that
	 context (the Debugger uses this). If aRequestor is not nil, then it will receive
	 a notify:at: message before the attempt to evaluate is aborted. Finally, the 
	 compiled method is invoked from here via withArgs:executeMethod:, hence
	 the system no longer creates Doit method litter on errors."

	| value selectedSource itsSelection itsSelectionString |
	self class: (context 
				ifNil: [ receiver class ]
				ifNotNil: [ context method methodClass ]).
	self noPattern: true.
	selectedSource := ((self compilationContext requestor respondsTo: #selection)
		and: [ 
			(itsSelection := self compilationContext requestor selection) notNil
				and: [ (itsSelectionString := itsSelection asString) isEmptyOrNil not ] ])
		ifTrue: [ itsSelectionString ]
		ifFalse: [ source ].
	self source: selectedSource.
	value := receiver withArgs: (context ifNil: [ #() ] ifNotNil: [ {context} ]) executeMethod:  self translate generateWithSource.
	self compilationContext logged
		ifTrue: [ Smalltalk globals 
			at: #SystemAnnouncer 
			ifPresent: [ :sysAnn | 
				sysAnn uniqueInstance evaluated: selectedSource contents context: context ] ].
	^ value! !

!OpalCompiler methodsFor: 'accessing' stamp: 'ClementBera 6/7/2013 09:49'!
failBlock: aBlock
	self compilationContext failBlock: aBlock.! !

!OpalCompiler methodsFor: 'public access' stamp: 'MarcusDenker 4/27/2013 19:40'!
format
	^self parse formattedCode.! !

!OpalCompiler methodsFor: 'public access' stamp: 'MarcusDenker 8/28/2013 10:31'!
format: textOrString 
	
	^self
		source: textOrString;
		format! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:55'!
logged: aBoolean
	self compilationContext logged:  aBoolean.! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:55'!
noPattern: aBoolean
	self compilationContext noPattern: aBoolean.
	! !

!OpalCompiler methodsFor: 'public access' stamp: 'MarcusDenker 5/26/2013 09:55'!
options: anOptionsArray
	self compilationContext parseOptions: anOptionsArray! !

!OpalCompiler methodsFor: 'public access' stamp: 'CamilleTeruel 7/29/2014 16:04'!
parse
	| expression selector arguments method |
	self compilationContext noPattern ifFalse: [ ^ self parseMethod ].
	expression := self parseExpression asSequenceNode transformLastToReturn.
	context
		ifNil: [ 
			selector := #DoIt.
			arguments := #() ] 
		ifNotNil: [ 
			selector := #DoItIn:.
			arguments := { RBVariableNode named: 'ThisContext' } ].
	method := RBMethodNode selector: selector arguments: arguments body: expression.
	context ifNotNil: [ method rewriteTempsForContext: context ].
	^ method! !

!OpalCompiler methodsFor: 'public access' stamp: 'MarcusDenker 8/28/2013 15:31'!
parse: textOrString 
	
	^self
		source: textOrString;
		parse! !

!OpalCompiler methodsFor: 'private' stamp: 'MarcusDenker 7/14/2015 12:13'!
parseExpression
	| parseClass |
	
	parseClass := self compilationContext parserClass.

	^self compilationContext optionParseErrors 
		ifTrue: [parseClass parseFaultyExpression: source contents]
		ifFalse: [parseClass parseExpression: source contents]! !

!OpalCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/25/2015 12:36'!
parseLiterals: aString
	^RBParser parseLiterals: aString! !

!OpalCompiler methodsFor: 'private' stamp: 'MarcusDenker 7/14/2015 12:16'!
parseMethod
	| parseClass |
	
	parseClass := self compilationContext parserClass.

	^self compilationContext optionParseErrors 
		ifTrue: [parseClass parseFaultyMethod: source contents]
		ifFalse: [parseClass parseMethod: source contents]! !

!OpalCompiler methodsFor: 'public access' stamp: 'MarcusDenker 7/25/2015 12:36'!
parseSelector: aString 
	"Answer the message selector for the argument, aString, which should parse successfully up to the temporary declaration or the end of the method header."
	
	^[RBParser parseMethodPattern: aString] on: Error do: [nil].! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 5/12/2013 11:20'!
receiver: anObject
	receiver := anObject.! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 10/7/2014 18:12'!
requestor: aRequestor
	self compilationContext requestor: aRequestor.
	self compilationContext interactive: (UIManager default interactiveParserFor: aRequestor).! !

!OpalCompiler methodsFor: 'accessing' stamp: 'MarcusDenker 4/27/2013 12:45'!
source: aString
	source := aString readStream.! !

!OpalCompiler methodsFor: 'public access' stamp: 'IgorStasenko 8/28/2013 10:36'!
translate
	[ self compile ] on: ReparseAfterSourceEditing do: [ :ex |
		self source: ex newSource readStream.
		self compile
	 ] .
	^ ast! !

Object subclass: #CCompilationContext
	instanceVariableNames: 'astTranslatorClass bytecodeGeneratorClass category class compiledMethodTrailer encoderClass environment failBlock interactive logged noPattern options parserClass requestor forSyntaxHighlighting semanticAnalyzerClass astTransformPlugins'
	classVariableNames: 'BytecodeBackend'
	poolDictionaries: ''
	category: 'OpalCompiler-Core-FrontEnd'!

!CCompilationContext commentStamp: 'ClementBera 1/27/2015 13:10' prior: 0!
I am a copy of the CompilationContext.

It is used

-> in the old Compiler so it is independed from Opal
-> in the new Compiler the class CompilationContext parametrizes Opal to use this Context so it can add instance variables to the context.

The second option is a workaround, we will need a copy of Opal to develop itself *or* need to add transactions to the language ;--)!

!CCompilationContext class methodsFor: 'accessing' stamp: 'ClementBera 7/7/2014 10:54'!
bytecodeBackend
	^ BytecodeBackend ifNil: [ self initialize ]! !

!CCompilationContext class methodsFor: 'accessing' stamp: 'ClementBera 7/7/2014 10:55'!
bytecodeBackend: bytecodeSet
	BytecodeBackend := bytecodeSet! !

!CCompilationContext class methodsFor: 'compiler' stamp: 'MarcusDenker 5/26/2013 09:56'!
compiler
	^self compilerClass new
		compilationContextClass: CompilationContext;
		environment: self environment;
		class: self! !

!CCompilationContext class methodsFor: 'instance creation' stamp: 'MarcusDenker 5/26/2013 09:29'!
default 
	^ self new parseOptions: OpalCompiler defaultOptions! !

!CCompilationContext class methodsFor: 'initialize' stamp: 'MarcusDenker 12/17/2015 17:11'!
initialize
	BytecodeBackend := OpalEncoderForV3PlusClosures  ! !

CCompilationContext initialize!

!CCompilationContext methodsFor: 'plugins' stamp: 'MarcusDenker 2/28/2015 15:22'!
addASTTransformationPlugin: aPlugin
	astTransformPlugins add: aPlugin! !

!CCompilationContext methodsFor: 'plugins' stamp: 'MarcusDenker 2/28/2015 15:27'!
astTransformPlugins
	^astTransformPlugins! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 15:47'!
astTranslatorClass
	^ astTranslatorClass ifNil: [ astTranslatorClass := OCASTTranslator ]! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 15:47'!
astTranslatorClass: anObject
	astTranslatorClass := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'ClementBera 1/27/2015 13:09'!
bytecodeGeneratorClass
	^ bytecodeGeneratorClass ifNil: [ bytecodeGeneratorClass := IRBytecodeGenerator ]! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 15:48'!
bytecodeGeneratorClass: anObject
	bytecodeGeneratorClass := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
category
	^ category! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
category: anObject
	category := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
class: anObject
	class := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'ClementBera 6/7/2013 10:00'!
compiledMethodTrailer
	^ compiledMethodTrailer ifNil: [ compiledMethodTrailer := CompiledMethodTrailer empty ]! !

!CCompilationContext methodsFor: 'accessing' stamp: 'ClementBera 6/7/2013 09:56'!
compiledMethodTrailer: anObject
	compiledMethodTrailer := anObject! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 5/26/2013 09:29'!
compilerOptions: anArray
	self parseOptions: anArray! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 5/26/2013 09:29'!
doesNotUnderstand: message

	(message selector isUnary and: [ message selector beginsWith: 'opt'] )
		ifTrue: [ ^ options includes: message selector ].
		
	^ super doesNotUnderstand: message! !

!CCompilationContext methodsFor: 'accessing' stamp: 'ClementBera 1/28/2015 09:24'!
encoderClass
	^ encoderClass ifNil: [ encoderClass := BytecodeBackend ]! !

!CCompilationContext methodsFor: 'accessing' stamp: 'ClementBera 1/28/2015 09:21'!
encoderClass: anObject
	encoderClass := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
environment
	^ environment! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
environment: anObject
	environment := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
failBlock
	^ failBlock! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
failBlock: anObject
	failBlock := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 11/4/2015 11:57'!
forSyntaxHighlighting
		^ forSyntaxHighlighting ifNil: [ ^false ]! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 11/4/2015 11:56'!
forSyntaxHighlighting: aBoolean
	forSyntaxHighlighting := aBoolean! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
getClass
	^ class! !

!CCompilationContext methodsFor: 'initialization' stamp: 'MarcusDenker 2/28/2015 15:21'!
initialize
	options := Set new.
	astTransformPlugins := OrderedCollection new.! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
interactive
	^ interactive ifNil: [ false ]! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
interactive: anObject
	interactive := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
logged
	^logged ifNil: [ false ].! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
logged: anObject
	logged := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
noPattern
	^noPattern ifNil: [ false ].! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
noPattern: anObject
	noPattern := anObject! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:11'!
optionInlineAndOr
	^ options includes: #optionInlineAndOr
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:11'!
optionInlineCase
	^ options includes: #optionInlineCase
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:11'!
optionInlineIf
	^ options includes: #optionInlineIf
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:11'!
optionInlineIfNil
	^ options includes: #optionInlineIfNil
! !

!CCompilationContext methodsFor: 'options' stamp: 'ClementBera 10/27/2014 11:25'!
optionInlineNone
	^ options includes: #optionInlineNone
! !

!CCompilationContext methodsFor: 'options' stamp: 'KevinLanvin 7/17/2015 14:15'!
optionInlineRepeat
	^ options includes: #optionInlineRepeat
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 9/30/2013 14:42'!
optionInlineTimesRepeat
	^ options includes: #optionInlineTimesRepeat
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:11'!
optionInlineToDo
	^ options includes: #optionInlineToDo
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:12'!
optionInlineWhile
	^ options includes: #optionInlineWhile
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:12'!
optionLongIvarAccessBytecodes
	^ options includes: #optionLongIvarAccessBytecodes
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:12'!
optionOptimizeIR
	^ options includes: #optionOptimizeIR
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/21/2015 14:21'!
optionParseErrors
	^ options includes: #optionParseErrors
! !

!CCompilationContext methodsFor: 'options' stamp: 'MarcusDenker 11/23/2015 17:10'!
parseOptions: optionsArray
	options parseOptions: optionsArray! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 7/25/2015 12:36'!
parserClass
	^ parserClass ifNil: [ parserClass := RBParser ]! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 15:50'!
parserClass: anObject
	parserClass := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
requestor
	^ requestor! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/26/2013 09:29'!
requestor: anObject
	requestor := anObject! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 11/4/2015 12:02'!
scope
	| newScope |

	newScope := OCClassScope for: class.
	requestor ifNotNil: [
		"the requestor is allowed to manage variables, the workspace is using it to auto-define vars"  
		newScope := (OCRequestorScope new
			compilationContext: self;
			requestor: requestor) outerScope: newScope].
	^newScope
	! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 15:50'!
semanticAnalyzerClass
	^ semanticAnalyzerClass ifNil: [ semanticAnalyzerClass := OCASTSemanticAnalyzer  ]! !

!CCompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 15:51'!
semanticAnalyzerClass: anObject
	semanticAnalyzerClass := anObject! !

Object subclass: #CompilationContext
	instanceVariableNames: 'requestor failBlock noPattern class category logged interactive options environment parserClass semanticAnalyzerClass astTranslatorClass bytecodeGeneratorClass compiledMethodTrailer forSyntaxHighlighting encoderClass astTransformPlugins'
	classVariableNames: 'BytecodeBackend WarningAllowed'
	poolDictionaries: ''
	category: 'OpalCompiler-Core-FrontEnd'!

!CompilationContext commentStamp: '<historical>' prior: 0!
The compilationContext holds all information that is needed in the whole compiler chain.

!

!CompilationContext class methodsFor: 'accessing' stamp: 'ClementBera 7/7/2014 10:55'!
bytecodeBackend
	^ BytecodeBackend ifNil: [ self initialize ]! !

!CompilationContext class methodsFor: 'accessing' stamp: 'ClementBera 7/7/2014 10:55'!
bytecodeBackend: bytecodeSet
	BytecodeBackend := bytecodeSet! !

!CompilationContext class methodsFor: 'compiler' stamp: 'MarcusDenker 5/26/2013 09:52'!
compiler
	^self compilerClass new
		compilationContextClass: CCompilationContext;
		environment: self environment;
		class: self! !

!CompilationContext class methodsFor: 'instance creation' stamp: 'MarcusDenker 5/13/2013 14:33'!
default 
	^ self new parseOptions: OpalCompiler defaultOptions! !

!CompilationContext class methodsFor: 'initialize' stamp: 'MarcusDenker 12/17/2015 17:11'!
initialize
	BytecodeBackend := OpalEncoderForV3PlusClosures  ! !

CompilationContext initialize!

!CompilationContext methodsFor: 'plugins' stamp: 'MarcusDenker 2/28/2015 15:21'!
addASTTransformationPlugin: aPlugin
	astTransformPlugins add: aPlugin! !

!CompilationContext methodsFor: 'plugins' stamp: 'MarcusDenker 2/28/2015 15:27'!
astTransformPlugins
	^astTransformPlugins! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 11:28'!
astTranslatorClass
	^ astTranslatorClass ifNil: [ astTranslatorClass := OCASTTranslator ]! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 11:27'!
astTranslatorClass: anObject
	astTranslatorClass := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'ClementBera 1/27/2015 13:09'!
bytecodeGeneratorClass
	^ bytecodeGeneratorClass ifNil: [ bytecodeGeneratorClass := IRBytecodeGenerator ]! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 11:27'!
bytecodeGeneratorClass: anObject
	bytecodeGeneratorClass := anObject! !

!CompilationContext methodsFor: 'backward compatibility' stamp: 'StephaneDucasse 5/31/2015 07:14'!
category
	"Please favor protocol instead of category. We want to have method protocol and class package and tag = a category"
	^ category! !

!CompilationContext methodsFor: 'backward compatibility' stamp: 'StephaneDucasse 5/31/2015 07:14'!
category: anObject
	"Please favor protocol: anObject instead of category:. We want to have method protocol and class package and tag = a category"
	category := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/7/2013 08:50'!
class: anObject
	class := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'ClementBera 6/7/2013 10:00'!
compiledMethodTrailer
	^ compiledMethodTrailer ifNil: [ compiledMethodTrailer := CompiledMethodTrailer empty ]! !

!CompilationContext methodsFor: 'accessing' stamp: 'ClementBera 6/7/2013 09:57'!
compiledMethodTrailer: anObject
	compiledMethodTrailer := anObject! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 5/14/2013 13:52'!
compilerOptions: anArray
	self parseOptions: anArray! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 5/10/2013 10:54'!
doesNotUnderstand: message

	(message selector isUnary and: [ message selector beginsWith: 'opt'] )
		ifTrue: [ ^ options includes: message selector ].
		
	^ super doesNotUnderstand: message! !

!CompilationContext methodsFor: 'accessing' stamp: 'ClementBera 1/27/2015 16:33'!
encoderClass
	^ encoderClass ifNil: [ encoderClass := BytecodeBackend ]! !

!CompilationContext methodsFor: 'accessing' stamp: 'ClementBera 1/27/2015 16:33'!
encoderClass: anObject
	encoderClass := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/13/2013 14:12'!
environment
	^ environment! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/13/2013 14:12'!
environment: anObject
	environment := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/7/2013 08:50'!
failBlock
	^ failBlock! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/7/2013 08:50'!
failBlock: anObject
	failBlock := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 11/4/2015 11:57'!
forSyntaxHighlighting
	^ forSyntaxHighlighting ifNil: [ ^false ]! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 11/4/2015 11:57'!
forSyntaxHighlighting: aBoolean
	forSyntaxHighlighting := aBoolean! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/12/2013 11:25'!
getClass
	^ class! !

!CompilationContext methodsFor: 'initialization' stamp: 'MarcusDenker 2/28/2015 15:21'!
initialize
	options := Set new.
	astTransformPlugins := OrderedCollection new.! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/13/2013 14:54'!
interactive
	^ interactive ifNil: [ false ]! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/7/2013 10:01'!
interactive: anObject
	interactive := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/12/2013 11:04'!
logged
	^logged ifNil: [ false ].! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/7/2013 08:50'!
logged: anObject
	logged := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/12/2013 11:00'!
noPattern
	^noPattern ifNil: [ false ].! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/7/2013 08:50'!
noPattern: anObject
	noPattern := anObject! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:12'!
optionInlineAndOr
	^ options includes: #optionInlineAndOr
! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:13'!
optionInlineCase
	^ options includes: #optionInlineCase
! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:13'!
optionInlineIf
	^ options includes: #optionInlineIf
! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:13'!
optionInlineIfNil
	^ options includes: #optionInlineIfNil
! !

!CompilationContext methodsFor: 'options' stamp: 'ClementBera 10/27/2014 11:25'!
optionInlineNone
	^ options includes: #optionInlineNone
! !

!CompilationContext methodsFor: 'options' stamp: 'KevinLanvin 7/17/2015 14:15'!
optionInlineRepeat
	^ options includes: #optionInlineRepeat
! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 9/30/2013 14:43'!
optionInlineTimesRepeat
	^ options includes: #optionInlineTimesRepeat
! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:13'!
optionInlineToDo
	^ options includes: #optionInlineToDo
! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:13'!
optionInlineWhile
	^ options includes: #optionInlineWhile
! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:13'!
optionLongIvarAccessBytecodes
	^ options includes: #optionLongIvarAccessBytecodes
! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/22/2013 16:13'!
optionOptimizeIR
	^ options includes: #optionOptimizeIR
! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 7/21/2015 14:21'!
optionParseErrors
	^ options includes: #optionParseErrors! !

!CompilationContext methodsFor: 'options' stamp: 'MarcusDenker 11/23/2015 17:10'!
parseOptions: optionsArray
	options parseOptions: optionsArray! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 7/25/2015 12:36'!
parserClass
	^ parserClass ifNil: [ parserClass := RBParser ]! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 11:27'!
parserClass: anObject
	parserClass := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'StephaneDucasse 5/31/2015 07:13'!
protocol
	^ category! !

!CompilationContext methodsFor: 'accessing' stamp: 'StephaneDucasse 5/31/2015 07:13'!
protocol: anObject
	category := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/7/2013 08:50'!
requestor
	^ requestor! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/7/2013 08:50'!
requestor: anObject
	requestor := anObject! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 11/4/2015 12:02'!
scope
	| newScope |

	newScope := OCClassScope for: class.
	requestor ifNotNil: [
		"the requestor is allowed to manage variables, the workspace is using it to auto-define vars"  
		newScope := (OCRequestorScope new 
			compilationContext: self;
			requestor: requestor) outerScope: newScope].
	^newScope
	! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 11:30'!
semanticAnalyzerClass
	^ semanticAnalyzerClass ifNil: [ semanticAnalyzerClass := OCASTSemanticAnalyzer  ]! !

!CompilationContext methodsFor: 'accessing' stamp: 'MarcusDenker 5/27/2013 11:27'!
semanticAnalyzerClass: anObject
	semanticAnalyzerClass := anObject! !

Object subclass: #DebuggerMethodMapOpal
	instanceVariableNames: 'methodNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-FrontEnd'!

!DebuggerMethodMapOpal commentStamp: '<historical>' prior: 0!
I provide helper methods deadling with

-> pc to text mapping
-> temporary variables for contexts
-> reading and setting tempary variables

All methods here should be moved to MethodContext.!

!DebuggerMethodMapOpal class methodsFor: 'instance creation' stamp: 'MarcusDenker 11/16/2012 12:11'!
forMethod: aMethod "<CompiledMethod>"
	"Answer a DebuggerMethodMap suitable for debugging activations of aMethod"
	^self new forMethod: aMethod
	
				! !

!DebuggerMethodMapOpal methodsFor: 'initialize-release' stamp: 'MarcusDenker 5/13/2013 13:21'!
forMethod: aCompiledMethod 
	methodNode := aCompiledMethod ast! !

!DebuggerMethodMapOpal methodsFor: 'public' stamp: 'MarcusDenker 12/17/2012 17:20'!
namedTempAt: index in: aContext
	"Answer the value of the temp at index in aContext where index is relative
	 to the array of temp names answered by tempNamesForContext:"

	| name |	
	name := (self tempNamesForContext: aContext) at: index.
	^self tempNamed: name in: aContext.! !

!DebuggerMethodMapOpal methodsFor: 'public' stamp: 'MarcusDenker 12/17/2012 17:21'!
namedTempAt: index put: aValue in: aContext
	"Assign the value of the temp at index in aContext where index is relative
	 to the array of temp names answered by tempNamesForContext:.
	 If the value is a copied value we also need to set it along the lexical chain."
	
	| name |	
	name := (self tempNamesForContext: aContext) at: index.
	^self tempNamed: name in: aContext put: aValue.! !

!DebuggerMethodMapOpal methodsFor: 'public' stamp: 'MarcusDenker 1/24/2013 14:12'!
rangeForPC: aPC
	"return the debug highlight for aPC"
	
	^self rangeForPC: aPC contextIsActiveContext: false
	! !

!DebuggerMethodMapOpal methodsFor: 'public' stamp: 'MarcusDenker 4/19/2013 08:32'!
rangeForPC: aPC contextIsActiveContext: contextIsActive
	"return the debug highlight for aPC"
	| pc |
	
	"When on the top of the stack the pc is pointing to right instruction, but deeper in the stack
	the pc was already advanced one bytecode, so we need to go back this one bytecode, which
	can consist of multiple bytes. But on IR, we record the *last* bytecode offset as the offset of the
	IR instruction, which means we can just go back one"

	pc := contextIsActive ifTrue: [aPC] ifFalse: [aPC - 1].
	^(methodNode sourceNodeForPC:  pc) debugHighlightRange
	! !

!DebuggerMethodMapOpal methodsFor: 'public' stamp: 'GuillermoPolito 4/9/2015 17:36'!
tempNamed: name in: aContext
	"Answer the value of the temp with name in aContext"
	
	| scope var |
	scope := aContext sourceNode scope.
	var := scope lookupVar: name.
	^var searchFromContext: aContext scope: scope.
		! !

!DebuggerMethodMapOpal methodsFor: 'public' stamp: 'MarcusDenker 4/17/2013 22:48'!
tempNamed: name in: aContext put: aValue
	"Assign the value of the temp with name in aContext
	 If the value is a copied value we also need to set it along the lexical chain."

	| scope var |
	scope := aContext sourceNode scope.
	var := scope lookupVar: name.
	^var writeFromContext: aContext scope: scope value: aValue.
	
	
	! !

!DebuggerMethodMapOpal methodsFor: 'public' stamp: 'MarcusDenker 4/17/2013 22:49'!
tempNamesForContext: aContext
	"Answer an Array of all the temp names in scope in aContext starting with
	 the home's first local (the first argument or first temporary if no arguments)."
	
	^ aContext sourceNode scope allTempNames.! !

Object subclass: #IRBuilder
	instanceVariableNames: 'ir currentScope jumpBackTargetStacks jumpAheadStacks currentSequence sourceMapNodes sourceMapByteIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Manipulation'!

!IRBuilder commentStamp: '<historical>' prior: 0!
I provide a simple interface for constructing an IRMethod.  For example, to create an ir method that compares first instVar to first arg and returns 'yes' or 'no' (same example as in BytecodeGenerator), do:

	IRBuilder new
		numArgs: 1;
		addTemps: #(a z);
		pushReceiver;
		pushInstVar: 1;
		pushTemp: #a;
		send: #>;
		jumpAheadTo: #else if: false;
		pushLiteral: 'yes';
		returnTop;
		jumpAheadTarget: #else;
		pushLiteral: 'no';
		returnTop;
		ir

Sending #compiledMethod to an ir method will generate its compiledMethod.  Sending #methodNode to it will decompile to its parse tree.
!

!IRBuilder class methodsFor: 'builder api' stamp: 'MarcusDenker 7/9/2013 16:09'!
buildIR: aBlock
	^(aBlock value: self new) ir.! !

!IRBuilder class methodsFor: 'builder api' stamp: 'MarcusDenker 7/9/2013 16:07'!
buildMethod: aBlock
	^(self buildIR: aBlock) compiledMethod! !

!IRBuilder methodsFor: 'private' stamp: 'ToonVerwaest 3/31/2011 13:17'!
add: instr
	
	"Associate instr with current parse node or byte range"
	instr sourceNode: self sourceNode.
	instr bytecodeIndex: self sourceByteIndex.
	^ currentSequence add: instr! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 10/12/2010 12:19'!
addBlockReturnTopIfRequired
	"If the current sequence is empty this means that there was a returntop before 
	then since there is no more stmts we do not need a blockreturntop"
	
	"cant we optimize this away later? Then the frontend can always just add a return...."
	
	| predecessors |
	self flag: 'cant we do this automatically.... frontend always adds return, we ignore it if there is a ret method before?'.
	
	predecessors := ir predecessorsOf: currentSequence.
	(currentSequence isEmpty and: [(predecessors isEmpty) or: [((ir predecessorsOf: currentSequence) 
								anySatisfy: [:each | (each last isBlockReturnTop not) and: [(each last isReturn) 
												or: [(each size > 1) and: [(each at: each size -1) isReturn] ]]])] ])
							ifTrue: [self popScope]
							ifFalse: [self blockReturnTop ]! !

!IRBuilder methodsFor: 'decompiling' stamp: 'ajh 6/22/2003 14:44'!
addJumpBackTarget: label to: sequence

	(jumpBackTargetStacks at: label ifAbsentPut: [OrderedCollection new])
		addLast: sequence! !

!IRBuilder methodsFor: 'initialize' stamp: 'ClementBera 7/16/2014 15:03'!
addLiteral: aLiteral
	"Add this literal at the end of the literal array if there is space left"
	aLiteral ifNil: [ ^ self ].
	ir addAdditionalLiteral: aLiteral.! !

!IRBuilder methodsFor: 'initialize' stamp: 'JorgeRessia 5/6/2010 11:04'!
addPragma: aPragma
	^ir addPragma: aPragma! !

!IRBuilder methodsFor: 'initialize' stamp: 'jb 4/2/2010 11:32'!
addTemp: tempKey
	
	self addTemps: {tempKey}! !

!IRBuilder methodsFor: 'initialize' stamp: 'MarcusDenker 1/23/2014 17:17'!
addTemps: newKeys
	| i offset |
	offset := self currentScope tempMap size.
	i := 1.
	newKeys do: [:key |
		self  currentScope tempMap at: key ifAbsentPut: [i:=i+1.offset + i - 1].
	].
! !

!IRBuilder methodsFor: 'initialize' stamp: 'MarcusDenker 6/6/2012 13:38'!
additionalLiterals:  literals
	"Add this literal at the end of the literal array if there is space left"
	ir addAdditionalLiterals: literals.! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 12/14/2012 10:43'!
blockReturnTop
	| retInst |
	
	retInst := IRInstruction blockReturnTop.
	self add: retInst.
	self startNewSequence.
	retInst  successor: currentSequence.
	self popScope.! !

!IRBuilder methodsFor: 'accessing' stamp: 'MarcusDenker 5/18/2013 17:37'!
compilationContext
	^ir compilationContext ! !

!IRBuilder methodsFor: 'initialize' stamp: 'MarcusDenker 5/14/2013 10:07'!
compilationContext: aCompilationContext
	ir compilationContext: aCompilationContext! !

!IRBuilder methodsFor: 'initialize' stamp: 'MarcusDenker 5/19/2011 13:49'!
createTempVectorNamed: name withVars: anArray
	
	"self addVectorTemps: anArray."
	self addTemp: name.
	self add: (IRInstruction createTempVectorNamed: name withVars: anArray).
! !

!IRBuilder methodsFor: 'scopes' stamp: 'MarcusDenker 4/13/2010 14:20'!
currentScope 
	^currentScope top! !

!IRBuilder methodsFor: 'initialization' stamp: 'MarcusDenker 6/13/2012 14:12'!
initialize
	ir := IRMethod new.
	jumpAheadStacks := IdentityDictionary new.
	jumpBackTargetStacks := IdentityDictionary new.
	sourceMapNodes := OrderedCollection new.	"stack"
	currentScope := Stack new.
	self pushScope: ir.
	
	"Leave an empty sequence up front (guaranteed not to be in loop)"
	ir startSequence: ((IRSequence orderNumber: 0) method:ir).
	currentSequence := (IRSequence orderNumber: 1) method:ir.
	ir startSequence add:
		(IRJump new
			destination: currentSequence;
			bytecodeIndex: sourceMapByteIndex;
			yourself).
! !

!IRBuilder methodsFor: 'results' stamp: 'MarcusDenker 11/6/2014 15:43'!
ir

	^ ir optimize! !

!IRBuilder methodsFor: 'accessing' stamp: 'MarcusDenker 5/14/2013 17:10'!
irPrimitive: primNode

	ir irPrimitive: primNode! !

!IRBuilder methodsFor: 'instructions' stamp: 'ToonVerwaest 3/27/2011 17:17'!
jumpAheadTarget: labelSymbol
	"Pop latest jumpAheadTo: with this labelSymbol and have it point to this new instruction sequence"

	| jumpInstr |
	self startNewSequence.
	jumpInstr := (jumpAheadStacks at: labelSymbol ifAbsent: [
			self error: 'Missing jumpAheadTo: ', labelSymbol printString]) removeLast.
	jumpInstr destination: currentSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'JB 8/1/2010 14:56'!
jumpAheadTo: labelSymbol
	"Jump to the sequence that will be created when jumpAheadTarget: labelSymbol is sent to self.  This is and its corresponding target is only good for one use.  Other jumpAheadTo: with the same label will be put on a stack and superceed existing ones until its jumpAheadTarget: is called."

	"jumpAheadTarget: label will pop this and replace destination with its basic block"

	(jumpAheadStacks at: labelSymbol ifAbsentPut: [OrderedCollection new])
		addLast: (self add: IRJump new).
	self startNewSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/22/2003 14:44'!
jumpAheadTo: labelSymbol if: boolean
	"Conditional jump to the sequence that will be created when jumpAheadTarget: labelSymbol is sent to self.  This and its corresponding target is only good for one use.  Other jumpAheadTo:... with the same label will be put on a stack and superceed existing ones until its jumpAheadTarget: is called."

	| instr |
	"jumpAheadTarget: label will pop this and replace destination with its basic block"
	(jumpAheadStacks at: labelSymbol ifAbsentPut: [OrderedCollection new])
		addLast: (instr := self add: (IRJumpIf new boolean: boolean)).
	self startNewSequence.
	instr otherwise: currentSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/22/2003 14:44'!
jumpBackTarget: labelSymbol
	"Remember this basic block for a future jumpBackTo: labelSymbol.  Stack up remembered targets with same name and remove them from stack for each jumpBackTo: called with same name."

	self startNewSequence.
	(jumpBackTargetStacks at: labelSymbol ifAbsentPut: [OrderedCollection new])
		addLast: currentSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 6/19/2012 13:19'!
jumpBackTo: labelSymbol
	"Pop last remembered position with this label and write an unconditional jump to it"

	| sequence jump |
	sequence := (jumpBackTargetStacks at: labelSymbol ifAbsent: [self error: 'Missing jumpBackTarget: ', labelSymbol printString]) removeLast.
	jump := IRJump new destination: sequence.
	self add: jump.
	self startNewSequence.
	jump successor: currentSequence.
	! !

!IRBuilder methodsFor: 'mapping' stamp: 'ajh 3/13/2003 13:17'!
mapToByteIndex: index
	"decompiling"

	sourceMapByteIndex := index! !

!IRBuilder methodsFor: 'mapping' stamp: 'ajh 6/22/2003 14:45'!
mapToNode: object
	"new instructions will be associated with object"

	sourceMapNodes addLast: object! !

!IRBuilder methodsFor: 'initialize' stamp: 'MarcusDenker 11/19/2012 17:16'!
numArgs: anInteger
	ir numArgs: anInteger.
	ir sourceNode: self sourceNode.! !

!IRBuilder methodsFor: 'mapping' stamp: 'ajh 6/22/2003 14:25'!
popMap

	sourceMapNodes removeLast! !

!IRBuilder methodsFor: 'scopes' stamp: 'JorgeRessia 5/20/2010 09:58'!
popScope
	currentScope pop.! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 3/10/2003 01:09'!
popTop

	self add: IRInstruction popTop! !

!IRBuilder methodsFor: 'accessing' stamp: 'md 7/10/2005 22:37'!
properties: aDict
	ir properties: aDict! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 9/3/2015 13:30'!
pushClosureCopyCopiedValues: copiedValuesNames args: args jumpTo: aJumpLabel
	
	|  irInstruction |
	
	irInstruction := IRInstruction pushClosureCopyCopiedValues: copiedValuesNames args: args.
	self add: irInstruction.
	(jumpAheadStacks at: aJumpLabel ifAbsentPut: [OrderedCollection new]) addLast: irInstruction.
	self startNewSequence.
	irInstruction blockSequence: currentSequence.
	self pushScope: irInstruction.
	self addTemps: args.
	self addTemps: copiedValuesNames.


	^irInstruction! !

!IRBuilder methodsFor: 'instructions' stamp: 'jre 9/29/2009 15:39'!
pushConsArray: size

	self add: (IRInstruction pushConsArray: size)! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 3/10/2003 01:09'!
pushDup

	self add: IRInstruction pushDup! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 8/19/2010 16:12'!
pushInstVar: index

	self add: (IRInstruction pushInstVar: index).! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 8/18/2010 19:55'!
pushLiteral: object

	self add: (IRInstruction pushLiteral: object)! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 8/18/2010 19:55'!
pushLiteralVariable: object

	self add: (IRInstruction pushLiteralVariable: object)! !

!IRBuilder methodsFor: 'instructions' stamp: 'jre 9/29/2009 15:39'!
pushNewArray: size

	self add: (IRInstruction pushNewArray: size)! !

!IRBuilder methodsFor: 'instructions' stamp: 'md 4/21/2005 11:38'!
pushReceiver

	self add: (IRInstruction pushReceiver)! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 6/13/2012 14:17'!
pushRemoteTemp: name inVector: nameOfVector

	^self add: (IRInstruction pushRemoteTemp: name inVectorAt: nameOfVector)! !

!IRBuilder methodsFor: 'scopes' stamp: 'MarcusDenker 8/18/2010 19:55'!
pushScope: anIRBlockOrMethod

	currentScope push: anIRBlockOrMethod! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 12/14/2012 11:51'!
pushTemp: aSelector

	^ self add: (IRInstruction pushTemp: aSelector)! !

!IRBuilder methodsFor: 'instructions' stamp: 'md 4/21/2005 12:06'!
pushThisContext

	self add: (IRInstruction pushThisContext)! !

!IRBuilder methodsFor: 'instructions' stamp: 'JorgeRessia 5/20/2010 07:25'!
returnTop

	self add: IRInstruction returnTop.
	self startNewSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 6/13/2012 14:19'!
send: selector

	^self add: (IRInstruction send: selector)! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 6/13/2012 14:19'!
send: selector toSuperOf: behavior

	^self add: (IRInstruction send: selector toSuperOf: behavior)! !

!IRBuilder methodsFor: 'mapping' stamp: 'MarcusDenker 8/20/2010 08:07'!
sourceByteIndex

	^ sourceMapByteIndex! !

!IRBuilder methodsFor: 'mapping' stamp: 'MarcusDenker 11/19/2012 17:14'!
sourceNode
	^ sourceMapNodes
		ifEmpty: [nil]
		ifNotEmpty: [sourceMapNodes last]! !

!IRBuilder methodsFor: 'private' stamp: 'HenrikSperreJohansen 10/13/2015 15:09'!
startNewSequence
	"End current instruction sequence and start a new sequence to add instructions to.  If ending block just falls through to new block then add an explicit jump to it so they stay linked"

	| newSequence | 
	currentSequence ifEmpty: [^ self].	"block is still empty, continue using it"
	newSequence := IRSequence orderNumber: currentSequence orderNumber + 1.
	newSequence method: ir.

	currentSequence last transitionsToNextSequence
		ifFalse: [ self add: (IRJump new destination: newSequence)].
	self currentScope isPushClosureCopy ifTrue: [self currentScope lastBlockSequence: currentSequence].
	currentSequence := newSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 6/13/2012 14:18'!
storeInstVar: name

	^self add: (IRInstruction storeInstVar: name).! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 6/13/2012 14:18'!
storeIntoLiteralVariable: name
	
	^self add: (IRInstruction storeIntoLiteralVariable: name)! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 6/13/2012 14:19'!
storeRemoteTemp: name inVector: nameOfVector

	^self add: (IRInstruction storeRemoteTemp: name inVectorAt: nameOfVector)! !

!IRBuilder methodsFor: 'instructions' stamp: 'MarcusDenker 6/13/2012 14:19'!
storeTemp: aSymbol

	^self add: (IRInstruction storeTemp: aSymbol)! !

!IRBuilder methodsFor: 'decompiling' stamp: 'ajh 3/21/2003 01:48'!
testJumpAheadTarget: label

	jumpAheadStacks at: label ifPresent: [:stack |
		[stack isEmpty] whileFalse: [self jumpAheadTarget: label]
	]! !

IRBuilder subclass: #IRReconstructor
	instanceVariableNames: 'temps remoteTemps closureCopiedValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Bytecode'!

!IRReconstructor commentStamp: '<historical>' prior: 0!
I am a specialized IRBuilder for the decompiler!

!IRReconstructor methodsFor: 'instructions' stamp: 'MarcusDenker 6/8/2012 13:53'!
blockReturnTop
	self fixPushNilsForTemps.
	^ super blockReturnTop! !

!IRReconstructor methodsFor: 'initialize' stamp: 'MarcusDenker 5/19/2011 13:50'!
createTempVectorNamed: name withVars: anArray
	" Don't add the temp yet, we only know it's index at the end of the block or method "
	"self addVectorTemps: anArray".
	" Update the byte index to point before the pushing of the new vector "
	sourceMapByteIndex := sourceMapByteIndex - 2.
	self add: (IRInstruction createTempVectorNamed: name withVars: anArray)! !

!IRReconstructor methodsFor: 'accessors' stamp: 'MarcusDenker 6/8/2012 15:24'!
currentSequence
	^currentSequence ! !

!IRReconstructor methodsFor: 'accessors' stamp: 'MarcusDenker 6/8/2012 15:25'!
currentSequence: aSeq
	currentSequence := aSeq! !

!IRReconstructor methodsFor: 'removing' stamp: 'MarcusDenker 6/8/2012 13:53'!
fixPushNilsForTemps
	" There are pushConstant: nil in the beginning of the blocksequence for all of the defined temps.
	  We got these pushConstant: nil in. Now our closure will generate them again, meaning we will double
	  the number of pushConstant: nil in the final block. To avoid this, we strip the ones we got in from the IR.  "

	| blocksequence |
	blocksequence := self currentScope blockSequence sequence.
	self currentScope definedTemps do: [ :temp | blocksequence removeFirst ]. 
	! !

!IRReconstructor methodsFor: 'initialization' stamp: 'ToonVerwaest 3/28/2011 00:05'!
initialize
	temps := Dictionary new.
	remoteTemps := Dictionary new.
	closureCopiedValues := Dictionary new.
	sourceMapByteIndex := 0.
	super initialize.! !

!IRReconstructor methodsFor: 'testing' stamp: 'MarcusDenker 5/12/2011 13:40'!
isLastClosureInstruction
	| nextJumps |
	nextJumps := jumpAheadStacks at: sourceMapByteIndex + 1 ifAbsent: [ ^ false ].
	^ nextJumps anySatisfy: [ :anOrigin | anOrigin = self currentScope ]! !

!IRReconstructor methodsFor: 'instructions' stamp: 'MarcusDenker 6/8/2012 13:46'!
pushClosureCopyCopiedValues: copiedValuesNames args: args jumpTo: aJumpLabel
	| anInstruction |
	anInstruction := super pushClosureCopyCopiedValues: copiedValuesNames args: args jumpTo: aJumpLabel.
	"remove pushed nils of local temps"
	anInstruction copiedValues withIndexDo: [ :aValue :index |
		self rememberReference: anInstruction -> index to: aValue in: closureCopiedValues ]! !

!IRReconstructor methodsFor: 'instructions' stamp: 'ToonVerwaest 3/27/2011 15:18'!
pushRemoteTemp: name inVector: nameOfVector
	| anInstruction |
	anInstruction := super pushRemoteTemp: name inVector: nameOfVector.
	self rememberReference: anInstruction to: nameOfVector in: remoteTemps.! !

!IRReconstructor methodsFor: 'instructions' stamp: 'ToonVerwaest 3/27/2011 15:20'!
pushTemp: aSelector
	| anInstruction |
	anInstruction := super pushTemp: aSelector.
	self rememberReference: anInstruction to: aSelector in: temps.! !

!IRReconstructor methodsFor: 'remapping' stamp: 'ToonVerwaest 3/27/2011 15:22'!
remapTemp: aTemp toRemote: aRemote
	(temps removeKey: aTemp ifAbsent: [ #() ])
		do: [ :tempAccess |
			tempAccess name: aRemote.
			self rememberReference: tempAccess to: aRemote in: temps ].
		
	(remoteTemps removeKey: aTemp ifAbsent: [ #() ])
		do: [ :tempAccess |
			tempAccess tempVectorName: aRemote.
			self rememberReference: tempAccess to: aRemote in: remoteTemps. ].

	(closureCopiedValues removeKey: aTemp ifAbsent: [ #() ])
		do: [ :aClosureAndIndex | |closure index|
			closure := aClosureAndIndex key.
			index := aClosureAndIndex value.
			closure copiedValues at: index put: aRemote.
			closure tempMap at: aRemote put: (closure tempMap removeKey: aTemp).
			self rememberReference: aClosureAndIndex to: aRemote in: closureCopiedValues. ].! !

!IRReconstructor methodsFor: 'remapping' stamp: 'ToonVerwaest 3/27/2011 15:19'!
rememberReference: anInstruction to: name in: dictionary
	(dictionary at: name ifAbsentPut: [ OrderedCollection new ])
		add: anInstruction! !

!IRReconstructor methodsFor: 'removing' stamp: 'ToonVerwaest 3/27/2011 18:09'!
removeLast: n
	" Make the address of the instruction be the address of the first removed instruction. "
	sourceMapByteIndex := sourceMapByteIndex - n.
	^ (currentSequence removeLast: n) collect: [ :node |
		node isTemp ifFalse: [ self error: 'Should only remove temp accesses!!' ].
		node name ]! !

!IRReconstructor methodsFor: 'instructions' stamp: 'MarcusDenker 5/19/2011 14:21'!
storeRemoteTemp: name inVector: nameOfVector
	| anInstruction |
	anInstruction := super storeRemoteTemp: name inVector: nameOfVector.
	self rememberReference: anInstruction to: nameOfVector in: remoteTemps.! !

!IRReconstructor methodsFor: 'instructions' stamp: 'ToonVerwaest 3/27/2011 15:20'!
storeTemp: aSelector
	| anInstruction |
	anInstruction := super storeTemp: aSelector.
	self rememberReference: anInstruction to: aSelector in: temps.! !

Object subclass: #IRBytecodeGenerator
	instanceVariableNames: 'encoder seqOrder orderSeq seqBytes jumps literals lastLiteral currentSeqId currentSeqNum bytes lastSpecialReturn primitiveBytes instrMaps instrMap stacks stack numArgs properties numberOfTemps additionalLiterals forceLongForm primNumber encoderClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Bytecode'!

!IRBytecodeGenerator commentStamp: 'ClementBera 1/27/2015 13:07' prior: 0!
Handles the byte code generation of jumps, literals and similar things. Byte code independent. The encoder is bytecode dependent.

I generate bytecodes in response to 'instructions' messages being sent to me.  I rewrite jumps at the end so their jump offsets are correct (see #bytecodes).  For example, to create a compiled method that compares first instVar to first arg and returns 'yes' or 'no' (same example as in IRBuilder), do:

	BytecodeGenerator new
		numArgs: 1;
		pushInstVar: 1;
		pushTemp: 1;
		send: #>;
		if: false goto: #else;
		pushLiteral: 'yes';
		returnTop;
		label: #else;
		pushLiteral: 'no';
		returnTop;
		compiledMethod

You can send #ir to the compiledMethod to decompile to its IRMethod, and you can send #methodNode to either to decompile to its parse tree.


Instance Variables
	additionalLiterals:		<OCLiteralSet> Those are literals evaluated for effect and optimized control flow messages selectors used in the method in order to be able to do sendersOf: on these literals with success.
	bytes:		<OrderedCollection of bytes> current sequence of bytecodes being written 
	encoder:		<BytecodeEncoder> Set the one you need depending on which bytecode set you want to use.
	forceLongForm:		<Boolean> true if instance variable access requires a long form (typically, Context access)
		
	Following inst vars are used to map bytecode pc to IR instruction	
	instrMap:		<OrderedCollection>
	instrMaps:		<IdentityDictionary of OrderedCollection>
			
	lastLiteral:		<Behavior> Basically in the case you would compile without annotating the method with its class and its selector, this literal is used to enforce the method class to be a literal to allow super sends.
	lastSpecialReturn:		<Message> used to generate quick returns
	literals:		<OCLiteralList> literals of the methods
	numArgs:		<Smi> number of arguments of the method
	numberOfTemps:		<Smi> number of temps of the method
	primNumber:		<Smi> primitive number (or 0)
	properties:		<AdditionalMethodState | nil> used to hold the additional method state (pragmas for examples)
			
	Following inst vars are used to correctly map the jumps (See #initialize for extra information)
	orderSeq:		<OrderedCollection> Reverse map of seq order
	seqBytes:		<IdentityDictionary>
	seqOrder:		<IdentityDictionary>
	jumps:		<IdentityDictionary>
	currentSeqId:		<Object>
	currentSeqNum:		<Smi>
			
	stack:		<Stack> simulated stack. Only simulates the depth of the stack. Store its maximum value in stacks instance variable.
	stacks:		<IdentityDictionary (seqId -> stackCount)> used to find out the maximum depth of the method and therefore set the largeFrameBit!

!IRBytecodeGenerator class methodsFor: 'instance creation' stamp: 'ClementBera 1/28/2015 09:26'!
newWithEncoderClass: class
	^ self basicNew 
		encoderClass: class;
		initialize;
		yourself! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
addLastLiteral: object
	lastLiteral ifNil: [ ^ lastLiteral := object ].
	((lastLiteral literalEqual: object)
		or: [ 
			"case of metaclass, they have no unique association"
			(lastLiteral isKindOf: Association) and: [ lastLiteral key isNil ] ])
		ifFalse: [ self error: 'there can only be one last literal' ]! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
addLiteral: object
	literals add: object.
	^ literals identityIndexOf: object! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
addPragma: aPragma
	properties ifNil: [ properties := AdditionalMethodState new ].
	properties := properties copyWith: aPragma. 

	
	! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'ClementBera 1/16/2015 15:32'!
addProperties: cm
	"set the properties of cm according to properties saved"
	properties ifNotNil: [
		cm penultimateLiteral: properties.
		properties  method: cm.
		properties  pragmas do: [:each | each method: cm] ].! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/16/2015 15:32'!
additionalLiterals: aSet
	additionalLiterals := aSet.
	! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:03'!
blockReturnTop
	encoder genReturnTopToCaller
! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'MarcusDenker 1/8/2016 13:59'!
bytecodes
	| stream |
	self updateJumpOffsets.
	stream := (ByteArray new: 100) writeStream. 
	primitiveBytes ifNotNil: [stream nextPutAll: primitiveBytes contents].
	orderSeq do: [ :seqId | |lastInstr|
			"If the instruction will emit bytes, record the first byte emitted as the instructions bytecode index"
			lastInstr := IRInstruction new -> 1.
			(instrMaps at: seqId) do: [ :assoc | |nextInstr|
				nextInstr := assoc.
				lastInstr key bytecodeIndex: ((nextInstr value - lastInstr value) > 0 ifTrue: [ 
					stream position + lastInstr value]).
				lastInstr := assoc.
				  ].
			lastInstr key bytecodeIndex: ((seqBytes at: seqId) size < lastInstr value ifFalse: [  stream position + lastInstr value]).
			stream nextPutAll: (seqBytes at: seqId) ].
	^ stream contents! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 13:43'!
closureFrom: fromSeqId to: toSeqId copyNumCopiedValues: numCopied numArgs: numArgs2
	| distance from to |
	from := seqOrder at: fromSeqId.
	to := seqOrder at: toSeqId ifAbsent: [ ^ self ].	"not done yet"
	distance := (from + 1 to: to - 1) inject: 0 into: [ :size :i | size + (seqBytes at: (orderSeq at: i)) size ].
	encoder genPushClosureCopyNumCopiedValues: numCopied numArgs: numArgs2 jumpSize: distance. ! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'ClementBera 1/16/2015 15:32'!
compiledMethod

	^ self compiledMethodWith: CompiledMethodTrailer empty! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'MarcusDenker 1/8/2016 14:11'!
compiledMethodWith: trailer
	| lits header quickPrimitive |
	lits := self literals.
	quickPrimitive := self quickMethodPrim.
	(primNumber = 0 and: [quickPrimitive > 0]) ifTrue: [
		"if we are a quick method we need to add a byteocde at the beginning. #bytecodes
		takes primitiveBytes into account" 
		primitiveBytes := (ByteArray new: 4) writeStream.
		encoder stream: primitiveBytes.
		encoder genCallPrimitive: quickPrimitive.
	].
	
	header := Smalltalk vm isSpur ifTrue: [ self spurVMHeader: lits size ] ifFalse: [ self v3VMHeader: lits size ].
	^ self compiledMethodWith: trailer header: header literals: lits! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'ClementBera 1/27/2015 15:08'!
compiledMethodWith: trailer header: header literals: lits
	| cm |
	cm := trailer createMethod: self bytecodes size class: CompiledMethod header: header.
	(WriteStream with: cm)
		position: cm initialPC - 1;
		nextPutAll: self bytecodes.
	lits withIndexDo: [:obj :i | cm literalAt: i put: obj].
	cm needsFrameSize: self stackFrameSize.
	
	self addProperties: cm.
	^ cm! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/27/2015 16:38'!
encoderClass
	^ encoderClass  ! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/27/2015 16:38'!
encoderClass: class
	encoderClass := class  ! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'MarcusDenker 1/8/2016 14:12'!
endPrimNumber
	"primitive number including quick return. Only valid at the end of generation"
	^ primNumber > 0
			ifTrue: [ primNumber ]
			ifFalse: [ self quickMethodPrim ]! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/16/2015 15:32'!
forceLongForm: aBoolean
	forceLongForm := aBoolean! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
from: fromSeqId goto: toSeqId

	| distance from to |
	from := seqOrder at: fromSeqId.
	to := seqOrder at: toSeqId ifAbsent: [^ self].
	from + 1 = to ifTrue: [^ self].  "fall through, no jump needed"

	from < to ifTrue: [ "jump forward"
		distance := (from + 1 to: to - 1) inject: 0 into: [:size :i | 
				size + (seqBytes at: (orderSeq at: i)) size].
		self jumpForward: distance.
	] ifFalse: [ "jump backward"
		distance := ((to to: from - 1) inject: 0 into: [:size :i |
				size + (seqBytes at: (orderSeq at: i)) size])
			+ bytes size.
		self jumpBackward: distance.
	].
! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
from: fromSeqId if: bool goto: toSeqId otherwise: otherwiseSeqId

	| distance from to otherwise |
	from := seqOrder at: fromSeqId.
	to := seqOrder at: toSeqId ifAbsent: [^ self jump: 0 if: bool].  "not done yet"
	otherwise := seqOrder at: otherwiseSeqId ifAbsent: [^ self jump: 0 if: bool].  "not done yet"
	from < to ifFalse: [self error].
	from + 1 = otherwise ifFalse: [self error].
	distance := (from + 1 to: to - 1)
		inject: 0
		into: [:size :i | size + (seqBytes at: (orderSeq at: i)) size].
	self jump: distance if: bool.
! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/19/2015 14:56'!
goto: seqId
	stacks at: seqId put: (stack linkTo: (stacks at: seqId ifAbsentPut: [ nil ])).
	self
		saveLastJump:
			(Message
				selector: #from:goto:
				arguments:
					{currentSeqId.
					seqId}).
	self from: currentSeqId goto: seqId! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'MarcusDenker 1/8/2016 14:09'!
hasPrimitive
	"do I have a primitive? Both normal primitive and quick return"
	primNumber > 0 ifTrue: [ ^true ].
	^ self endPrimNumber > 0! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/19/2015 14:56'!
if: bool goto: seqId
	| otherwiseSeqId |
	otherwiseSeqId := self newDummySeqId.
	self if: bool goto: seqId otherwise: otherwiseSeqId.
	self label: otherwiseSeqId! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/19/2015 14:55'!
if: bool goto: seqId1 otherwise: seqId2
	stack pop.
	stacks at: seqId1 put: (stack linkTo: (stacks at: seqId1 ifAbsentPut: [ nil ])).
	stacks at: seqId2 put: (stack linkTo: (stacks at: seqId2 ifAbsentPut: [ nil ])).
	self
		saveLastJump:
			(Message
				selector: #from:if:goto:otherwise:
				arguments:
					{currentSeqId.
					bool.
					seqId1.
					seqId2}).
	self
		from: currentSeqId
		if: bool
		goto: seqId1
		otherwise: seqId2! !

!IRBytecodeGenerator methodsFor: 'initialize' stamp: 'cb 1/27/2015 13:32'!
initialize

	super initialize.

	encoder := self encoderClass new.
	encoder stream: self.
	
	primNumber := 0.
	
	literals := OCLiteralList new.
	"The following dicts are keyed by sequence id given by client in label: (and gotos)."
	seqOrder := IdentityDictionary new.  "seqId -> seq order num"
	seqBytes := IdentityDictionary new.  "seqId -> seq bytecodes"
	jumps := IdentityDictionary new.  "seqId -> last jump instr"
	instrMaps := IdentityDictionary new.  "seqId -> (clientInstr -> bytecode pos)"
	stacks := IdentityDictionary new.  "seqId -> stackCount"
	numArgs := 0.
	currentSeqNum := 0.
	orderSeq := OrderedCollection new.  "reverse map of seqOrder"
	additionalLiterals := OCLiteralSet new.
	forceLongForm := false.
	"starting label in case one is not provided by client"
	self label: self newDummySeqId.
	

	! !

!IRBytecodeGenerator methodsFor: 'initialize' stamp: 'ClementBera 1/16/2015 15:27'!
irPrimitive: anIrPrimitive
	literals isEmpty ifFalse: [self error: 'init prim before adding instructions'].
	anIrPrimitive spec ifNotNil: [literals add: anIrPrimitive spec].
	primNumber := anIrPrimitive num.
	primNumber = 0 ifTrue: [ ^ self ].
	self encoderClass callPrimitiveCode ifNil: [ ^ self ].
	encoder genCallPrimitive: primNumber! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:14'!
jump: distance if: condition
	distance = 0
		ifTrue: [ ^ encoder genPop ].
	condition
		ifTrue: [ encoder genBranchPopTrue: distance ]
		ifFalse: [ encoder genBranchPopFalse: distance ]
		! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:36'!
jumpBackward: distance

	encoder genJumpLong: distance negated - self encoderClass backJumpBytecodeSize! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/20/2015 15:33'!
jumpForward: distance

	distance = 0 ifTrue: [^ self].  
	encoder genJump: distance.
! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'NicolaiHess 11/18/2015 00:01'!
label: seqId
	lastSpecialReturn := nil.
	currentSeqId := seqId.
	currentSeqNum := currentSeqNum + 1.
	seqOrder at: seqId put: currentSeqNum.
	orderSeq at: currentSeqNum ifAbsentPut: [seqId].
	bytes := seqBytes at: seqId ifAbsentPut: [OrderedCollection new].
	jumps at: seqId ifAbsentPut: [nil].
	instrMap := instrMaps at: seqId ifAbsentPut: [OrderedCollection new].
	stack
		ifNil: [ stack := stacks at: currentSeqId ifAbsentPut: [ IRStackCount new ] ]
		ifNotNil: [stack := stacks at: currentSeqId ifAbsentPut: [ stack class newOn:stack ] ]
	! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'KevinLanvin 1/23/2015 14:21'!
literalIndexOf: object

	| index |
	
	(index := literals literalIndexOf: object ifAbsent: 0) > 0 ifFalse: [
		index := self addLiteral: object].
	
	"conversion from 1 based to 0 based"
	^ index - 1! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'ClementBera 1/16/2015 15:32'!
literals
	literals := literals asArray.	"Put the optimized selectors in literals so as to browse senders more easily"
	additionalLiterals := additionalLiterals asArray reject: [ :e | literals hasLiteral: e ].
	additionalLiterals isEmpty
		ifFalse: [ 
			"Use one entry per literal if enough room, else make anArray"
			literals := literals size + additionalLiterals size + 2 > 255
				ifTrue: [ literals copyWith: additionalLiterals ]
				ifFalse: [ literals , additionalLiterals ] ].
	(literals anySatisfy: [ :each | each isMethodProperties ])
		ifFalse: [ literals := literals copyWith: nil ].
	^ lastLiteral ifNil: [ literals copyWith: nil ] ifNotNil: [ literals copyWith: lastLiteral ]! !

!IRBytecodeGenerator methodsFor: 'mapping' stamp: 'HenrikSperreJohansen 10/12/2015 16:33'!
mapBytesTo: instr
	"Record the current byte offset in instruction sequence as start of instr. 
	This is later used to calculate the total byte offset of instruction in generated code,
	see #bytecodes"
	instrMap add: instr -> (bytes size + 1)! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
newDummySeqId

	^ Object new! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'MarcusDenker 1/8/2016 13:35'!
nextPut: byte
	bytes add: byte! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/16/2015 15:32'!
numArgs

	^ numArgs! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/16/2015 15:32'!
numArgs: n

	numArgs := n! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/16/2015 15:32'!
numTemps

	^ numberOfTemps! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/16/2015 15:32'!
numTemps: anInteger

	numberOfTemps := anInteger! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/20/2015 15:24'!
popTop
	stack pop.
	encoder genPop! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
pragmas: aCollection
	aCollection do: [:each | self addPragma: each]! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'KevinLanvin 1/16/2015 16:13'!
primNum
	^ primNumber ! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/16/2015 15:32'!
properties
	^ properties! !

!IRBytecodeGenerator methodsFor: 'accessing' stamp: 'ClementBera 1/16/2015 15:32'!
properties: propDict
	properties := propDict.! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'NicolaiHess 11/18/2015 00:02'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs2 to: toSeqId
	| blockSeqId |
	blockSeqId := self newDummySeqId.
	stack pop: numCopied.
	stacks at: blockSeqId put: ((IRClosureStackCount new numMethodTempVars:(numberOfTemps)) startAt: (numArgs2+numCopied)).
	stack push.
	stacks at: toSeqId put: (stack linkTo: (stacks at: toSeqId ifAbsentPut: [ nil ])).
	self
		saveLastJump:
			(Message
				selector: #closureFrom:to:copyNumCopiedValues:numArgs:
				arguments:
					{currentSeqId.
					toSeqId.
					numCopied.
					numArgs2}).
	self
		closureFrom: currentSeqId
		to: toSeqId
		copyNumCopiedValues: numCopied
		numArgs: numArgs2.
	self label: blockSeqId! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 14:01'!
pushConsArray: size
	stack push.
	stack pop: size.
	encoder genPushConsArray: size! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 14:10'!
pushDup
	stack push.
	encoder genDup! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 14:57'!
pushInstVar: instVarIndex
	stack push.
	forceLongForm
		ifTrue: [ encoder genPushInstVarLong: instVarIndex - 1 ]
		ifFalse: [ encoder genPushInstVar: instVarIndex - 1 ]! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 14:46'!
pushLiteral: object
	stack push.
	"identity includes else 0.0 = 0 whereas it's a Float" 
	(self encoderClass specialLiterals identityIncludes: object) ifTrue: [ 
		^ encoder genPushSpecialLiteral: object ].
	encoder genPushLiteral: (self literalIndexOf: object)
! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:50'!
pushLiteralVariable: object 
	stack push.
	encoder genPushLiteralVar: (self literalIndexOf: object).! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'NicolaiHess 11/18/2015 00:02'!
pushNClosureTemps: n
	n = 0 ifTrue: [ ^ self ].
	n timesRepeat:[ stack push].
	encoder genPushNClosureTemps: n.! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 13:59'!
pushNewArray: size
	stack push.
	encoder genPushNewArray: size! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/19/2015 17:24'!
pushReceiver
	stack push.
	encoder genPushReceiver ! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:27'!
pushRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	stack push.
	encoder genPushRemoteTemp: tempIndex - 1 inVectorAt: tempVectorIndex - 1! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:06'!
pushTemp: index
	stack push.
	encoder genPushTemp: index - 1! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/19/2015 17:23'!
pushThisContext

	stack push.
	encoder genPushThisContext ! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/27/2015 15:50'!
quickMethodPrim

	| index |
	self numArgs = 0 ifFalse: [^ 0].
	lastSpecialReturn ifNil: [^ 0].
	(seqBytes  size <= 2) ifFalse: [^ 0].
	"this is for ruling out the case in which the structure is the same as a quick return
	but with and invalid special literal."
	((literals size = 1) and: [ (self encoderClass specialLiterals identityIncludes: literals first) not and: [ lastSpecialReturn selector = #returnConstant: ] ] )
		ifTrue: [^ 0].
	lastSpecialReturn selector == #returnReceiver 
		ifTrue: [^256].
	lastSpecialReturn selector == #returnConstant:
		 ifTrue: [^(index := self encoderClass specialLiterals identityIndexOf: lastSpecialReturn argument) > 0
					ifTrue: [256 + index] ifFalse: [0]].
	lastSpecialReturn selector == #returnInstVar: 
		ifTrue: [^forceLongForm 
					ifTrue: [0]  "when compiling long bytecodes for Contexts, do not do quick return either"
					ifFalse: [263 + lastSpecialReturn argument]]
	! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 14:25'!
returnConstant: constant
	bytes ifEmpty: [ lastSpecialReturn := Message selector: #returnConstant: argument: constant ].
	(#(nil true false) includes: constant) ifTrue: 
		[ ^ encoder genReturnSpecialLiteral:constant ].
	self pushLiteral: constant.
	self returnTop! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 14:02'!
returnInstVar: index 
	bytes ifEmpty: [
		lastSpecialReturn := Message selector: #returnInstVar: argument: index].
	self pushInstVar: index.
	self returnTop.
! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 14:22'!
returnReceiver
	bytes ifEmpty: [ lastSpecialReturn := Message selector: #returnReceiver].
	encoder genReturnReceiver.
! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/16/2015 16:11'!
returnTop
	stack pop.
	encoder genReturnTop! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
saveLastJump: message
	jumps at: currentSeqId put: {bytes size. message}.
 ! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 14:07'!
send: selector
	| nArgs |
	nArgs := selector numArgs.
	stack pop: nArgs.
	(self encoderClass specialSelectors includes: selector)
		ifTrue: [ ^ encoder genSendSpecial: (self encoderClass specialSelectors indexOf: selector) numArgs: nArgs ].
	encoder genSend: (self literalIndexOf: selector) numArgs: nArgs! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:44'!
send: selector toSuperOf: behavior

	| index nArgs |
	nArgs := selector numArgs.
	stack pop: nArgs.

	self addLastLiteral: behavior binding.  
	index := self literalIndexOf: selector.
	encoder genSendSuper: index numArgs: nArgs
! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'ClementBera 2/24/2015 16:21'!
spurVMHeader: literalsSize
	^ (CompiledMethod headerFlagForEncoder: self encoderClass) +
		(self numArgs bitShift: 24) +
		( self numTemps bitShift: 18) +
		literalsSize +
		(self hasPrimitive asBit bitShift: 16)! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'ClementBera 1/16/2015 15:32'!
stackFrameSize
	^ (stacks collect: [:s | s length]) max! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:53'!
storeInstVar: index 
	forceLongForm 
		ifTrue: [ encoder genStoreInstVarLong: index - 1 ]
		ifFalse: [ encoder genStoreInstVar: index - 1 ]! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:47'!
storeIntoLiteralVariable: object 
	encoder genStoreLiteralVar: (self literalIndexOf: object). ! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 14:57'!
storePopInstVar: index 
	stack pop.
	forceLongForm 
		ifTrue: [ encoder genStorePopInstVarLong: index - 1 ]
		ifFalse: [ encoder genStorePopInstVar: index - 1 ]! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:50'!
storePopIntoLiteralVariable: assoc

	encoder genStorePopLiteralVar: (self literalIndexOf: assoc).
	stack pop! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:28'!
storePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex 
	stack pop.
	encoder genStorePopRemoteTemp: tempIndex - 1 inVectorAt: tempVectorIndex - 1! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:05'!
storePopTemp: index
	stack pop. 
	encoder genStorePopTemp: index - 1! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:28'!
storeRemoteTemp: tempIndex inVectorAt: tempVectorIndex 
	encoder genStoreRemoteTemp: tempIndex - 1 inVectorAt: tempVectorIndex - 1! !

!IRBytecodeGenerator methodsFor: 'instructions' stamp: 'KevinLanvin 1/23/2015 15:06'!
storeTemp: index
	encoder genStoreTemp: index - 1! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
updateJump: seqId
	"Recalculate final jump bytecodes.  Return true if jump bytecodes SIZE has changed, otherwise return false"
	| pair s1 |
	pair := jumps at: seqId.
	pair ifNil: [^ false].  "no jump, a return"
	bytes := seqBytes  at: seqId.
	s1 := bytes size.
	bytes removeLast: (bytes size - pair first).
	pair last sendTo: self.
	^ s1 ~= bytes size.! !

!IRBytecodeGenerator methodsFor: 'private' stamp: 'ClementBera 1/16/2015 15:29'!
updateJumpOffsets
	[ orderSeq 
		inject: false 
		into: [ :changed :seqId | (self updateJump: seqId) or: [ changed ]] 
	] whileTrue! !

!IRBytecodeGenerator methodsFor: 'results' stamp: 'GuillermoPolito 8/14/2015 11:24'!
v3VMHeader: literalsSize
	| header primBits endPrimNumber |
	self encoderClass name = #OpalEncoderForSistaV1 ifTrue: [ 
		self error: 'SistaV1 non supported in non spur VM'].
	endPrimNumber := self endPrimNumber.
	primBits := endPrimNumber <= 16r1FF
		ifTrue: [endPrimNumber]
		ifFalse: ["For now the high bit of primitive no. is in the 29th bit of header"
				(endPrimNumber bitAnd: 16r1FF) + ((endPrimNumber bitAnd: 16r200) bitShift: 19)].
	header := (self numArgs bitShift: 24) +
				(self numTemps bitShift: 18) +
				(literalsSize bitShift: 9) +
				primBits.
	^ header! !

Object subclass: #IRBytecodeScope
	instanceVariableNames: 'temps numArgs ownTempVectors copiedValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Bytecode'!

!IRBytecodeScope commentStamp: '<historical>' prior: 0!
I am an internal class used by the  decompiler to recreat variable information!

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 13:43'!
args
	| args |
	args := Array new: numArgs.
	1 to: numArgs do: [ :idx | args at: idx put: self -> (idx - 1)].
	^ args! !

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 14:52'!
copiedValues
	^ copiedValues! !

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 14:48'!
copiedValues: someCopiedValues
	copiedValues := someCopiedValues! !

!IRBytecodeScope methodsFor: 'initialization' stamp: 'ToonVerwaest 3/27/2011 14:49'!
initialize
	temps := 0.
	ownTempVectors := OrderedCollection new! !

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 14:51'!
newTempVector: aTempVector at: offset
	ownTempVectors add: aTempVector.
	self tempAt: offset! !

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 13:08'!
numArgs
	^ numArgs! !

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 13:45'!
numArgs: anInteger
	numArgs := anInteger.
	temps := temps max: numArgs! !

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 14:55'!
ownTempVectors
	^ ownTempVectors! !

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 16:21'!
tempAt: zeroBasedIndex
	temps := temps max: zeroBasedIndex + 1.
	^ self -> zeroBasedIndex! !

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 12:37'!
tempAt: remoteIndex inRemote: remoteArray
	^ remoteIndex! !

!IRBytecodeScope methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 14:59'!
temps
	| result tempOffset numTemps |
	tempOffset := copiedValues size + numArgs.
	numTemps := temps - tempOffset.
	result := Array new: numTemps.
	tempOffset := tempOffset - 1.
	1 to: numTemps do: [ :idx | result at: idx put: self -> (tempOffset + idx)  ].
	ownTempVectors do: [ :tempVector | result at: tempVector index - tempOffset put: tempVector ].
	^ result! !

Object subclass: #IRInstruction
	instanceVariableNames: 'sourceNode bytecodeIndex sequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRInstruction commentStamp: '<historical>' prior: 0!
I am an instruction in the IR (intermediate representation) language.  The IR serves as the intermediary between the Smalltalk language and the bytecode language.  It is easier to optimize and translate to/from this language than it is to optimize/translate directly from Smalltalk to bytecodes.  The IR is generic and simple consisting of just twelve instructions.  They are:

	goto: labelNum
	if: boolean goto: labelNum1 otherwise: labelNum2
	label: labelNum
	popTop
	pushDup
	pushLiteral: object
	pushTemp: name
	blockReturn
	returnTop
	send: selector
	send: selector toSuperOf: behavior
	storeTemp: name

Each instruction is reified as an instance of one of my subclasses and grouped by basic block (IRSequence) into an IRMethod.  IRInterpreter visits each instruction in a IRMethod responding to the above instruction messages sent to it.
!

IRInstruction subclass: #IRAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRAccess commentStamp: '<historical>' prior: 0!
IRAccess models all bytecodes that read or write variables or self/super/thisContext!

IRAccess subclass: #IRInstVarAccess
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRInstVarAccess commentStamp: '<historical>' prior: 0!
I am a bytecode accessing an instance variable. As such, I have an index.!

!IRInstVarAccess methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 13:23'!
index
	^ index! !

!IRInstVarAccess methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 13:23'!
index: anInteger
	index := anInteger! !

!IRInstVarAccess methodsFor: 'testing' stamp: 'ClementBer 10/14/2014 13:23'!
isInstVarAccess
	^ true! !

IRInstVarAccess subclass: #IRPopIntoInstVar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPopIntoInstVar commentStamp: 'ClementBer 10/14/2014 14:47' prior: 0!
Pop into instance variable.!

!IRPopIntoInstVar methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPopIntoInstVar: self! !

IRInstVarAccess subclass: #IRPushInstVar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushInstVar commentStamp: 'ClementBer 10/14/2014 14:47' prior: 0!
push inst var!

!IRPushInstVar methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushInstVar: self! !

!IRPushInstVar methodsFor: 'testing' stamp: 'ClementBer 10/14/2014 15:55'!
canBeQuickReturn
	^ true! !

!IRPushInstVar methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 16:00'!
quickRetNode
	^ IRReturnInstVar new
		index: index;
		yourself! !

IRInstVarAccess subclass: #IRStoreInstVar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRStoreInstVar commentStamp: 'ClementBer 10/14/2014 14:47' prior: 0!
store inst var!

!IRStoreInstVar methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitStoreInstVar: self! !

!IRStoreInstVar methodsFor: 'testing' stamp: 'ClementBer 10/14/2014 15:36'!
isStore
	^ true! !

!IRStoreInstVar methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 15:45'!
popIntoNode
	^ IRPopIntoInstVar new
		index: index; 
		yourself! !

IRAccess subclass: #IRLiteralVariableAccess
	instanceVariableNames: 'association'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRLiteralVariableAccess commentStamp: '<historical>' prior: 0!
LiteralVariables are 

-> Globals
-> Pool access
-> Class Var access!

!IRLiteralVariableAccess methodsFor: 'accessing' stamp: 'MarcusDenker 6/6/2012 12:33'!
association 
	^association! !

!IRLiteralVariableAccess methodsFor: 'accessing' stamp: 'md 7/9/2005 21:14'!
association: anAssociation
	association := anAssociation! !

!IRLiteralVariableAccess methodsFor: 'testing' stamp: 'md 10/4/2005 16:45'!
isLiteralVariable
	^true! !

!IRLiteralVariableAccess methodsFor: 'accessing' stamp: 'MarcusDenker 8/4/2011 14:05'!
name
	^association key! !

IRLiteralVariableAccess subclass: #IRPopIntoLiteralVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPopIntoLiteralVariable commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
pop into literal variable!

!IRPopIntoLiteralVariable methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPopIntoLiteralVariable: self! !

IRLiteralVariableAccess subclass: #IRPushLiteralVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushLiteralVariable commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
push literal variable!

!IRPushLiteralVariable methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushLiteralVariable: self! !

IRLiteralVariableAccess subclass: #IRStoreLiteralVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRStoreLiteralVariable commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
store literal variable!

!IRStoreLiteralVariable methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitStoreLiteralVariable: self! !

!IRStoreLiteralVariable methodsFor: 'testing' stamp: 'ClementBer 10/14/2014 15:36'!
isStore
	^ true! !

!IRStoreLiteralVariable methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 15:46'!
popIntoNode
	^ IRPopIntoLiteralVariable new
		association: association;
		yourself! !

IRAccess subclass: #IRPushReceiver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushReceiver commentStamp: '<historical>' prior: 0!
I am modelling the push self bytecode!

!IRPushReceiver methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushReceiver: self! !

!IRPushReceiver methodsFor: 'testing' stamp: 'ClementBer 10/14/2014 15:55'!
canBeQuickReturn
	^ true! !

!IRPushReceiver methodsFor: 'testing' stamp: 'JorgeRessia 4/29/2010 17:06'!
isSelf
	^true! !

!IRPushReceiver methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 16:00'!
quickRetNode
	^ IRReturnReceiver new
	! !

IRAccess subclass: #IRPushThisContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushThisContext commentStamp: 'MarcusDenker 8/11/2014 10:14' prior: 0!
I model push thisContext bytecode!

!IRPushThisContext methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushThisContext: self! !

IRAccess subclass: #IRTempAccess
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRTempAccess commentStamp: '<historical>' prior: 0!
I model the pushTemporary Bytecode!

IRTempAccess subclass: #IRPopIntoTemp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPopIntoTemp commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
pop into temp!

!IRPopIntoTemp methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPopIntoTemp: self! !

IRTempAccess subclass: #IRPushTemp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushTemp commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
push temp!

!IRPushTemp methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushTemp: self! !

IRTempAccess subclass: #IRRemoteTempAccess
	instanceVariableNames: 'tempVectorName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRRemoteTempAccess commentStamp: 'MarcusDenker 8/11/2014 10:14' prior: 0!
I model the pushRemoteTemporary Bytecode!

IRRemoteTempAccess subclass: #IRPopIntoRemoteTemp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPopIntoRemoteTemp commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
pop into remote temp!

!IRPopIntoRemoteTemp methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPopIntoRemoteTemp: self! !

IRRemoteTempAccess subclass: #IRPushRemoteTemp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushRemoteTemp commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
push remote temp!

!IRPushRemoteTemp methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushRemoteTemp: self! !

!IRRemoteTempAccess methodsFor: 'testing' stamp: 'ToonVerwaest 3/26/2011 18:50'!
isRemoteTemp
	^ true! !

!IRRemoteTempAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 3/26/2011 18:48'!
tempVectorName
	^ tempVectorName! !

!IRRemoteTempAccess methodsFor: 'accessing' stamp: 'MarcusDenker 8/18/2010 15:31'!
tempVectorName: anObject
	tempVectorName := anObject! !

IRRemoteTempAccess subclass: #IRStoreRemoteTemp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRStoreRemoteTemp commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
store remote temp!

!IRStoreRemoteTemp methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitStoreRemoteTemp: self! !

!IRStoreRemoteTemp methodsFor: 'testing' stamp: 'ClementBer 10/14/2014 15:37'!
isStore
	^ true! !

!IRStoreRemoteTemp methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 15:47'!
popIntoNode
	^ IRPopIntoRemoteTemp new
		name: name;
		tempVectorName: tempVectorName;
		yourself! !

IRTempAccess subclass: #IRStoreTemp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRStoreTemp commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
store temp!

!IRStoreTemp methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitStoreTemp: self! !

!IRStoreTemp methodsFor: 'testing' stamp: 'ClementBer 10/14/2014 15:37'!
isStore
	^ true! !

!IRStoreTemp methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 15:46'!
popIntoNode
	^ IRPopIntoTemp new
		name: name;
		yourself! !

!IRTempAccess methodsFor: 'testing' stamp: 'ToonVerwaest 3/26/2011 18:52'!
isRemoteTemp
	^ false! !

!IRTempAccess methodsFor: 'testing' stamp: 'md 2/22/2005 11:28'!
isTemp
	^true.! !

!IRTempAccess methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 13:27'!
name

	^name! !

!IRTempAccess methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 13:27'!
name: aString
	name := aString! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'JorgeRessia 5/6/2010 16:33'!
blockReturnTop
	^ IRBlockReturnTop new
		! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'MarcusDenker 8/19/2010 08:21'!
createTempVectorNamed: aTempVectorName withVars: anArray  

	^ IRTempVector new
		name: aTempVectorName;
		vars: anArray;
		yourself.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/11/2009 19:44'!
popTop
	^ IRPop new! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'MarcusDenker 8/27/2010 13:28'!
pushClosureCopyCopiedValues: copiedValues args: arguments
	^IRPushClosureCopy new
			copiedValues: copiedValues;
			arguments: arguments;
			yourself.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'MarcusDenker 8/19/2010 15:03'!
pushConsArray: aSize 
	^IRPushArray new
		size: aSize;
		cons: true;
		yourself.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'MarcusDenker 8/13/2010 13:43'!
pushDup

	^ IRPushDup new! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 13:23'!
pushInstVar: index

	^ IRPushInstVar new 
			index:  index; 
			yourself! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'MarcusDenker 8/13/2010 13:23'!
pushLiteral: object

	^ IRPushLiteral new
		literal: object! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 13:24'!
pushLiteralVariable: object

	^ IRPushLiteralVariable new
		association: object;
		yourself
	 ! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'MarcusDenker 8/19/2010 15:03'!
pushNewArray: aSize
	
	^IRPushArray new
		size: aSize;
		cons: false;
		yourself.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 13:27'!
pushReceiver
	^ IRPushReceiver new! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 13:25'!
pushRemoteTemp: aName inVectorAt: nameOfVector
	^ IRPushRemoteTemp new
		name: aName;
		tempVectorName: nameOfVector;
		yourself.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 13:24'!
pushTemp: aName
	aName = 'self' ifTrue: [self error: 'use pushReceiver'].
	^ IRPushTemp new
		name: aName;
		yourself! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 15:10'!
pushThisContext
	^ IRPushThisContext new! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'MarcusDenker 4/15/2010 15:22'!
returnTop

	^ IRReturn new! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 3/10/2003 01:08'!
send: selector

	^ IRSend new
		selector: selector! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'MarcusDenker 8/12/2010 14:31'!
send: selector toSuperOf: behavior

	behavior ifNil: [self error: 'super of nil does not exist'].
	^ IRSend new
		selector: selector;
		superOf: behavior;
		yourself.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 13:23'!
storeInstVar: index
	^ IRStoreInstVar new 
		index: index; 
		yourself
	! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 13:24'!
storeIntoLiteralVariable: object

	^ IRStoreLiteralVariable new
		association: object;
		yourself! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 13:25'!
storeRemoteTemp: aName inVectorAt: nameOfVector
	^ IRStoreRemoteTemp new
		name: aName;
		tempVectorName: nameOfVector;
		yourself.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ClementBer 10/14/2014 13:25'!
storeTemp: aName
	^ IRStoreTemp new
		name: aName;
		yourself
! !

!IRInstruction methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:17'!
accept: aVisitor
	self subclassResponsibility! !

!IRInstruction methodsFor: 'adding' stamp: 'md 7/9/2005 22:41'!
addInstructionsAfter: aCollection
	sequence addInstructions: aCollection after: self.! !

!IRInstruction methodsFor: 'adding' stamp: 'md 7/9/2005 22:41'!
addInstructionsBefore: aCollection
	sequence addInstructions: aCollection before: self.! !

!IRInstruction methodsFor: 'mapping' stamp: 'ajh 3/13/2003 13:07'!
bytecodeIndex

	^ bytecodeIndex! !

!IRInstruction methodsFor: 'mapping' stamp: 'ajh 3/13/2003 13:14'!
bytecodeIndex: index

	bytecodeIndex := index! !

!IRInstruction methodsFor: 'mapping' stamp: 'md 9/1/2005 21:18'!
bytecodeOffset
	| startpc |
	startpc := self method compiledMethod initialPC.
	self bytecodeIndex ifNil: [^startpc].
	^self bytecodeIndex + startpc - 1.! !

!IRInstruction methodsFor: 'testing' stamp: 'ClementBer 10/14/2014 15:55'!
canBeQuickReturn
	^ false! !

!IRInstruction methodsFor: 'inspector' stamp: 'MarcusDenker 10/21/2014 10:44'!
children
	^#()! !

!IRInstruction methodsFor: 'replacing' stamp: 'ClementBera 7/26/2013 15:48'!
delete
	sequence ifNil: [self error: 'This node doesn''t have a sequence'].
	sequence remove: self.! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 12/19/2012 08:07'!
isBlockReturnTop

	^false ! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 12/19/2012 08:05'!
isGoto
	"is unconditional jump"
	
	^ false ! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 12/14/2012 11:52'!
isIf

	^ false ! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 8/18/2010 20:11'!
isInstVarAccess

	^false.! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 12/19/2012 08:07'!
isJump
	"goto or if"

	^false ! !

!IRInstruction methodsFor: 'testing' stamp: 'md 10/4/2005 16:52'!
isLiteralVariable
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 12/14/2012 11:52'!
isPop

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: ''!
isPushClosureCopy
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 9/20/2013 15:14'!
isPushLiteral
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 9/20/2013 13:26'!
isPushLiteral: valueTest

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 8/13/2010 14:25'!
isRead
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 12/19/2012 08:07'!
isReturn

	^ false ! !

!IRInstruction methodsFor: 'testing' stamp: 'md 2/26/2005 16:22'!
isSelf
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 12/19/2012 08:05'!
isSend
	^false.! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 8/13/2010 14:26'!
isStore
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 2/22/2005 11:28'!
isTemp
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'MarcusDenker 12/14/2012 11:51'!
isTempVector
	^false! !

!IRInstruction methodsFor: 'accessing' stamp: 'md 7/9/2005 22:42'!
method
	^sequence method.! !

!IRInstruction methodsFor: 'accessing' stamp: 'MarcusDenker 8/8/2011 13:29'!
nonBodySuccessorSequences
	^self successorSequences! !

!IRInstruction methodsFor: 'printing' stamp: 'MarcusDenker 10/21/2014 11:09'!
printOn: aStream
	IRPrinterV2 new
			stream: aStream;
			visitNode: self! !

!IRInstruction methodsFor: 'replacing' stamp: 'md 10/11/2004 15:56'!
replaceNode: aNode withNode: anotherNode 
	self error: 'I don''t store other nodes'! !

!IRInstruction methodsFor: 'replacing' stamp: 'ClementBera 7/26/2013 15:48'!
replaceWith: aNode
	sequence ifNil: [self error: 'This node doesn''t have a sequence'].
	sequence replaceNode: self withNode: aNode! !

!IRInstruction methodsFor: 'replacing' stamp: 'ClementBera 7/26/2013 15:48'!
replaceWithInstructions: aCollection 

	sequence ifNil: [self error: 'This node doesn''t have a sequence'].
	sequence replaceNode: self withNodes: aCollection! !

!IRInstruction methodsFor: 'accessing' stamp: 'md 7/9/2005 22:38'!
sequence
	^sequence! !

!IRInstruction methodsFor: 'accessing' stamp: 'md 7/9/2005 22:39'!
sequence: aSeq
	sequence := aSeq! !

!IRInstruction methodsFor: 'inspector' stamp: 'MarcusDenker 10/21/2014 10:45'!
sourceInterval
	^self sourceNode sourceInterval! !

!IRInstruction methodsFor: 'mapping' stamp: 'ajh 3/6/2003 14:32'!
sourceNode

	^ sourceNode
	! !

!IRInstruction methodsFor: 'mapping' stamp: 'ajh 3/6/2003 14:32'!
sourceNode: parseNode

	sourceNode := parseNode
	! !

!IRInstruction methodsFor: 'accessing' stamp: 'MarcusDenker 12/14/2012 11:51'!
successorSequences
	"sent to last instruction in sequence which is expected to be a jump and return instruction"

	^ #()! !

!IRInstruction methodsFor: 'testing' stamp: 'HenrikSperreJohansen 10/13/2015 15:08'!
transitionsToNextSequence
	"Does the current instruction intrinsically know how to transition to the next sequence?"
	^ self isJump or: [self isReturn or: [self isPushClosureCopy ]]! !

IRInstruction subclass: #IRJump
	instanceVariableNames: 'destination successor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRJump commentStamp: 'ajh 3/24/2003 23:56' prior: 0!
Instruction "goto: labelNum"!

!IRJump methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:38'!
accept: aVisitor
	^ aVisitor visitJump: self! !

!IRJump methodsFor: 'accessing' stamp: 'ajh 3/10/2003 23:08'!
destination

	^ destination! !

!IRJump methodsFor: 'accessing' stamp: 'JorgeRessia 5/19/2010 11:17'!
destination: aSequence
	destination := aSequence! !

!IRJump methodsFor: 'testing' stamp: 'MarcusDenker 12/14/2012 11:51'!
isGoto
	"is unconditional jump"

	^ true! !

!IRJump methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:22'!
isJump
	"goto or if"

	^ true! !

!IRJump methodsFor: 'accessing' stamp: 'MarcusDenker 4/23/2013 15:48'!
successor
	^successor! !

!IRJump methodsFor: 'accessing' stamp: 'MarcusDenker 6/19/2012 13:18'!
successor: succ
	successor := succ! !

!IRJump methodsFor: 'accessing' stamp: 'MarcusDenker 6/19/2012 13:57'!
successorSequences

	^ {destination. successor} ! !

IRJump subclass: #IRJumpIf
	instanceVariableNames: 'boolean otherwise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRJumpIf commentStamp: 'ajh 3/24/2003 23:56' prior: 0!
Instruction "if: boolean goto: labelNum1 otherwise: labelNum2"!

!IRJumpIf methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitJumpIf: self! !

!IRJumpIf methodsFor: 'acessing' stamp: 'ajh 3/10/2003 00:43'!
boolean

	^ boolean! !

!IRJumpIf methodsFor: 'acessing' stamp: 'ajh 3/10/2003 00:43'!
boolean: bool

	boolean := bool! !

!IRJumpIf methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:19'!
isGoto
	"is unconditional jump"

	^ false! !

!IRJumpIf methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:21'!
isIf

	^ true! !

!IRJumpIf methodsFor: 'acessing' stamp: 'HenrikSperreJohansen 10/13/2015 15:37'!
nextBytecodeOffsetAfterJump
	"check if we are in ifTrue:ifFalse: / ifFalse:ifTrue: or in ifTrue: / ifFalse: and answers the next byte code offset"
	^destination last isJump 
		ifTrue: [ destination last destination first bytecodeOffset ]
		ifFalse: [ 
			(destination sequence at: ((destination size - 1) max: 1)) bytecodeOffset ]! !

!IRJumpIf methodsFor: 'acessing' stamp: 'MarcusDenker 8/8/2011 13:30'!
nonBodySuccessorSequences

	^ {destination}! !

!IRJumpIf methodsFor: 'acessing' stamp: 'ajh 3/10/2003 00:43'!
otherwise

	^ otherwise! !

!IRJumpIf methodsFor: 'acessing' stamp: 'pmm 2/2/2007 18:05'!
otherwise: aSequence

	otherwise := aSequence! !

!IRJumpIf methodsFor: 'acessing' stamp: 'ajh 3/11/2003 00:02'!
successorSequences

	^ {destination. otherwise}! !

IRJump subclass: #IRPushClosureCopy
	instanceVariableNames: 'numArgs blockSequence tempMap copiedValues lastBlockSequence arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushClosureCopy commentStamp: 'MarcusDenker 8/11/2014 10:15' prior: 0!
Instruction push closure copy bytecode

I am modelled as a Jump as the bytecode of the block is inlined into the method, with the execution jumping over these embedded bytecodes. 

!

!IRPushClosureCopy methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushClosureCopy: self! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'MarcusDenker 8/27/2010 13:28'!
arguments
	^arguments! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'MarcusDenker 8/27/2010 13:28'!
arguments: anArray
	arguments := anArray! !

!IRPushClosureCopy methodsFor: 'private' stamp: 'NicolaiHess 10/26/2014 01:16'!
blockHasTempVector: aSymbol
	^ blockSequence hasTempVector: aSymbol! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jb 3/29/2010 13:38'!
blockSequence 
^blockSequence! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jb 4/2/2010 16:27'!
blockSequence: anIRSequence 
	blockSequence := anIRSequence! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'ToonVerwaest 3/26/2011 19:26'!
copiedValues
	^ copiedValues! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'MarcusDenker 8/19/2010 15:00'!
copiedValues: anArray 
	copiedValues := anArray.! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'MarcusDenker 10/14/2010 15:27'!
definedTemps

	^self tempMap keys copyWithoutAll: (arguments, copiedValues).! !

!IRPushClosureCopy methodsFor: 'testing' stamp: 'NicolaiHess 10/26/2014 01:15'!
hasTempVector: aSymbol
	^ (blockSequence hasTempVector: aSymbol) or:[sequence hasTempVector: aSymbol]! !

!IRPushClosureCopy methodsFor: 'scoping' stamp: 'MarcusDenker 8/18/2010 14:55'!
indexForVarNamed: aName

	^tempMap at: aName! !

!IRPushClosureCopy methodsFor: 'initialization' stamp: 'MarcusDenker 5/19/2011 14:55'!
initialize
	super initialize.
	tempMap := Dictionary new.
	! !

!IRPushClosureCopy methodsFor: 'testing' stamp: 'HenrikSperreJohansen 10/13/2015 15:11'!
isGoto
	^ 	false! !

!IRPushClosureCopy methodsFor: 'testing' stamp: 'HenrikSperreJohansen 10/13/2015 15:11'!
isJump
	^ 	false! !

!IRPushClosureCopy methodsFor: 'testing' stamp: 'JorgeRessia 12/25/2009 20:44'!
isPushClosureCopy
	^true! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'JorgeRessia 5/19/2010 11:23'!
lastBlockSequence 
	^lastBlockSequence! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'JorgeRessia 5/19/2010 11:23'!
lastBlockSequence: aSequence
	lastBlockSequence := aSequence! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'MarcusDenker 8/8/2011 13:30'!
nonBodySuccessorSequences

	^ {destination}! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jorgeRessia 10/1/2009 16:31'!
numArgs
	^numArgs! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'MarcusDenker 8/19/2010 15:00'!
numArgs: aSmallInteger 
	numArgs := aSmallInteger! !

!IRPushClosureCopy methodsFor: 'private' stamp: 'NicolaiHess 10/26/2014 01:19'!
sequenceHasTempVector: aSymbol
	^ sequence hasTempVector: aSymbol! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jb 3/31/2010 11:32'!
successorSequences

	^ {destination. blockSequence} ! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'MarcusDenker 4/13/2010 14:52'!
tempKeys
	^tempMap keys ! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jb 8/26/2010 17:01'!
tempMap
	^tempMap! !

!IRPushClosureCopy methodsFor: 'testing' stamp: 'MarcusDenker 8/19/2010 10:34'!
tempVectorName
	self blockSequence do:[:irNode | irNode isTempVector ifTrue:[^irNode name]].
	^nil.! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'NicolaiHess 10/26/2014 01:17'!
tempVectorNamed: aName
    (self blockHasTempVector: aName)
        ifTrue: [ ^ blockSequence tempVectorNamed: aName ].
    (self sequenceHasTempVector: aName)
                ifTrue: [ ^ sequence tempVectorNamed: aName ].
    ^ nil! !

IRInstruction subclass: #IRPop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPop commentStamp: 'ajh 3/24/2003 23:57' prior: 0!
Instruction "popTop"!

!IRPop methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPop: self! !

!IRPop methodsFor: 'testing' stamp: 'ms 7/10/2007 14:12'!
isPop
	^true! !

IRInstruction subclass: #IRPushArray
	instanceVariableNames: 'size cons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushArray commentStamp: 'MarcusDenker 8/11/2014 10:16' prior: 0!
I model the pushArray bytecode.

Used for setting up the temp vectors and for the brace array construct: { }.!

!IRPushArray methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushArray: self! !

!IRPushArray methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 14:28'!
cons
	^ cons! !

!IRPushArray methodsFor: 'accessing' stamp: 'MarcusDenker 8/13/2010 13:33'!
cons: aBool
	cons := aBool.! !

!IRPushArray methodsFor: 'initialization' stamp: 'MarcusDenker 8/13/2010 13:31'!
initialize
	size := 0.
	cons := false.
	! !

!IRPushArray methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 13:42'!
size 
	^ size! !

!IRPushArray methodsFor: 'accessing' stamp: 'MarcusDenker 8/13/2010 13:32'!
size: aSmallInteger 
	size := aSmallInteger! !

IRInstruction subclass: #IRPushDup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushDup commentStamp: 'ajh 3/24/2003 23:56' prior: 0!
Instruction "pushDup"!

!IRPushDup methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushDup: self! !

IRInstruction subclass: #IRPushLiteral
	instanceVariableNames: 'literal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRPushLiteral commentStamp: 'ajh 3/24/2003 23:56' prior: 0!
Instruction "pushLiteral: object"!

!IRPushLiteral methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitPushLiteral: self! !

!IRPushLiteral methodsFor: 'testing' stamp: 'ClementBer 10/14/2014 15:55'!
canBeQuickReturn
	^ true! !

!IRPushLiteral methodsFor: 'testing' stamp: 'MarcusDenker 9/20/2013 13:26'!
isPushLiteral

	^ true! !

!IRPushLiteral methodsFor: 'testing' stamp: 'MarcusDenker 9/20/2013 13:26'!
isPushLiteral: valueTest
	^ valueTest value: literal! !

!IRPushLiteral methodsFor: 'accessing' stamp: 'MarcusDenker 8/13/2010 13:23'!
literal

	^ literal! !

!IRPushLiteral methodsFor: 'accessing' stamp: 'MarcusDenker 8/13/2010 13:23'!
literal: object

	literal := object! !

!IRPushLiteral methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 16:00'!
quickRetNode
	^ IRReturnLiteral new
		literal: literal;
		yourself! !

IRInstruction subclass: #IRReturn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRReturn commentStamp: '<historical>' prior: 0!
Instruction "returnTop"!

IRReturn subclass: #IRBlockReturnTop
	instanceVariableNames: 'successor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRBlockReturnTop commentStamp: 'MarcusDenker 8/11/2014 10:16' prior: 0!
I model the bytecode for block returns.!

!IRBlockReturnTop methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitBlockReturnTop: self! !

!IRBlockReturnTop methodsFor: 'testing' stamp: 'md 10/8/2004 16:04'!
isBlockReturnTop

	^true.! !

!IRBlockReturnTop methodsFor: 'accessing' stamp: 'ClementBera 10/27/2014 10:54'!
successor
	^ successor! !

!IRBlockReturnTop methodsFor: 'accessing' stamp: 'MarcusDenker 6/19/2012 13:50'!
successor: anObject

	successor := anObject. ! !

!IRBlockReturnTop methodsFor: 'accessing' stamp: 'MarcusDenker 6/19/2012 13:50'!
successorSequences
	"sent to last instruction in sequence which is expected to be a jump and return instruction"

	^  { successor }! !

!IRReturn methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:49'!
accept: aVisitor
	^ aVisitor visitReturn: self! !

!IRReturn methodsFor: 'testing' stamp: 'ajh 3/10/2003 16:10'!
isReturn

	^ true! !

!IRReturn methodsFor: 'accessing' stamp: 'MarcusDenker 8/8/2011 13:47'!
nonBodySuccessorSequences
	^#()! !

IRReturn subclass: #IRReturnInstVar
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRReturnInstVar commentStamp: 'ClementBer 10/14/2014 15:23' prior: 0!
specific node when returning an inst var!

!IRReturnInstVar methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:10'!
accept: aVisitor
	^ aVisitor visitReturnInstVar: self! !

!IRReturnInstVar methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 15:58'!
index
	^ index! !

!IRReturnInstVar methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 15:58'!
index: anObject
	index := anObject! !

IRReturn subclass: #IRReturnLiteral
	instanceVariableNames: 'literal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRReturnLiteral commentStamp: 'ClementBer 10/14/2014 14:48' prior: 0!
specific node when returning a constant!

!IRReturnLiteral methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:10'!
accept: aVisitor
	^ aVisitor visitReturnLiteral: self! !

!IRReturnLiteral methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 15:58'!
literal
	^ literal! !

!IRReturnLiteral methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 15:58'!
literal: anObject
	literal := anObject! !

IRReturn subclass: #IRReturnReceiver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRReturnReceiver commentStamp: 'ClementBer 10/14/2014 15:23' prior: 0!
specific node when returning self!

!IRReturnReceiver methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:10'!
accept: aVisitor
	^ aVisitor visitReturnReceiver: self! !

IRInstruction subclass: #IRSend
	instanceVariableNames: 'selector superOf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRSend commentStamp: 'ajh 3/24/2003 23:57' prior: 0!
Instruction "send: selector" or "send: selector toSuperOf: behavior"!

!IRSend methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitSend: self! !

!IRSend methodsFor: 'testing' stamp: 'md 11/12/2004 15:57'!
isSend
	^true.! !

!IRSend methodsFor: 'testing' stamp: 'md 10/10/2005 17:37'!
isSuperSend
    ^superOf notNil! !

!IRSend methodsFor: 'accessing' stamp: 'md 6/23/2005 13:45'!
selector
	^selector! !

!IRSend methodsFor: 'accessing' stamp: 'ajh 3/10/2003 00:44'!
selector: symbol

	selector := symbol! !

!IRSend methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 14:24'!
superOf

	^ superOf ! !

!IRSend methodsFor: 'accessing' stamp: 'ajh 3/10/2003 00:45'!
superOf: behavior

	superOf := behavior! !

IRInstruction subclass: #IRTempVector
	instanceVariableNames: 'name vars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRTempVector commentStamp: 'MarcusDenker 8/11/2014 10:17' prior: 0!
I model the tempVector.

The tempvector is an array that stores all escaping variables of a block that are written to from outside.!

!IRTempVector methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:32'!
accept: aVisitor
	^ aVisitor visitTempVector: self! !

!IRTempVector methodsFor: 'accessing' stamp: 'MarcusDenker 5/19/2011 13:26'!
indexForVarNamed: aName
	^vars indexOf: aName
! !

!IRTempVector methodsFor: 'initialization' stamp: 'MarcusDenker 8/19/2010 01:09'!
initialize 
	vars := Dictionary new! !

!IRTempVector methodsFor: 'testing' stamp: 'MarcusDenker 8/19/2010 08:36'!
isTempVector
	^true! !

!IRTempVector methodsFor: 'accessing' stamp: 'MarcusDenker 8/19/2010 01:06'!
name
	^ name! !

!IRTempVector methodsFor: 'accessing' stamp: 'MarcusDenker 8/19/2010 01:05'!
name: anObject
	name := anObject! !

!IRTempVector methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 13:37'!
vars
	^ vars! !

!IRTempVector methodsFor: 'accessing' stamp: 'MarcusDenker 8/19/2010 08:13'!
vars: anObject
	vars := anObject.! !

Object subclass: #IRMethod
	instanceVariableNames: 'sourceNode startSequence numArgs properties tempMap pragmas additionalLiterals compiledMethod compilationContext irPrimitive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRMethod commentStamp: 'ajh 5/23/2003 11:08' prior: 0!
I am a method in the IR (intermediate representation) language consisting of IRInstructions grouped by IRSequence (basic block).  The IRSequences form a control graph (therefore I only have to hold onto the starting sequence).  #compiledMethod will convert me to a CompiledMethod.  #methodNode will convert me back to a parse tree.
!

!IRMethod methodsFor: 'optimizing' stamp: 'ajh 3/10/2003 15:45'!
absorbConstantConditionalJumps

	startSequence absorbConstantConditionalJumps: IdentitySet new! !

!IRMethod methodsFor: 'optimizing' stamp: 'ajh 3/10/2003 15:45'!
absorbJumpsToSingleInstrs

	startSequence absorbJumpToSingleInstr: IdentitySet new! !

!IRMethod methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:23'!
accept: aVisitor
	^ aVisitor visitMethod: self! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 5/13/2011 13:42'!
addAdditionalLiteral: aLiteral
	additionalLiterals add: aLiteral! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 6/6/2012 13:38'!
addAdditionalLiterals: literals 
	additionalLiterals :=  literals! !

!IRMethod methodsFor: 'inlining' stamp: 'md 9/11/2005 18:52'!
addInstructionsAfter: aCollection
	| returningSeqs  lastInstr |
	aCollection ifEmpty: [^self].
	returningSeqs := self allSequences select: [:each | each last isReturn].
	lastInstr := returningSeqs last last.
	lastInstr addInstructionsBefore: aCollection.
	! !

!IRMethod methodsFor: 'inlining' stamp: 'md 7/14/2005 12:31'!
addInstructionsBefore: aCollection

	(self startSequence nextSequence first) addInstructionsBefore: aCollection.
	! !

!IRMethod methodsFor: 'accessing' stamp: 'JorgeRessia 5/6/2010 11:07'!
addPragma: aPragma
	
	pragmas add: aPragma.! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 5/13/2011 13:56'!
additionalLiterals
	^additionalLiterals! !

!IRMethod methodsFor: 'enumerating' stamp: 'md 6/10/2005 16:07'!
allInstructions
	" return irNodes as a flat collection "

	| irInstructions |
	irInstructions := OrderedCollection new.
	startSequence withAllSuccessorsDo: [:seq | seq do: [:bc | irInstructions add: bc]].
	^irInstructions! !

!IRMethod methodsFor: 'enumerating' stamp: 'md 6/13/2005 10:41'!
allInstructionsMatching: aBlock
	" return irNodes as a flat collection "

	| irInstructions |
	irInstructions := OrderedCollection new.
	startSequence withAllSuccessorsDo: [:seq | seq do: [:bc | (aBlock value: bc) ifTrue: [irInstructions add: bc]]].
	^irInstructions! !

!IRMethod methodsFor: 'enumerating' stamp: 'jb 3/29/2010 18:04'!
allSequences
	^ startSequence withAllSuccessors! !

!IRMethod methodsFor: 'enumerating' stamp: 'MarcusDenker 8/13/2010 14:11'!
allTempAccessInstructions
	^self allInstructionsMatching: [:bc | bc isTemp].! !

!IRMethod methodsFor: 'inspector' stamp: 'MarcusDenker 10/21/2014 10:56'!
children
	^self startSequence withAllSuccessors! !

!IRMethod methodsFor: 'accessing' stamp: 'ClementBera 5/23/2013 11:09'!
compilationContext
	^ compilationContext ifNil: [ 
		"only happens when decompiling or using stand-alone"
		compilationContext := CompilationContext default]! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 5/13/2013 13:57'!
compilationContext: aCompilationContext
	compilationContext := aCompilationContext! !

!IRMethod methodsFor: 'translating' stamp: 'MarcusDenker 8/11/2010 17:06'!
compiledMethod

	^ self compiledMethodWith: CompiledMethodTrailer empty! !

!IRMethod methodsFor: 'translating' stamp: 'MarcusDenker 12/17/2012 14:25'!
compiledMethodWith: trailer

	^compiledMethod 
		ifNil: [self generate: trailer ]
		ifNotNil: [compiledMethod]! !

!IRMethod methodsFor: 'enumerating' stamp: 'MarcusDenker 12/13/2012 17:39'!
firstInstructionMatching: aBlock
	" return irNodes as a flat collection "

	startSequence withAllSuccessorsDo: [:seq | seq do: [:bc | (aBlock value: bc) ifTrue: [^bc]]].
	^nil! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 7/22/2013 16:09'!
forceLongForm
	compilationContext ifNil: [ ^ false ].
	^compilationContext optionLongIvarAccessBytecodes
		! !

!IRMethod methodsFor: 'translating' stamp: 'MarcusDenker 12/17/2012 14:24'!
generate
	^self generate: CompiledMethodTrailer empty! !

!IRMethod methodsFor: 'translating' stamp: 'ClementBer 10/14/2014 14:22'!
generate: trailer
	
	| irTranslator |
      irTranslator := IRTranslatorV2 new
		compilationContext: compilationContext;
		trailer: trailer;
		visitNode: self;
		pragmas: pragmas;
		yourself.
	compiledMethod := irTranslator compiledMethod.
	self sourceNode 
		ifNotNil: [ 
			compiledMethod classBinding: self sourceNode methodClass binding.
			compiledMethod selector: self sourceNode selector ]
		ifNil: [ 
			compiledMethod classBinding: UndefinedObject binding.
			compiledMethod selector: #UndefinedMethod ].
	^ compiledMethod! !

!IRMethod methodsFor: 'testing' stamp: 'ToonVerwaest 3/27/2011 17:45'!
hasTempVector: aSymbol
	startSequence withAllSuccessorsDo: [ :seq | (seq hasTempVector: aSymbol) ifTrue: [ ^ true ]].
	^ false! !

!IRMethod methodsFor: 'scoping' stamp: 'MarcusDenker 8/18/2010 14:54'!
indexForVarNamed: aName

	^tempMap at: aName! !

!IRMethod methodsFor: 'initialization' stamp: 'MarcusDenker 5/15/2013 11:12'!
initialize

	irPrimitive := IRPrimitive null.
	tempMap := Dictionary new.
	pragmas := OrderedCollection new.
	additionalLiterals := OCLiteralSet new.
	numArgs := 0.! !

!IRMethod methodsFor: 'debugging' stamp: 'HenrikSperreJohansen 10/12/2015 16:33'!
instructionForPC: aPC
"generates the compiledMethod and optimize the ir. 
	Removes the side-effect of optimizing the IR while looking for instruction, 
	which results in incorrect found instruction"
	self compiledMethod.
	"For a given PC, the actual instruction may start N bytes ahead, specifically startPC of blocks is *after* the bytecode that creates the block. N = 3 must be revisited when bytecode sets are extended"
	0 to: 3 do: [ :off |
		(self firstInstructionMatching: [:ir | ir bytecodeOffset = (aPC - off) ]) ifNotNil: [:it |^it]]
	! !

!IRMethod methodsFor: 'decompiling' stamp: 'MarcusDenker 8/8/2011 13:42'!
instructionsForDecompiling
	"return all instructions, but skip the block bodies, as the decompiler
	recurses over blocks"
	
	^startSequence instructionsForDecompiling allButFirst.! !

!IRMethod methodsFor: 'accessing' stamp: 'md 11/15/2004 17:08'!
ir
	^self.! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 5/15/2013 08:29'!
irPrimitive

	^ irPrimitive! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 5/15/2013 08:29'!
irPrimitive: aPrimitiveNode

	irPrimitive := aPrimitiveNode! !

!IRMethod methodsFor: 'testing' stamp: 'JorgeRessia 5/13/2010 11:18'!
isPushClosureCopy
	^false.! !

!IRMethod methodsFor: 'testing' stamp: 'md 6/21/2005 13:56'!
isSend
	^false.! !

!IRMethod methodsFor: 'printing' stamp: 'ClementBer 10/14/2014 14:22'!
longPrintOn: stream

	IRPrinterV2 new
		stream: stream;
		visitNode: self! !

!IRMethod methodsFor: 'accessing' stamp: 'md 6/16/2005 15:02'!
method
	^self.! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 8/18/2010 19:03'!
numArgs

	^ numArgs! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 8/18/2010 19:03'!
numArgs: anInteger

	numArgs := anInteger! !

!IRMethod methodsFor: 'optimizing' stamp: 'ClementBera 7/16/2014 11:27'!
optimize
	self removeEmptyStart.
	self compilationContext optionOptimizeIR ifFalse: [^self].
	self absorbJumpsToSingleInstrs.
	
	"This last two optimizations works but the problem 
	when you absorb conditional jumps 
	is that and: / or: chained generate explicitely 
	constant conditional jumps to tip the JIt and the 
	decompiler that they are and: or: and not conditions/loops
	
	self absorbConstantConditionalJumps.
	self absorbJumpsToSingleInstrs"! !

!IRMethod methodsFor: 'accessing' stamp: 'JorgeRessia 5/20/2010 10:15'!
predecessorsOf: aSequence
	| predecessors |
	predecessors := OrderedCollection new.
	self allSequences do: [:each | (each successorSequences includes: aSequence) ifTrue: [predecessors add: each]].
	^predecessors! !

!IRMethod methodsFor: 'accessing' stamp: 'md 7/10/2005 22:06'!
properties
	^properties! !

!IRMethod methodsFor: 'accessing' stamp: 'md 7/10/2005 22:06'!
properties: propDict
	properties := propDict.! !

!IRMethod methodsFor: 'optimizing' stamp: 'ClementBera 2/28/2014 10:24'!
removeEmptyStart

	 (startSequence size = 1 and: [ startSequence last isPushClosureCopy not ]) ifTrue: [
        "startSeq is just unconditional jump, forget it"
        startSequence := startSequence last destination].
! !

!IRMethod methodsFor: 'inlining' stamp: 'md 9/12/2005 12:00'!
removeReturn
	self allSequences last removeLast.! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 11/6/2014 14:53'!
sourceInterval
	^self sourceNode sourceInterval! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 11/19/2012 17:11'!
sourceNode
	^sourceNode! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 11/19/2012 17:12'!
sourceNode: aNode
	sourceNode := aNode! !

!IRMethod methodsFor: 'accessing' stamp: 'ajh 3/10/2003 17:53'!
startSequence

	^ startSequence! !

!IRMethod methodsFor: 'initialize' stamp: 'md 7/9/2005 22:36'!
startSequence: irSequence

	startSequence := irSequence.
	irSequence method: self.! !

!IRMethod methodsFor: 'accessing' stamp: 'MarcusDenker 4/13/2010 14:47'!
tempKeys

	^ tempMap keys! !

!IRMethod methodsFor: 'accessing' stamp: 'JorgeRessia 4/16/2010 11:34'!
tempMap
	^ tempMap! !

!IRMethod methodsFor: 'enumerating' stamp: 'MarcusDenker 12/18/2012 14:28'!
tempVectorNamed: aName
	
	^self firstInstructionMatching: [:ir | ir isTempVector and:  [ir name = aName ] ]! !

Object subclass: #IRPrimitive
	instanceVariableNames: 'primitiveNum spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Bytecode'!

!IRPrimitive commentStamp: 'ajh 3/24/2003 21:35' prior: 0!
I represent a primitive.  I am more than just a number if I am a named primitive.

Structure:

 num	<Integer>	Primitive number.
 spec	<Object>		Stored in first literal when num is 117 or 120.
!

!IRPrimitive class methodsFor: 'initialization' stamp: 'JorgeRessia 1/10/2010 11:28'!
from: aPragmaNode

	^ self new initializeFrom: aPragmaNode! !

!IRPrimitive class methodsFor: 'instance creation' stamp: 'ajh 7/14/2001 12:47'!
null

	^ self new num: 0! !

!IRPrimitive methodsFor: 'accessing' stamp: 'MarcusDenker 8/12/2010 15:54'!
initializeFrom: aPragmaNode

	primitiveNum := 0.
	spec := Array 
		with: (aPragmaNode arguments second) name
		with: (aPragmaNode arguments first) name
		with: 0 with: 0.
! !

!IRPrimitive methodsFor: 'accessing' stamp: 'ajh 7/14/2001 12:37'!
num

	^ primitiveNum! !

!IRPrimitive methodsFor: 'accessing' stamp: 'ajh 7/14/2001 12:23'!
num: n

	primitiveNum := n! !

!IRPrimitive methodsFor: 'printing' stamp: 'ajh 3/12/2003 12:26'!
printOn: aStream

	aStream nextPutAll: 'primitive '; print: primitiveNum! !

!IRPrimitive methodsFor: 'printing' stamp: 'MarcusDenker 8/13/2010 11:39'!
printPrimitiveOn: aStream
	"Print the primitive on aStream"

	| primIndex primDecl |
	primIndex := primitiveNum.
	primIndex = 0
		ifTrue: [ ^ self ].
	primIndex = 120
		ifTrue: [ 
			"External call spec"
			^ aStream print: spec ].
	aStream nextPutAll: '<primitive: '.
	primIndex = 117
		ifTrue: [ 
			primDecl := spec.
			aStream
				nextPut: $';
				nextPutAll: primDecl second;
				nextPut: $'.
			primDecl first
				ifNotNil: [ 
					aStream
						nextPutAll: ' module: ';
						nextPut: $';
						nextPutAll: primDecl first;
						nextPut: $' ] ]
		ifFalse: [ aStream print: primIndex ].
	aStream nextPut: $>.
	(primIndex ~= 117 and: [ primIndex ~= 120 ])
		ifTrue: [ 
			Smalltalk
				at: #Interpreter
				ifPresent: [ :cls | 
					aStream
						nextPutAll: ' "';
						nextPutAll: ((cls classPool at: #PrimitiveTable) at: primIndex + 1);
						nextPutAll: '" ' ] ]! !

!IRPrimitive methodsFor: 'printing' stamp: 'ajh 3/19/2003 22:02'!
sourceText

	^ String streamContents: [:stream |
		self printPrimitiveOn: stream]! !

!IRPrimitive methodsFor: 'accessing' stamp: 'ajh 7/14/2001 12:37'!
spec

	^ spec! !

!IRPrimitive methodsFor: 'accessing' stamp: 'ajh 7/14/2001 12:30'!
spec: literal

	spec := literal! !

Object subclass: #IRRemoteArray
	instanceVariableNames: 'size index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Bytecode'!

!IRRemoteArray commentStamp: '<historical>' prior: 0!
I model the TempVector for the decompiler!

!IRRemoteArray methodsFor: 'enumerating' stamp: 'ToonVerwaest 3/27/2011 12:46'!
do: aBlock
	1 to: size do: [ :idx | aBlock value: (idx - 1) ]! !

!IRRemoteArray methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 14:59'!
index
	^ index! !

!IRRemoteArray methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 12:39'!
index: anIndex
	index := anIndex! !

!IRRemoteArray methodsFor: 'enumerating' stamp: 'MarcusDenker 5/19/2011 14:27'!
indexOf: anInteger
	^anInteger + 1.! !

!IRRemoteArray methodsFor: 'accessing' stamp: 'ToonVerwaest 3/26/2011 19:15'!
size
	^ size! !

!IRRemoteArray methodsFor: 'accessing' stamp: 'ToonVerwaest 3/26/2011 19:13'!
size: aSize
	size := aSize! !

Object subclass: #IRSequence
	instanceVariableNames: 'sequence orderNumber method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Nodes'!

!IRSequence commentStamp: '<historical>' prior: 0!
A sequence is corresponds to a block in the control flow graph.!

!IRSequence class methodsFor: 'instance creation' stamp: 'MarcusDenker 6/13/2012 14:11'!
orderNumber: aNumber
	^self new orderNumber: aNumber! !

!IRSequence methodsFor: 'copying' stamp: 'dr 9/10/2005 20:59'!
, otherCollection 
	^sequence, otherCollection! !

!IRSequence methodsFor: 'optimizing' stamp: 'MarcusDenker 9/20/2013 15:18'!
absorbConstantConditionalJumps: alreadySeen
	"Collapse sequences that look like:
			[if] goto s1
			...
		 s1:	pushConst: true/false
			goto s2
		 s2:	if true/false goto s3 else s4
	into:
			[if] goto s3/s4

	These sequences are produced by and:/or: messages"

	| seq bool if |
	(alreadySeen includes: self) ifTrue: [^ self].
	alreadySeen add: self.

	[(seq := self successorSequences) notEmpty  "not return"
	  and: [(seq := seq first "destination") size = 2
	   and: [(seq first isPushLiteral: [:obj | (bool := obj) isKindOf: Boolean])
	    and: [seq last isGoto
	     and: [(if := seq last destination first) isIf]]]]
	] whileTrue: [ "absorb"
		self last destination: (bool == if boolean
			ifTrue: [if destination]
			ifFalse: [if otherwise]).
	].

	self successorSequences do: [:instrs | instrs ifNotNil: [:i | i absorbConstantConditionalJumps: alreadySeen]].

! !

!IRSequence methodsFor: 'optimizing' stamp: 'md 5/17/2013 16:49'!
absorbJumpToSingleInstr: alreadySeen
	"Collapse jumps to single return instructions into caller"

	| seqs seq |
	(alreadySeen includes: self) ifTrue: [^ self].
	alreadySeen add: self.
	[ (seqs := self successorSequences) size = 1  "unconditional jump..." 
	   and: [((seq := seqs first) size = 1)  "...to single instruction..."
	    and: [seq successorSequences size < 2
		and: [self last isBlockReturnTop not
		  and: [((seq sequence size = 1) and: [(seq sequence first isBlockReturnTop) or: [seq sequence first isReturn]]) not]]]]"...but don't collapse conditional jumps so their otherwiseSequences can stay right after them"
	] whileTrue: [ "replace goto with single instruction"
		self removeLast.
		seq do: [:instr |  self add: instr copy].
	].

	seqs do: [:instrs | instrs ifNotNil: [:i | i absorbJumpToSingleInstr: alreadySeen]].
! !

!IRSequence methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:23'!
accept: aVisitor
	^ aVisitor visitSequence: self! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:57'!
add: anInstruction

	sequence add: anInstruction.
	anInstruction sequence: self.
	^anInstruction.! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:57'!
add: instr after: another

	sequence add: instr after: another.
	instr sequence: self.
	^instr.! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:58'!
add: instr before: another
	sequence add: instr before: another.
	instr sequence: self.
	^instr.! !

!IRSequence methodsFor: 'adding' stamp: 'dr 9/11/2005 15:35'!
addAll: aCollection
	^sequence addAll: aCollection! !

!IRSequence methodsFor: 'adding' stamp: 'md 9/28/2005 17:55'!
addAllFirst: aCollection
	^sequence addAllFirst: aCollection.! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:58'!
addInstructions: aCollection
	
	^aCollection do: [:instr | self add: instr].! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:57'!
addInstructions: aCollection after: anInstruction
	
	^aCollection reverseDo: [:instr | self add: instr after: anInstruction].! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 12:29'!
addInstructions: aCollection before: anInstruction

	aCollection do: [:instr | self add: instr before: anInstruction].! !

!IRSequence methodsFor: 'adding' stamp: 'dr 9/10/2005 20:57'!
addLast: anInstruction
	^self add: anInstruction.! !

!IRSequence methodsFor: 'accessing' stamp: 'md 9/29/2005 11:25'!
after: o
	^sequence after: o! !

!IRSequence methodsFor: 'accessing' stamp: 'dr 9/10/2005 21:01'!
at: index
	^sequence at: index! !

!IRSequence methodsFor: 'inspector' stamp: 'MarcusDenker 10/21/2014 11:01'!
children
	^sequence! !

!IRSequence methodsFor: 'enumerating' stamp: 'MarcusDenker 8/19/2010 08:39'!
contains: aBlock
	^sequence contains: aBlock.! !

!IRSequence methodsFor: 'enumerating' stamp: 'dr 9/10/2005 21:02'!
detect: aBlock
	^sequence detect: aBlock! !

!IRSequence methodsFor: 'enumerating' stamp: 'md 7/14/2005 12:24'!
do: aBlock
	^sequence do: aBlock.! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:31'!
first
	^sequence first! !

!IRSequence methodsFor: 'testing' stamp: 'MarcusDenker 8/19/2010 15:30'!
hasTempVector: aSymbol
	^sequence anySatisfy: [:irNode | irNode isTempVector and: [irNode name = aSymbol]].! !

!IRSequence methodsFor: 'testing' stamp: 'md 7/14/2005 12:30'!
ifEmpty: aBlock
	^sequence ifEmpty: aBlock! !

!IRSequence methodsFor: 'testing' stamp: 'md 7/14/2005 12:30'!
ifNotEmpty: aBlock
	^sequence ifNotEmpty: aBlock! !

!IRSequence methodsFor: 'initialization' stamp: 'jb 4/1/2010 13:48'!
initialize
	sequence := OrderedCollection new.! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:58'!
instructionsDo: aBlock

	^self withAllSuccessorsDo: [:seq | seq do: aBlock].! !

!IRSequence methodsFor: 'successor sequences' stamp: 'MarcusDenker 8/8/2011 13:42'!
instructionsForDecompiling

	| irInstructions |
	irInstructions := OrderedCollection new.
	self withNonBodySuccessorsDo: [:seq | seq do: [:bc | irInstructions add: bc]].
	^irInstructions
	! !

!IRSequence methodsFor: 'testing' stamp: 'md 7/14/2005 12:23'!
isEmpty
	^sequence isEmpty! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:23'!
last
	^sequence last! !

!IRSequence methodsFor: 'printing' stamp: 'ClementBer 10/14/2014 16:52'!
longPrintOn: stream

	[IRPrinterV2 new
		stream: stream;
		visitNode: self
	] onDNU: #orderNumber do: [:ex | ex resume: ex receiver]! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:00'!
method

	^method! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:00'!
method: aIRMethod

	method := aIRMethod! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:58'!
nextSequence

	| sequences i |
	sequences := self withAllSuccessors.
	i := sequences findFirst: [:seq | seq orderNumber = self orderNumber].
	(i = 0 or: [i = sequences size]) ifTrue: [^ nil].
	^ sequences at: i + 1! !

!IRSequence methodsFor: 'successor sequences' stamp: 'MarcusDenker 8/8/2011 13:31'!
nonBodySuccessorSequences

	sequence isEmpty ifTrue: [^ #()].
	^ sequence last nonBodySuccessorSequences! !

!IRSequence methodsFor: 'testing' stamp: 'dr 9/10/2005 20:55'!
notEmpty
	^sequence notEmpty! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:00'!
orderNumber
	"Sequences are sorted by this number"

	^ orderNumber! !

!IRSequence methodsFor: 'accessing' stamp: 'JorgeRessia 6/19/2010 08:20'!
orderNumber: num
	"Sequences are sorted by this number"
	orderNumber := num.! !

!IRSequence methodsFor: 'printing' stamp: 'md 7/14/2005 12:00'!
printOn: stream

	stream nextPutAll: 'an '.
	self class printOn: stream.
	stream space.
	stream nextPut: $(.
	self orderNumber printOn: stream.
	stream nextPut: $).
! !

!IRSequence methodsFor: 'replacing' stamp: 'md 7/14/2005 12:00'!
remove: aNode
	aNode sequence: nil.
	sequence remove: aNode ifAbsent: [self error].! !

!IRSequence methodsFor: 'removing' stamp: 'dr 9/10/2005 21:03'!
removeFirst
	^sequence removeFirst.! !

!IRSequence methodsFor: 'removing' stamp: 'md 7/14/2005 12:25'!
removeLast
	^sequence removeLast.! !

!IRSequence methodsFor: 'removing' stamp: 'ToonVerwaest 3/26/2011 14:40'!
removeLast: n
	^sequence removeLast: n.! !

!IRSequence methodsFor: 'replacing' stamp: 'ClementBer 10/14/2014 15:44'!
replaceNode: aNode withNode: anotherNode 

	| index |
	index := sequence indexOf: aNode ifAbsent: [ self error ].
	sequence at: index put: (anotherNode sequence: self).! !

!IRSequence methodsFor: 'replacing' stamp: 'md 7/14/2005 12:01'!
replaceNode: aNode withNodes: aCollection 

	self addInstructions: aCollection before: aNode.
	sequence remove: aNode ifAbsent: [self error].! !

!IRSequence methodsFor: 'enumerating' stamp: 'md 7/14/2005 12:28'!
reverseDo: aBlock
	^sequence reverseDo: aBlock.! !

!IRSequence methodsFor: 'enumerating' stamp: 'md 7/14/2005 12:28'!
select: aBlock
	^sequence select: aBlock.! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:32'!
sequence
	^sequence! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:25'!
size
	^sequence size.! !

!IRSequence methodsFor: 'inspector' stamp: 'MarcusDenker 10/21/2014 11:05'!
sourceInterval
	^self sequence first sourceInterval first to: self sequence last sourceInterval last! !

!IRSequence methodsFor: 'inspector' stamp: 'MarcusDenker 10/22/2014 10:28'!
sourceNode
	"we should do better here"
	^RBSequenceNode new.! !

!IRSequence methodsFor: 'manipulating' stamp: 'ToonVerwaest 3/27/2011 17:20'!
splitAfter: instruction

	| newSeq index next |
	next := self nextSequence.
	next := next
		ifNil: [self orderNumber + 1]
		ifNotNil: [(next orderNumber + self orderNumber) / 2].
	newSeq := self class new orderNumber: next.
	newSeq method: self method.
	"Split after instruction"
	index := sequence indexOf: instruction.
	(sequence last: sequence size - index) do: [:instr | newSeq add: instr].
	sequence := sequence first: index.
	self flag: 'The jump inherits the bytecode index from the instruction where it was split. Check if this value is correct.'.
	self add: (IRJump new destination: newSeq; bytecodeIndex: (instruction bytecodeIndex + 1)).
	^ newSeq! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:59'!
successorSequences

	sequence isEmpty ifTrue: [^ #()].
	^ sequence last successorSequences! !

!IRSequence methodsFor: 'accessing' stamp: 'MarcusDenker 12/20/2012 14:21'!
tempVectorNamed: aSymbol
	^sequence detect: [:irNode | irNode isTempVector and: [irNode name = aSymbol]].! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:59'!
withAllSuccessors
	"Return me and all my successors sorted by sequence orderNumber"

	| list |
	list := OrderedCollection new: 20.
	self withAllSuccessorsDo: [:seq | list add: seq].
	^ list asSortedCollection: [:x :y | x orderNumber <= y orderNumber]! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:59'!
withAllSuccessorsDo: block
	"Iterate over me and all my successors only once"

	self withAllSuccessorsDo: block alreadySeen: IdentitySet new! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:59'!
withAllSuccessorsDo: block alreadySeen: set
	"Iterate over me and all my successors only once"

	(set includes: self) ifTrue: [^ self].
	set add: self.
	block value: self.
	self successorSequences do: [:seq |
		seq ifNotNil: [seq withAllSuccessorsDo: block alreadySeen: set]].
! !

!IRSequence methodsFor: 'successor sequences' stamp: 'MarcusDenker 8/8/2011 13:27'!
withNonBodySuccessorsDo: block
	"Iterate over me and all my successors only once"

	self withNonBodySuccessorsDo: block alreadySeen: IdentitySet new! !

!IRSequence methodsFor: 'successor sequences' stamp: 'MarcusDenker 8/8/2011 13:28'!
withNonBodySuccessorsDo: block alreadySeen: set
	"Iterate over me and all my successors only once"

	(set includes: self) ifTrue: [^ self].
	set add: self.
	block value: self.
	self nonBodySuccessorSequences do: [:seq |
		seq ifNotNil: [seq withNonBodySuccessorsDo: block alreadySeen: set]].
! !

Object subclass: #IRStackCount
	instanceVariableNames: 'start position length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Bytecode'!

!IRStackCount commentStamp: 'ajh 3/25/2003 00:34' prior: 0!
This keeps track of the stack count for the BytecodeGenerator.!

IRStackCount subclass: #IRClosureStackCount
	instanceVariableNames: 'numMethodTempVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Bytecode'!

!IRClosureStackCount commentStamp: 'NicolaiHess 11/17/2015 23:57' prior: 0!
IRClosureStackCount is used to distinguish between a stack 
in the method scope and a stack within a closure block. The
closure stack size is independent of the number of tempvars from the compiled method, therefore that number is subtracted
from this stack size length.!

!IRClosureStackCount class methodsFor: 'instance creation' stamp: 'NicolaiHess 11/17/2015 23:58'!
newOn: stack
	^ (self startAt: stack position)
		numMethodTempVars: stack numMethodTempVars;
		yourself! !

!IRClosureStackCount methodsFor: 'initialization' stamp: 'NicolaiHess 11/17/2015 23:59'!
initialize

	super initialize.

	numMethodTempVars := 0.! !

!IRClosureStackCount methodsFor: 'accessing' stamp: 'NicolaiHess 11/17/2015 23:59'!
length

	^ super length - self numMethodTempVars! !

!IRClosureStackCount methodsFor: 'accessing' stamp: 'NicolaiHess 11/17/2015 23:59'!
numMethodTempVars
	^ numMethodTempVars! !

!IRClosureStackCount methodsFor: 'accessing' stamp: 'NicolaiHess 11/17/2015 23:59'!
numMethodTempVars: nilOrNumber
	numMethodTempVars := nilOrNumber ifNil:[0]! !

!IRStackCount class methodsFor: 'instance creation' stamp: 'ajh 3/13/2003 01:49'!
new

	^ super new startAt: 0! !

!IRStackCount class methodsFor: 'instance creation' stamp: 'NicolaiHess 11/18/2015 00:00'!
newOn: stack

	^ self startAt: stack position! !

!IRStackCount class methodsFor: 'instance creation' stamp: 'MarcusDenker 8/13/2010 15:26'!
startAt: pos

	^ self new startAt: pos! !

!IRStackCount methodsFor: 'comparing' stamp: 'ajh 3/13/2003 01:39'!
= other

	^ self class == other class 
	  and: [start = other start
	  and: [position = other position
	  and: [length = other size]]]! !

!IRStackCount methodsFor: 'comparing' stamp: 'ajh 3/13/2003 01:51'!
hash

	^ position hash bitXor: (length hash bitXor: start hash)! !

!IRStackCount methodsFor: 'results' stamp: 'ajh 3/13/2003 01:32'!
length

	^length! !

!IRStackCount methodsFor: 'results' stamp: 'NicolaiHess 11/18/2015 00:00'!
linkTo: stackOrNil

	stackOrNil ifNil: [^  self class newOn: self].
	^ self position = stackOrNil start
		ifTrue: [stackOrNil]
		ifFalse: [self error: 'stack out of sync in bytecode generator']! !

!IRStackCount methodsFor: 'affecting' stamp: 'jorgeRessia 11/3/2009 16:56'!
pop

	^ self pop: 1! !

!IRStackCount methodsFor: 'affecting' stamp: 'MarcusDenker 6/19/2012 10:07'!
pop: n

	(position := position - n) < 0 
		ifTrue: [self error: 'stack underflow in bytecode generator']! !

!IRStackCount methodsFor: 'results' stamp: 'ajh 3/13/2003 01:32'!
position

	^position! !

!IRStackCount methodsFor: 'printing' stamp: 'ajh 3/13/2003 01:38'!
printOn: aStream
	
	super printOn: aStream.
	aStream
		nextPutAll: ' start '; print: start;
		nextPutAll: ' stop '; print: position;
		nextPutAll: ' max '; print: length.
! !

!IRStackCount methodsFor: 'affecting' stamp: 'jorgeRessia 11/3/2009 16:54'!
push
	^ self push: 1! !

!IRStackCount methodsFor: 'affecting' stamp: 'jorgeRessia 11/3/2009 16:59'!
push: n
	(position := position + n) > length 
		ifTrue: [length := position]! !

!IRStackCount methodsFor: 'results' stamp: 'ajh 3/13/2003 01:32'!
size

	^length! !

!IRStackCount methodsFor: 'results' stamp: 'ajh 3/13/2003 01:36'!
start

	^ start! !

!IRStackCount methodsFor: 'initialize' stamp: 'ajh 3/13/2003 01:48'!
startAt: pos

	start := position := length := pos! !

Object subclass: #IRVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Manipulation'!

!IRVisitor commentStamp: 'ClementBer 10/14/2014 13:58' prior: 0!
I visit an IRMethod instructions and write them out to a print stream.!

IRVisitor subclass: #IRFix
	instanceVariableNames: 'prevInstr storePopToFix retToFix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Manipulation'!

!IRFix commentStamp: 'ClementBera 10/27/2014 10:59' prior: 0!
Fix the IR nodes.

Transforms:

store, pop => popInto
some returns => quick returns!

!IRFix methodsFor: 'private' stamp: 'ClementBer 10/14/2014 16:40'!
convertRet: assoc forSeq: seq 
	| push ret |
	push := assoc key.
	ret := assoc value.
	seq replaceNode: push withNode: (push quickRetNode sourceNode: ret sourceNode).
	seq remove: ret.! !

!IRFix methodsFor: 'private' stamp: 'ClementBer 10/14/2014 16:40'!
convertStorePop: assoc forSeq: seq 
	| store pop |
	store := assoc key.
	pop := assoc value.
	seq replaceNode: store withNode: (store popIntoNode sourceNode: store sourceNode).
	seq remove: pop.! !

!IRFix methodsFor: 'initialize' stamp: 'ClementBer 10/14/2014 16:21'!
initialize

	super initialize.

	storePopToFix := OrderedCollection new.
	retToFix := OrderedCollection new.! !

!IRFix methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 15:57'!
visitInstruction: instr
	self visitNode: instr.
	prevInstr := instr.! !

!IRFix methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:18'!
visitPop: pop
	prevInstr ifNil: [ ^ self ].
	prevInstr isStore ifFalse: [ ^ self ].
	"store then pop, however, cannot remove instr while iterating over the collection"
	storePopToFix add: prevInstr -> pop.
	
	! !

!IRFix methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:19'!
visitReturn: ret
	prevInstr ifNil: [ ^ self ].
	prevInstr canBeQuickReturn ifFalse: [ ^ self ].
	retToFix add: prevInstr -> ret.! !

!IRFix methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:19'!
visitSequence: instructionSequence
	prevInstr := nil.
	storePopToFix reset.
	retToFix reset.
	super visitSequence: instructionSequence.
	retToFix do: [ :each | self convertRet: each forSeq: instructionSequence ].
	storePopToFix do: [ :each | self convertStorePop: each forSeq: instructionSequence ]! !

IRVisitor subclass: #IRPrinterV2
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Manipulation'!

!IRPrinterV2 commentStamp: 'ClementBer 10/14/2014 14:16' prior: 0!
I interpret IRMethod instructions and write them out to a print stream.!

!IRPrinterV2 methodsFor: 'private' stamp: 'ClementBer 10/14/2014 14:15'!
label: seqNum

	"add tab and cr since this does not get called within interpretInstruction:"
	stream cr.  "extra cr just to space out sequences"
	stream nextPutAll: 'label: '.
	seqNum printOn: stream.
	stream cr.
! !

!IRPrinterV2 methodsFor: 'private' stamp: 'ClementBer 10/14/2014 14:21'!
stream: stringWriteStream

	stream := stringWriteStream! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:12'!
visitBlockReturnTop: blockReturnTop

	stream nextPutAll: 'blockReturnTop'.

! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'MarcusDenker 6/25/2015 15:25'!
visitInstruction: aNode
	self visitNode: aNode.
	stream cr.! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:13'!
visitJump: jump

	stream nextPutAll: 'goto: '.
	jump destination orderNumber printOn: stream.
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:13'!
visitJumpIf: jumpIf

	stream nextPutAll: 'if: '.
	jumpIf boolean printOn: stream.
	stream nextPutAll: ' goto: '.
	jumpIf destination orderNumber printOn: stream.
	stream nextPutAll: ' else: '.
	jumpIf otherwise orderNumber printOn: stream.
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:16'!
visitPop: pop

	stream nextPutAll: 'popTop'
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:22'!
visitPopIntoInstVar: instVar
	
	stream nextPutAll: 'popIntoInstVar: '.
	instVar index printOn: stream.
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:22'!
visitPopIntoLiteralVariable: litVar
	
	| object |
	object := litVar association.
	stream nextPutAll: 'popIntoLiteralVariable: '.
	object isVariableBinding ifTrue: [^ stream nextPutAll: object key].
	object printOn: stream.! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:23'!
visitPopIntoRemoteTemp: remoteTemp

	stream nextPutAll: 'popIntoRemoteTemp: '.
	remoteTemp name printOn: stream..
	stream nextPutAll: ' inVector: '.
	remoteTemp tempVectorName printOn: stream! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:23'!
visitPopIntoTemp: tmp

	stream nextPutAll: 'popIntoTemp: '.
	tmp name printOn: stream.


! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:17'!
visitPushArray: array
	
	array cons 
		ifTrue: [  
			stream nextPutAll: 'pushConsArray: ' ]
		ifFalse: [
			stream nextPutAll: 'pushNewArray: ' ].
	array size printOn: stream. 
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'MarcusDenker 10/21/2014 10:55'!
visitPushClosureCopy: closure

	stream nextPutAll: 'pushClosureCopyCopiedValues: '.
	stream nextPutAll: closure copiedValues printString .
	stream nextPutAll: ' args: '.
	stream nextPutAll: closure arguments printString.
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:17'!
visitPushDup: dup
	
	stream nextPutAll: 'pushDup'


! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:18'!
visitPushInstVar: instVar
	
	stream nextPutAll: 'pushInstVar: '.
	instVar index printOn: stream.
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:34'!
visitPushLiteral: lit

	| object |
	object := lit literal.
	stream nextPutAll: 'pushLiteral: '.
	object isVariableBinding ifTrue: [^ stream nextPutAll: object key].
	object printOn: stream.
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:32'!
visitPushLiteralVariable: var
	
	| object |
	object := var association.
	stream nextPutAll: 'pushLiteralVariable: '.
	object isVariableBinding ifTrue: [^ stream nextPutAll: object key].
	object printOn: stream.! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:30'!
visitPushReceiver: receiver

	stream nextPutAll: 'pushReceiver'


! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:18'!
visitPushRemoteTemp: remoteTemp

	stream nextPutAll: 'pushRemoteTemp: '.
	remoteTemp name printOn: stream..
	stream nextPutAll: ' inVector: '.
	remoteTemp tempVectorName printOn: stream! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:41'!
visitPushTemp: tmp

	stream nextPutAll: 'pushTemp: '.
	tmp name printOn: stream.


! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:19'!
visitPushThisContext: ctxt

	stream nextPutAll: 'pushThisContext'
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:19'!
visitReturn: ret
	
	stream nextPutAll: 'returnTop'.

! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:23'!
visitReturnInstVar: instVar
	stream nextPutAll: 'returnInstVar: '.
   instVar index printOn: stream.! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:23'!
visitReturnLiteral: lit

	| object |
	object := lit literal.
	stream nextPutAll: 'returnLiteral: '.
	object isVariableBinding ifTrue: [^ stream nextPutAll: object key].
	object printOn: stream.
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:24'!
visitReturnReceiver: receiver

	stream nextPutAll: 'returnReceiver'


! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:19'!
visitSend: send

	send superOf
		ifNil: [ stream nextPutAll: 'send: '.
			send selector printOn: stream. ]
		ifNotNil: [ :behavior | stream nextPutAll: 'send: '.
			send selector printOn: stream.
			stream nextPutAll: ' toSuperOf: '.
			behavior printOn: stream ]

! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 15:49'!
visitSequence: instructionSequence
	self label: instructionSequence orderNumber.
	super visitSequence: instructionSequence
! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:20'!
visitStoreInstVar: instVar
	stream nextPutAll: 'storeInstVar: '.
   instVar index printOn: stream.! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:21'!
visitStoreLiteralVariable: var

	| object |
	object := var association.
	stream nextPutAll: 'storeLiteralVariable: '.
	object isVariableBinding ifTrue: [^ stream nextPutAll: object key].
	object printOn: stream.! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:21'!
visitStoreRemoteTemp: remoteTemp
	stream nextPutAll: 'storeRemoteTemp: '.
	remoteTemp name printOn: stream..
	stream nextPutAll: ' inVector: '.
	remoteTemp tempVectorName printOn: stream.! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:41'!
visitStoreTemp: tmp

   	stream nextPutAll: 'storeTemp: '.
	tmp name printOn: stream.
 ! !

!IRPrinterV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:13'!
visitTempVector: tempVector

	stream nextPutAll: 'createTempVectorNamed: '.
	tempVector name printOn: stream.
	stream nextPutAll: ' withVars: '.
	stream nextPutAll: tempVector vars printString.
	
	! !

IRVisitor subclass: #IRTranslatorV2
	instanceVariableNames: 'gen currentScope trailer tempVectorStack compilationContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-IR-Manipulation'!

!IRTranslatorV2 commentStamp: 'ClementBer 10/14/2014 13:34' prior: 0!
I visit IRMethod instructions, sending the appropriate bytecode messages to my BytecodeGenerator (gen). !

!IRTranslatorV2 methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 13:35'!
compilationContext
	^ compilationContext ifNil: [ compilationContext := CompilationContext default ]! !

!IRTranslatorV2 methodsFor: 'accessing' stamp: 'ClementBer 10/14/2014 13:35'!
compilationContext: aContext
	compilationContext := aContext! !

!IRTranslatorV2 methodsFor: 'results' stamp: 'ClementBer 10/14/2014 13:57'!
compiledMethod
	^ gen compiledMethodWith: trailer! !

!IRTranslatorV2 methodsFor: 'results' stamp: 'ClementBer 10/14/2014 13:57'!
compiledMethodWith: aTrailer

	^ gen compiledMethodWith: aTrailer! !

!IRTranslatorV2 methodsFor: 'private' stamp: 'ClementBer 10/14/2014 13:56'!
currentScope 
	^currentScope top! !

!IRTranslatorV2 methodsFor: 'initialize' stamp: 'ClementBera 1/28/2015 09:27'!
initialize
	gen := self compilationContext bytecodeGeneratorClass newWithEncoderClass: self compilationContext encoderClass.
	trailer := CompiledMethodTrailer empty.
	currentScope := Stack new.
	tempVectorStack := Stack new.
! !

!IRTranslatorV2 methodsFor: 'private' stamp: 'ClementBer 10/14/2014 16:17'!
label: seqNum

	gen label: seqNum.
	
! !

!IRTranslatorV2 methodsFor: 'private' stamp: 'ClementBer 10/14/2014 13:40'!
popScope

	currentScope size = 1 ifFalse: [currentScope pop]
! !

!IRTranslatorV2 methodsFor: 'private' stamp: 'ClementBer 10/14/2014 14:25'!
pragmas: aCollection
	gen pragmas: aCollection! !

!IRTranslatorV2 methodsFor: 'private' stamp: 'ClementBer 10/14/2014 13:47'!
pushScope: anIRBlockOrMethod

	currentScope push: anIRBlockOrMethod! !

!IRTranslatorV2 methodsFor: 'initialize' stamp: 'ClementBer 10/14/2014 13:35'!
trailer: aTrailer

	trailer := aTrailer! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/27/2014 10:35'!
visitBlockReturnTop: blockReturnTop

	gen blockReturnTop
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'HenrikSperreJohansen 10/12/2015 16:33'!
visitInstruction: instr
	gen mapBytesTo: instr.
	self visitNode: instr.
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:01'!
visitJump: jump

	gen goto: jump destination orderNumber
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:01'!
visitJumpIf: jumpIf

	gen 
		if: jumpIf boolean 
		goto: jumpIf destination orderNumber 
		otherwise: jumpIf otherwise orderNumber
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:02'!
visitPop: pop

	gen popTop

! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:06'!
visitPopIntoInstVar: instVar
	gen storePopInstVar: instVar index! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:08'!
visitPopIntoLiteralVariable: var

	gen storePopIntoLiteralVariable: var association! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:10'!
visitPopIntoRemoteTemp: remoteTemp
	| tempIndex tempVectorIndex tempVector |

	tempVector := tempVectorStack detect: [ :each | each name = remoteTemp tempVectorName ].
	tempVectorIndex := tempVector indexForVarNamed: remoteTemp name.
	tempIndex := self currentScope indexForVarNamed: remoteTemp tempVectorName.

	gen storePopRemoteTemp: tempVectorIndex inVectorAt: tempIndex! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:25'!
visitPopIntoTemp: tmp

   	gen storePopTemp: (self currentScope indexForVarNamed: tmp name)! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:02'!
visitPushArray: array

	array cons 
		ifTrue: [  
			gen pushConsArray: array size ]
		ifFalse: [
			gen pushNewArray: array size ]! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'HenrikSperreJohansen 10/12/2015 16:33'!
visitPushClosureCopy: closure

	closure copiedValues do: [:name | 	
		gen pushTemp: (self currentScope indexForVarNamed: name).
	].
	gen mapBytesTo: closure.
	gen pushClosureCopyNumCopiedValues: closure copiedValues size 
			numArgs: closure arguments size 
			to: closure destination orderNumber.
	self pushScope: closure.
	gen pushNClosureTemps: closure definedTemps size

! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:02'!
visitPushDup: dup
	
	gen pushDup


! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:13'!
visitPushInstVar: instVar
	
	gen pushInstVar: instVar index
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:13'!
visitPushLiteral: lit

	gen pushLiteral: lit literal! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:14'!
visitPushLiteralVariable: var

	gen pushLiteralVariable: var association! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:14'!
visitPushReceiver: receiver

	gen pushReceiver


! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:02'!
visitPushRemoteTemp: remoteTemp
	| tempIndex tempVectorIndex tempVector |

	tempVector := tempVectorStack detect: [:each | each name = remoteTemp tempVectorName].
	tempVectorIndex := tempVector indexForVarNamed: remoteTemp name.
	tempIndex := self currentScope indexForVarNamed: remoteTemp tempVectorName.

	gen pushRemoteTemp: tempVectorIndex inVectorAt: tempIndex
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:02'!
visitPushTemp: tmp

	gen pushTemp: (self currentScope indexForVarNamed: tmp name)



! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:14'!
visitPushThisContext: ctxt

	gen pushThisContext

! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/27/2014 10:36'!
visitReturn: ret
	
	gen returnTop


! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/27/2014 10:36'!
visitReturnInstVar: instVar

	gen returnInstVar: instVar index! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/27/2014 10:36'!
visitReturnLiteral: lit

	gen returnConstant: lit literal
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/27/2014 10:36'!
visitReturnReceiver: rec

	gen returnReceiver


! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:03'!
visitSend: send

	send superOf
		ifNil: [ gen send: send selector ]
		ifNotNil: [ :behavior | gen send: send selector toSuperOf: behavior ]
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/27/2014 10:35'!
visitSequence: instructionSequence
	self currentScope isPushClosureCopy ifTrue: [ 
		self currentScope destination = instructionSequence ifTrue: [ self popScope ] ].
	self label: instructionSequence orderNumber.
	super visitSequence: instructionSequence
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 15:50'!
visitSequences:  irSequences
	irSequences withIndexDo: [ :seq :i | seq orderNumber: i].
	self visitNodes: irSequences.
! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:14'!
visitStoreInstVar: instVar
	gen storeInstVar: instVar index! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:14'!
visitStoreLiteralVariable: var

	gen storeIntoLiteralVariable: var association! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:15'!
visitStoreRemoteTemp: remoteTemp
	| tempIndex tempVectorIndex tempVector |

	tempVector := tempVectorStack detect: [:each | each name = remoteTemp tempVectorName].
	tempVectorIndex := tempVector indexForVarNamed: remoteTemp name.
	tempIndex := self currentScope indexForVarNamed: remoteTemp tempVectorName.

	gen storeRemoteTemp: tempVectorIndex inVectorAt: tempIndex! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:15'!
visitStoreTemp: tmp

   	gen storeTemp: (self currentScope indexForVarNamed: tmp name)! !

!IRTranslatorV2 methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:03'!
visitTempVector: tempVector

	tempVectorStack push: tempVector.
	gen pushNewArray: tempVector vars size. 
	gen storePopTemp: (self currentScope indexForVarNamed: tempVector name)! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitBlockReturnTop: blockReturnTop! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBera 10/15/2014 17:11'!
visitInstruction: instr
	 ! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitJump: jump! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitJumpIf: jumpIf! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 15:48'!
visitMethod: method
	self visitNodes: method allSequences.! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:55'!
visitNode: elem
	^ elem accept: self! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 13:55'!
visitNodes: col
	col do: [ :each | self visitNode: each ]! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPop: pop! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:06'!
visitPopIntoInstVar: instVar! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:07'!
visitPopIntoLiteralVariable: litVar! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:09'!
visitPopIntoRemoteTemp: remoteTemp! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:08'!
visitPopIntoTemp: tmp! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPushArray: pushArray! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPushClosureCopy: pushClosureCopy! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPushDup: pushDup! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPushInstVar: pushInstVar! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPushLiteral: pushLiteral! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPushLiteralVariable: pushLiteralVariable! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:29'!
visitPushReceiver: receiver! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPushRemoteTemp: pushRemoteTemp! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPushTemp: pushTemp! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitPushThisContext: pushThisContext! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitReturn: return! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:11'!
visitReturnInstVar: instVar! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:12'!
visitReturnLiteral: lit! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 16:12'!
visitReturnReceiver: rec! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitSend: send! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 15:49'!
visitSequence: sequence
	sequence do: [ :instr | self visitInstruction: instr].! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitStoreInstVar: storeInstVar! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitStoreLiteralVariable: storeLiteralVariable! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitStoreRemoteTemp: storeRemoteTemp! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitStoreTemp: storeTemp! !

!IRVisitor methodsFor: 'visiting' stamp: 'ClementBer 10/14/2014 14:09'!
visitTempVector: tempVector! !

Object subclass: #OCAbstractScope
	instanceVariableNames: 'outerScope node children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCAbstractScope commentStamp: 'ajh 3/24/2003 21:53' prior: 0!
I am a symbol table where variable names are associated with SemVars.  Each context (method/closure) get a fresh scope that inherits from its outer scope.!

OCAbstractScope subclass: #OCAbstractMethodScope
	instanceVariableNames: 'thisContextVar tempVars copiedVars tempVector id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCAbstractMethodScope commentStamp: '<historical>' prior: 0!
I am an abstract superclass for Block and Method scopes!

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'GuillermoPolito 4/9/2015 15:05'!
addCopiedTempToAllScopesUpToDefVector: aVariable
		
	(self hasCopyingTempNamed: aVariable name)
		ifFalse: [self addCopyingTemp: aVariable ].
	self tempVectorName = aVariable name ifTrue: [^ self].
	^ self outerScope addCopiedTempToAllScopesUpToDefVector: aVariable.! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 8/13/2014 10:10'!
addCopyingTemp: aTempVar
	^ copiedVars add: (OCCopyingTempVariable new
			originalVar: aTempVar originalVar;
			name: aTempVar name;
			escaping: aTempVar escaping;
			usage: aTempVar usage;
			scope: self;
			yourself)! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 8/13/2014 10:10'!
addCopyingTempNamed: name
	^ copiedVars add: (OCCopyingTempVariable new
			name: name;
			scope: self;
			yourself)! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 9/22/2010 11:10'!
addCopyingTempToAllScopesUpToDefTemp: aVar

	(self hasCopyingTempNamed: aVar name) ifFalse: [self addCopyingTemp: aVar].
	tempVars at: aVar name ifPresent: [:v | ^ self].
	^ self outerScope addCopyingTempToAllScopesUpToDefTemp: aVar.
				! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 9/22/2010 10:51'!
addCopyingTempToAllScopesUpToDefVector: aName
		
	(self hasCopyingTempNamed: aName) ifFalse: [self addCopyingTempNamed: aName].
	self tempVectorName = aName  ifTrue: [^ self].
	^ self outerScope addCopyingTempToAllScopesUpToDefVector: aName.! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'DenisKudryashov 12/18/2015 15:53'!
addTemp: name
	^self addTemp: OCTempVariable new withName: name! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'DenisKudryashov 12/18/2015 15:52'!
addTemp: aTempVariable withName: aString
	^ tempVars
		at: aString
		put: (aTempVariable
				name: aString;
				scope: self;
				yourself)! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 8/17/2014 13:23'!
addVectorTemp: aTemp
	^ tempVector 
		at:  aTemp name
		put: (OCVectorTempVariable new
			name: aTemp name;
			vectorName: self tempVectorName;
			scope: self;
			usage: aTemp usage;
			escaping: aTemp escaping;
			yourself)! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 12/17/2012 15:18'!
allTempNames
	^self allTemps collect: #name.! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'ClementBera 7/9/2013 18:05'!
allTemps
	"return all temps defined, even the ones in the outer scope that are not used in the current.
	 This includes the arguments
	 We do not need to care about shadowed temps as temp shadowing is not allowed."
	| temps |
	temps := OrderedCollection new.
	self outerScope allTemps do: [ :var |
	 	(self localTempNames includes: var name) ifFalse: [
			temps add: var.]
		].
	temps addAll: self localTemps.
	^temps asArray.
	! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'JorgeRessia 9/7/2010 20:24'!
copiedVars
	^ copiedVars! !

!OCAbstractMethodScope methodsFor: 'lookup' stamp: 'SeanDeNigris 5/19/2015 13:44'!
findVariable: aBlock ifNone: aNotFound

	(aBlock value: thisContextVar) ifTrue: [^ thisContextVar].
	self allTemps
		detect: [ :var | aBlock value: var ]
		ifFound: [ :var | ^ var ].
	
	outerScope ifNotNil: [
		^  outerScope findVariable: aBlock ifNone: aNotFound ]! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 9/10/2010 08:46'!
hasCopyingTempNamed: name
	^self copiedVars anySatisfy: [:each | each name = name]! !

!OCAbstractMethodScope methodsFor: 'initializing' stamp: 'MarcusDenker 9/9/2010 17:25'!
id: int
	id := int! !

!OCAbstractMethodScope methodsFor: 'initialization' stamp: 'DenisKudryashov 12/18/2015 17:21'!
initialize

	tempVars :=  OrderedDictionary new.
	tempVector  := Dictionary new.
	copiedVars := OCKeyedSet keyBlock: [:var | var name].
	id := 0.
	
	thisContextVar := OCThisContextVariable new
		scope: self; yourself.
! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 12/17/2012 15:14'!
localTempNames
	^self localTemps collect: [:each | each name]! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'ClementBera 7/9/2013 18:10'!
localTemps
	"all temps accessed in the context... for tempVectors, it takes all the vars even those not used here"
	| localVars |
	localVars := OrderedCollection new.
	self copiedVars do:  [:var |
		var isStoringTempVector 
			ifTrue: [var tempVectorForTempStoringIt do: [:tempVectorVars | localVars add: tempVectorVars]]
	].
	self tempVars do:  [:var | localVars add: var].
	^localVars asArray! !

!OCAbstractMethodScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/10/2015 10:55'!
lookupTempVector: name inContext: aContext
	"Similar to lookupVariable:inContext: but looks for a temp vector. If we don't find the temp vector (because it was nilled or not created), we lookup in the outer context with the corresponding outer scope"
	
	| variable theVector |
	variable := self
		variableNamed: name
		ifAbsent: [ ^ self outerScope lookupVar: name inContext: aContext outerContext ].
	theVector := variable readFromContext: aContext scope: self.
	theVector ifNil: [ ^ self outerScope lookupTempVector: name inContext: aContext outerContext ].
	^ { variable . theVector }! !

!OCAbstractMethodScope methodsFor: 'lookup' stamp: 'MarcusDenker 9/22/2010 10:39'!
lookupVar: name
	copiedVars at: name ifPresent: [:v | ^ v].
	tempVector  at: name ifPresent: [:v | ^ v].
	tempVars at: name ifPresent: [:v | ^ v].
	name = 'thisContext' ifTrue: [^ thisContextVar].
	^self outerScope lookupVar: name
	! !

!OCAbstractMethodScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/10/2015 10:54'!
lookupVar: name inContext: aContext
	"We lookup a variable in a context. If it not in this context, we look in the outer context using the corresponding outer scope"
	
	| variable theValue |
	variable := self
		variableNamed: name
		ifAbsent: [ ^ self outerScope lookupVar: name inContext: aContext outerContext ].
	theValue := variable readFromContext: aContext scope: self.
	^ theValue! !

!OCAbstractMethodScope methodsFor: 'lookup' stamp: 'MarcusDenker 6/5/2013 13:53'!
lookupVarForDeclaration: name
	tempVars at: name ifPresent: [:v | ^ v].
	name = 'thisContext' ifTrue: [^ thisContextVar].
	^self outerScope lookupVarForDeclaration: name
	! !

!OCAbstractMethodScope methodsFor: 'debugging' stamp: 'GuillermoPolito 4/9/2015 13:18'!
methodScope

	^ self outerScope methodScope! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 9/22/2010 11:07'!
moveToVectorTemp: aTempVar

	self addVectorTemp: aTempVar.
	self removeTemp: aTempVar.	! !

!OCAbstractMethodScope methodsFor: 'scope' stamp: 'MarcusDenker 10/7/2010 10:06'!
newBlockScope: int
	^ OCBlockScope new outerScope: self; id: int; yourself.! !

!OCAbstractMethodScope methodsFor: 'scope' stamp: 'MarcusDenker 10/7/2010 10:05'!
newOptimizedBlockScope: int
	^ OCOptimizedBlockScope new 
			outerScope: self; 
			id: int;
			yourself.! !

!OCAbstractMethodScope methodsFor: 'scope' stamp: 'MarcusDenker 5/18/2013 16:40'!
outerNotOptimizedScope
	^self! !

!OCAbstractMethodScope methodsFor: 'scope' stamp: 'ClementBera 8/5/2013 10:49'!
outerOffsetTo: aScope
	"return how many scopes up from me aScope is. We ignore optimized scopes so the resulting offset maps to
	 contexts"

	| offset scope |
	offset := 0.
	scope := self.
	[scope == aScope] whileFalse: [
		scope isOptimizedBlockScope 
			ifTrue: [scope := scope outerNotOptimizedScope]
			ifFalse: [ 
			offset := offset + 1. 
			scope isInstanceScope ifTrue: [^0]. 
			scope := scope outerScope ] ].
	^offset.
	! !

!OCAbstractMethodScope methodsFor: 'scope' stamp: 'ajh 7/8/2004 14:19'!
popScope
	"Propogate free var usages to their outer vars, then return outer scope"

	^ self outerScope! !

!OCAbstractMethodScope methodsFor: 'printing' stamp: 'ajh 3/20/2003 11:29'!
printOn: stream

	super printOn: stream.
	stream space.
	self scopeLevel printOn: stream.
! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 8/13/2014 10:08'!
removeTemp: tempVar

	tempVars removeKey: tempVar name! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 10/14/2010 13:46'!
tempVarNames

	^ self tempVars collect: [:each| each name]! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 8/13/2014 10:08'!
tempVars

	^ tempVars! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'JorgeRessia 9/7/2010 20:25'!
tempVector
	^ tempVector ! !

!OCAbstractMethodScope methodsFor: 'temp vars' stamp: 'MarcusDenker 11/15/2012 16:08'!
tempVectorName
	"the name of the tempVector is not a valid name of a temp variable
	 This way we avoid name clashes "
	^'0vector', id asString! !

!OCAbstractMethodScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/9/2015 17:15'!
variableNamed: name ifAbsent: aBlock
	copiedVars at: name ifPresent: [:v | ^ v].
	tempVector  at: name ifPresent: [:v | ^ v].
	tempVars at: name ifPresent: [:v | ^ v].
	name = 'thisContext' ifTrue: [^ thisContextVar].
	
	^ aBlock value.! !

OCAbstractMethodScope subclass: #OCBlockScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCBlockScope commentStamp: '<historical>' prior: 0!
I modelt the scope of a block!

!OCBlockScope methodsFor: 'testing' stamp: 'MarcusDenker 8/17/2014 13:20'!
hasEscapingVars
	^ (copiedVars isEmpty and: [tempVector isEmpty]) not! !

!OCBlockScope methodsFor: 'accessing' stamp: 'MarcusDenker 10/14/2010 10:13'!
inComingCopiedVars
	^ copiedVars select: [:each | outerScope copiedVars includes: each].! !

!OCBlockScope methodsFor: 'testing' stamp: 'JorgeRessia 9/7/2010 18:39'!
isBlockScope
	^ true! !

!OCBlockScope methodsFor: 'testing' stamp: 'MarcusDenker 12/14/2012 11:51'!
isInsideOptimizedLoop
	^ self outerScope isInsideOptimizedLoop! !

OCBlockScope subclass: #OCOptimizedBlockScope
	instanceVariableNames: 'isInlinedLoop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCOptimizedBlockScope commentStamp: '<historical>' prior: 0!
In Smalltalk, methods like ifTrue: are inlined an there is no Block for the arguments of these message sends.
To be consistent, these blocks need nevertheless a scope.

!

!OCOptimizedBlockScope methodsFor: 'initialization' stamp: 'JorgeRessia 9/23/2010 13:16'!
initialize
	super initialize.
	isInlinedLoop := false! !

!OCOptimizedBlockScope methodsFor: 'testing' stamp: 'JorgeRessia 9/23/2010 13:21'!
isInsideOptimizedLoop
	^ isInlinedLoop
		ifTrue: [true]
		ifFalse: [self outerScope isInsideOptimizedLoop]! !

!OCOptimizedBlockScope methodsFor: 'testing' stamp: 'JorgeRessia 9/11/2010 08:08'!
isOptimizedBlockScope
	^ true! !

!OCOptimizedBlockScope methodsFor: 'accessing' stamp: 'GuillermoPolito 4/10/2015 10:57'!
lookupVar: name inContext: aContext
	"I work as OCAbstractMethodScope>>lookupVar:inContext:, looking up in the outer scope but staying in the same context because I'm optimized"
	
	| variable theValue |
	variable := self
		variableNamed: name
		ifAbsent: [ ^ self outerScope lookupVar: name inContext: aContext ].
	theValue := variable readFromContext: aContext scope: self.
	^ theValue! !

!OCOptimizedBlockScope methodsFor: 'private' stamp: 'MarcusDenker 12/14/2012 11:25'!
markInlinedLoop
	isInlinedLoop := true! !

!OCOptimizedBlockScope methodsFor: 'accessing' stamp: 'JorgeRessia 9/23/2010 14:00'!
outerNotOptimizedScope
	^self outerScope outerNotOptimizedScope! !

OCAbstractMethodScope subclass: #OCMethodScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCMethodScope commentStamp: '<historical>' prior: 0!
I am the scope for a Method!

!OCMethodScope methodsFor: 'testing' stamp: 'MarcusDenker 8/27/2010 11:31'!
isMethodScope 
	^true! !

!OCMethodScope methodsFor: 'testing' stamp: 'GuillermoPolito 4/9/2015 13:18'!
methodScope

	^ self! !

!OCAbstractScope methodsFor: 'initializing' stamp: 'MarcusDenker 10/16/2014 11:19'!
addChild: aScope
	self children add: aScope! !

!OCAbstractScope methodsFor: 'accessing' stamp: 'MarcusDenker 10/16/2014 11:27'!
children
	^children ifNil: [ children := OrderedCollection new ]! !

!OCAbstractScope methodsFor: 'decompiling' stamp: 'ms 7/11/2007 11:16'!
instanceScope

	^self outerScope instanceScope! !

!OCAbstractScope methodsFor: 'testing' stamp: 'NicolaiHess 8/24/2014 00:16'!
isBlockScope

	^false! !

!OCAbstractScope methodsFor: 'testing' stamp: 'JorgeRessia 9/23/2010 19:15'!
isInsideOptimizedLoop
	^ false! !

!OCAbstractScope methodsFor: 'testing' stamp: 'JorgeRessia 9/23/2010 19:15'!
isInstanceScope
	^ false! !

!OCAbstractScope methodsFor: 'testing' stamp: 'NicolaiHess 8/24/2014 00:16'!
isMethodScope

	^false! !

!OCAbstractScope methodsFor: 'testing' stamp: 'MarcusDenker 12/20/2012 14:38'!
isOptimizedBlockScope
	^false! !

!OCAbstractScope methodsFor: 'lookup' stamp: 'ajh 2/25/2003 22:41'!
lookupSelector: name

	Symbol hasInterned: name ifTrue: [ :sym | ^ sym].
	^ nil! !

!OCAbstractScope methodsFor: 'lookup' stamp: 'ajh 3/11/2003 20:19'!
lookupVar: name
	"subclass responsibility"

	^ self outerScope lookupVar: name! !

!OCAbstractScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/10/2015 10:53'!
lookupVar: name inContext: aContext

	^ self outerScope lookupVar: name inContext: aContext outerContext! !

!OCAbstractScope methodsFor: 'lookup' stamp: 'MarcusDenker 6/5/2013 13:53'!
lookupVarForDeclaration: name
	"subclass responsibility"

	^ self outerScope lookupVarForDeclaration: name! !

!OCAbstractScope methodsFor: 'accessing' stamp: 'MarcusDenker 12/18/2012 13:39'!
node
	^node! !

!OCAbstractScope methodsFor: 'accessing' stamp: 'MarcusDenker 12/18/2012 13:32'!
node: aNode
	node := aNode! !

!OCAbstractScope methodsFor: 'levels' stamp: 'ajh 2/26/2003 13:44'!
outerScope

	^ outerScope! !

!OCAbstractScope methodsFor: 'initializing' stamp: 'MarcusDenker 10/16/2014 11:16'!
outerScope: aSemScope

	outerScope := aSemScope.
	aSemScope addChild: self. ! !

!OCAbstractScope methodsFor: 'lookup' stamp: 'ajh 2/25/2003 22:40'!
possibleSelectorsFor: string

	^ Symbol possibleSelectorsFor: string! !

!OCAbstractScope methodsFor: 'levels' stamp: 'ajh 3/20/2003 11:27'!
scopeLevel

	outerScope ifNil: [^ 0].
	^ outerScope scopeLevel + 1! !

!OCAbstractScope methodsFor: 'accessing' stamp: 'GuillermoPolito 4/9/2015 17:16'!
variableNamed: aName

	^ self variableNamed: aName ifAbsent: [ nil ]! !

OCAbstractScope subclass: #OCClassScope
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCClassScope commentStamp: 'ajh 3/24/2003 21:44' prior: 0!
I include all variable enries for class, pool and global vars.!

!OCClassScope class methodsFor: 'instance creation' stamp: 'MarcusDenker 8/21/2010 18:39'!
for: aClass
	^self new 
		class: aClass;
		yourself! !

!OCClassScope methodsFor: 'accessing' stamp: 'ajh 2/25/2003 20:10'!
class: aBehavior

	class := aBehavior! !

!OCClassScope methodsFor: 'lookup' stamp: 'IgorStasenko 11/11/2014 11:55'!
findVariable: lookupBlock ifNone: notFoundBlock 
	| var |
	class classPool associationsDo: [ :assoc |
		var := OCLiteralVariable new 
			assoc: assoc; 
			scope: self; 
			yourself.
			
		(lookupBlock value: var) ifTrue: [ ^ var ].
		 ].
	
	class sharedPools do: [ :pool |
		pool classPool associationsDo: [ :assoc | 
			var := OCLiteralVariable new 
			assoc: assoc; 
			scope: self; 
			yourself.
			(lookupBlock value: var) ifTrue: [ ^ var ].
			 ].
		 ].

	^ class environment findVariable: lookupBlock ifNone: notFoundBlock 
! !

!OCClassScope methodsFor: 'accessing' stamp: 'MarcusDenker 2/2/2016 14:31'!
getClass
	^class! !

!OCClassScope methodsFor: 'levels' stamp: 'MarcusDenker 6/25/2014 16:45'!
instanceScope

	^ OCInstanceScope new
		slots: class allSlots;
		outerScope: self;
		yourself! !

!OCClassScope methodsFor: 'lookup' stamp: 'MarcusDenker 6/14/2013 15:22'!
lookupVar: name
	"Return a SemVar for my pool var with this name.  Return nil if none found"

	^(class bindingOf: name asSymbol) ifNotNil: [:assoc | 
		OCLiteralVariable new 
			assoc: assoc; 
			scope: self; 
			yourself]
! !

!OCClassScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/10/2015 10:58'!
lookupVar: name inContext: aContext
	"I'll lookup a variable in a class. The context does not play any role in here because variables in classes are statically defined"

	^ self lookupVar: name! !

!OCClassScope methodsFor: 'lookup' stamp: 'MarcusDenker 6/5/2013 13:52'!
lookupVarForDeclaration: name
	^self lookupVar: name! !

!OCClassScope methodsFor: 'levels' stamp: 'MarcusDenker 8/27/2010 12:35'!
newMethodScope
	^ self instanceScope newMethodScope! !

!OCClassScope methodsFor: 'printing' stamp: 'MarcusDenker 6/18/2013 10:00'!
printOn: stream

	class printOn: stream.! !

!OCClassScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/9/2015 17:15'!
variableNamed: name ifAbsent: aBlock
	"Return a SemVar for my pool var with this name.  Return nil if none found"

	^(class bindingOf: name asSymbol) ifNotNil: [:assoc | 
		OCLiteralVariable new 
			assoc: assoc; 
			scope: self; 
			yourself] ifNil: aBlock! !

OCAbstractScope subclass: #OCInstanceScope
	instanceVariableNames: 'vars selfVar superVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCInstanceScope commentStamp: 'MarcusDenker 8/11/2014 10:18' prior: 0!
I include all variable enries for slots, self, super.!

!OCInstanceScope methodsFor: 'acessing' stamp: 'MarcusDenker 12/17/2012 15:18'!
allTemps
	^#()! !

!OCInstanceScope methodsFor: 'lookup' stamp: 'IgorStasenko 11/10/2014 17:55'!
findVariable: lookupBlock ifNone: notFoundBlock 

	(lookupBlock value: selfVar) ifTrue: [ ^ selfVar ].
	(lookupBlock value: superVar) ifTrue: [ ^ superVar ].
	
	vars valuesDo: [ :var | (lookupBlock value: var) ifTrue: [ ^ var ] ].

	^ outerScope findVariable: lookupBlock ifNone: notFoundBlock ! !

!OCInstanceScope methodsFor: 'initialization' stamp: 'DenisKudryashov 12/18/2015 17:21'!
initialize
  
	vars := Dictionary new.
	selfVar := OCSelfVariable new
		scope: self;
		yourself.
	superVar := OCSuperVariable new
		scope: self;
		yourself.! !

!OCInstanceScope methodsFor: 'acessing' stamp: 'ms 7/10/2007 17:58'!
instanceScope
	^self! !

!OCInstanceScope methodsFor: 'testing' stamp: 'ajh 7/8/2004 20:26'!
isInstanceScope

	^ true! !

!OCInstanceScope methodsFor: 'lookup' stamp: 'MarcusDenker 9/1/2010 15:32'!
lookupVar: name
	"Return a ScopeVar for my inst var with this name.  Return nil if none found"

	name = 'self' ifTrue: [^ selfVar].
	name = 'super' ifTrue: [^ superVar].
	^ vars at: name ifAbsent: [self outerScope lookupVar: name]! !

!OCInstanceScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/9/2015 17:13'!
lookupVar: name inContext: aContext
	"Return a ScopeVar for my inst var with this name.  Return nil if none found"

	name = 'self' ifTrue: [^ selfVar].
	name = 'super' ifTrue: [^ superVar].
	^ vars at: name ifAbsent: [self outerScope lookupVar: name inContext: aContext ]! !

!OCInstanceScope methodsFor: 'lookup' stamp: 'MarcusDenker 6/14/2013 13:34'!
lookupVarForDeclaration: name
	"Return a ScopeVar for my inst var with this name.  Return nil if none found"
	name = 'self' ifTrue: [^ selfVar].
	name = 'super' ifTrue: [^ superVar].
	^ vars at: name ifAbsent: [self outerScope lookupVarForDeclaration: name]! !

!OCInstanceScope methodsFor: 'scope' stamp: 'MarcusDenker 9/9/2010 17:22'!
newMethodScope

	^ OCMethodScope new outerScope: self! !

!OCInstanceScope methodsFor: 'initializing' stamp: 'MarcusDenker 8/17/2014 13:18'!
slots: slotCollection

	slotCollection do: [ :slot |
		vars at: slot name put:
			(OCSlotVariable new
				slot: slot;
				scope: self;
				yourself)].
! !

!OCInstanceScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/9/2015 17:17'!
variableNamed: name ifAbsent: aBlock
	"Return a ScopeVar for my inst var with this name.  Return nil if none found"

	name = 'self' ifTrue: [^ selfVar].
	name = 'super' ifTrue: [^ superVar].
	^ vars at: name ifAbsent: aBlock! !

OCAbstractScope subclass: #OCRequestorScope
	instanceVariableNames: 'requestor compilationContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCRequestorScope commentStamp: 'MarcusDenker 8/11/2014 10:18' prior: 0!
A special scope for tools: variables in the worspace have their own scope, for example!

!OCRequestorScope methodsFor: 'temp vars' stamp: 'MarcusDenker 11/4/2015 12:21'!
allTemps
	^#()! !

!OCRequestorScope methodsFor: 'accessing' stamp: 'MarcusDenker 11/4/2015 12:02'!
compilationContext
	^ compilationContext! !

!OCRequestorScope methodsFor: 'accessing' stamp: 'MarcusDenker 11/4/2015 12:02'!
compilationContext: anObject
	compilationContext := anObject! !

!OCRequestorScope methodsFor: 'lookup' stamp: 'MarcusDenker 11/4/2015 12:24'!
findVariable: aBlock ifNone: aNotFound
	outerScope ifNotNil: [
		^  outerScope findVariable: aBlock ifNone: aNotFound ]! !

!OCRequestorScope methodsFor: 'lookup' stamp: 'MarcusDenker 11/4/2015 12:19'!
lookupVar: name

	name = 'self' ifTrue: [  ^outerScope lookupVar: name].
	name = 'super' ifTrue: [  ^outerScope lookupVar: name]. 
	name first isUppercase ifTrue: [ ^outerScope lookupVar: name ].  
	((compilationContext forSyntaxHighlighting) and: [(requestor hasBindingOf: name asSymbol) not]) 
		ifTrue: [  ^ super lookupVar: name].
	 (requestor bindingOf: name asSymbol) 
		ifNotNil: [:assoc | ^ OCLiteralVariable new assoc: assoc; scope: self; yourself].
	^ super lookupVar: name. ! !

!OCRequestorScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/9/2015 17:12'!
lookupVar: name inContext: context

	name = 'self' ifTrue: [  ^outerScope lookupVar: name inContext: context outerContext].
	name = 'super' ifTrue: [  ^outerScope lookupVar: name inContext: context outerContext].
	name first isUppercase ifTrue: [ ^outerScope lookupVar: name inContext: context outerContext]. 
	
	(requestor bindingOf: name asSymbol) ifNotNil: [:assoc | 
		^ OCLiteralVariable new assoc: assoc; scope: self; yourself].
	^ super lookupVar: name inContext: context outerContext.! !

!OCRequestorScope methodsFor: 'lookup' stamp: 'MarcusDenker 5/18/2013 13:52'!
newMethodScope
	 
	^ OCMethodScope new outerScope: (self outerScope: outerScope instanceScope) ! !

!OCRequestorScope methodsFor: 'accessing' stamp: 'MarcusDenker 4/11/2013 14:37'!
requestor
	^ requestor! !

!OCRequestorScope methodsFor: 'accessing' stamp: 'MarcusDenker 4/11/2013 14:37'!
requestor: anObject
	requestor := anObject! !

!OCRequestorScope methodsFor: 'lookup' stamp: 'GuillermoPolito 4/9/2015 17:17'!
variableNamed: name ifAbsent: aBlock

	name = 'self' ifTrue: [  ^outerScope lookupVar: name].
	name = 'super' ifTrue: [  ^outerScope lookupVar: name].
	name first isUppercase ifTrue: [ ^outerScope lookupVar: name ]. 
	
	(requestor bindingOf: name asSymbol) ifNotNil: [:assoc | 
		^ OCLiteralVariable new assoc: assoc; scope: self; yourself].

	^ aBlock value! !

Object subclass: #OCAbstractVariable
	instanceVariableNames: 'scope usage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCAbstractVariable commentStamp: '<historical>' prior: 0!
I am an entry in a Scope that gets associated with variable nodes of the same name. !

OCAbstractVariable subclass: #OCAbstractLocalVariable
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCAbstractLocalVariable commentStamp: '<historical>' prior: 0!
I am an argument or temporary variable of a method or block.

index is not the index in the bytecode but just used for sorting
(see tempVars). to be fixed...!

!OCAbstractLocalVariable methodsFor: 'testing' stamp: 'ms 7/31/2007 00:42'!
isLocal

	^true! !

!OCAbstractLocalVariable methodsFor: 'read/write usage' stamp: 'DenisKudryashov 12/18/2015 16:55'!
isUninitialized

	^ self isWrite not! !

!OCAbstractLocalVariable methodsFor: 'accessing' stamp: 'ajh 6/23/2004 22:51'!
name

	^ name! !

!OCAbstractLocalVariable methodsFor: 'initializing' stamp: 'jorgeRessia 11/14/2009 10:56'!
name: string
	name := string! !

OCAbstractLocalVariable subclass: #OCSpecialVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCSpecialVariable commentStamp: '<historical>' prior: 0!
I model self, thisContext and super!

OCSpecialVariable subclass: #OCSelfVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCSelfVariable commentStamp: 'DenisKudryashov 12/18/2015 16:44' prior: 0!
I model self variables !

!OCSelfVariable class methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 14:32'!
semanticNodeClass

	^RBSelfNode ! !

!OCSelfVariable methodsFor: 'initialization' stamp: 'DenisKudryashov 12/18/2015 17:20'!
initialize
	super initialize.
	
	name := 'self'! !

!OCSelfVariable methodsFor: 'testing' stamp: 'DenisKudryashov 12/18/2015 17:26'!
isSelf
	^true! !

!OCSpecialVariable methodsFor: 'emitting' stamp: 'MarcusDenker 9/3/2010 15:46'!
emitStore: methodBuilder

	self shouldNotImplement! !

!OCSpecialVariable methodsFor: 'emitting' stamp: 'DenisKudryashov 12/18/2015 17:26'!
emitValue: methodBuilder

	methodBuilder pushReceiver
	! !

!OCSpecialVariable methodsFor: 'testing' stamp: 'MarcusDenker 4/16/2013 15:55'!
isSpecialVariable
	^true! !

!OCSpecialVariable methodsFor: 'testing' stamp: 'DenisKudryashov 12/18/2015 17:28'!
isThisContext
	^false! !

!OCSpecialVariable methodsFor: 'testing' stamp: 'MarcusDenker 4/9/2013 10:39'!
isUninitialized

	^ false! !

!OCSpecialVariable methodsFor: 'testing' stamp: 'NicolaiHess 8/24/2014 00:27'!
isWritable
	^ false! !

OCSpecialVariable subclass: #OCSuperVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCSuperVariable commentStamp: 'DenisKudryashov 12/18/2015 16:44' prior: 0!
I model super variables!

!OCSuperVariable class methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 14:32'!
semanticNodeClass

	^RBSuperNode ! !

!OCSuperVariable methodsFor: 'initialization' stamp: 'DenisKudryashov 12/18/2015 17:20'!
initialize
	super initialize.
	
	name := 'super'! !

!OCSuperVariable methodsFor: 'testing' stamp: 'DenisKudryashov 12/18/2015 17:27'!
isSuper
	^true! !

OCSpecialVariable subclass: #OCThisContextVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCThisContextVariable commentStamp: 'DenisKudryashov 12/18/2015 16:44' prior: 0!
I model thisContext variables!

!OCThisContextVariable class methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 14:31'!
semanticNodeClass

	^RBThisContextNode ! !

!OCThisContextVariable methodsFor: 'emitting' stamp: 'DenisKudryashov 12/18/2015 17:25'!
emitValue: methodBuilder

	methodBuilder pushThisContext! !

!OCThisContextVariable methodsFor: 'initialization' stamp: 'DenisKudryashov 12/18/2015 17:20'!
initialize
	super initialize.
	
	name := 'thisContext'! !

!OCThisContextVariable methodsFor: 'testing' stamp: 'DenisKudryashov 12/18/2015 17:27'!
isThisContext
	^true! !

OCAbstractLocalVariable subclass: #OCTempVariable
	instanceVariableNames: 'escaping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCTempVariable commentStamp: 'MarcusDenker 8/11/2014 10:19' prior: 0!
I model temp variables. With Closures, there are two kinds: Copying and those that are stores in a so called temp vector, a heap allocated array that itself is stored in an un-named copying temp variable.!

OCTempVariable subclass: #OCArgumentVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCArgumentVariable commentStamp: 'DenisKudryashov 12/18/2015 16:46' prior: 0!
I model argument variables. By definition, an argument variable is always initialized, and can't be written to.!

!OCArgumentVariable class methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 16:40'!
semanticNodeClass

	^RBArgumentNode ! !

!OCArgumentVariable methodsFor: 'testing' stamp: 'DenisKudryashov 12/18/2015 17:15'!
isArg

	^ true! !

!OCArgumentVariable methodsFor: 'testing' stamp: 'DenisKudryashov 12/18/2015 16:30'!
isUninitialized

	^ false! !

!OCArgumentVariable methodsFor: 'testing' stamp: 'DenisKudryashov 12/18/2015 16:46'!
isWritable

	^ false! !

OCTempVariable subclass: #OCCopyingTempVariable
	instanceVariableNames: 'originalVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCCopyingTempVariable commentStamp: 'MarcusDenker 8/11/2014 10:20' prior: 0!
A copying temp is a temp that is copied into a block that later reads this variable.

Not: the temp vector is passed as a copying temp, too.!

!OCCopyingTempVariable methodsFor: 'temp vector' stamp: 'GuillermoPolito 4/9/2015 16:01'!
indexFromIR

	^ scope node irInstruction indexForVarNamed: name! !

!OCCopyingTempVariable methodsFor: 'debugging' stamp: 'GuillermoPolito 4/9/2015 13:19'!
indexInTempVectorFromIR: aName
	^(scope methodScope node irInstruction tempVectorNamed: name) indexForVarNamed: aName.! !

!OCCopyingTempVariable methodsFor: 'testing' stamp: 'MarcusDenker 9/9/2010 16:06'!
isCopying
	^true! !

!OCCopyingTempVariable methodsFor: 'accessing' stamp: 'ClementBera 5/21/2013 14:47'!
originalVar
	^ originalVar! !

!OCCopyingTempVariable methodsFor: 'accessing' stamp: 'ClementBera 5/21/2013 14:47'!
originalVar: anObject
	originalVar := anObject! !

!OCCopyingTempVariable methodsFor: 'temp vector' stamp: 'MarcusDenker 11/15/2012 17:09'!
tempVectorForTempStoringIt
	"If I am stroring a temp Vector, this method returns this victor.
	useful for analysis e.g. which variables are active in a context"
	
	| searchScope |
	self isStoringTempVector ifFalse: [^nil].
	searchScope := scope.
	
	[searchScope isInstanceScope or: [searchScope tempVectorName = name]] 
		whileFalse: [searchScope := searchScope outerScope].
	searchScope isInstanceScope 
		ifTrue: [ ^nil] "not found"
		ifFalse: [^ searchScope tempVector]
	! !

!OCTempVariable class methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 14:41'!
semanticNodeClass

	^RBTemporaryNode ! !

!OCTempVariable methodsFor: 'comparing' stamp: 'MarcusDenker 11/16/2012 11:24'!
= aTempVar

	^aTempVar class = self class 
		and: [aTempVar scope = self scope 
		and: [aTempVar name = self name
		and: [aTempVar usage = self usage]]].

	! !

!OCTempVariable methodsFor: 'emitting' stamp: ''!
emitStore: methodBuilder

	methodBuilder storeTemp: name. ! !

!OCTempVariable methodsFor: 'emitting' stamp: ''!
emitValue: methodBuilder

	methodBuilder pushTemp: name.! !

!OCTempVariable methodsFor: 'escaping' stamp: 'MarcusDenker 9/22/2010 11:04'!
escaping
	^escaping! !

!OCTempVariable methodsFor: 'escaping' stamp: 'MarcusDenker 9/22/2010 11:04'!
escaping: anObject
	escaping := anObject! !

!OCTempVariable methodsFor: 'comparing' stamp: 'MarcusDenker 11/16/2012 11:26'!
hash

	^ name hash bitXor: (usage hash bitXor: scope hash).! !

!OCTempVariable methodsFor: 'debugging' stamp: 'GuillermoPolito 4/9/2015 15:58'!
indexFromIR

	^scope outerNotOptimizedScope node irInstruction indexForVarNamed: name! !

!OCTempVariable methodsFor: 'initialization' stamp: 'MarcusDenker 9/5/2010 20:18'!
initialize
	super initialize.
	escaping := false.! !

!OCTempVariable methodsFor: 'testing' stamp: 'MarcusDenker 9/9/2010 16:07'!
isCopying
	^false! !

!OCTempVariable methodsFor: 'escaping' stamp: 'MarcusDenker 9/21/2010 16:06'!
isEscaping
	^escaping = #escapingRead or: [escaping = #escapingWrite]! !

!OCTempVariable methodsFor: 'escaping' stamp: 'MarcusDenker 9/21/2010 16:22'!
isEscapingRead
	^escaping = #escapingRead
! !

!OCTempVariable methodsFor: 'escaping' stamp: 'MarcusDenker 9/21/2010 16:22'!
isEscapingWrite
	^escaping = #escapingWrite
! !

!OCTempVariable methodsFor: 'testing' stamp: 'MarcusDenker 11/15/2012 16:37'!
isStoringTempVector
	"I am a temp that stores a temp vector. Those generated temps have a invalid name starting with 0"
	^name first = $0.! !

!OCTempVariable methodsFor: 'testing' stamp: 'ajh 6/23/2004 23:18'!
isTemp

	^ true! !

!OCTempVariable methodsFor: 'testing' stamp: ''!
isTempVectorTemp
	^false! !

!OCTempVariable methodsFor: 'escaping' stamp: 'MarcusDenker 9/21/2010 18:06'!
markEscapingRead
	escaping = #escapingWrite ifFalse: [escaping := #escapingRead]! !

!OCTempVariable methodsFor: 'escaping' stamp: 'NicolaiHess 10/24/2014 00:26'!
markEscapingWrite
	escaping := #escapingWrite.
	self isRepeatedWrite ifFalse:[usage := #write]! !

!OCTempVariable methodsFor: 'escaping' stamp: 'NicolaiHess 10/24/2014 00:07'!
markRepeatedWrite
	"same as write"
	self markWrite.
	super markRepeatedWrite.! !

!OCTempVariable methodsFor: 'escaping' stamp: 'MarcusDenker 5/18/2011 16:00'!
markWrite

	"if an escaping var is wrote to later, it needs to be remote"
	self isEscaping 
		ifTrue: [self markEscapingWrite].
	super markWrite.! !

!OCTempVariable methodsFor: 'debugging' stamp: 'GuillermoPolito 4/9/2015 17:38'!
readFromContext: aContext scope: contextScope
	"Usually the loop is useless, the first case with i = offset returns the correct result. 
	However, the loop is required for specific case as Debugger restart feature."

	^ aContext tempAt: (contextScope outerNotOptimizedScope node irInstruction indexForVarNamed: name)! !

!OCTempVariable methodsFor: 'debugging' stamp: 'GuillermoPolito 4/9/2015 17:52'!
searchFromContext: aContext scope: contextScope
	"Usually the loop is useless, the first case with i = offset returns the correct result. 
	However, the loop is required for specific case as Debugger restart feature."

	^ contextScope lookupVar: name inContext: aContext! !

!OCTempVariable methodsFor: 'debugging' stamp: 'GuillermoPolito 4/9/2015 15:58'!
writeFromContext: aContext scope: contextScope value: aValue
	
	"offset := contextScope outerOffsetTo: scope.
	contextForRead := aContext.
	offset timesRepeat: [contextForRead := contextForRead outerContext].
	"^aContext tempAt: self indexFromIR put: aValue! !

OCTempVariable subclass: #OCVectorTempVariable
	instanceVariableNames: 'vectorName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCVectorTempVariable commentStamp: 'MarcusDenker 8/11/2014 10:20' prior: 0!
I model a temp variable that is stored in a temp vector.!

!OCVectorTempVariable methodsFor: 'emitting' stamp: 'MarcusDenker 12/18/2012 16:42'!
emitStore: methodBuilder

	methodBuilder storeRemoteTemp: name inVector: vectorName.! !

!OCVectorTempVariable methodsFor: 'emitting' stamp: 'MarcusDenker 12/18/2012 16:42'!
emitValue: methodBuilder

	methodBuilder pushRemoteTemp: name inVector: vectorName.! !

!OCVectorTempVariable methodsFor: 'debugging' stamp: 'GuillermoPolito 4/9/2015 13:29'!
indexFromIR
	^scope methodScope node irInstruction indexForVarNamed: name! !

!OCVectorTempVariable methodsFor: 'testing' stamp: 'MarcusDenker 9/5/2010 17:13'!
isRemote
	^true! !

!OCVectorTempVariable methodsFor: 'testing' stamp: 'MarcusDenker 9/9/2010 16:11'!
isTempVectorTemp
	^true! !

!OCVectorTempVariable methodsFor: 'debugging' stamp: 'GuillermoPolito 4/9/2015 17:26'!
readFromContext: aContext scope: contextScope

	| offset pairVariableVector |
	pairVariableVector := contextScope lookupTempVector: vectorName inContext: aContext.
	offset := pairVariableVector first indexInTempVectorFromIR: name.
	^pairVariableVector second at: offset.! !

!OCVectorTempVariable methodsFor: 'debugging' stamp: 'GuillermoPolito 4/9/2015 17:34'!
searchFromContext: aContext scope: contextScope

	| offset pairVariableVector |
	pairVariableVector := contextScope lookupTempVector: vectorName inContext: aContext.
	offset := pairVariableVector first indexInTempVectorFromIR: name.
	^pairVariableVector second at: offset.! !

!OCVectorTempVariable methodsFor: 'accessing' stamp: 'MarcusDenker 12/18/2012 16:44'!
vectorName
	^ vectorName! !

!OCVectorTempVariable methodsFor: 'accessing' stamp: 'MarcusDenker 12/18/2012 16:43'!
vectorName: anObject
	vectorName := anObject! !

!OCVectorTempVariable methodsFor: 'debugging' stamp: 'NicolaiHess 10/26/2014 01:27'!
writeFromContext: aContext scope: contextScope value: aValue
	| tempVectorVar theVector offset |
	tempVectorVar := contextScope lookupVar: vectorName.
	theVector := tempVectorVar readFromContext: aContext scope: tempVectorVar scope.
	offset := tempVectorVar indexInTempVectorFromIR: name.
	^theVector at: offset put: aValue.! !

!OCAbstractVariable class methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 14:29'!
semanticNodeClass
	self subclassResponsibility ! !

!OCAbstractVariable methodsFor: 'converting' stamp: 'ajh 3/16/2003 20:08'!
asString

	^ self name! !

!OCAbstractVariable methodsFor: 'accessing' stamp: 'ClementBera 5/21/2013 14:53'!
definingScope
	^ scope! !

!OCAbstractVariable methodsFor: 'emitting' stamp: 'JorgeRessia 4/19/2010 09:35'!
emitStore: methodBuilder

	self subclassResponsibility! !

!OCAbstractVariable methodsFor: 'emitting' stamp: 'JorgeRessia 4/19/2010 09:35'!
emitValue: methodBuilder

	self subclassResponsibility! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'MarcusDenker 6/13/2013 14:59'!
isArg
	^false! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'NicolaiHess 6/16/2015 21:50'!
isClassVariable
	^ false! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'ajh 7/8/2004 16:25'!
isGlobal

	^ false! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'NicolaiHess 6/16/2015 21:52'!
isGlobalVariable
	^ false! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'MarcusDenker 8/27/2010 11:16'!
isInstance
	^false
! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'MarcusDenker 9/20/2013 13:28'!
isLiteralVariable
	^false! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'ms 7/31/2007 00:42'!
isLocal

	^false! !

!OCAbstractVariable methodsFor: 'read/write usage' stamp: 'DenisKudryashov 12/18/2015 16:30'!
isRead
	^usage = #read
! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'MarcusDenker 9/21/2010 16:02'!
isRemote
	^false! !

!OCAbstractVariable methodsFor: 'read/write usage' stamp: 'NicolaiHess 10/24/2014 00:10'!
isRepeatedWrite
	^usage = #repeatedWrite
! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'MarcusDenker 9/1/2010 14:44'!
isSelf
	^false! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'MarcusDenker 4/16/2013 15:55'!
isSpecialVariable
	^false! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'MarcusDenker 9/1/2010 15:30'!
isSuper
	^false! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'ajh 3/18/2003 11:13'!
isTemp

	^ false! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'MarcusDenker 6/14/2013 15:42'!
isUndeclared

	^ false! !

!OCAbstractVariable methodsFor: 'read/write usage' stamp: 'MarcusDenker 4/9/2013 10:39'!
isUninitialized

	^ false! !

!OCAbstractVariable methodsFor: 'read/write usage' stamp: 'MarcusDenker 10/16/2013 15:27'!
isUnused
	"when the var is never read or written, it is not used.
	Note: we have a special #arg use which means arguments are never unused"
	^ usage isNil! !

!OCAbstractVariable methodsFor: 'testing' stamp: 'NicolaiHess 8/24/2014 00:27'!
isWritable
	^ true! !

!OCAbstractVariable methodsFor: 'read/write usage' stamp: 'NicolaiHess 10/24/2014 00:10'!
isWrite
	^ usage = #write or: [ self isRepeatedWrite ]! !

!OCAbstractVariable methodsFor: 'read/write usage' stamp: 'MarcusDenker 10/16/2013 15:25'!
markRead
	"reading does not change a #write, nor an #arg"
	usage ifNil: [usage := #read]! !

!OCAbstractVariable methodsFor: 'read/write usage' stamp: 'NicolaiHess 10/24/2014 00:05'!
markRepeatedWrite
	"blocks in a loop have to know if write usage happens outside (just #write) or
	in the loop -> #repeatedWrite"
	usage := #repeatedWrite.! !

!OCAbstractVariable methodsFor: 'read/write usage' stamp: 'MarcusDenker 10/16/2013 15:26'!
markWrite
	"write is the strongest use: a read is turned into a write"
	usage := #write.! !

!OCAbstractVariable methodsFor: 'accessing' stamp: 'ajh 6/23/2004 22:47'!
name

	^ self subclassResponsibility! !

!OCAbstractVariable methodsFor: 'accessing' stamp: 'ClementBera 5/21/2013 14:52'!
originalVar
	^ self! !

!OCAbstractVariable methodsFor: 'printing' stamp: 'ajh 2/27/2003 00:38'!
printOn: stream

	stream nextPutAll: self name! !

!OCAbstractVariable methodsFor: 'accessing' stamp: 'ajh 6/23/2004 22:52'!
scope

	^ scope! !

!OCAbstractVariable methodsFor: 'initializing' stamp: 'ajh 7/8/2004 16:17'!
scope: aLexicalScope

	scope := aLexicalScope! !

!OCAbstractVariable methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 14:28'!
semanticNodeClass
	^self class semanticNodeClass! !

!OCAbstractVariable methodsFor: 'accessing' stamp: 'MarcusDenker 9/5/2010 20:13'!
usage

	^ usage! !

!OCAbstractVariable methodsFor: 'accessing' stamp: 'MarcusDenker 9/22/2010 11:05'!
usage: anObject

	usage := anObject! !

!OCAbstractVariable methodsFor: 'accessing' stamp: 'MarcusDenker 8/12/2015 10:25'!
variable
	"I return the first class variable that I model in the case of globals and ivars"
	^self! !

OCAbstractVariable subclass: #OCLiteralVariable
	instanceVariableNames: 'assoc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCLiteralVariable commentStamp: 'ajh 3/24/2003 21:53' prior: 0!
I am a global, pool, or class variable.!

!OCLiteralVariable class methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 14:30'!
semanticNodeClass

	^RBGlobalNode! !

!OCLiteralVariable methodsFor: 'accessing' stamp: 'GiselaDecuzzi 5/22/2013 15:06'!
assoc
	^ assoc! !

!OCLiteralVariable methodsFor: 'initializing' stamp: 'ajh 2/26/2003 17:31'!
assoc: anAssociation

	assoc := anAssociation! !

!OCLiteralVariable methodsFor: 'emitting' stamp: 'MarcusDenker 7/18/2014 07:22'!
emitStore: methodBuilder

	 assoc emitStore: methodBuilder

! !

!OCLiteralVariable methodsFor: 'emitting' stamp: 'MarcusDenker 7/18/2014 07:23'!
emitValue: methodBuilder
	assoc emitValue: methodBuilder! !

!OCLiteralVariable methodsFor: 'testing' stamp: 'NicolaiHess 6/16/2015 21:45'!
isClassVariable
	^ assoc isClassVariable! !

!OCLiteralVariable methodsFor: 'testing' stamp: 'MarcusDenker 2/2/2016 14:31'!
isFromSharedPool
	| sharedPools |
	sharedPools := scope getClass baseClass sharedPools.
	^ sharedPools 
		detect: [ :pool | pool classVarNames includes: assoc key ]
		ifFound: [ true ]
		ifNone: [ false ]! !

!OCLiteralVariable methodsFor: 'testing' stamp: 'ajh 7/8/2004 16:25'!
isGlobal

	^ true! !

!OCLiteralVariable methodsFor: 'testing' stamp: 'NicolaiHess 6/16/2015 21:46'!
isGlobalVariable
	^ assoc isGlobalVariable! !

!OCLiteralVariable methodsFor: 'testing' stamp: 'MarcusDenker 9/20/2013 13:28'!
isLiteralVariable
	^true.! !

!OCLiteralVariable methodsFor: 'accessing' stamp: 'ajh 7/2/2004 14:15'!
name

	^ assoc name! !

!OCLiteralVariable methodsFor: 'accessing' stamp: 'ms 8/5/2006 14:35'!
value
	^assoc value! !

!OCLiteralVariable methodsFor: 'accessing' stamp: 'MarcusDenker 8/12/2015 09:02'!
variable
	^assoc! !

OCAbstractVariable subclass: #OCSlotVariable
	instanceVariableNames: 'slot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCSlotVariable commentStamp: 'MarcusDenker 7/2/2014 14:26' prior: 0!
I am a slot in a class. 

Actual code generation is forwarded to the Slot class.

e.g. an InstanceVariableSlot will generate bytecode for reading and writing an ivar, while other Slots either just call the reflective operations of the Slot (#read: and #write:to) or do their own code generation.!

!OCSlotVariable class methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 14:29'!
semanticNodeClass

	^RBInstanceVariableNode! !

!OCSlotVariable methodsFor: 'emitting' stamp: 'CamilleTeruel 4/17/2014 15:36'!
emitStore: methodBuilder

	slot emitStore: methodBuilder! !

!OCSlotVariable methodsFor: 'emitting' stamp: 'CamilleTeruel 4/17/2014 15:38'!
emitValue: methodBuilder

	slot emitValue: methodBuilder! !

!OCSlotVariable methodsFor: 'testing' stamp: 'CamilleTeruel 4/17/2014 16:00'!
isInstance
	^ true! !

!OCSlotVariable methodsFor: 'accessing' stamp: 'CamilleTeruel 4/17/2014 16:46'!
name
	^ slot name! !

!OCSlotVariable methodsFor: 'accessing' stamp: 'CamilleTeruel 4/17/2014 16:50'!
name: aString
	slot name: aString asSymbol! !

!OCSlotVariable methodsFor: 'accessing' stamp: 'CamilleTeruel 4/17/2014 15:51'!
slot
	^ slot! !

!OCSlotVariable methodsFor: 'accessing' stamp: 'CamilleTeruel 4/17/2014 15:51'!
slot: aSlot
	slot := aSlot! !

!OCSlotVariable methodsFor: 'accessing' stamp: 'MarcusDenker 8/12/2015 09:02'!
variable
	^slot! !

OCAbstractVariable subclass: #OCUndeclaredVariable
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Semantics'!

!OCUndeclaredVariable commentStamp: 'MarcusDenker 7/2/2014 14:27' prior: 0!
I am a Variable that is not declared.

I am like a global an association, but instead of Smalltalk globals, I live in the Undeclared global dictionary.!

!OCUndeclaredVariable class methodsFor: 'accessing' stamp: 'DenisKudryashov 12/18/2015 15:28'!
semanticNodeClass
	^RBVariableNode! !

!OCUndeclaredVariable methodsFor: 'accessing' stamp: 'MarcusDenker 6/14/2013 15:36'!
assoc
	^Undeclared associationAt: name! !

!OCUndeclaredVariable methodsFor: 'emitting' stamp: 'MarcusDenker 6/14/2013 15:36'!
emitStore: methodBuilder

	methodBuilder storeIntoLiteralVariable:  self assoc

! !

!OCUndeclaredVariable methodsFor: 'emitting' stamp: 'MarcusDenker 6/14/2013 15:36'!
emitValue: methodBuilder

	methodBuilder pushLiteralVariable: self assoc.
! !

!OCUndeclaredVariable methodsFor: 'testing' stamp: 'MarcusDenker 6/14/2013 15:42'!
isUndeclared

	^ true! !

!OCUndeclaredVariable methodsFor: 'accessing' stamp: 'MarcusDenker 6/14/2013 15:33'!
name
	^ name! !

!OCUndeclaredVariable methodsFor: 'accessing' stamp: 'MarcusDenker 6/14/2013 15:33'!
name: anObject
	name := anObject! !

Object subclass: #OCCompilerASTPlugin
	instanceVariableNames: 'ast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Translator'!

!OCCompilerASTPlugin commentStamp: 'MarcusDenker 2/28/2015 15:00' prior: 0!
I am an abtract superclass for compiler plugings.

The compiler consists of multiple passes:

source 
	- [ Scanner/Parser ]  -> 
AST 
	- [ SemCheck ] -> 
AST   <<HERE>>
	- [ ASTTranslator ] -> 
IR 
	- [ IRBuilder ] ->
 CompiledMethod


These plugins are called <<HERE>>, that is, after semantic analysis before generating the IR.
They are sorted by #priority and handed a *copy* of the AST.


!

!OCCompilerASTPlugin class methodsFor: 'instance creation' stamp: 'MarcusDenker 2/28/2015 15:56'!
transform: ast
	^self new
		ast: ast;
		transform.! !

!OCCompilerASTPlugin methodsFor: 'accessing' stamp: 'MarcusDenker 2/28/2015 15:57'!
ast: anAst
	ast := anAst! !

!OCCompilerASTPlugin methodsFor: 'api' stamp: 'MarcusDenker 2/28/2015 15:01'!
priority
	^100 "default. Priority 0 is used by Reflectivity to be the last"! !

!OCCompilerASTPlugin methodsFor: 'api' stamp: 'PavelKrivanek 10/23/2015 09:57'!
transform
	
	self subclassResponsibility.! !

!OCCompilerASTPlugin methodsFor: 'api' stamp: 'MarcusDenker 2/28/2015 15:03'!
transform: anRBMethodNode
	"by default do nothing"
	^ ast := anRBMethodNode.! !

!Object methodsFor: '*OpalCompiler-Core' stamp: 'HenrikSperreJohansen 11/6/2015 11:18'!
mustBeBooleanInMagic: context
	"Permits to redefine methods inlined by compiler.
	Take the ast node corresponding to the mustBeBoolean error, compile it on the with Opal fly and executes it as a DoIt. Then resume the execution of the context."

	| sendNode methodNode method |

	"get the message send node that triggered mustBeBoolean"
	sendNode := context sourceNode sourceNodeForPC: context pc - 1.
	"Build node to perform send unoptimized"
	methodNode := RBMethodNode 
		selector: #ExecuteUnOptimizedIn: 
		arguments: { RBVariableNode named:'ThisContext' } 
		body: sendNode copy asSequenceNode.
	"Rewrite temps to access the values in context"
	methodNode rewriteTempsForContext: context.
	"Rewrite non-local returns to return to the correct context from send"
	RBParseTreeRewriter new 
		replace: '^ ``@value' with: 'ThisContext home return: ``@value';
		executeTree: methodNode.
	"Add a return to the method body"
	methodNode body transformLastToReturn.	
	"Keep same compilation context as the sender node's"
	methodNode compilationContext: sendNode methodNode compilationContext copy.
	"Disable inlining so the message send will be unoptimized"
	methodNode compilationContext compilerOptions: #(- optionInlineIf optionInlineAndOr optionInlineWhile).
	"Generate the method"	
	method := methodNode generate.
	"resume the context at the instruction following the send when returning from deoptimized code"
	context pc: sendNode irInstruction nextBytecodeOffsetAfterJump.
	"Execute the generated method"
	^ context receiver withArgs: {context} executeMethod: method! !

Object subclass: #OpalEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Encoders'!

!OpalEncoder commentStamp: '<historical>' prior: 0!
I encode names and literals into tree nodes with byte codes for the compiler. Byte codes for literals are not assigned until the tree-sizing pass of the compiler, because only then is it known which literals are actually needed. I also keep track of sourceCode ranges during parsing and code generation so I can provide an inverse map for the debugger.!

OpalEncoder subclass: #OpalBytecodeEncoder
	instanceVariableNames: 'stream position rootNode blockExtentsToLocals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Encoders'!

!OpalBytecodeEncoder commentStamp: '<historical>' prior: 0!
I am an abstract superclass for different bytecode set encoders.  Subclasses inherit the literal management of Encoder and encapsulate the mapping of opcodes to specific bytecodes.!

!OpalBytecodeEncoder class methodsFor: 'bytecode decoding' stamp: 'ClementBera 5/7/2015 10:00'!
nonExtensionBytecodeAt: pc in: method
	"Answer the actual bytecode at pc in method, skipping past any preceeding extensions."
	| thePC bytecode |
	thePC := pc.
	[self isExtension: (bytecode := method at: thePC)] whileTrue:
		[thePC := thePC + (self bytecodeSize: bytecode)].
	^bytecode! !

!OpalBytecodeEncoder class methodsFor: 'bytecode decoding' stamp: 'ClementBera 1/27/2015 14:14'!
specialSelectors	
	^ #(#+ #- #< #> #'<=' #'>=' #= #'~=' #* #/ #'\\' #@ #bitShift: #'//' #bitAnd: #bitOr: #at: #at:put: #size #next #nextPut: #atEnd #'==' nil "class" nil "blockCopy:" #value #value: #do: #new #new: #x #y)! !

!OpalBytecodeEncoder class methodsFor: 'bytecode decoding' stamp: 'ClementBera 12/28/2014 17:30'!
stackDeltaForPrimitive: primitiveIndex in: method 
	"This is the default implementation. Subclasses with inline primitives
	will need to override."
	^ 0! !

!OpalBytecodeEncoder methodsFor: 'temps' stamp: 'eem 6/23/2008 10:55'!
bindAndJuggle: name
	"This is used to insert a new temp and reorcder temps on editing.
	 It doesn't really work for closure compilation since we have multiple
	 locations for temps.  Simply signal a reparse is necessary."

	ReparseAfterSourceEditing signal! !

!OpalBytecodeEncoder methodsFor: 'temps' stamp: 'Alexandre Bergel 5/22/2010 12:47'!
blockExtentsToTempsMap
	"Answer a Dictionary of blockExtent to temp locations for the current method.
	 This is used by the debugger to locate temp vars in contexts.  A temp map
	 entry is a pair of the temp's name and its index, where an index is either an
	 integer for a normal temp or a pair of the index of the indirect temp vector
	 containing  the temp and the index of the temp in its indirect temp vector."
	| blockExtentsToTempsMap |
	blockExtentsToLocals ifNil:
		[^nil].
	blockExtentsToTempsMap := Dictionary new.
	blockExtentsToLocals keysAndValuesDo:
		[:blockExtent :locals|
		blockExtentsToTempsMap
			at: blockExtent
			put: (Array streamContents:
					[:str|
					locals withIndexDo:
						[:local :index|
						local isIndirectTempVector
							ifTrue: [local remoteTemps withIndexDo:
										[:remoteLocal :innerIndex| str nextPut: { remoteLocal key. { index. innerIndex } }]]
							ifFalse: [str nextPut: { local key. index }]]])].
	^blockExtentsToTempsMap! !

!OpalBytecodeEncoder methodsFor: 'bytecode generation' stamp: 'ClementBera 1/27/2015 14:14'!
genPushNClosureTemps: numTemps
	numTemps timesRepeat: [ self genPushSpecialLiteral: nil ]! !

!OpalBytecodeEncoder methodsFor: 'bytecode generation' stamp: 'GuillermoPolito 8/17/2015 13:52'!
genPushSpecialLiteral: aLiteral

	self subclassResponsibility! !

!OpalBytecodeEncoder methodsFor: 'testing' stamp: 'eem 6/29/2009 11:11'!
hasGeneratedMethod
	^blockExtentsToLocals notNil! !

!OpalBytecodeEncoder methodsFor: 'accessing' stamp: 'eem 5/14/2008 17:47'!
methodStreamPosition
	^stream position! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 7/27/2008 00:39'!
nextPut: aByte
	"For sizing make the encoder its own stream and
	 keep track of position with this version of nextPut:"
	position := position + 1! !

!OpalBytecodeEncoder methodsFor: 'temps' stamp: 'eem 6/3/2008 12:33'!
noteBlockExtent: blockExtent hasLocals: tempNodes
	blockExtentsToLocals ifNil:
		[blockExtentsToLocals := Dictionary new].
	blockExtentsToLocals at: blockExtent put: tempNodes asArray! !

!OpalBytecodeEncoder methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:52'!
outOfRangeError: string index: index range: rangeStart to: rangeEnd
	"For now..."
	^self error: thisContext sender method selector, ' ', string
				, ' index ', index printString
				, ' is out of range ', rangeStart printString, ' to ', rangeEnd printString! !

!OpalBytecodeEncoder methodsFor: 'accessing' stamp: 'eem 5/24/2008 11:56'!
rootNode "^<BlockNode>"
	^rootNode! !

!OpalBytecodeEncoder methodsFor: 'accessing' stamp: 'eem 5/24/2008 11:56'!
rootNode: node "<BlockNode>"
	rootNode := node! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 18:22'!
sizeBranchPopFalse: distance
	^self sizeOpcodeSelector: #genBranchPopFalse: withArguments: {distance}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 18:22'!
sizeBranchPopTrue: distance
	^self sizeOpcodeSelector: #genBranchPopTrue: withArguments: {distance}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'EstebanLorenzano 8/27/2014 14:37'!
sizeCallPrimitive: primitiveIndex
	^self sizeOpcodeSelector: #genCallPrimitive: withArguments: {primitiveIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:28'!
sizeDup
	^self sizeOpcodeSelector: #genDup withArguments: #()! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:40'!
sizeJump: distance
	^self sizeOpcodeSelector: #genJump: withArguments: {distance}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:40'!
sizeJumpLong: distance
	^self sizeOpcodeSelector: #genJumpLong: withArguments: {distance}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 7/27/2008 00:39'!
sizeOpcodeSelector: genSelector withArguments: args
	stream := self.
	position := 0.
	self perform: genSelector withArguments: args.
	^position! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:28'!
sizePop
	^self sizeOpcodeSelector: #genPop withArguments: #()! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/30/2008 16:46'!
sizePushClosureCopyNumCopiedValues: numCopied numArgs: numArgs jumpSize: jumpSize
	^self
		sizeOpcodeSelector: #genPushClosureCopyNumCopiedValues:numArgs:jumpSize:
		withArguments: {numCopied. numArgs. jumpSize}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/30/2008 16:36'!
sizePushConsArray: numElements
	^self sizeOpcodeSelector: #genPushConsArray: withArguments: {numElements}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 16:22'!
sizePushInstVar: instVarIndex
	^self sizeOpcodeSelector: #genPushInstVar: withArguments: {instVarIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 6/19/2008 08:54'!
sizePushInstVarLong: instVarIndex
	^self sizeOpcodeSelector: #genPushInstVarLong: withArguments: {instVarIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:43'!
sizePushLiteral: literalIndex
	^self sizeOpcodeSelector: #genPushLiteral: withArguments: {literalIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:43'!
sizePushLiteralVar: literalIndex
	^self sizeOpcodeSelector: #genPushLiteralVar: withArguments: {literalIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/24/2008 12:35'!
sizePushNewArray: size
	^self sizeOpcodeSelector: #genPushNewArray: withArguments: {size}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 16:21'!
sizePushReceiver
	^self sizeOpcodeSelector: #genPushReceiver withArguments: #()! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/24/2008 22:59'!
sizePushRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	^self sizeOpcodeSelector: #genPushRemoteTemp:inVectorAt: withArguments: {tempIndex. tempVectorIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:37'!
sizePushSpecialLiteral: specialLiteral
	^self sizeOpcodeSelector: #genPushSpecialLiteral: withArguments: {specialLiteral}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:26'!
sizePushTemp: tempIndex
	^self sizeOpcodeSelector: #genPushTemp: withArguments: {tempIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:28'!
sizePushThisContext
	^self sizeOpcodeSelector: #genPushThisContext withArguments: #()! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/15/2008 09:07'!
sizeReturnReceiver
	^self sizeOpcodeSelector: #genReturnReceiver withArguments: #()! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:38'!
sizeReturnSpecialLiteral: specialLiteral
	^self sizeOpcodeSelector: #genReturnSpecialLiteral: withArguments: {specialLiteral}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:34'!
sizeReturnTop
	^self sizeOpcodeSelector: #genReturnTop withArguments: #()! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/15/2008 09:06'!
sizeReturnTopToCaller
	^self sizeOpcodeSelector: #genReturnTopToCaller withArguments: #()! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 16:11'!
sizeSend: selectorLiteralIndex numArgs: nArgs
	^self sizeOpcodeSelector: #genSend:numArgs: withArguments: {selectorLiteralIndex. nArgs}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 16:11'!
sizeSendSuper: selectorLiteralIndex numArgs: nArgs
	^self sizeOpcodeSelector: #genSendSuper:numArgs: withArguments: {selectorLiteralIndex. nArgs}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:44'!
sizeStoreInstVar: instVarIndex
	^self sizeOpcodeSelector: #genStoreInstVar: withArguments: {instVarIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 6/19/2008 08:54'!
sizeStoreInstVarLong: instVarIndex
	^self sizeOpcodeSelector: #genStoreInstVarLong: withArguments: {instVarIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:43'!
sizeStoreLiteralVar: literalIndex
	^self sizeOpcodeSelector: #genStoreLiteralVar: withArguments: {literalIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/15/2008 10:00'!
sizeStorePopInstVar: instVarIndex
	^self sizeOpcodeSelector: #genStorePopInstVar: withArguments: {instVarIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 6/19/2008 08:54'!
sizeStorePopInstVarLong: instVarIndex
	^self sizeOpcodeSelector: #genStorePopInstVarLong: withArguments: {instVarIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/15/2008 10:20'!
sizeStorePopLiteralVar: literalIndex
	^self sizeOpcodeSelector: #genStorePopLiteralVar: withArguments: {literalIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/24/2008 23:02'!
sizeStorePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	^self sizeOpcodeSelector: #genStorePopRemoteTemp:inVectorAt: withArguments: {tempIndex. tempVectorIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:36'!
sizeStorePopTemp: tempIndex
	^self sizeOpcodeSelector: #genStorePopTemp: withArguments: {tempIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/24/2008 23:02'!
sizeStoreRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	^self sizeOpcodeSelector: #genStoreRemoteTemp:inVectorAt: withArguments: {tempIndex. tempVectorIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'eem 5/14/2008 17:45'!
sizeStoreTemp: tempIndex
	^self sizeOpcodeSelector: #genStoreTemp: withArguments: {tempIndex}! !

!OpalBytecodeEncoder methodsFor: 'opcode sizing' stamp: 'ClementBera 12/28/2014 17:30'!
sizeTrapIfNotInstanceOf: litIndex 
	^ self sizeOpcodeSelector: #genTrapIfNotInstanceOf: withArguments: {litIndex}
! !

!OpalBytecodeEncoder methodsFor: 'accessing' stamp: 'ClementBera 1/27/2015 14:14'!
stream: s
	stream := s! !

!OpalBytecodeEncoder methodsFor: 'initialize-release' stamp: 'eem 7/24/2008 17:24'!
streamToMethod: aCompiledMethod
	stream := WriteStream with: aCompiledMethod.
	stream position: aCompiledMethod initialPC - 1! !

!OpalBytecodeEncoder methodsFor: 'testing' stamp: 'eem 7/17/2008 12:34'!
supportsClosureOpcodes
	"Answer if the receiver supports the
		genPushNewArray:/genPushConsArray:
		genPushRemoteTemp:inVectorAt:
		genStoreRemoteTemp:inVectorAt:
		genStorePopRemoteTemp:inVectorAt:
		genPushClosureCopyCopiedValues:numArgs:jumpSize:
	 opcodes"
	^false! !

OpalBytecodeEncoder subclass: #OpalEncoderForLongFormV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Encoders'!

!OpalEncoderForLongFormV3 commentStamp: '<historical>' prior: 0!
I am an alternate to EncoderForV3 that tries to use thje longest forms of bytecodes possible so as to avoid using as many bytecode as possible to allow for the unused portions of the bytecode set this makes available to be reassigned.



I do not use the following ranges

0 through 111

	   0- 15 	0000iiii 	Push Receiver Variable #iiii

	  16- 31 	0001iiii 	Push Temporary Location #iiii

	  32- 63 	001iiiii 		Push Literal Constant #iiiii

	  64- 95 	010iiiii 		Push Literal Variable #iiiii

	  96-103 	01100iii 	Pop and Store Receiver Variable #iii

	104-111 	01101iii 	Pop and Store Temporary Location #iii

138-159

	138-143 				Unused.

	144-151 	10010iii 	Jump iii + 1 (i.e., 1 through 8).

	152-159 	10011iii 	Pop and Jump 0n False iii +1 (i.e., 1 through 8).

176-255

	176-191 	1011iiii 	Send Arithmetic Message #iiii

	192-207 	1100iiii 	Send Special Message #iiii

	208-223 	1101iiii 	Send Literal Selector #iiii With No Arguments

	224-239 	1110iiii 	Send Literal Selector #iiii With 1 Argument

	240-255 	1111iiii 	Send Literal Selector #iiii With 2 Arguments

= 112 + (160 - 138) + (256 - 176) =  214, or 84% of the bytecodes!

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:52'!
genBranchPopFalse: distance
	"See BlueBook page 596"
	distance < 0 ifTrue:
		[^self outOfRangeError: 'distance' index: distance range: 0 to: 1023].
	distance < 1024 ifTrue:
		["172-175 	101011ii jjjjjjjj 	Pop and Jump On False ii *256+jjjjjjjj"
		 stream
			nextPut: 172 + (distance bitShift: -8);
			nextPut: distance + 1024 \\ 256.
		 ^self].
	^self outOfRangeError: 'distance' index: distance range: 0 to: 1023! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:53'!
genBranchPopTrue: distance
	"See BlueBook page 596"
	distance < 0 ifTrue:
		[^self outOfRangeError: 'distance' index: distance range: 0 to: 1023].
	distance < 1024 ifTrue:
		["168-171 	101010ii jjjjjjjj 	Pop and Jump On True ii *256+jjjjjjjj"
		 stream
			nextPut: 168 + (distance bitShift: -8);
			nextPut: distance + 1024 \\ 256.
		 ^self].
	^self outOfRangeError: 'distance' index: distance range: 0 to: 1023! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:12'!
genDup
	"See BlueBook page 596"
	"136 	10001000 	Duplicate Stack Top"
	stream nextPut: 136! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:20'!
genJump: distance
	"See BlueBook page 596"
	^self genJumpLong: distance! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:53'!
genJumpLong: distance
	"See BlueBook page 596"
	(distance >= -1024 and: [distance < 1024]) ifTrue:
		["160-167 	10100iii jjjjjjjj 	Jump(iii - 4) *256+jjjjjjjj"
		 stream
			nextPut: 160 + (distance + 1024 bitShift: -8);
			nextPut: distance + 1024 \\ 256.
		 ^self].
	^self outOfRangeError: 'distance' index: distance range: -1024 to: 1023! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:12'!
genPop
	"See BlueBook page 596"
	"135 	10000111 	Pop Stack Top"
	stream nextPut: 135! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:46'!
genPushInstVar: instVarIndex
	"See BlueBook page 596"
	(instVarIndex >= 0 and: [instVarIndex < 64]) ifTrue: 
		["128 	10000000 jjkkkkkk 	Push (Receiver Variable, Temporary Location, Literal Constant, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 128;
			nextPut: instVarIndex.
		 ^self].
	self genPushInstVarLong: instVarIndex! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:51'!
genPushInstVarLong: instVarIndex
	"See BlueBook page 596"
	"See also MaybeContextInstanceVariableNode"
	(instVarIndex >= 0 and: [instVarIndex < 256]) ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 64;
			nextPut: instVarIndex.
		 ^self].
	^self outOfRangeError: 'index' index: instVarIndex range: 0 to: 255! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:54'!
genPushLiteral: literalIndex
	"See BlueBook page 596"
	literalIndex < 0 ifTrue: 
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255].
	literalIndex < 64 ifTrue: 
		["128 	10000000 jjkkkkkk 	Push (Receiver Variable, Temporary Location, Literal Constant, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 128;
			nextPut: 128 + literalIndex.
		 ^self].
	literalIndex < 256 ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 96;
			nextPut: literalIndex.
		 ^self].
	^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:54'!
genPushLiteralVar: literalIndex
	"See BlueBook page 596"
	literalIndex < 0 ifTrue: 
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255].
	literalIndex < 64 ifTrue: 
		["128 	10000000 jjkkkkkk 	Push (Receiver Variable, Temporary Location, Literal Constant, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 128;
			nextPut: 192 + literalIndex.
		 ^self].
	literalIndex < 256 ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 128;
			nextPut: literalIndex.
		 ^self].
	^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:12'!
genPushReceiver
	"See BlueBook page 596"
	"112-119 	01110iii 	Push (receiver, true, false, nil, -1, 0, 1, 2) [iii]"
	stream nextPut: 112! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:12'!
genPushSpecialLiteral: aLiteral
	"112-119 	01110iii 	Push (receiver, true, false, nil, -1, 0, 1, 2) [iii]"
	| index |
	index := #(true false nil -1 0 1 2) indexOf: aLiteral ifAbsent: 0.
	index = 0 ifTrue:
		[^self error: 'push special literal: ', aLiteral printString,  ' is not one of true false nil -1 0 1 2'].
	stream nextPut: index + 112! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:54'!
genPushTemp: tempIndex
	"See BlueBook page 596"
	tempIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63].
	tempIndex < 64 ifTrue: 
		["128 	10000000 jjkkkkkk 	Push (Receiver Variable, Temporary Location, Literal Constant, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 128;
			nextPut: 64 + tempIndex.
		 ^self].
	^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:12'!
genPushThisContext
	"See BlueBook page 596"
	"137 	10001001 	Push Active Context"
	stream nextPut: 137! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:12'!
genReturnReceiver
	"See BlueBook page 596"
	"120-123 	011110ii 	Return (receiver, true, false, nil) [ii] From Message"
	stream nextPut: 120! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:12'!
genReturnSpecialLiteral: aLiteral
	"120-123 	011110ii 	Return (receiver, true, false, nil) [ii] From Message"
	| index |
	index := #(true false nil) indexOf: aLiteral ifAbsent: 0.
	index = 0 ifTrue:
		[^self error: 'return special literal: ', aLiteral printString,  ' is not one of true false nil'].
	stream nextPut: 120 + index! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:12'!
genReturnTop
	"See BlueBook page 596"
	"124-125 	0111110i 	Return Stack Top From (Message, Block) [i]"
	stream nextPut: 124! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 14:12'!
genReturnTopToCaller
	"See BlueBook page 596"
	"124-125 	0111110i 	Return Stack Top From (Message, Block) [i]"
	stream nextPut: 125! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:56'!
genSend: selectorLiteralIndex numArgs: nArgs
	"See BlueBook page 596 (with exceptions for 132 & 134)"
	nArgs < 0 ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31 "!!!!"].
	selectorLiteralIndex < 0 ifTrue:
		["No special selector sends in long form."
		^self outOfRangeError: 'selector literal index' index: selectorLiteralIndex range: 0 to: 255].
	(selectorLiteralIndex < 32 and: [nArgs < 8]) ifTrue: 
		["	131 	10000011 jjjkkkkk 	Send Literal Selector #kkkkk With jjj Arguments"
		 stream
			nextPut: 131;
			nextPut: ((nArgs bitShift: 5) + selectorLiteralIndex).
		 ^self].
	(selectorLiteralIndex < 64 and: [nArgs < 4]) ifTrue: 
	 	["In Squeak V3
			134 	10000110 jjjjjjjj kkkkkkkk 	Send Literal Selector #kkkkkkkk To Superclass With jjjjjjjj Arguments
		 is replaced by
			134 	10000110 jjkkkkkk 	Send Literal Selector #kkkkkk With jj Arguments"
		 stream
			nextPut: 134;
			nextPut: ((nArgs bitShift: 6) + selectorLiteralIndex).
		 ^self].
	(selectorLiteralIndex <= 255 and: [nArgs <= 31]) ifTrue: 
		["In Squeak V3
			132 	10000100 jjjjjjjj kkkkkkkk 	Send Literal Selector #kkkkkkkk With jjjjjjjj Arguments
		  is replaced by
			132 	10000100 ooojjjjj kkkkkkkk
				ooo = 0 => Send Literal Selector #kkkkkkkk With jjjjj Arguments
				ooo = 1 => Send Literal Selector #kkkkkkkk To Superclass With jjjjj Arguments"
		stream
			nextPut: 132;
			nextPut: nArgs;
			nextPut: selectorLiteralIndex.
		 ^self].
	nArgs > 31 ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31].
	selectorLiteralIndex > 255 ifTrue: 
		[^self outOfRangeError: 'selector literal index' index: selectorLiteralIndex range: 0 to: 255]! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:55'!
genSendSuper: selectorLiteralIndex numArgs: nArgs
	"See BlueBook page 596 (with exceptions for 132 & 134)"
	nArgs < 0 ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31 "!!!!"].
	selectorLiteralIndex < 0 ifTrue:
		[^self outOfRangeError: 'selector literal index' index: selectorLiteralIndex range: 0 to: 255].
	(selectorLiteralIndex < 32 and: [nArgs < 8]) ifTrue: 
		["	133 	10000011 jjjkkkkk 	Send Literal Selector #kkkkk To Superclass With jjj Arguments"
		 stream
			nextPut: 133;
			nextPut: ((nArgs bitShift: 5) + selectorLiteralIndex).
		 ^self].
	(selectorLiteralIndex <= 255 and: [nArgs <= 31]) ifTrue: 
		["In Squeak V3
			132 	10000100 jjjjjjjj kkkkkkkk 	Send Literal Selector #kkkkkkkk With jjjjjjjj Arguments
		  is replaced by
			132 	10000100 ooojjjjj kkkkkkkk
				ooo = 0 => Send Literal Selector #kkkkkkkk With jjjjj Arguments
				ooo = 1 => Send Literal Selector #kkkkkkkk To Superclass With jjjjj Arguments"
		stream
			nextPut: 132;
			nextPut: 32 + nArgs;
			nextPut: selectorLiteralIndex.
		 ^self].
	nArgs > 31 ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31].
	selectorLiteralIndex > 255 ifTrue: 
		[^self outOfRangeError: 'selector literal index' index: selectorLiteralIndex range: 0 to: 255]! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:48'!
genStoreInstVar: instVarIndex
	"See BlueBook page 596"
	(instVarIndex >= 0 and: [instVarIndex < 64]) ifTrue: 
		["129 	10000001 jjkkkkkk 	Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 129;
			nextPut: instVarIndex.
		 ^self].
	self genStoreInstVarLong: instVarIndex! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:51'!
genStoreInstVarLong: instVarIndex
	"See BlueBook page 596"
	"See also MaybeContextInstanceVariableNode"
	(instVarIndex >= 0 and: [instVarIndex < 256]) ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 160;
			nextPut: instVarIndex.
		 ^self].
	^self outOfRangeError: 'index' index: instVarIndex range: 0 to: 255! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:57'!
genStoreLiteralVar: literalIndex
	"See BlueBook page 596"
	literalIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255].
	literalIndex < 64 ifTrue: 
		["129 	10000001 jjkkkkkk 	Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 129;
			nextPut: 192 + literalIndex.
		 ^self].
	literalIndex <= 255 ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 224;
			nextPut: literalIndex.
		 ^self].
	^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:50'!
genStorePopInstVar: instVarIndex
	"See BlueBook page 596"
	(instVarIndex >= 0 and: [instVarIndex < 64]) ifTrue:
		["130 	10000010 jjkkkkkk 	Pop and Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 130;
			nextPut: instVarIndex.
		 ^self].
	self genStorePopInstVarLong: instVarIndex! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:51'!
genStorePopInstVarLong: instVarIndex
	"See BlueBook page 596"
	"See also MaybeContextInstanceVariableNode"
	(instVarIndex >= 0 and: [instVarIndex < 256]) ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 192;
			nextPut: instVarIndex.
		 ^self].
	^self outOfRangeError: 'index' index: instVarIndex range: 0 to: 255! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:58'!
genStorePopLiteralVar: literalIndex
	"See BlueBook page 596"
	literalIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255].
	literalIndex < 64 ifTrue: 
		["130 	10000010 jjkkkkkk 	Pop and Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 130;
			nextPut: 192 + literalIndex.
		 ^self].
	literalIndex <= 255 ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 224;
			nextPut: literalIndex.
		 self genPop.
		 ^self].
	^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:58'!
genStorePopTemp: tempIndex
	"See BlueBook page 596"
	tempIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63].
	tempIndex < 64 ifTrue: 
		["130 	10000010 jjkkkkkk 	Pop and Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 130;
			nextPut: 64 + tempIndex.
		 ^self].
	^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63! !

!OpalEncoderForLongFormV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:58'!
genStoreTemp: tempIndex
	"See BlueBook page 596"
	tempIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63].
	tempIndex < 64 ifTrue: 
		["129 	10000001 jjkkkkkk 	Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 129;
			nextPut: 64 + tempIndex.
		 ^self].
	^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63! !

OpalEncoderForLongFormV3 subclass: #OpalEncoderForLongFormV3PlusClosures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Encoders'!

!OpalEncoderForLongFormV3PlusClosures commentStamp: '<historical>' prior: 0!
An encoder for the V3 bytecode set augmented with the following bytecodes that are part of the full closure implementation.
	138   10001010 jkkkkkkk		Push (Array new: kkkkkkk) (j = 0)
								or	Pop kkkkkkk elements into: (Array new: kkkkkkk) (j = 1)

	140   10001100 kkkkkkkk jjjjjjjj 	Push Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
	141   10001101 kkkkkkkk jjjjjjjj 	Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
	142   10001110 kkkkkkkk jjjjjjjj 	Pop and Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
	143   10001111 llllkkkk jjjjjjjj iiiiiiii	Push Closure Num Copied llll Num Args kkkk BlockSize jjjjjjjjiiiiiiii
This is an exact duplicate of EncoderForV3PlusClosures.
Could be a trait (or in Newspeak, a Mixin).
For now we impose upon you to synchronise any and all changes between these two classes.!

!OpalEncoderForLongFormV3PlusClosures methodsFor: 'bytecode generation' stamp: 'GuillermoPolito 8/14/2015 11:36'!
genPushClosureCopyNumCopiedValues: numCopied numArgs: numArgs jumpSize: jumpSize
	"143 	10001111 llllkkkk jjjjjjjj iiiiiiii	Push Closure Num Copied llll Num Args kkkk BlockSize jjjjjjjjiiiiiiii"
	(jumpSize < 0 or: [jumpSize > 65535]) ifTrue:
		[^self outOfRangeError: 'block size' index: jumpSize range: 0 to: 65535].
	(numCopied < 0 or: [numCopied > 15]) ifTrue:
		[^self outOfRangeError: 'num copied' index: numCopied range: 0 to: 15].
	(numArgs < 0 or: [numArgs > 15]) ifTrue:
		[^self outOfRangeError: 'num args' index: numArgs range: 0 to: 15].
	stream
		nextPut: 143;
		nextPut: numArgs + (numCopied bitShift: 4);
		nextPut: (jumpSize bitShift: -8);
		nextPut: (jumpSize bitAnd: 16rFF)! !

!OpalEncoderForLongFormV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:06'!
genPushConsArray: size
	(size < 0 or: [size > 127]) ifTrue:
		[^self outOfRangeError: 'numElements' index: size range: 0 to: 127].
	"138 	10001010 1kkkkkkk 	Pop kkkkkkk into: (Array new: kkkkkkk)"
	stream
		nextPut: 138;
		nextPut: size + 128! !

!OpalEncoderForLongFormV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:05'!
genPushNewArray: size
	(size < 0 or: [size > 127]) ifTrue:
		[^self outOfRangeError: 'size' index: size range: 0 to: 127].
	"138 	10001010 0kkkkkkk 	Push (Array new: kkkkkkk)"
	stream
		nextPut: 138;
		nextPut: size! !

!OpalEncoderForLongFormV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 6/16/2008 09:45'!
genPushRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	(tempIndex >= 0 and: [tempIndex < 256
	 and: [tempVectorIndex >= 0 and: [tempVectorIndex < 256]]]) ifTrue:
		["140 	10001100 kkkkkkkk jjjjjjjj 	Push Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
		 stream
			nextPut: 140;
			nextPut: tempIndex;
			nextPut: tempVectorIndex.
		 ^self].
	tempIndex >= 256 ifTrue:
		[^self outOfRangeError: 'remoteTempIndex' index: tempIndex range: 0 to: 255].
	tempVectorIndex >= 256 ifTrue:
		[^self outOfRangeError: 'tempVectorIndex' index: tempVectorIndex range: 0 to: 255]! !

!OpalEncoderForLongFormV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:04'!
genStorePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	"142 	10001110 kkkkkkkk jjjjjjjj 	Pop and Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
	(tempIndex >= 0 and: [tempIndex < 256
	 and: [tempVectorIndex >= 0 and: [tempVectorIndex < 256]]]) ifTrue:
		[stream
			nextPut: 142;
			nextPut: tempIndex;
			nextPut: tempVectorIndex.
		 ^self].
	tempIndex >= 256 ifTrue:
		[^self outOfRangeError: 'remoteTempIndex' index: tempIndex range: 0 to: 255].
	tempVectorIndex >= 256 ifTrue:
		[^self outOfRangeError: 'tempVectorIndex' index: tempVectorIndex range: 0 to: 255]! !

!OpalEncoderForLongFormV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:04'!
genStoreRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	"141 	10001101 kkkkkkkk jjjjjjjj 	Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
	(tempIndex >= 0 and: [tempIndex < 256
	 and: [tempVectorIndex >= 0 and: [tempVectorIndex < 256]]]) ifTrue:
		[stream
			nextPut: 141;
			nextPut: tempIndex;
			nextPut: tempVectorIndex.
		 ^self].
	tempIndex >= 256 ifTrue:
		[^self outOfRangeError: 'remoteTempIndex' index: tempIndex range: 0 to: 255].
	tempVectorIndex >= 256 ifTrue:
		[^self outOfRangeError: 'tempVectorIndex' index: tempVectorIndex range: 0 to: 255]! !

!OpalEncoderForLongFormV3PlusClosures methodsFor: 'testing' stamp: 'eem 5/24/2008 18:12'!
supportsClosureOpcodes
	^true! !

OpalBytecodeEncoder subclass: #OpalEncoderForSistaV1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Encoders'!

!OpalEncoderForSistaV1 commentStamp: 'ClementBera 5/7/2015 10:08' prior: 0!
EncoderForSistaV1 encodes a bytecode set for Sista, the Speculative Inlining Smalltalk Architecture, a project by Cl√©ment Bera and Eliot Miranda.  Sista is an optimizer that exists in the Smalltalk image, /not/ in the VM,  and optimizes by substituting normal bytecoded methods by optimized bytecoded methods that may use special bytecodes for which the Cogit can generate faster code.  These bytecodes eliminate overheads such as bounds checks or polymorphic code (indexing Array, ByteArray, String etc).  But the bulk of the optimization performed is in inlining blocks and sends for the common path.  This bytecode set therefore differs from a normal Smalltalk set in providing a set of inlined primitives that do not validate their arguments that the compiler generates only when it can prove that the primitives' arguments are valid.

The basic scheme is that the Cogit generates code containing performance counters.  When these counters trip, a callback into the image is performed, at which point Sista analyses some portion of the stack, looking at performance data for the methods on the stack, and optimises based on the stack and performance data.  Execution then resumes in the optimized code.

The Sista Cogit (e.g. SistaStackToRegisterMappingCogit) adds counters to conditional branches.  Each branch has an executed and a taken count.  On execution the executed count is decremented and if the count goes below zero the VM sends a message at a special index in the specialObjectsArray (as of writing, conditionalCounterTrippedOn:).  Then if the branch is taken the taken count is decremented.  The two counter values allow the Sista optimizer to collect basic block execution paths and to know what are the "hot" paths through execution that are worth agressively optimizing.  Since conditional branches are about 1/6 as frequent as sends, and since they can be used to determine the hot path through code, they are a better choice to count than, for example, method or block entry.

The VM provides a primitive that fills an Array with the state of the counters, and the state of each linked send in a method.  Tthe optimizer obtains the branch and send data for a method via this primitive.


This bytecde set encodes a bytecode set for Smalltalk that lifts limits on the number of literals and branch distances, and extended push integer and push character bytecodes.  Bytecodes are ordered by length to make decoding easier.  Bytecodes marked with an * are extensible via a prefix bytecode.

N.B.  Extension bytecodes can only come before extensible bytecodes, and only if valid (one cannot extend a bytecode extensible by Ext A with an Ext B).  An extensible bytecode consumes (and zeros) its extension(s).  Hence the hidden implicit variables holding extensions are always zero except after a valid sequence of extension bytecodes.

Instance Variables (inherited)

1 Byte Bytecodes
	code	(note)	binary			name
	0-15		0000 iiii 			Push Receiver Variable #iiii
	16-31		0001 iiii			Push Literal Variable #iiii
	32-63		001 iiiii				Push Literal #iiiii
	64-71		01000 iii			Push Temp #iii
	72-75		010010 ii			Push Temp #ii + 8
	76			01001100			Push Receiver
	77			01001101			Push true
	78			01001110			Push false
	79			01001111			Push nil
	80			01010000			Push 0
	81			01010001			Push 1
*	82			01010010			Push thisContext, (then Extend B = 1 => push thisProcess)
	83			01010011			Duplicate Stack Top
	84-87		010101 ii			UNASSIGNED
	88-91		010110 ii			Return Receiver/true/false/nil
	92			01011100			Return top
	93			01011101			BlockReturn nil
*	94			01011110			BlockReturn Top [* return from enclosing block N, N = Extend A, then jump by Ext B ]
*	95			01011111			Nop
	96-111		0110 iiii			Send Arithmetic Message #iiii #(#+ #- #< #> #'<=' #'>=' #= #'~=' #* #/ #'\\' #@ #bitShift: #'//' #bitAnd: #bitOr:)
	112-119	01110 iii			Send Special Message #iii #(#at: #at:put: #size #next #nextPut: #atEnd #'==' class)
	120		01111000			UNASSIGNED (was: blockCopy:)
	121		01111001			Send Special Message #value
	122-123	0111101 i			Send Special Message #i #(#value: #do:)
	124-127	011111 ii			Send Special Message #ii #(#new #new: #x #y))
	128-143	1000 iiii			Send Literal Selector #iiii With 0 Argument
	144-159	1001 iiii			Send Literal Selector #iiii With 1 Arguments
	160-175	1010 iiii			Send Literal Selector #iiii With 2 Arguments
	176-183	10110 iii			Jump iii + 1 (i.e., 1 through 8)
	184-191	10111 iii			Pop and Jump 0n True iii +1 (i.e., 1 through 8)
	192-199	11000 iii			Pop and Jump 0n False iii +1 (i.e., 1 through 8)
	200-207	11001 iii			Pop and Store Receiver Variable #iii
	208-215	11010 iii			Pop and Store Temporary Variable #iii
	216		11011000			Pop Stack Top
	217		11011001			Unconditionnal trap
	218-219	1101101 i			UNASSIGNED
	220-223	110111 ii			UNASSIGNED

2 Byte Bytecodes
*	224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)
*	225		11100001	bbbbbbbb	Extend B (Ext B = Ext B prev * 256 + Ext B)
*	226		11100010	iiiiiiii		Push Receiver Variable #iiiiiiii (+ Extend A * 256)
*	227		11100011	iiiiiiii		Push Literal Variable #iiiiiiii (+ Extend A * 256)
*	228		11100100	iiiiiiii		Push Literal #iiiiiiii (+ Extend A * 256)
	229		11100101	iiiiiiii		Push Temporary Variable #iiiiiiii
	230		11100110	iiiiiiii		PushNClosureTemps iiiiiiii
	231		11100111	jkkkkkkk	Push (Array new: kkkkkkk) (j = 0)
									&	Pop kkkkkkk elements into: (Array new: kkkkkkk) (j = 1)
*	232		11101000	iiiiiiii		Push Integer #iiiiiiii (+ Extend B * 256, where bbbbbbbb = sddddddd, e.g. -32768 = i=0, a=0, s=1)
*	233		11101001	iiiiiiii		Push Character #iiiiiiii (+ Extend B * 256)
**	234		11101010	iiiiijjj		Send Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments
**	235	(1)	11101011	iiiiijjj	ExtendB < 64
										ifTrue: [Send To Superclass Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments]
										ifFalse: [Send To Superclass of Stacked Class Literal Selector #iiiii (+ Extend A * 32) with jjj (+ (Extend B bitAnd: 63) * 8) Arguments]
*	236		11101100	iiiiiiii		UNASSIGNED
*	237		11101101	iiiiiiii		Jump #iiiiiiii (+ Extend B * 256, where bbbbbbbb = sddddddd, e.g. -32768 = i=0, a=0, s=1)
*	238		11101110	iiiiiiii		Pop and Jump 0n True #iiiiiiii (+ Extend B * 256, where Extend B >= 0)
*	239		11101111	iiiiiiii		Pop and Jump 0n False #iiiiiiii (+ Extend B * 256, where Extend B >= 0)
*	240		11110000	iiiiiiii		Pop and Store Receiver Variable #iiiiiii (+ Extend A * 256)
*	241		11110001	iiiiiiii		Pop and Store Literal Variable #iiiiiiii (+ Extend A * 256)
	242		11110010	iiiiiiii		Pop and Store Temporary Variable #iiiiiiii
*	243		11110011	iiiiiiii		Store Receiver Variable #iiiiiii (+ Extend A * 256)
*	244		11110100	iiiiiiii		Store Literal Variable #iiiiiiii (+ Extend A * 256)
	245		11110110	iiiiiiii		Store Temporary Variable #iiiiiiii
	246-247	1111011 i	xxxxxxxx	UNASSIGNED

3 Byte Bytecodes
	248	(2)	11111000 	iiiiiiii		mjjjjjjj		Call Primitive #iiiiiiii + (jjjjjjj * 256) m=1 means inlined primitive, no hard return after execution.
	249		11111001 	xxxxxxxx	syyyyyyy	Reserved for Push Float
**	250		11111010 	eeiiikkk		jjjjjjjj		Push Closure Num Copied iii (+ExtA//16*8) Num Args kkk (+ ExtA\\16*8) BlockSize jjjjjjjj (+ExtB*256). ee = num extensions
	251		11111011 	kkkkkkkk	jjjjjjjj		Push Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
	252		11111100 	kkkkkkkk	jjjjjjjj		Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
	253		11111101 	kkkkkkkk	jjjjjjjj		Pop and Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
**	254		11111110	kkkkkkkk	jjjjjjjj		branch If Not Instance Of Behavior/Array Of Behavior kkkkkkkk (+ Extend A * 256, where Extend A >= 0) distance jjjjjjjj (+ Extend B * 256, where Extend B >= 0)
	255		11111111	xxxxxxxx	yyyyyyyy	UNASSIGNED

(1) Bytecode 235 is a super send bytecode that starts the lookup in the superclass of some class.  It has two forms, "norma;" and "directed". In the normal form, the class is the value of the method's methodClassAssociation which must be the last literal.  In the directed form the class is the class on top of stack.

(2) The Call Primitive Bytecode specifies either a primitive in the primitive table (m=0) or an inlined primitive (m=1). Non-inlined primtiives from the primitive table have index (jjjjjjj * 256) + iiiiiiii and return from the method if they succeed.  This bytecode is only valid as the first bytecode of a method.  Inline primitives have index (jjjjjjj * 256) + iiiiiiii, cannot fail, and do not return when they succeed, yielding a result (typically on top of stack after popping their arguments, but possibly in a byte data stack, for example for unboxed floating-point primitives).

We sort the inline primitive operations by arity.  Nullary primitives occupy the 0-999 range.  Unary primitives occupy the 1-1999 range, etc.

We define the following inlined primitives:
1000	unchecked class
1001	unchecked pointer numSlots
1002	unchecked pointer basicSize
1003	unchecked byte8Type format numBytes (includes CompiledMethod)
1004	unchecked short16Type format numShorts
1005	unchecked word32Type format numWords
1006	unchecked doubleWord64Type format numDoubleWords

2000	unchecked SmallInteger #+.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)
2001	unchecked SmallInteger #-.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)
2002	unchecked SmallInteger #*.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)
2003	unchecked SmallInteger #/.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)
2004	unchecked SmallInteger #//.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)
2005	unchecked SmallInteger #\\.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)
2006	unchecked SmallInteger #quo:.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)

2016	unchecked SmallInteger #bitAnd:.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)
2017	unchecked SmallInteger #bitOr:.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)
2018	unchecked SmallInteger #bitXor:.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)
2019	unchecked SmallInteger #bitShift:.  Both arguments are SmallIntegers and the result fits in a SmallInteger (* depends on word size)

2032	unchecked SmallInteger #>.  Both arguments are SmallIntegers
2033	unchecked SmallInteger #<.  Both arguments are SmallIntegers
2034	unchecked SmallInteger #>=.  Both arguments are SmallIntegers
2035	unchecked SmallInteger #<=.  Both arguments are SmallIntegers
2036	unchecked SmallInteger #=.  Both arguments are SmallIntegers
2037	unchecked SmallInteger #~=.  Both arguments are SmallIntegers

2064	unchecked Pointer Object>>at:.		The receiver is guaranteed to be a pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger
2065	unchecked Byte Object>>at:.			The receiver is guaranteed to be a non-pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger.  The result is a SmallInteger.
2066	unchecked 16-bit Word Object>>at:.			The receiver is guaranteed to be a non-pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger.  The result is a SmallInteger.
2067	unchecked Word Object>>at:.			The receiver is guaranteed to be a non-pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger.  The result is a SmallInteger.
2068	unchecked DoubleWord Object>>at:.	The receiver is guaranteed to be a non-pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger.  The result is a SmallInteger or a LargePositiveInteger.
2069	unchecked QuadWord Object>>at:.		The receiver is guaranteed to be a non-pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger.  The result is a SmallInteger or a LargePositiveInteger.

3000	unchecked Pointer Object>>at:put:.			The receiver is guaranteed to be a pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger
3001	unchecked Byte Object>>at:put:.			The receiver is guaranteed to be a non-pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger.  The argument is a SmallInteger.  The primitive stores the least significant 8 bits.
3002	unchecked Word Object>>at:put:.			The receiver is guaranteed to be a non-pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger.  The argument is a SmallInteger.  The primitive stores the least significant 16 bits.
3003	unchecked DoubleWord Object>>at:put:.	The receiver is guaranteed to be a non-pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger.  The argument is a SmallInteger.  The primitive stores the least significant 32 bits.
3004	unchecked QuadWord Object>>at:put:.		The receiver is guaranteed to be a non-pointer object.  The 0-relative (1-relative?) index is an in-range SmallInteger.  The argument is a SmallInteger.  The primitive stores the least significant 64 bits.!

!OpalEncoderForSistaV1 class methodsFor: 'bytecode decoding' stamp: 'ClementBera 1/27/2015 14:15'!
backJumpBytecodeSize
	^ 4! !

!OpalEncoderForSistaV1 class methodsFor: 'compiled method support' stamp: 'eem 5/18/2014 18:54'!
bindingReadScanBlockFor: litVarIndex using: scanner
	"Answer a block argument for InstructionStream>>scanFor: that answers true
	 for reads of the value of the binding with zero-relative index litVarIndex.
	 N.B. Don't assume the compiler uses the most compact encoding available."

	"	16-31		0001 i i i i				Push Literal Variable #iiii
	 *	224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)
	 *	227		11100011	i i i i i i i i	Push Literal Variable #iiiiiiii (+ Extend A * 256)"
	| extension |
	extension := 0.
	^[:b| | prevext |
	   prevext := extension.
	   extension := b = 224 ifTrue: [scanner followingByte bitShift: 8] ifFalse: [0].
	   (b < 32 and: [b >= 16 and: [b - 16 = litVarIndex]])
	    or: [b = 227
			and: [scanner followingByte + prevext = litVarIndex]]]! !

!OpalEncoderForSistaV1 class methodsFor: 'compiled method support' stamp: 'eem 5/18/2014 18:59'!
bindingWriteScanBlockFor: litVarIndex using: scanner
	"Answer a block argument for InstructionStream>>scanFor: that answers true
	 for writes of the value of the binding with zero-relative index litVarIndex.
	 N.B. Don't assume the compiler uses the most compact encoding available."

	"*	224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)
	 *	241		11110001	iiiiiiii		Pop and Store Literal Variable #iiiiiiii (+ Extend A * 256)
	 *	244		11110100	iiiiiiii		Store Literal Variable #iiiiiiii (+ Extend A * 256)"
	| extension |
	extension := 0.
	^[:b| | prevext |
	   prevext := extension.
	   extension := b = 224 ifTrue: [scanner followingByte bitShift: 8] ifFalse: [0].
	   (b = 241 or: [b = 244])
	   and: [scanner followingByte + prevext = litVarIndex]]! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:00'!
bytecodeSize: bytecode
	"Answer the number of bytes in the bytecode."
	bytecode < 224 ifTrue: [^1].
	bytecode < 248 ifTrue: [^2].
	^3! !

!OpalEncoderForSistaV1 class methodsFor: 'bytecode decoding' stamp: 'eem 5/18/2014 19:22'!
callPrimitiveCode
	"Answer the call primitive bytecode, if it exists in the encoder's bytecode set, or nil if not.
	 248	11111000 	iiiiiiii	mjjjjjjj	Call Primitive #iiiiiiii + (jjjjjjj * 256) m=1 means inlined primitive, no hard return after execution."
	^248! !

!OpalEncoderForSistaV1 class methodsFor: 'compiled method support' stamp: 'eem 5/18/2014 18:56'!
extensionsAt: bcpc in: method into: aTrinaryBlock
	"If the bytecode at pc is an extension then evaluate aBinaryBlock with the values of extA and extB and number of extension *bytes*.
	 If the bytecode at pc is not extended then evaluate aBinaryBlock with 0 and 0.
	224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)
	225		11100001	bbbbbbbb	Extend B (Ext B = Ext B prev * 256 + Ext B)"
 
	| scanpc byte extByte extA extB |
	scanpc := bcpc.
	"There may be an extension (it could be a false positive).  We must scan as fast as possible..."
	extA := extB := 0.
	[byte := method at: scanpc.
	 byte >= 224 and: [byte <= 225]] whileTrue: 
		[extByte := method at: scanpc + 1.
		 scanpc := scanpc + 2.
		 byte = 224
			ifTrue:
				[extA := (extA bitShift: 8) + extByte]
			ifFalse:
				[extB := (extB = 0 and: [extByte > 127])
					ifTrue: [extByte - 256]
					ifFalse: [(extB bitShift: 8) + extByte]]].
	^aTrinaryBlock value: extA value: extB value: scanpc - bcpc


"Why use
	byte >= 224 and: [byte <= 225]
 and not
	(byte bitAnd: 16rFE) = 16rE0
 ?
 | n |
 n := 100000000.
 #(0 224) collect:
	[:byte|
	{ Time millisecondsToRun: [1 to: n do: [:i| (byte >= 224 and: [byte <= 225]) ifTrue: []]].
	   Time millisecondsToRun: [1 to: n do: [:i| (byte bitAnd: 16rFE) = 16rE0 ifTrue: []]] }] #(#(297 599) #(702 671))"! !

!OpalEncoderForSistaV1 class methodsFor: 'compiled method support' stamp: 'eem 5/18/2014 18:57'!
instVarReadScanBlockFor: varIndexCode using: scanner
	"Answer a block argument for InstructionStream>>scanFor: that answers true
	 for reads of the inst var with zero-relative index varIndexCode.
	 N.B. Don't assume the compiler uses the most compact encoding available."

	"	0-15		0000 i i i i 				Push Receiver Variable #iiii
	*	224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)
	*	226		11100010	i i i i i i i i	Push Receiver Variable #iiiiiiii (+ Extend A * 256)"
	| extension |
	extension := 0.
	^[:b| | prevext |
	   prevext := extension.
	   extension := b = 224 ifTrue: [scanner followingByte bitShift: 8] ifFalse: [0].
	   (b < 16 and: [b = varIndexCode])
	    or: [b = 226
			and: [scanner followingByte + prevext = varIndexCode]]]! !

!OpalEncoderForSistaV1 class methodsFor: 'compiled method support' stamp: 'eem 5/18/2014 18:59'!
instVarWriteScanBlockFor: varIndexCode using: scanner
	"Answer a block argument for InstructionStream>>scanFor: that answers true
	 for writes of the inst var with zero-relative index varIndexCode.
	 N.B. Don't assume the compiler uses the most compact encoding available."

	"	200-207	11001 iii			Pop and Store Receiver Variable #iii
	*	224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)
	*	240		11110000	iiiiiiii		Pop and Store Receiver Variable #iiiiiii (+ Extend A * 256)
	*	243		11110011	iiiiiiii		Store Receiver Variable #iiiiiii (+ Extend A * 256)"
	| extension |
	extension := 0.
	^[:b| | prevext |
	   prevext := extension.
	   extension := b = 224 ifTrue: [scanner followingByte bitShift: 8] ifFalse: [0].
	   (b >= 200
	    and: [b < 208
	    and: [b - 200 = varIndexCode]])
	   or: [(b = 240 or: [b = 243])
		  and: [scanner followingByte + prevext = varIndexCode]]]! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 18:59'!
interpretJumpIfCondIn: anInstructionStream
	"Double-dispatch through the encoder to select the correct conditional jump decoder for the instruction set."
	^anInstructionStream interpretSistaV1JumpIfCond! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:00'!
interpretJumpIn: anInstructionStream
	"Double-dispatch through the encoder to select the correct unconditional jump decoder for the instruction set."
	^anInstructionStream interpretSistaV1Jump! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:00'!
interpretNextInstructionFor: aClient in: anInstructionStream
	"Double-dispatch through the encoder to select the correct instruction set decoder."
	^anInstructionStream interpretNextSistaV1InstructionFor: aClient! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:01'!
isBlockReturnAt: pc in: method
	"Answer whether the bytecode at pc is a return from block."
	"	93			01011101			BlockReturn nil
	 *	94			01011110			BlockReturn Top [* return from enclosing block N, N = Extend A, then jump by Ext B ]"
	^(self nonExtensionBytecodeAt: pc in: method) between: 93 and: 94! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:03'!
isBranchIfFalseAt: pc in: method
	"Answer whether the bytecode at pc is a conditional branch-if-false."

	"	192-199	11000 iii				Pop and Jump 0n False iii +1 (i.e., 1 through 8)
	 *	239		11101111	iiiiiiii		Pop and Jump 0n False #iiiiiiii (+ Extend B * 256, where Extend B >= 0)"
	| byte |
	byte := self nonExtensionBytecodeAt: pc in: method.
	^byte >= 192 and: [byte <= 199 or: [byte = 239]]! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:04'!
isBranchIfTrueAt: pc in: method
	"Answer whether the bytecode at pc is a conditional branch-if-true."

	"	184-191	10111 iii				Pop and Jump 0n True iii +1 (i.e., 1 through 8)
	 *	238		11101110	iiiiiiii		Pop and Jump 0n True #iiiiiiii (+ Extend B * 256, where Extend B >= 0))"
	| byte |
	byte := self nonExtensionBytecodeAt: pc in: method.
	^byte >= 184 and: [byte <= 191 or: [byte = 238]]! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:15'!
isCreateBlockAt: pc in: method
	"Answer whether the bytecode at pc is a block creation bytecode."
	
	"250		11111010 	eeiiikkk		jjjjjjjj		Push Closure Num Copied iii (+ExtA//16*8) Num Args kkk (+ ExtA\\16*8) BlockSize jjjjjjjj (+ExtB*256). ee = num extensions"

	| byte |
	byte := self nonExtensionBytecodeAt: pc in: method.
	^ byte = 250! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:17'!
isExtension: bytecode
	"Answer if the bytecode is an extension bytecode, i.e. one that extends
	 the range of the following bytecode."
	^bytecode >= 16rE0 and: [bytecode <= 16rE1]! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:06'!
isJumpAt: pc in: method
	"Answer whether the bytecode at pc is an (unconditional) jump."

	"	176-183	10110 iii				Jump iii + 1 (i.e., 1 through 8)
	 *	225		11100001	bbbbbbbb	Extend B (Ext B = Ext B prev * 256 + Ext B)
	 *	237		11101101	iiiiiiii		Jump #iiiiiiii (+ Extend B * 256, where bbbbbbbb = sddddddd, e.g. -32768 = i=0, a=0, s=1)"
	| byte |
	byte := self nonExtensionBytecodeAt: pc in: method.
	^byte >= 176 and: [byte <= 183 or: [byte = 237]]! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 13:29'!
isJustPopAt: pc in: method
	"Answer whether the bytecode at pc is a pop."

	^(method at: pc) = 216 "216		11011000			Pop Stack Top"! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:10'!
isRealSendAt: pc in: method
	"Answer whether the bytecode at pc is a real message-send, not blockCopy:."

	^self isSendAt: pc in: method! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:11'!
isReturnAt: pc in: method
	"Answer whether the bytecode at pc is a return from block."
	"	88-91		010110 ii			Return Receiver/true/false/nil
		92			01011100			Return top
		93			01011101			BlockReturn nil
	 *	94			01011110			BlockReturn Top [* return from enclosing block N, N = Extend A, then jump by Ext B ]"
	^(self nonExtensionBytecodeAt: pc in: method) between: 88 and: 94! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 9/3/2014 08:52'!
isReturnTopFromMethodAt: pc in: method
	"Answer whether the bytecode at pc is a return stack top from method."

	^(method at: pc) = 92! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:14'!
isSendAt: pc in: method
	"Answer whether the bytecode at pc is a message-send."

	"	96-111		0110 iiii			Send Arithmetic Message #iiii #(#+ #- #< #> #'<=' #'>=' #= #'~=' #* #/ #'\\' #@ #bitShift: #'//' #bitAnd: #bitOr:)
		112-119	01110 iii			Send Special Message #iii #(#at: #at:put: #size #next #nextPut: #atEnd #'==' class)
		120		01111000			UNASSIGNED (was: blockCopy:)
		121		01111001			Send Special Message #value
		122-123	0111101 i			Send Special Message #i #(#value: #do:)
		124-127	011111 ii			Send Special Message #ii #(#new #new: #x #y))
		128-143	1000 iiii			Send Literal Selector #iiii With 0 Argument
		144-159	1001 iiii			Send Literal Selector #iiii With 1 Arguments
		160-175	1010 iiii			Send Literal Selector #iiii With 2 Arguments
	 **	234		11101010	iiiiijjj	Send Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments
	 **	235		11101011	iiiiijjj	Send To Superclass Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments"

	| byte |
	byte := self nonExtensionBytecodeAt: pc in: method.
	^byte >= 96
	  and: [byte <= 175
		 or: [byte >= 234 and: [byte <= 235]]]! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:19'!
isStoreAt: pc in: method
	"Answer whether the bytecode at pc is a store or store-pop."

	"	200-207	11001 iii						Pop and Store Receiver Variable #iii
		208-215	11010 iii						Pop and Store Temporary Variable #iii
	 *	224		11100000	aaaaaaaa			Extend A (Ext A = Ext A prev * 256 + Ext A)
	 *	240		11110000	iiiiiiii				Pop and Store Receiver Variable #iiiiiii (+ Extend A * 256)
	 *	241		11110001	iiiiiiii				Pop and Store Literal Variable #iiiiiiii (+ Extend A * 256)
		242		11110010	iiiiiiii				Pop and Store Temporary Variable #iiiiiiii
	 *	243		11110011	iiiiiiii				Store Receiver Variable #iiiiiii (+ Extend A * 256)
	 *	244		11110100	iiiiiiii				Store Literal Variable #iiiiiiii (+ Extend A * 256)
		245		11110110	iiiiiiii				Store Temporary Variable #iiiiiiii

		252		11111100 	kkkkkkkk	jjjjjjjj	Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
		253		11111101 	kkkkkkkk	jjjjjjjj	Pop and Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"

	| byte |
	byte := self nonExtensionBytecodeAt: pc in: method.
	^byte >= 200
	  and: [byte <= 215
		 or: [(byte between: 240 and: 245)
		 or: [(byte between: 252 and: 253)]]]! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:18'!
isStorePopAt: pc in: method
	"Answer whether the bytecode at pc is a store or store-pop."

	"	200-207	11001 iii						Pop and Store Receiver Variable #iii
		208-215	11010 iii						Pop and Store Temporary Variable #iii
	 *	224		11100000	aaaaaaaa			Extend A (Ext A = Ext A prev * 256 + Ext A)
	 *	240		11110000	iiiiiiii				Pop and Store Receiver Variable #iiiiiii (+ Extend A * 256)
	 *	241		11110001	iiiiiiii				Pop and Store Literal Variable #iiiiiiii (+ Extend A * 256)
		242		11110010	iiiiiiii				Pop and Store Temporary Variable #iiiiiiii

		253		11111101 	kkkkkkkk	jjjjjjjj	Pop and Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"

	| byte |
	byte := self nonExtensionBytecodeAt: pc in: method.
	^byte >= 200
	  and: [byte <= 215
		 or: [(byte between: 240 and: 242)
		 or: [byte = 253]]]! !

!OpalEncoderForSistaV1 class methodsFor: 'compiled method support' stamp: 'ClementBera 5/19/2015 15:37'!
markerOrNilFor: compiledMethod
	"What is a marker method?  It is method with body like 
		'self subclassResponsibility' or '^ self subclassResponsibility' 
	used to indicate ('mark') a special property.

	Marker methods compile to bytecode like:

		9 <70> self
		10 <D0> send: <literal 1>
		11 <87> pop
		12 <78> returnSelf

	for the first form, or 

		9 <70> self
		10 <D0> send: <literal 1>
		11 <7C> returnTop

	for the second form."

	| e |
	((e := compiledMethod endPC) = 19 or: [e = 20]) ifFalse: [^ nil].
	(compiledMethod numLiterals = 3) ifFalse:[^ nil].
	(compiledMethod at: 17) = 76 ifFalse:[^ nil].		"push self"
	(compiledMethod at: 18) = 128 ifFalse:[^ nil].		"send <literal 1>"
	"If we reach this point, we have a marker method that sends self <literal 1>"
	^ compiledMethod literalAt: 1! !

!OpalEncoderForSistaV1 class methodsFor: 'scanning' stamp: 'eem 5/18/2014 19:39'!
method: method refersInBytecodeToLiteral: aLiteral specialSelectorIndex: specialOrNil
	"Answer if method refers to the literal aLiteral in the bytecode, as opposed to in its literal frame."

	"	77			01001101				Push true
		78			01001110				Push false
		79			01001111				Push nil
		80			01010000				Push 0
		81			01010001				Push 1
		88-91		010110 ii				Return Receiver/true/false/nil
		93			01011101				BlockReturn nil
		96-111		0110 iiii				Send Arithmetic Message #iiii #(#+ #- #< #> #'<=' #'>=' #= #'~=' #* #/ #'\\' #@ #bitShift: #'//' #bitAnd: #bitOr:)
		112-119	01110 iii				Send Special Message #iii #(#at: #at:put: #size #next #nextPut: #atEnd #'==' class)
		120		01111000				UNASSIGNED (was: blockCopy:)
		121		01111001				Send Special Message #value
		122-123	0111101 i				Send Special Message #i #(#value: #do:)
		124-127	011111 ii				Send Special Message #ii #(#new #new: #x #y))
	*	224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)
	*	225		11100001	sbbbbbbb	Extend B (Ext B = Ext B prev * 256 + Ext B)
	*	232		11101000	iiiiiiii		Push Integer #iiiiiiii (+ Extend B * 256, where bbbbbbbb = sddddddd, e.g. -32768 = i=0, a=0, s=1)
	*	233		11101001	iiiiiiii		Push Character #iiiiiiii (+ Extend B * 256)
		249		11111001 	xxxxxxxx	syyyyyyy	Reserved for Push Float"
	| byte extended scanner |
	specialOrNil ifNotNil:
		[byte := specialOrNil + 95.
		^(InstructionStream on: method) scanFor: [:b| b = byte]].
	extended := false.
	aLiteral isInteger ifTrue:
		[(aLiteral >= -32768 and: [aLiteral <= 32767]) ifFalse: [^false].
		 scanner := InstructionStream on: method.
		 (aLiteral >= 0 and: [aLiteral <= 255]) ifTrue:
			[aLiteral <= 1 ifTrue:
				[byte := aLiteral + 80.
				 ^scanner scanFor: [:b| b = byte]].
			 ^scanner scanFor:
				[:b|
				(b = 232
				 and: [extended not
				 and: [scanner followingByte = aLiteral]])
				or: [extended := b = 225.
					false]]].
		 byte := (aLiteral bitShift: -8) bitAnd: 255.
		^scanner scanFor:
			[:b|
			(b = 232
			 and: [extended
			 and: [scanner followingByte = (aLiteral bitAnd: 255)]])
			or: [extended := b = 225 and: [scanner followingByte = byte].
				false]]].
	aLiteral isCharacter ifTrue:
		[aLiteral asciiValue <= 65535 ifFalse: [^false].
		 scanner := InstructionStream on: method.
		 aLiteral asciiValue <= 255 ifTrue:
			[^scanner scanFor:
				[:b|
				(b = 233
				 and: [extended not
				 and: [scanner followingByte = aLiteral]])
				or: [extended := b = 225.
					false]]].
		 byte := (aLiteral bitShift: -8) bitAnd: 255.
		^scanner scanFor:
			[:b|
			(b = 233
			 and: [extended
			 and: [scanner followingByte = (aLiteral bitAnd: 255)]])
			or: [extended := b = 225 and: [scanner followingByte = byte].
				false]]].
	aLiteral == nil ifTrue:
		[^(InstructionStream on: method) scanFor: [:b| b = 79 or: [b = 91 or: b = 93]]].
	aLiteral == true ifTrue:
		[^(InstructionStream on: method) scanFor: [:b| b = 77 or: [b = 89]]].
	aLiteral == false ifTrue:
		[^(InstructionStream on: method) scanFor: [:b| b = 78 or: [b = 90]]].
	
	^false! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'ClementBera 2/24/2015 16:09'!
nonExtensionBytecodeAt: pc in: method
	"Answer the actual bytecode at pc in method, skipping past any preceeding extensions."
	| scanpc byte |
	scanpc := pc.
	[ byte := method at: scanpc.
	 byte >= 224 and: [byte <= 225]] whileTrue: [ scanpc := scanpc + 2 ].
	^ byte! !

!OpalEncoderForSistaV1 class methodsFor: 'block closure support' stamp: 'ClementBera 5/7/2015 10:09'!
numLocalTempsForBlockAt: startpc in: method
	| firstByte |
	firstByte := method at: startpc.
	^ firstByte = 230 
		ifFalse: [ 0 ]
		ifTrue: [ (method at: startpc + 1) ]
	! !

!OpalEncoderForSistaV1 class methodsFor: 'compiled method support' stamp: 'ClementBera 5/19/2015 16:41'!
prepareMethod: compiledMethod forSimulationWith: numArgs
	self shouldBeImplemented! !

!OpalEncoderForSistaV1 class methodsFor: 'bytecode decoding' stamp: 'ClementBEra 4/2/2015 09:43'!
selectorToSendOrItselfFor: anInstructionStream in: method at: pc
	"If anInstructionStream is at a send bytecode then answer the send's selector,
	 otherwise answer anInstructionStream itself.  The rationale for answering
	 anInstructionStream instead of, say, nil, is that potentially any existing object
	 can be used as a selector, but since anInstructionStream postdates the method,
	 it can't be one of them.

	 The compilcation is that for convenience we assume the pc could be
	 pointing to the raw send bytecode after its extensions, or at the extension
	 preceeding the raw send bytecode.
		96-111		0110 iiii			Send Arithmetic Message #iiii #(#+ #- #< #> #'<=' #'>=' #= #'~=' #* #/ #'\\' #@ #bitShift: #'//' #bitAnd: #bitOr:)
		112-119	01110 iii			Send Special Message #iii #(#at: #at:put: #size #next #nextPut: #atEnd #'==' class)
		120		01111000			UNASSIGNED (was: blockCopy:)
		121		01111001			Send Special Message #value
		122-123	0111101 i			Send Special Message #i #(#value: #do:)
		124-127	011111 ii			Send Special Message #ii #(#new #new: #x #y))
		128-143	1000 iiii			Send Literal Selector #iiii With 0 Argument
		144-159	1001 iiii			Send Literal Selector #iiii With 1 Arguments
		160-175	1010 iiii			Send Literal Selector #iiii With 2 Arguments
	*	224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)
	*	225		11100001	bbbbbbbb	Extend B (Ext B = Ext B prev * 256 + Ext B)
	**	234		11101010	iiiiijjj		Send Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments
	**	235		11101011	iiiiijjj		Send To Superclass Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments"

	| byte |
	byte := method at: pc.
	byte < 96 ifTrue:
		[^anInstructionStream].
	byte <= 175 ifTrue: 
		["special byte or short send"
		 ^byte >= 128
			ifTrue: [method literalAt: (byte bitAnd: 15) + 1]
			ifFalse: [Smalltalk specialSelectorAt: byte - 95]].
	byte < 234 ifTrue: "need to check for either extension cuz order of extensions is not restricted. so extB could preceed extA"
		[(byte >= 224 and: [byte <= 225]) ifTrue:
			[^self extensionsAt: pc in: method into:
				[:extA :extB :nExtBytes| | byteAfter index |
				byteAfter := method at: pc + nExtBytes.
				(byteAfter >= 234 and: [byteAfter <= 235])
					ifTrue:
						[index := ((method at: pc + nExtBytes + 1) bitShift: -3) + (extA bitShift: 5).
						 method literalAt: index + 1]
					ifFalse: [anInstructionStream]]].
		^anInstructionStream].
	byte > 235 ifTrue:
		[^anInstructionStream].
	"they could be extended..."
	^self extensionsAt: pc in: method into:
		[:extA :extB :nExtBytes| | index |
		 index := ((method at: pc + 1) bitShift: -3) + (extA bitShift: 5).
		 method literalAt: index + 1]! !

!OpalEncoderForSistaV1 class methodsFor: 'compiled method support' stamp: 'ClementBera 5/19/2015 16:14'!
sendsToSuperFor: compiledMethod
	"Answer whether the receiver sends any message to super."
	| scanner |
	scanner := InstructionStream on: compiledMethod.
	^ scanner scanFor: 
		[:instr |  instr = 235 ]! !

!OpalEncoderForSistaV1 class methodsFor: 'bytecode decoding' stamp: 'ClementBera 1/27/2015 14:15'!
specialLiterals
	^ #(true false nil 0 1) ! !

!OpalEncoderForSistaV1 class methodsFor: 'bytecode decoding' stamp: 'eem 8/8/2014 19:40'!
stackDeltaForPrimitive: primitiveIndex in: method
	"Answer the stack delta for the callPrimitive: bytecode (see my class comment).
	 There is no delta for non-inlined primitives (its implicitly 0 - method numArgs).
	 Inlined primitives are grouped by the thousand by argument count, 32 args max ;-)."
	^primitiveIndex < 32678
		ifTrue: [0]
		ifFalse: [primitiveIndex - 32768 // 1000]! !

!OpalEncoderForSistaV1 class methodsFor: 'instruction stream support' stamp: 'eem 5/18/2014 19:21'!
superSendScanBlockUsing: scanner
	"Answer a block argument for InstructionStream>>scanFor:
	 that answers true for super sends."

	"*	224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)
	 *	225		11100001	sbbbbbbb	Extend B (Ext B = Ext B prev * 256 + Ext B)
	 **	235		11101011	iiiiijjj		Send To Superclass Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments"
					
	^[:instr | instr = 235]! !

!OpalEncoderForSistaV1 class methodsFor: 'compiled method support' stamp: 'eem 5/18/2014 19:00'!
supportsClosures
	"Answer if the instruction set supports closures (contains
	 closure creation and indirect temp access bytecodes)."

	^true! !

!OpalEncoderForSistaV1 class methodsFor: 'bytecode decoding' stamp: 'ClementBera 12/29/2014 11:37'!
unusedBytecode
	"Answer the opcode of a single-byte unused bytecode, if it exists in the encoder's bytecode set, or nil if not."
	^ 84! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBera 5/7/2015 10:01'!
genBranchIfNotInstanceOf: literalIndex distance: distance
	"254		11111110	kkkkkkkk	jjjjjjjj		branch If Not Instance Of Behavior/Array Of Behavior kkkkkkkk (+ Extend A * 256, where Extend A >= 0) distance jjjjjjjj (+ Extend B * 256, where Extend B >= 0)"
							
	| extendedIndex extendedDistance |
	(literalIndex < 0 or: [literalIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 65536].
	(distance < 1 or: [distance > 32767]) ifTrue:
		[^self outOfRangeError: 'distance' index: distance range: 0 to: 32767].
	(extendedIndex := literalIndex) > 255 ifTrue:
		[self genUnsignedSingleExtendA: extendedIndex // 256.
		 extendedIndex := extendedIndex \\ 256].
	(extendedDistance := distance) > 255 ifTrue:
		[self genUnsignedSingleExtendB: (distance bitShift: -8).
		extendedDistance := distance bitAnd: 255].
	
	stream
		nextPut: 254;
		nextPut: extendedIndex;
		nextPut: extendedDistance! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 16:28'!
genBranchPopFalse: distance
	(distance > 0 and: [distance < 9]) ifTrue:
		["192-199	11000 iii			Pop and Jump 0n False iii + 1 (i.e., 1 through 8)"
		 stream nextPut: 191 + distance.
		 ^self].
	^self genBranchPopFalseLong: distance! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 16:33'!
genBranchPopFalseLong: distance
	"239		11101111	iiiiiiii		Pop and Jump 0n False #iiiiiiii (+ Extend B * 256, where Extend B >= 0)	"
	| distanceMod256 |
	(distance < 0 or: [distance > 32767]) ifTrue:
		[^self outOfRangeError: 'distance' index: distance range: 0 to: 32767].
	distanceMod256 := (distance < 0 or: [distance > 255])
							ifTrue:
								[self genUnsignedSingleExtendB: (distance bitShift: -8).
								 distance bitAnd: 255]
							ifFalse: [distance].
	stream
		nextPut: 239;
		nextPut: distanceMod256! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 16:31'!
genBranchPopTrue: distance
	(distance > 0 and: [distance < 9]) ifTrue:
		["184-191	10111 iii			Pop and Jump 0n True iii + 1 (i.e., 1 through 8)"
		 stream nextPut: 183 + distance.
		 ^self].
	^self genBranchPopTrueLong: distance! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 16:33'!
genBranchPopTrueLong: distance
	"238		11101110	iiiiiiii		Pop and Jump 0n True #iiiiiiii (+ Extend B * 256, where Extend B >= 0)"
	| distanceMod256 |
	(distance < 0 or: [distance > 32767]) ifTrue:
		[^self outOfRangeError: 'distance' index: distance range: 0 to: 32767].
	(distance > 0 and: [distance < 9]) ifTrue:
		["184-191	10111 iii			Pop and Jump 0n True iii + 1 (i.e., 1 through 8)"
		 stream nextPut: 183 + distance.
		 ^self].
	distanceMod256 := (distance < 0 or: [distance > 255])
							ifTrue:
								[self genUnsignedSingleExtendB: (distance bitShift: -8).
								 distance bitAnd: 255]
							ifFalse: [distance].
	stream
		nextPut: 238;
		nextPut: distanceMod256! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 16:37'!
genCallInlinePrimitive: primitiveIndex
	"248		11111000	i i i i i i i i	1jjjjjjj		Call Primitive #iiiiiiii + (jjjjjjj * 256)"
	"N.B. We could have made CallPrimitive a 2-byte code taking an extension, but that would
	 complicate the VM's determination of the primitive number and the primitive error code
	 store since the extension, being optional, would make the sequence variable length."
	(primitiveIndex < 1 or: [primitiveIndex > 32767]) ifTrue:
		[self outOfRangeError: 'primitive index' index: primitiveIndex range: 1 to: 32767].
	stream
		nextPut: 248;
		nextPut: (primitiveIndex bitAnd: 255);
		nextPut: (primitiveIndex bitShift: -8) + 128! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 8/7/2014 16:02'!
genCallPrimitive: primitiveIndex
	"248		11111000	i i i i i i i i	0jjjjjjj		Call Primitive #iiiiiiii + (jjjjjjj * 256)"
	"N.B. We could have made CallPrimitive a 2-byte code taking an extension, but that would
	 complicate the VM's determination of the primitive number and the primitive error code
	 store since the extension, being optional, would make the sequence variable length."
	(primitiveIndex < 1 or: [primitiveIndex > 65535]) ifTrue:
		[self outOfRangeError: 'primitive index' index: primitiveIndex range: 1 to: 65535].
	stream
		nextPut: 248;
		nextPut: (primitiveIndex bitAnd: 255);
		nextPut: (primitiveIndex bitShift: -8)! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 16:57'!
genDup
	"83			01010011			Duplicate Stack Top"
	stream nextPut: 83! !

!OpalEncoderForSistaV1 methodsFor: 'in-line primitive generation' stamp: 'eem 4/7/2014 16:38'!
genInlineSmallIntegerAdd
	^self genCallInlinePrimitive: 0! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 16:59'!
genJump: distance
	(distance > 0 and: [distance < 9]) ifTrue:
		["176-183	10110 iii			Jump iii + 1 (i.e., 1 through 8)"
		 stream nextPut: 175 + distance.
		 ^self].
	"237		11101101	iiiiiiii		Jump #iiiiiiii (+ Extend B * 256, where bbbbbbbb = sddddddd, e.g. -32768 = i=0, a=0, s=1)"
	^self genJumpLong: distance! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 16:59'!
genJumpLong: distance
	"237		11101101	iiiiiiii		Jump #iiiiiiii (+ Extend B * 256, where bbbbbbbb = sddddddd, e.g. -32768 = i=0, a=0, s=1)"
	(distance between: -32768 and: 32767) ifFalse:
		[^self outOfRangeError: 'index' index: distance range: -32768 to: 32767].
	(distance < 0 or: [distance > 255]) ifTrue:
		[self genSignedSingleExtendB: (distance bitShift: -8)].
	stream
		nextPut: 237;
		nextPut: (distance bitAnd: 255)! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 16:27'!
genNop
	"95			01011111			Nop"
	stream nextPut: 95! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 17:01'!
genPop
	"216		11011000			Pop Stack Top"
	stream nextPut: 216! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 09:27'!
genPushCharacter: aCharacterOrCode
	"233		11101001	i i i i i i i i	Push Character #iiiiiiii (+ Extend B * 256)"
	"Why restrict the range to 16 bits when we could encode arbitrarily 32-bit Characters?
	 Well, 16 bits requires 4 bytes (extB + byte, 78 + byte) and so beyond this range we
	 lose space verses a single-byte pushLiteral and a 4 byte Character literal on 32-bits.
	 And generating the same bytecode on 64-bit and 32-bit is important if we want to be
	 able to load binary code from one to the other (e.g. via Fuel)."
	| code |
	code := aCharacterOrCode isInteger ifTrue: [aCharacterOrCode] ifFalse: [aCharacterOrCode asInteger].
	(code < 0 or: [code > 65535]) ifTrue:
		[^self outOfRangeError: 'character' index: code range: 0 to: 65535].
	(code > 255) ifTrue:
		[self genUnsignedSingleExtendB: (code bitShift: -8)].
	stream
		nextPut: 233;
		nextPut: (code bitAnd: 255)! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/7/2014 17:01'!
genPushClosureCopyNumCopiedValues: numCopied numArgs: numArgs jumpSize: jumpSize
	"250		11111010 eeiiikkk		jjjjjjjj		Push Closure Num Copied iii (+ Ext A // 16 * 8) Num Args kkk (+ Ext A \\ 16 * 8) BlockSize jjjjjjjj (+ Ext B * 256). ee = num extensions"
	"Including numExtensions makes decoding the bytecode quicker since it obviates having to scan from the beginning of a method."
	| numExtensions numCopiedMod8 numArgsMod8 extA |
	(jumpSize < 0 or: [jumpSize > 65535]) ifTrue:
		[^self outOfRangeError: 'block size' index: jumpSize range: 0 to: 65535].
	(numCopied < 0 or: [numCopied > 127]) ifTrue:
		[^self outOfRangeError: 'num copied' index: numCopied range: 0 to: 127].
	(numArgs < 0 or: [numArgs > 127]) ifTrue:
		[^self outOfRangeError: 'num args' index: numArgs range: 0 to: 127].
	extA := numExtensions := 0.
	(numArgsMod8 := numArgs) > 7 ifTrue:
		[extA := numArgs // 8.
		 numArgsMod8 := numArgsMod8 \\ 8].
	(numCopiedMod8 := numCopied) > 7 ifTrue:
		[extA := extA + (numCopied // 8 * 16).
		 numCopiedMod8 := numCopiedMod8 \\ 8].
	extA ~= 0 ifTrue:
		[self genUnsignedSingleExtendA: extA.
		 numExtensions := 1].
	jumpSize > 255 ifTrue:
		[numExtensions := numExtensions + 1.
		 self genUnsignedSingleExtendB: jumpSize // 256].
	stream
		nextPut: 250;
		nextPut: (numExtensions bitShift: 6) + (numCopiedMod8 bitShift: 3) + numArgsMod8;
		nextPut: (jumpSize bitAnd: 16rFF)! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBEra 4/2/2015 09:42'!
genPushConsArray: size
	(size < 0 or: [size > 127]) ifTrue:
		[^self outOfRangeError: 'size' index: size range: 0 to: 127].
	"231		11100111	jkkkkkkk	Push (Array new: kkkkkkk) (j = 0)
									&	Pop kkkkkkk elements into: (Array new: kkkkkkk) (j = 1)"
	stream
		nextPut: 231;
		nextPut: size + 128! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eliot 10/12/2012 15:12'!
genPushInstVar: instVarIndex
	(instVarIndex between: 0 and: 15) ifTrue:
		["0-15 	0000iiii 	Push Receiver Variable #iiii"
		 stream nextPut: 0 + instVarIndex.
		 ^self].
	self genPushInstVarLong: instVarIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:28'!
genPushInstVarLong: instVarIndex
	"226		11100010	i i i i i i i i	Push Receiver Variable #iiiiiiii (+ Extend A * 256)"
	"See also MaybeContextInstanceVariableNode"
	(instVarIndex < 0 or: [instVarIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'index' index: instVarIndex range: 0 to: 65535].
	instVarIndex > 255 ifTrue:
		[self genUnsignedSingleExtendA: instVarIndex // 256].
	stream
		nextPut: 226;
		nextPut: instVarIndex \\ 256! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 09:22'!
genPushInteger: anInteger
	"80			01010000				Push 0
	 81			01010001				Push 1
	 232		11101000	i i i i i i i i	Push Integer #iiiiiiii (+ Extend B * 256, where bbbbbbbb = sddddddd, e.g. -32768 = i=0, a=0, s=1)"
	"Why restrict the range to 16 bits when we could encode arbitrarily large integers?
	 Well, 16 bits requires 4 bytes (extB + byte, 78 + byte) and so beyond this range we lose space
	 verses a single-byte pushLiteral and a 4 byte integer literal on 32-bits.  And generating the same
	 bytecode on 64-bit and 32-bit is important if we want to be able to load binary code from one to
	 the other (e.g. via Fuel)."
	anInteger = 0 ifTrue:
		[stream nextPut: 80.
		 ^self].
	anInteger = 1 ifTrue:
		[stream nextPut: 81.
		 ^self].
	(anInteger < -32768 or: [anInteger > 32767]) ifTrue:
		[^self outOfRangeError: 'integer' index: anInteger range: -32768 to: 32767].
	(anInteger < 0 or: [anInteger > 255]) ifTrue:
		[self genSignedSingleExtendB: (anInteger bitShift: -8)].
	stream
		nextPut: 232;
		nextPut: (anInteger bitAnd: 255)! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBera 1/27/2015 16:01'!
genPushLiteral: literalIndex
    | extendedIndex |
    (literalIndex < 0 or: [literalIndex > 32767]) ifTrue:
        [^self outOfRangeError: 'index' index: literalIndex range: 0 to: 32768].
    literalIndex < 32 ifTrue: 
        ["32-63     001iiiii     Push Literal #iiiii"
         stream nextPut: 32 + literalIndex.
         ^self].
    "228        11100100    i i i i i i i i    Push Literal #iiiiiiii (+ Extend A * 256)"
    (extendedIndex := literalIndex) > 255 ifTrue:
        [self genUnsignedSingleExtendA: extendedIndex // 256.
         extendedIndex := extendedIndex \\ 256].
    stream
        nextPut: 228;
        nextPut: extendedIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eliot 10/18/2012 14:51'!
genPushLiteralVar: literalIndex
	| extendedIndex |
	(literalIndex < 0 or: [literalIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 65535].
	literalIndex < 16 ifTrue: 
		["16-31		0001 i i i i		Push Literal Variable #iiii"
		 stream nextPut: 16 + literalIndex.
		 ^self].
	"227		11100011	i i i i i i i i	Push Literal Variable #iiiiiiii (+ Extend A * 256)"
	(extendedIndex := literalIndex) > 255 ifTrue:
		[self genUnsignedSingleExtendA: extendedIndex // 256.
		 extendedIndex := extendedIndex \\ 256].
	stream
		nextPut: 227;
		nextPut: extendedIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBera 1/27/2015 14:14'!
genPushNClosureTemps: numTemps
	"	230		11100110	iiiiiiii		PushNClosureTemps iiiiiiii"
	(numTemps < 0 or: [numTemps >= 64]) ifTrue:
		[^self outOfRangeError: 'closure num temps' index: numTemps range: 0 to: 127].
	stream nextPut: 230.
	stream nextPut: numTemps! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eliot 11/4/2012 15:01'!
genPushNewArray: size
	(size < 0 or: [size > 127]) ifTrue:
		[^self outOfRangeError: 'size' index: size range: 0 to: 127].
	"231		11100111	jkkkkkkk	Push (Array new: kkkkkkk) (j = 0)
									&	Pop kkkkkkk elements into: (Array new: kkkkkkk) (j = 1)"
	stream
		nextPut: 231;
		nextPut: size! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eliot 10/18/2012 14:43'!
genPushReceiver
	"76			01001100		Push Receiver"
	stream nextPut: 76! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 09:29'!
genPushRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	"251		11111011 kkkkkkkk	jjjjjjjj		Push Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
	(tempIndex < 0 or: [tempIndex >= 256]) ifTrue:
		[^self outOfRangeError: 'remoteTempIndex' index: tempIndex range: 0 to: 255].
	(tempVectorIndex < 0 or: [tempVectorIndex >= 256]) ifTrue:
		[^self outOfRangeError: 'tempVectorIndex' index: tempVectorIndex range: 0 to: 255].
	stream
		nextPut: 251;
		nextPut: tempIndex;
		nextPut: tempVectorIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBEra 4/2/2015 09:42'!
genPushSpecialLiteral: aLiteral
	"77			01001101			Push true
	 78			01001110			Push false
	 79			01001111			Push nil
	 80			01010000			Push 0
	 81			01010001			Push 1
	 232		11101000	iiiiiiii		Push Integer #iiiiiiii (+ Extend B * 256, where bbbbbbbb = sddddddd, e.g. -32768 = i=0, a=0, s=1)"
	| index |
	aLiteral isInteger ifTrue:
		[aLiteral == 0 ifTrue:
			[stream nextPut: 80.
			 ^self].
		 aLiteral == 1 ifTrue:
			[stream nextPut: 81.
			 ^self].
		 ^self genPushInteger: aLiteral].
	index := #(true false nil)
					indexOf: aLiteral
					ifAbsent: [^self error: 'push special literal: ', aLiteral printString,  ' is not one of true false nil'].
	stream nextPut: 76 + index! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 09:52'!
genPushTemp: tempIndex
	(tempIndex < 0 or: [tempIndex > 63]) ifTrue:
		[^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63].
	tempIndex < 12 ifTrue: 
		["64-71		01000 i i i		Push Temporary Variable #iii
		   72-75	010010 i i		Push Temporary Variable #ii + 8"
		 stream nextPut: 64 + tempIndex.
		 ^self].
	"229		11100101	i i i i i i i i	Push Temporary Variable #iiiiiiii"
	stream
		nextPut: 229;
		nextPut: tempIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 7/28/2014 20:51'!
genPushThisContext
	"82			01010010			Push thisContext, (then e.g. Extend B 1 = push thisProcess)"
	stream nextPut: 82! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 09:56'!
genReturnReceiver
	"88-91		010110 ii			Return Receiver/true/false/nil"
	stream nextPut: 88! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 09:58'!
genReturnSpecialLiteral: aLiteral
	"88-91		010110 ii			Return Receiver/true/false/nil"
	| index |
	index := #(true false nil) indexOf: aLiteral ifAbsent: 0.
	index = 0 ifTrue:
		[^self error: 'return special literal: ', aLiteral printString,  ' is not one of true false nil'].
	stream nextPut: 88 + index! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:06'!
genReturnTop
	"92		1011100		Return Stack Top From Message"
	stream nextPut: 92! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBEra 4/2/2015 09:42'!
genReturnTopToCaller
	"94		01011110		Return Stack Top From Block [* return from enclosing block N, ExtA]"
	"If extended, the least significant bit of the extension determines if we return to the caller or not
	 and the most significant bits determine how many levels of the static chain to return from.
		ExtA = iiiiiiij
		iiiiiii=0,j=0	=>	return to caller
		iiiiiii=0,j=1	=>	illegal
		iiiiiii=1,j=0	=>	return to outerContext
		iiiiiii=1,j=1	=>	return to outerContext sender/return from outerContext
		iiiiiii=2,j=0	=>	return to outerContext outerContext
		iiiiiii=2,j=1	=>	return to outerContext outerContext sender/return from outerContext outerContext
		etc"

	stream nextPut: 94! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBera 5/7/2015 10:03'!
genSend: selectorLiteralIndex numArgs: nArgs
	| extendedIndex extendedNArgs |
	(selectorLiteralIndex < 0 or: [selectorLiteralIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'selectorLiteralIndex' index: selectorLiteralIndex range: 0 to: 65535].
	(nArgs < 0 or: [nArgs > 31]) ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31 "!!!!"].
	(selectorLiteralIndex < 16 and: [nArgs < 3]) ifTrue: 
	 	["128-143	1000 iiii			Send Literal Selector #iiii With 0 Argument
		  144-159	1001 iiii			Send Literal Selector #iiii With 1 Arguments
		  160-175	1010 iiii			Send Literal Selector #iiii With 2 Arguments"
		 stream nextPut: 128 + (nArgs * 16) + selectorLiteralIndex.
		 ^self].
	(extendedIndex := selectorLiteralIndex) > 31 ifTrue:
		[self genUnsignedSingleExtendA: extendedIndex // 32.
		 extendedIndex := extendedIndex \\ 32].
	(extendedNArgs := nArgs) > 7 ifTrue:
		[self genUnsignedSingleExtendB: extendedNArgs // 8.
		 extendedNArgs := extendedNArgs \\ 8].
	"234		11101010	i i i i i j j j	Send Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments"
	stream
		nextPut: 234;
		nextPut: extendedNArgs + (extendedIndex * 8)! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBEra 4/2/2015 09:42'!
genSendDirectedSuper: selectorLiteralIndex numArgs: nArgs
	| extendedIndex |
	(selectorLiteralIndex < 0 or: [selectorLiteralIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'selectorLiteralIndex' index: selectorLiteralIndex range: 0 to: 65535].
	(nArgs < 0 or: [nArgs > 31]) ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31 "!!!!"].
	(extendedIndex := selectorLiteralIndex) > 31 ifTrue:
		[self genUnsignedSingleExtendA: extendedIndex // 32.
		 extendedIndex := extendedIndex \\ 32].
	"Bit 6 of the ExtB byte is the directed send flag.  Bit 6 allows for future expansion to up to 255 args."
	self genUnsignedSingleExtendB: nArgs // 8 + 64.
	"235		11101011	iiiiijjj		Send To Superclass Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments"
	stream
		nextPut: 235;
		nextPut: nArgs \\ 8 + (extendedIndex * 8)! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:21'!
genSendSpecial: specialSelectorIndex numArgs: nArgs
	self assert: (specialSelectorIndex between: 1 and: Smalltalk specialSelectorSize).
	self assert: nArgs = (Smalltalk specialNargsAt: specialSelectorIndex).
	"Special selector sends.
		96-111		0110 iiii			Send Arithmetic Message #iiii #(#+ #- #< #> #'<=' #'>=' #= #'~=' #* #/ #'\\' #@ #bitShift: #'//' #bitAnd: #bitOr:)
		112-119	01110 iii			Send Special Message #iii #(#at: #at:put: #size ? ? ? #'==' class ? value value: ? ? ? ? ?)"

	stream nextPut: specialSelectorIndex + 95! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:22'!
genSendSuper: selectorLiteralIndex numArgs: nArgs
	| extendedIndex extendedNArgs |
	(selectorLiteralIndex < 0 or: [selectorLiteralIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'selectorLiteralIndex' index: selectorLiteralIndex range: 0 to: 65535].
	(nArgs < 0 or: [nArgs > 31]) ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31 "!!!!"].
	(extendedIndex := selectorLiteralIndex) > 31 ifTrue:
		[self genUnsignedSingleExtendA: extendedIndex // 32.
		 extendedIndex := extendedIndex \\ 32].
	(extendedNArgs := nArgs) > 7 ifTrue:
		[self genUnsignedSingleExtendB: extendedNArgs // 8.
		 extendedNArgs := extendedNArgs \\ 8].
	"235		11101011	iiiiijjj		Send To Superclass Literal Selector #iiiii (+ Extend A * 32) with jjj (+ Extend B * 8) Arguments"
	stream
		nextPut: 235;
		nextPut: extendedNArgs + (extendedIndex * 8)! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eliot 10/22/2012 16:07'!
genSignedSingleExtendB: extendedIndex
	(extendedIndex between: -128 and: 127) ifFalse:
		[^self outOfRangeError: 'index' index: extendedIndex range: -128 to: 127].
	"225		11100001	sbbbbbbb	Extend B (Ext B = Ext B prev * 256 + Ext B)"
	stream
		nextPut: 225;
		nextPut: (extendedIndex >= 0 ifTrue: [extendedIndex] ifFalse: [extendedIndex + 256]) ! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:27'!
genStoreInstVar: instVarIndex
	"243		11110011	iiiiiiii		Store Receiver Variable #iiiiiii (+ Extend A * 256)"
	self genStoreInstVarLong: instVarIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:28'!
genStoreInstVarLong: instVarIndex
	"243		11110011	iiiiiiii		Store Receiver Variable #iiiiiii (+ Extend A * 256)"
	(instVarIndex < 0 or: [instVarIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'index' index: instVarIndex range: 0 to: 65535].
	instVarIndex > 255 ifTrue:
		[self genUnsignedSingleExtendA: instVarIndex // 256].
	stream
		nextPut: 243;
		nextPut: instVarIndex \\ 256! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:35'!
genStoreLiteralVar: literalIndex
	"244		11110100	iiiiiiii		Store Literal Variable #iiiiiiii (+ Extend A * 256)"
	(literalIndex < 0 or: [literalIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 65535].
	literalIndex > 255 ifTrue: 
		[self genUnsignedSingleExtendA: literalIndex // 256].
	stream
		nextPut: 244;
		nextPut: literalIndex \\ 256! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:37'!
genStorePopInstVar: instVarIndex
	"200-207	11001 iii			Pop and Store Receiver Variable #iii
	 240		11110000	iiiiiiii	Pop and Store Receiver Variable #iiiiiii (+ Extend A * 256)"
	(instVarIndex < 0 or: [instVarIndex > 7]) ifTrue:
		[^self genStorePopInstVarLong: instVarIndex].
	stream nextPut: 200 + instVarIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:37'!
genStorePopInstVarLong: instVarIndex
	"240		11110000	iiiiiiii		Pop and Store Receiver Variable #iiiiiii (+ Extend A * 256)"
	(instVarIndex < 0 or: [instVarIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'index' index: instVarIndex range: 0 to: 65535].
	instVarIndex > 255 ifTrue:
		[self genUnsignedSingleExtendA: instVarIndex // 256].
	stream
		nextPut: 240;
		nextPut: instVarIndex \\ 256! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:39'!
genStorePopLiteralVar: literalIndex
	"241		11110001	iiiiiiii		Pop and Store Literal Variable #iiiiiiii (+ Extend A * 256)"
	(literalIndex < 0 or: [literalIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 65535].
	literalIndex > 255 ifTrue: 
		[self genUnsignedSingleExtendA: literalIndex // 256].
	stream
		nextPut: 241;
		nextPut: literalIndex \\ 256! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:39'!
genStorePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	"253		11111101 	kkkkkkkk	jjjjjjjj		Pop and Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
	(tempIndex < 0 or: [tempIndex >= 256]) ifTrue:
		[^self outOfRangeError: 'remoteTempIndex' index: tempIndex range: 0 to: 255].
	(tempVectorIndex < 0 or: [tempVectorIndex >= 256]) ifTrue:
		[^self outOfRangeError: 'tempVectorIndex' index: tempVectorIndex range: 0 to: 255].
	stream
		nextPut: 253;
		nextPut: tempIndex;
		nextPut: tempVectorIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:43'!
genStorePopTemp: tempIndex
	"208-215	11010 iii			Pop and Store Temporary Variable #iii
	 242		11110010	iiiiiiii	Pop and Store Temporary Variable #iiiiiiii"
	(tempIndex < 0 or: [tempIndex > 63]) ifTrue:
		[^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63].
	tempIndex < 8 ifTrue:
		[stream nextPut: 208 + tempIndex.
		 ^self].
	stream
		nextPut: 242;
		nextPut: tempIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 4/8/2014 10:45'!
genStoreRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	"252		11111100 	kkkkkkkk	jjjjjjjj		Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
	(tempIndex < 0 or: [tempIndex >= 256]) ifTrue:
		[^self outOfRangeError: 'remoteTempIndex' index: tempIndex range: 0 to: 255].
	(tempVectorIndex < 0 or: [tempVectorIndex >= 256]) ifTrue:
		[^self outOfRangeError: 'tempVectorIndex' index: tempVectorIndex range: 0 to: 255].
	stream
		nextPut: 252;
		nextPut: tempIndex;
		nextPut: tempVectorIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBEra 4/2/2015 09:43'!
genStoreTemp: tempIndex
	"245		11110110	iiiiiiii		Store Temporary Variable #iiiiiiii"
	(tempIndex < 0 or: [tempIndex > 63]) ifTrue:
		[^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63].
	stream
		nextPut: 245;
		nextPut: tempIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'ClementBEra 4/2/2015 09:43'!
genTrap
	"217		11011001			Unconditionnal trap"
	stream nextPut: 217! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eem 8/1/2014 06:53'!
genTrapIfNotInstanceOf: literalIndex
	"*	236		11101100	iiiiiiii		Trap If Not Instance Of Behavior/Array Of Behavior #iiiiiiii (+ Extend A * 256, where Extend A >= 0)"

	| extendedIndex |
	(literalIndex < 0 or: [literalIndex > 65535]) ifTrue:
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 65536].
	(extendedIndex := literalIndex) > 255 ifTrue:
		[self genUnsignedSingleExtendA: extendedIndex // 256.
		 extendedIndex := extendedIndex \\ 256].
	stream
		nextPut: 236;
		nextPut: extendedIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eliot 10/18/2012 14:47'!
genUnsignedMultipleExtendA: extendedIndex
	"224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)"
	extendedIndex > 255 ifTrue:
		[self genUnsignedMultipleExtendA: extendedIndex // 256].
	stream
		nextPut: 224;
		nextPut: extendedIndex \\ 256! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eliot 10/18/2012 14:48'!
genUnsignedSingleExtendA: extendedIndex
	(extendedIndex between: 0 and: 255) ifFalse:
		[^self outOfRangeError: 'index' index: extendedIndex range: 0 to: 255].
	"224		11100000	aaaaaaaa	Extend A (Ext A = Ext A prev * 256 + Ext A)"
	stream
		nextPut: 224;
		nextPut: extendedIndex! !

!OpalEncoderForSistaV1 methodsFor: 'bytecode generation' stamp: 'eliot 10/18/2012 14:48'!
genUnsignedSingleExtendB: extendedIndex
	(extendedIndex between: 0 and: 255) ifFalse:
		[^self outOfRangeError: 'index' index: extendedIndex range: 0 to: 255].
	"225		11100001	sbbbbbbb	Extend B (Ext B = Ext B prev * 256 + Ext B)"
	stream
		nextPut: 225;
		nextPut: extendedIndex! !

!OpalEncoderForSistaV1 methodsFor: 'testing' stamp: 'GuillermoPolito 8/17/2015 13:54'!
isSpecialLiteralForPush: literal
	^ literal == false
		or:
			[ 
			literal == true
				or:
					[ 
					literal isNil
						or:
							[ 
							(literal isInteger and: [ literal between: -32768 and: 32767 ])
								or:
									[ literal isCharacter and: [ literal asInteger between: 0 and: 65535 ] ] ] ] ]! !

OpalBytecodeEncoder subclass: #OpalEncoderForV3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Encoders'!

!OpalEncoderForV3 commentStamp: '<historical>' prior: 0!
I add behaviour to Encoder to size and emit bytecodes for the Squeak V3.x VM bytecode set.  The intention is for another subclass to restrict the range of bytecodes used to long forms only, allowing the bytecode set to be redefined by avoiding using the many short forms.  The short forms may then be reassigned.!

!OpalEncoderForV3 class methodsFor: 'compiled method support' stamp: 'ClementBera 12/29/2014 11:37'!
supportsClosures
	"Answer if the instruction set supports closures (contains
	 closure creation and indirect temp access bytecodes)."

	^ false! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:59'!
genBranchPopFalse: distance
	"See BlueBook page 596"
	distance < 0 ifTrue:
		[^self outOfRangeError: 'distance' index: distance range: 0 to: 1023].
	(distance > 0 and: [distance < 9]) ifTrue:
		["152-159 	10011iii 	Pop and Jump 0n False iii +1 (i.e., 1 through 8)"
		 stream nextPut: 152 + distance - 1.
		 ^self].
	distance < 1024 ifTrue:
		["172-175 	101011ii jjjjjjjj 	Pop and Jump On False ii *256+jjjjjjjj"
		 stream
			nextPut: 172 + (distance bitShift: -8);
			nextPut: distance + 1024 \\ 256.
		 ^self].
	^self outOfRangeError: 'distance' index: distance range: 0 to: 1023! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:59'!
genBranchPopTrue: distance
	"See BlueBook page 596"
	distance < 0 ifTrue:
		[^self outOfRangeError: 'distance' index: distance range: 0 to: 1023].
	distance < 1024 ifTrue:
		["168-171 	101010ii jjjjjjjj 	Pop and Jump On True ii *256+jjjjjjjj"
		 stream
			nextPut: 168 + (distance bitShift: -8);
			nextPut: distance + 1024 \\ 256.
		 ^self].
	^self outOfRangeError: 'distance' index: distance range: 0 to: 1023! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/15/2008 09:40'!
genDup
	"See BlueBook page 596"
	"136 	10001000 	Duplicate Stack Top"
	stream nextPut: 136! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/14/2008 17:41'!
genJump: distance
	"See BlueBook page 596"
	(distance > 0 and: [distance < 9]) ifTrue:
		["144-151 	10010iii 	Jump iii + 1 (i.e., 1 through 8)"
		 stream nextPut: 144 + distance - 1.
		 ^self].
	"160-167 	10100iii jjjjjjjj 	Jump(iii - 4) *256+jjjjjjjj"
	^self genJumpLong: distance! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:59'!
genJumpLong: distance
	"See BlueBook page 596"
	(distance >= -1024 and: [distance < 1024]) ifTrue:
		["160-167 	10100iii jjjjjjjj 	Jump(iii - 4) *256+jjjjjjjj"
		 stream
			nextPut: 160 + (distance + 1024 bitShift: -8);
			nextPut: distance + 1024 \\ 256.
		 ^self].
	^self outOfRangeError: 'distance' index: distance range: -1024 to: 1023! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/14/2008 17:27'!
genPop
	"See BlueBook page 596"
	"135 	10000111 	Pop Stack Top"
	stream nextPut: 135! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:40'!
genPushInstVar: instVarIndex
	"See BlueBook page 596"
	instVarIndex >= 0 ifTrue:
		[instVarIndex < 16 ifTrue:
			["0-15 	0000iiii 	Push Receiver Variable #iiii"
			 stream nextPut: 0 + instVarIndex.
			 ^self].
		instVarIndex < 64 ifTrue:
			["128 	10000000 jjkkkkkk 	Push (Receiver Variable, Temporary Location, Literal Constant, Literal Variable) [jj] #kkkkkk"
			 stream
				nextPut: 128;
				nextPut: instVarIndex.
			 ^self]].
	self genPushInstVarLong: instVarIndex! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:51'!
genPushInstVarLong: instVarIndex
	"See BlueBook page 596"
	"See also MaybeContextInstanceVariableNode"
	(instVarIndex >= 0 and: [instVarIndex < 256]) ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 64;
			nextPut: instVarIndex.
		 ^self].
	^self outOfRangeError: 'index' index: instVarIndex range: 0 to: 255! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:00'!
genPushLiteral: literalIndex
	"See BlueBook page 596"
	literalIndex < 0 ifTrue: 
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255].
	literalIndex < 32 ifTrue: 
		["32-63 	001iiiii 	Push Literal Constant #iiiii"
		 stream nextPut: 32 + literalIndex.
		 ^self].
	literalIndex < 64 ifTrue: 
		["128 	10000000 jjkkkkkk 	Push (Receiver Variable, Temporary Location, Literal Constant, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 128;
			nextPut: 128 + literalIndex.
		 ^self].
	literalIndex < 256 ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 96;
			nextPut: literalIndex.
		 ^self].
	^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 16:59'!
genPushLiteralVar: literalIndex
	"See BlueBook page 596"
	literalIndex < 0 ifTrue: 
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255].
	literalIndex < 32 ifTrue: 
		["64-95 	010iiiii 	Push Literal Variable #iiiii"
		 stream nextPut: 64 + literalIndex.
		 ^self].
	literalIndex < 64 ifTrue: 
		["128 	10000000 jjkkkkkk 	Push (Receiver Variable, Temporary Location, Literal Constant, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 128;
			nextPut: 192 + literalIndex.
		 ^self].
	literalIndex < 256 ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 128;
			nextPut: literalIndex.
		 ^self].
	^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/14/2008 16:16'!
genPushReceiver
	"See BlueBook page 596"
	"112-119 	01110iii 	Push (receiver, true, false, nil, -1, 0, 1, 2) [iii]"
	stream nextPut: 112! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/14/2008 17:38'!
genPushSpecialLiteral: aLiteral
	"112-119 	01110iii 	Push (receiver, true, false, nil, -1, 0, 1, 2) [iii]"
	| index |
	index := #(true false nil -1 0 1 2) indexOf: aLiteral ifAbsent: 0.
	index = 0 ifTrue:
		[^self error: 'push special literal: ', aLiteral printString,  ' is not one of true false nil -1 0 1 2'].
	stream nextPut: index + 112! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:00'!
genPushTemp: tempIndex
	"See BlueBook page 596"
	tempIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63].
	tempIndex < 16 ifTrue: 
		["16-31 	0001iiii 	Push Temporary Location #iiii"
		 stream nextPut: 16 + tempIndex.
		 ^self].
	tempIndex < 64 ifTrue: 
		["128 	10000000 jjkkkkkk 	Push (Receiver Variable, Temporary Location, Literal Constant, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 128;
			nextPut: 64 + tempIndex.
		 ^self].
	^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/14/2008 17:36'!
genPushThisContext
	"See BlueBook page 596"
	"137 	10001001 	Push Active Context"
	stream nextPut: 137! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/14/2008 17:40'!
genReturnReceiver
	"See BlueBook page 596"
	"120-123 	011110ii 	Return (receiver, true, false, nil) [ii] From Message"
	stream nextPut: 120! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/14/2008 17:39'!
genReturnSpecialLiteral: aLiteral
	"120-123 	011110ii 	Return (receiver, true, false, nil) [ii] From Message"
	| index |
	index := #(true false nil) indexOf: aLiteral ifAbsent: 0.
	index = 0 ifTrue:
		[^self error: 'return special literal: ', aLiteral printString,  ' is not one of true false nil'].
	stream nextPut: 120 + index! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/14/2008 17:35'!
genReturnTop
	"See BlueBook page 596"
	"124-125 	0111110i 	Return Stack Top From (Message, Block) [i]"
	stream nextPut: 124! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/14/2008 17:35'!
genReturnTopToCaller
	"See BlueBook page 596"
	"124-125 	0111110i 	Return Stack Top From (Message, Block) [i]"
	stream nextPut: 125! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'GuillermoPolito 8/17/2015 13:51'!
genSend: selectorLiteralIndex numArgs: nArgs
	"See BlueBook page 596 (with exceptions for 132 & 134)"
	nArgs < 0 ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31 "!!!!"].
	selectorLiteralIndex < 0 ifTrue:
		["Special selector sends.
			176-191 	1011iiii 	Send Arithmetic Message #iiii
			192-207 	1100iiii 	Send Special Message #iiii"
		 (selectorLiteralIndex negated between: 176 and: 207) ifFalse:
			[^self outOfRangeError: 'special selector code' index: selectorLiteralIndex negated range: 176 to: 207].
		 stream nextPut: selectorLiteralIndex negated.
		 ^self].
	(selectorLiteralIndex < 16 and: [nArgs < 3]) ifTrue:
		["	208-223 	1101iiii 	Send Literal Selector #iiii With No Arguments
			224-239 	1110iiii 	Send Literal Selector #iiii With 1 Argument
			240-255 	1111iiii 	Send Literal Selector #iiii With 2 Arguments"
		 stream nextPut: 208 + (nArgs * 16) + selectorLiteralIndex.
		 ^self].
	(selectorLiteralIndex < 32 and: [nArgs < 8]) ifTrue: 
		["	131 	10000011 jjjkkkkk 	Send Literal Selector #kkkkk With jjj Arguments"
		 stream
			nextPut: 131;
			nextPut: ((nArgs bitShift: 5) + selectorLiteralIndex).
		 ^self].
	(selectorLiteralIndex < 64 and: [nArgs < 4]) ifTrue: 
	 	["In Squeak V3
			134 	10000110 jjjjjjjj kkkkkkkk 	Send Literal Selector #kkkkkkkk To Superclass With jjjjjjjj Arguments
		 is replaced by
			134 	10000110 jjkkkkkk 	Send Literal Selector #kkkkkk With jj Arguments"
		 stream
			nextPut: 134;
			nextPut: ((nArgs bitShift: 6) + selectorLiteralIndex).
		 ^self].
	(selectorLiteralIndex < 256 and: [nArgs < 32]) ifTrue: 
		["In Squeak V3
			132 	10000100 jjjjjjjj kkkkkkkk 	Send Literal Selector #kkkkkkkk With jjjjjjjj Arguments
		  is replaced by
			132 	10000100 ooojjjjj kkkkkkkk
				ooo = 0 => Send Literal Selector #kkkkkkkk With jjjjj Arguments
				ooo = 1 => Send Literal Selector #kkkkkkkk To Superclass With jjjjj Arguments"
		stream
			nextPut: 132;
			nextPut: nArgs;
			nextPut: selectorLiteralIndex.
		 ^self].
	nArgs >= 32 ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31].
	selectorLiteralIndex >= 256 ifTrue: 
		[^self outOfRangeError: 'selector literal index' index: selectorLiteralIndex range: 0 to: 255]! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'ClementBera 1/27/2015 14:15'!
genSendSpecial: specialSelectorIndex numArgs: nArgs
	self assert: (specialSelectorIndex between: 1 and: Smalltalk specialSelectorSize).
	self assert: nArgs = (Smalltalk specialNargsAt: specialSelectorIndex).
	"Special selector sends.
		96-111		0110 iiii			Send Arithmetic Message #iiii #(#+ #- #< #> #'<=' #'>=' #= #'~=' #* #/ #'\\' #@ #bitShift: #'//' #bitAnd: #bitOr:)
		112-119	01110 iii			Send Special Message #iii #(#at: #at:put: #size ? ? ? #'==' class ? value value: ? ? ? ? ?)"

	stream nextPut: specialSelectorIndex + 175! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:00'!
genSendSuper: selectorLiteralIndex numArgs: nArgs
	"See BlueBook page 596 (with exceptions for 132 & 134)"
	nArgs < 0 ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31 "!!!!"].
	selectorLiteralIndex < 0 ifTrue:
		[^self outOfRangeError: 'selector literal index' index: selectorLiteralIndex range: 0 to: 255].
	(selectorLiteralIndex < 32 and: [nArgs < 8]) ifTrue: 
		["	133 	10000011 jjjkkkkk 	Send Literal Selector #kkkkk To Superclass With jjj Arguments"
		 stream
			nextPut: 133;
			nextPut: ((nArgs bitShift: 5) + selectorLiteralIndex).
		 ^self].
	(selectorLiteralIndex < 256 and: [nArgs < 32]) ifTrue: 
		["In Squeak V3
			132 	10000100 jjjjjjjj kkkkkkkk 	Send Literal Selector #kkkkkkkk With jjjjjjjj Arguments
		  is replaced by
			132 	10000100 ooojjjjj kkkkkkkk
				ooo = 0 => Send Literal Selector #kkkkkkkk With jjjjj Arguments
				ooo = 1 => Send Literal Selector #kkkkkkkk To Superclass With jjjjj Arguments"
		stream
			nextPut: 132;
			nextPut: 32 + nArgs;
			nextPut: selectorLiteralIndex.
		 ^self].
	nArgs >= 32 ifTrue:
		[^self outOfRangeError: 'numArgs' index: nArgs range: 0 to: 31].
	selectorLiteralIndex >= 256 ifTrue: 
		[^self outOfRangeError: 'selector literal index' index: selectorLiteralIndex range: 0 to: 255]! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:37'!
genStoreInstVar: instVarIndex
	"See BlueBook page 596"
	(instVarIndex >= 0 and: [instVarIndex < 64]) ifTrue: 
		["129 	10000001 jjkkkkkk 	Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 129;
			nextPut: instVarIndex.
		 ^self].
	self genStoreInstVarLong: instVarIndex! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:51'!
genStoreInstVarLong: instVarIndex
	"See BlueBook page 596"
	"See also MaybeContextInstanceVariableNode"
	(instVarIndex >= 0 and: [instVarIndex < 256]) ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 160;
			nextPut: instVarIndex.
		 ^self].
	^self outOfRangeError: 'index' index: instVarIndex range: 0 to: 255! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:01'!
genStoreLiteralVar: literalIndex
	"See BlueBook page 596"
	literalIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255].
	literalIndex < 64 ifTrue: 
		["129 	10000001 jjkkkkkk 	Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 129;
			nextPut: 192 + literalIndex.
		 ^self].
	literalIndex < 256 ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 224;
			nextPut: literalIndex.
		 ^self].
	^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:43'!
genStorePopInstVar: instVarIndex
	"See BlueBook page 596"
	instVarIndex >= 0 ifTrue:
		[instVarIndex < 8 ifTrue:
			["96-103 	01100iii 	Pop and Store Receiver Variable #iii"
			 stream nextPut: 96 + instVarIndex.
			 ^self].
		instVarIndex < 64 ifTrue:
			["130 	10000010 jjkkkkkk 	Pop and Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
			 stream
				nextPut: 130;
				nextPut: instVarIndex.
			 ^self]].
	self genStorePopInstVarLong: instVarIndex! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 6/19/2008 08:52'!
genStorePopInstVarLong: instVarIndex
	"See BlueBook page 596"
	"See also MaybeContextInstanceVariableNode"
	(instVarIndex >= 0 and: [instVarIndex < 256]) ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 192;
			nextPut: instVarIndex.
		 ^self].
	^self outOfRangeError: 'index' index: instVarIndex range: 0 to: 255! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:01'!
genStorePopLiteralVar: literalIndex
	"See BlueBook page 596"
	literalIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255].
	literalIndex < 64 ifTrue: 
		["130 	10000010 jjkkkkkk 	Pop and Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 130;
			nextPut: 192 + literalIndex.
		 ^self].
	literalIndex < 256 ifTrue: 
		["132 	10000100 iiijjjjj kkkkkkkk 	(Send, Send Super, Push Receiver Variable, Push Literal Constant, Push Literal Variable, Store Receiver Variable, Store-Pop Receiver Variable, Store Literal Variable)[iii] #kkkkkkkk jjjjj"
		 stream
			nextPut: 132;
			nextPut: 224;
			nextPut: literalIndex.
		 self genPop.
		 ^self].
	^self outOfRangeError: 'index' index: literalIndex range: 0 to: 255! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:01'!
genStorePopTemp: tempIndex
	"See BlueBook page 596"
	tempIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63].
	tempIndex < 8 ifTrue: 
		["104-111 	01101iii 	Pop and Store Temporary Location #iii"
		 stream nextPut: 104 + tempIndex.
		 ^self].
	tempIndex < 64 ifTrue: 
		["130 	10000010 jjkkkkkk 	Pop and Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 130;
			nextPut: 64 + tempIndex.
		 ^self].
	^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63! !

!OpalEncoderForV3 methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:01'!
genStoreTemp: tempIndex
	"See BlueBook page 596"
	tempIndex < 0 ifTrue:
		[^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63].
	tempIndex < 64 ifTrue: 
		["129 	10000001 jjkkkkkk 	Store (Receiver Variable, Temporary Location, Illegal, Literal Variable) [jj] #kkkkkk"
		 stream
			nextPut: 129;
			nextPut: 64 + tempIndex.
		 ^self].
	^self outOfRangeError: 'index' index: tempIndex range: 0 to: 63! !

!OpalEncoderForV3 methodsFor: 'testing' stamp: 'GuillermoPolito 8/17/2015 13:54'!
isSpecialLiteralForPush: literal
	^ literal == false
		or:
			[ 
			literal == true
				or:
					[ 
					literal isNil
						or: [ literal isInteger and: [ literal between: -1 and: 2 ] ] ] ]! !

OpalEncoderForV3 subclass: #OpalEncoderForV3PlusClosures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Encoders'!

!OpalEncoderForV3PlusClosures commentStamp: '<historical>' prior: 0!
An encoder for the V3 bytecode set augmented with the following bytecodes that are part of the full closure implementation.
	138   10001010 jkkkkkkk		Push (Array new: kkkkkkk) (j = 0)
								or	Pop kkkkkkk elements into: (Array new: kkkkkkk) (j = 1)

	140   10001100 kkkkkkkk jjjjjjjj 	Push Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
	141   10001101 kkkkkkkk jjjjjjjj 	Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
	142   10001110 kkkkkkkk jjjjjjjj 	Pop and Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj
	143   10001111 llllkkkk jjjjjjjj iiiiiiii	Push Closure Num Copied llll Num Args kkkk BlockSize jjjjjjjjiiiiiiii
This is an exact duplicate of EncoderForLongFormV3PlusClosures.
Could be a trait (or in Newspeak, a Mixin).
For now we impose upon you to synchronise any and all changes between these two classes.!

!OpalEncoderForV3PlusClosures class methodsFor: 'bytecode decoding' stamp: 'ClementBera 1/27/2015 14:15'!
backJumpBytecodeSize
	^ 2! !

!OpalEncoderForV3PlusClosures class methodsFor: 'compiled method support' stamp: 'ClementBera 12/29/2014 12:12'!
bindingReadScanBlockFor: litIndex using: scanner
	"Answer a block argument for InstructionStream>>scanFor: that answers true
	 for reads of the value of the binding with zero-relative index litVarIndex.
	 N.B. Don't assume the compiler uses the most compact encoding available."
	^ [:b|
		b >= 64
		and:
			[b <= 95
				ifTrue: [b - 64 = litIndex]
				ifFalse:
					[b = 128
						ifTrue: [scanner followingByte - 192 = litIndex]
						ifFalse:
							[b = 132
							 and: [(scanner followingByte between: 128 and: 159)
							 and: [scanner thirdByte = litIndex]]]]]]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'compiled method support' stamp: 'ClementBera 12/29/2014 12:11'!
bindingWriteScanBlockFor: litVarIndex using: scanner
	"Answer a block argument for InstructionStream>>scanFor: that answers true
	 for writes of the value of the binding with zero-relative index litVarIndex.
	 N.B. Don't assume the compiler uses the most compact encoding available."
	^ [:b|
		(b = 129 or: [b = 130])
			ifTrue: [scanner followingByte - 192 = litVarIndex]
			ifFalse:
				[b = 132
				 and: [scanner followingByte >= 224
				 and: [scanner thirdByte = litVarIndex]]]]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'EstebanLorenzano 8/20/2015 12:05'!
bytecodeSize: bytecode
	"Answer the number of bytes in the bytecode."
	bytecode <= 125 ifTrue:
		[^1].
	bytecode >= 176 ifTrue:
		[^1].
	bytecode >= 160 ifTrue: "long jumps"
		[^2].
	bytecode >= 144 ifTrue: "short jumps"
		[^1].
	"extensions"
	bytecode >= 128 ifTrue:
		[^#(2 2 2 2 3 2 2 1 1 1 2 3 3 3 3 4) at: bytecode - 127].
	^nil! !

!OpalEncoderForV3PlusClosures class methodsFor: 'bytecode decoding' stamp: 'EstebanLorenzano 8/20/2015 12:05'!
callPrimitiveCode
	"139	11101111	iiiiiiii jjjjjjjj	Call Primitive #iiiiiiii + (jjjjjjjj * 256)"
	^139! !

!OpalEncoderForV3PlusClosures class methodsFor: 'compiled method support' stamp: 'ClementBera 12/29/2014 12:13'!
instVarReadScanBlockFor: varIndexCode using: scanner
	"Answer a block argument for InstructionStream>>scanFor: that answers true
	 for reads of the inst var with zero-relative index varIndexCode.
	 N.B. Don't assume the compiler uses the most compact encoding available."
	^ [:b|
		b < 16
			ifTrue: [b = varIndexCode]
			ifFalse:
				[b = 128
					ifTrue: [scanner followingByte = varIndexCode and: [varIndexCode <= 63]]
					ifFalse:
						[b = 132
						 and: [(scanner followingByte between: 64 and: 95)
						 and: [scanner thirdByte = varIndexCode]]]]]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'compiled method support' stamp: 'ClementBera 12/29/2014 12:11'!
instVarWriteScanBlockFor: varIndexCode using: scanner
	"Answer a block argument for InstructionStream>>scanFor: that answers true
	 for writes of the inst var with zero-relative index varIndexCode.
	 N.B. Don't assume the compiler uses the most compact encoding available."
	^ [:b|
		b >= 96
		and: [b <= 103
				ifTrue: [b - 96 = varIndexCode]
				ifFalse:
					[(b = 129 or: [b = 130])
						ifTrue: [scanner followingByte = varIndexCode and: [varIndexCode <= 63]]
						ifFalse:
							[b = 132
							 and: [(scanner followingByte between: 160 and: 223)
							 and: [scanner thirdByte = varIndexCode]]]]]]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/28/2014 18:09'!
interpretJumpIfCondIn: anInstructionStream
	"Double-dispatch through the encoder to select the correct conditional jump decoder for the instruction set."
	^anInstructionStream interpretV3PlusClosureJumpIfCond! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/28/2014 18:09'!
interpretJumpIn: anInstructionStream
	"Double-dispatch through the encoder to select the correct unconditional jump decoder for the instruction set."
	^ anInstructionStream interpretV3PlusClosureJump! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/28/2014 18:08'!
interpretNextInstructionFor: aClient in: anInstructionStream
	"Double-dispatch through the encoder to select the correct instruction set decoder."
	^ anInstructionStream interpretNextV3PlusClosureInstructionFor: aClient! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 11:57'!
isBlockReturnAt: pc in: method
	^ (method at: pc) =  125! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:18'!
isBranchIfFalseAt: pc in: method
	"Answer whether the bytecode at pc is a conditional branch-if-false."
	
	
	| byte |
	byte := method at: pc.
	^(byte between: 152 and: 159) or: [byte between: 172 and: 175]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:19'!
isBranchIfTrueAt: pc in: method
	"Answer whether the bytecode at pc is a conditional branch-if-true."
	
	| byte |
	byte := method at: pc.
	^ byte between: 168 and: 171! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:15'!
isCreateBlockAt: pc in: method
	^ (method at: pc) = 143! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:17'!
isJumpAt: pc in: method
	"Answer whether the bytecode at pc is an (unconditional) jump."

	| byte |
	byte := method at: pc.
	^ (byte between: 144 and: 151) or: [byte between: 160 and: 167]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:20'!
isJustPopAt: pc in: method
	"Answer whether the bytecode at pc is a pop."

	^ (method at: pc) = 135! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:21'!
isReturnAt: pc in: method
	"Answer whether the bytecode at pc is a return from block."
	
	^(method at: pc) between: 120 and: 125! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:23'!
isSendAt: pc in: method
	"Answer whether the bytecode at pc is a message-send."
	
	| byte |
	byte := method at: pc.
	^byte >= 131
	  and: [ "special send or short send" 
		byte >= 176 or: [ "long sends" byte <= 134]]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:23'!
isStoreAt: pc in: method
	"Answer whether the bytecode at pc is a store or store-pop."

	| byte |
	byte := method at: pc.
	^(byte between: 96 and: 142)
		and: [
			"96 103		storeAndPopReceiverVariableBytecode"
			"104 111	storeAndPopTemporaryVariableBytecode"
			byte <= 111 
			or: [
				"129		extendedStoreBytecode"
				byte >= 129
				and: [
					"130		extendedStoreAndPopBytecode"
					byte <= 130
					or: [(
							"132		doubleExtendedDoAnythingBytecode"
							byte = 132	 
							and: [ (method at: pc+1) >= 160 ])
					or: [
						"141		storeRemoteTempLongBytecode"
						byte = 141
					or: [
						"142		storeAndPopRemoteTempLongBytecode"
						byte = 142]]]]]]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 12:24'!
isStorePopAt: pc in: method
	"Answer whether the bytecode at pc is a store or store-pop."
	
	| byte |
	byte := method at: pc.
	"130		extendedStoreAndPopBytecode"
	^ byte = 130
		or: [
			"142		storeAndPopRemoteTempLongBytecode"
			byte = 142
		or: [
			"96 103		storeAndPopReceiverVariableBytecode"
			"104 111	storeAndPopTemporaryVariableBytecode"
			byte between: 96 and: 111 ]]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'compiled method support' stamp: 'ClementBera 5/19/2015 15:37'!
markerOrNilFor: compiledMethod
	"What is a marker method?  It is method with body like 
		'self subclassResponsibility' or '^ self subclassResponsibility' 
	used to indicate ('mark') a special property.

	Marker methods compile to bytecode like:

		9 <70> self
		10 <D0> send: <literal 1>
		11 <87> pop
		12 <78> returnSelf

	for the first form, or 

		9 <70> self
		10 <D0> send: <literal 1>
		11 <7C> returnTop

	for the second form."

	| e |
	((e := compiledMethod endPC) = 19 or: [e = 20]) ifFalse: [^ nil].
	(compiledMethod numLiterals = 3) ifFalse:[^ nil].
	(compiledMethod at: 17) =  16r70 ifFalse:[^ nil].		"push self"
	(compiledMethod at: 18) = 16rD0 ifFalse:[^ nil].		"send <literal 1>"
	"If we reach this point, we have a marker method that sends self <literal 1>"
	^ compiledMethod literalAt: 1! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 2/24/2015 16:08'!
nonExtensionBytecodeAt: pc in: method
	"Answer the actual bytecode at pc in method, skipping past any preceeding extensions."
	^ method at: pc! !

!OpalEncoderForV3PlusClosures class methodsFor: 'block closure support' stamp: 'ClementBera 12/29/2014 14:50'!
numLocalTempsForBlockAt: startpc in: method
	"4 = size of push closure copy bytecode"
	^ BlockLocalTempCounter
		tempCountForBlockAt: startpc - 4 
		in: method ! !

!OpalEncoderForV3PlusClosures class methodsFor: 'compiled method support' stamp: 'ClementBera 5/19/2015 16:41'!
prepareMethod: compiledMethod forSimulationWith: numArgs
	| xpc |
	xpc := compiledMethod initialPC.
	"long store temp"
	(compiledMethod at: xpc) = 129 
		ifTrue: [
			compiledMethod at: xpc + 1 put: (16r40 + numArgs).
			compiledMethod at: xpc + 3 put: (16r10 + numArgs)]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'instruction stream support' stamp: 'ClementBera 12/29/2014 11:50'!
selectorToSendOrItselfFor: anInstructionStream in: method at: pc
	"If anInstructionStream is at a send bytecode then answer the send's selector,
	 otherwise answer anInstructionStream itself.  The rationale for answering
	 anInstructionStream instead of, say, nil, is that potentially any existing object
	 can be used as a selector, but since anInstructionStream postdates the method,
	 it can't be one of them."

	| byte byte2 |
	byte := method at: pc.
	byte < 131 ifTrue: [^ anInstructionStream].
	byte >= 176
		ifTrue: [
			"special byte or short send"
			byte >= 208
				ifTrue: [^ method literalAt: (byte bitAnd: 15) + 1]
				ifFalse: [^ Smalltalk specialSelectorAt: byte - 176 + 1]]
		ifFalse: [
			byte <= 134 
				ifTrue: [ 
					byte2 := method at: pc + 1.
					byte = 131 ifTrue: [^ method literalAt: byte2 \\ 32 + 1].
					byte = 132 ifTrue: [
						byte2 < 64 ifTrue: [^ method literalAt: ( method at: pc + 2) + 1]]	.
					byte = 133 ifTrue: [^ method literalAt: byte2 \\ 32 + 1].
					byte = 134 ifTrue: [^ method literalAt: byte2 \\ 64 + 1]]].
	^ anInstructionStream! !

!OpalEncoderForV3PlusClosures class methodsFor: 'compiled method support' stamp: 'ClementBera 5/19/2015 16:13'!
sendsToSuperFor: compiledMethod
	"Answer whether the receiver sends any message to super."
	| scanner |
	scanner := InstructionStream on: compiledMethod.
	^ scanner scanFor: 
		[:instr |  instr = 16r85 or: [instr = 16r84
						and: [scanner followingByte between: 16r20 and: 16r3F]]]! !

!OpalEncoderForV3PlusClosures class methodsFor: 'bytecode decoding' stamp: 'ClementBera 1/27/2015 14:15'!
specialLiterals
	^ #(true false nil -1 0 1 2) ! !

!OpalEncoderForV3PlusClosures class methodsFor: 'compiled method support' stamp: 'ClementBera 12/29/2014 11:37'!
supportsClosures
	"Answer if the instruction set supports closures (contains
	 closure creation and indirect temp access bytecodes)."

	^true! !

!OpalEncoderForV3PlusClosures class methodsFor: 'bytecode decoding' stamp: 'ClementBera 12/29/2014 11:36'!
unusedBytecode
	"Answer the opcode of a single-byte unused bytecode, if it exists in the encoder's bytecode set, or nil if not."
	^ 126! !

!OpalEncoderForV3PlusClosures methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 8/20/2015 12:07'!
genCallPrimitive: primitiveIndex
	"139	11101111	iiiiiiii jjjjjjjj	Call Primitive #iiiiiiii + (jjjjjjjj * 256)"
	(primitiveIndex < 1 or: [primitiveIndex > 65535]) ifTrue:
		[self outOfRangeError: 'primitive index' index: primitiveIndex range: 1 to: 65535].
	stream
		nextPut: 139;
		nextPut: (primitiveIndex bitAnd: 255);
		nextPut: (primitiveIndex bitShift: -8)! !

!OpalEncoderForV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:11'!
genPushClosureCopyNumCopiedValues: numCopied numArgs: numArgs jumpSize: jumpSize
	"143 	10001111 llllkkkk jjjjjjjj iiiiiiii	Push Closure Num Copied llll Num Args kkkk BlockSize jjjjjjjjiiiiiiii"
	(jumpSize < 0 or: [jumpSize > 65535]) ifTrue:
		[^self outOfRangeError: 'block size' index: jumpSize range: 0 to: 65535].
	(numCopied < 0 or: [numCopied > 15]) ifTrue:
		[^self outOfRangeError: 'num copied' index: numCopied range: 0 to: 15].
	(numArgs < 0 or: [numArgs > 15]) ifTrue:
		[^self outOfRangeError: 'num args' index: numArgs range: 0 to: 15].
	stream
		nextPut: 143;
		nextPut: numArgs + (numCopied bitShift: 4);
		nextPut: (jumpSize bitShift: -8);
		nextPut: (jumpSize bitAnd: 16rFF)! !

!OpalEncoderForV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:03'!
genPushConsArray: size
	(size < 0 or: [size > 127]) ifTrue:
		[^self outOfRangeError: 'numElements' index: size range: 0 to: 127].
	"138 	10001010 1kkkkkkk 	Push (Array new: kkkkkkk)"
	stream
		nextPut: 138;
		nextPut: size + 128! !

!OpalEncoderForV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:06'!
genPushNewArray: size
	(size < 0 or: [size > 127]) ifTrue:
		[^self outOfRangeError: 'numElements' index: size range: 0 to: 127].
	"138 	10001010 0kkkkkkk 	Pop kkkkkkk into: (Array new: kkkkkkk)"
	stream
		nextPut: 138;
		nextPut: size! !

!OpalEncoderForV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 6/16/2008 09:45'!
genPushRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	(tempIndex >= 0 and: [tempIndex < 256
	 and: [tempVectorIndex >= 0 and: [tempVectorIndex < 256]]]) ifTrue:
		["140 	10001100 kkkkkkkk jjjjjjjj 	Push Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
		 stream
			nextPut: 140;
			nextPut: tempIndex;
			nextPut: tempVectorIndex.
		 ^self].
	tempIndex >= 256 ifTrue:
		[^self outOfRangeError: 'remoteTempIndex' index: tempIndex range: 0 to: 255].
	tempVectorIndex >= 256 ifTrue:
		[^self outOfRangeError: 'tempVectorIndex' index: tempVectorIndex range: 0 to: 255]! !

!OpalEncoderForV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:02'!
genStorePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	"142 	10001110 kkkkkkkk jjjjjjjj 	Pop and Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
	(tempIndex >= 0 and: [tempIndex < 256
	 and: [tempVectorIndex >= 0 and: [tempVectorIndex < 256]]]) ifTrue:
		[stream
			nextPut: 142;
			nextPut: tempIndex;
			nextPut: tempVectorIndex.
		 ^self].
	tempIndex >= 256 ifTrue:
		[^self outOfRangeError: 'remoteTempIndex' index: tempIndex range: 0 to: 255].
	tempVectorIndex >= 256 ifTrue:
		[^self outOfRangeError: 'tempVectorIndex' index: tempVectorIndex range: 0 to: 255]! !

!OpalEncoderForV3PlusClosures methodsFor: 'bytecode generation' stamp: 'eem 5/30/2008 17:02'!
genStoreRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	"141 	10001101 kkkkkkkk jjjjjjjj 	Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
	(tempIndex >= 0 and: [tempIndex < 256
	 and: [tempVectorIndex >= 0 and: [tempVectorIndex < 256]]]) ifTrue:
		[stream
			nextPut: 141;
			nextPut: tempIndex;
			nextPut: tempVectorIndex.
		 ^self].
	tempIndex >= 256 ifTrue:
		[^self outOfRangeError: 'remoteTempIndex' index: tempIndex range: 0 to: 255].
	tempVectorIndex >= 256 ifTrue:
		[^self outOfRangeError: 'tempVectorIndex' index: tempVectorIndex range: 0 to: 255]! !

!OpalEncoderForV3PlusClosures methodsFor: 'testing' stamp: 'eem 5/24/2008 18:12'!
supportsClosureOpcodes
	^true! !

!Behavior methodsFor: '*OpalCompiler-Core' stamp: 'SebastianTleye 7/16/2013 17:05'!
recompile: selector from: oldClass
	"Compile the method associated with selector in the receiver's method dictionary."

	| method newMethod |
	method := oldClass compiledMethodAt: selector.
	newMethod := self compiler
				source: (oldClass sourceCodeAt: selector);
				class: self;
				failBlock: [^ self];
				compiledMethodTrailer: method trailer;
				compile.   "Assume OK after proceed from SyntaxError"
	selector == newMethod selector ifFalse: [self error: 'selector changed!!'].
	self basicAddSelector: selector withMethod: newMethod.! !

!RBVariableNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 5/22/2013 16:50'!
binding
	^self propertyAt: #binding ifAbsent: [nil].! !

!RBVariableNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 5/22/2013 16:51'!
binding: aSemVar
	aSemVar ifNil: [^self removeProperty: #binding ifAbsent: []].
	self propertyAt: #binding put: aSemVar.! !

!RBVariableNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 5/22/2013 16:50'!
isArg

	^self binding isArg! !

!RBVariableNode methodsFor: '*opalcompiler-core' stamp: 'ClementBera 8/5/2013 11:03'!
isClean
	^ (self isInstance | self isSpecialVariable) not! !

!RBVariableNode methodsFor: '*opalcompiler-core' stamp: 'jorgeRessia 11/20/2009 16:40'!
isGlobal
	^self binding isGlobal! !

!RBVariableNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 5/22/2013 16:50'!
isInstance
	^self binding isInstance! !

!RBVariableNode methodsFor: '*opalcompiler-core' stamp: 'ClementBera 8/5/2013 11:07'!
isSpecialVariable
	^ self binding isSpecialVariable! !

!RBVariableNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 5/22/2013 16:50'!
isTemp
	^self binding isTemp! !

!RBVariableNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 6/14/2013 15:44'!
isUndeclared

	^self binding isUndeclared! !

Set subclass: #OCKeyedSet
	instanceVariableNames: 'keyBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Extras'!

!OCKeyedSet commentStamp: '<historical>' prior: 0!
Like Set except a key of every element is used for hashing and searching instead of the element itself.  keyBlock gets the key of an element.!

!OCKeyedSet class methodsFor: 'instance creation' stamp: 'ajh 10/23/2000 23:16'!
keyBlock: oneArgBlock
 	"Create a new KeySet whose way to access an element's key is by executing oneArgBlock on the element"
 
 	^ self new keyBlock: oneArgBlock! !

!OCKeyedSet methodsFor: 'adding' stamp: 'md 3/14/2006 12:37'!
add: newObject
	"Include newObject as one of the receiver's elements, but only if
	not already present. Answer newObject."

	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: (keyBlock value: newObject).
	(array at: index) ifNil: [self atNewIndex: index put: newObject].
	^ newObject! !

!OCKeyedSet methodsFor: 'adding' stamp: 'ajh 12/4/2001 05:27'!
addAll: aCollection 
 	"Include all the elements of aCollection as the receiver's elements"
 
 	(aCollection respondsTo: #associationsDo:)
 		ifTrue: [aCollection associationsDo: [:ass | self add: ass]]
 		ifFalse: [aCollection do: [:each | self add: each]].
 	^ aCollection! !

!OCKeyedSet methodsFor: 'accessing' stamp: 'ajh 9/5/2000 03:57'!
at: key 
 	"Answer the value associated with the key."
 
 	^ self at: key ifAbsent: [self errorKeyNotFound]! !

!OCKeyedSet methodsFor: 'accessing' stamp: 'MarcusDenker 8/18/2010 19:13'!
at: key ifAbsent: aBlock 
 	"Answer the value associated with the key or, if key isn't found,
 	answer the result of evaluating aBlock."
 
 	^(array at: (self findElementOrNil: key)) 
		ifNil: [aBlock value]
		ifNotNil: [:o | o].
 	! !

!OCKeyedSet methodsFor: 'accessing' stamp: 'ajh 12/10/2000 15:42'!
at: key ifAbsentPut: aBlock 
 	"Answer the value associated with the key or, if key isn't found,
 	add the result of evaluating aBlock to self"
 
 	^ self at: key ifAbsent: [self add: aBlock value]! !

!OCKeyedSet methodsFor: 'accessing' stamp: 'ajh 9/5/2000 03:58'!
at: key ifPresent: aBlock
 	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."
 
 	| v |
 	v := self at: key ifAbsent: [^ nil].
 	^ aBlock value: v
 ! !

!OCKeyedSet methodsFor: 'copying' stamp: 'ThomasHeniart 5/22/2015 10:41'!
collect: aBlock 
	"OCKeyedSet>>collect: must return an instance of Set and not an instance of his own class"

	| newSet |
	newSet := Set new: self size.
	array do: [:each | each ifNotNil: [newSet add: (aBlock value: each enclosedSetElement)]].
	^ newSet! !

!OCKeyedSet methodsFor: 'copying' stamp: 'nice 6/16/2009 20:56'!
copyEmpty
	^super copyEmpty
		keyBlock: keyBlock copy! !

!OCKeyedSet methodsFor: 'private' stamp: 'ajh 3/29/2001 19:04'!
errorKeyNotFound
 
 	self error: 'key not found'! !

!OCKeyedSet methodsFor: 'private' stamp: 'MarcusDenker 8/12/2010 15:55'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"

	| element index |
	index := start.
	[ (element := array at: (index := index \\ array size + 1)) isNil ] whileFalse: [
		| newIndex |
		(newIndex := self findElementOrNil: (keyBlock value: element)) = index ifFalse: [
			array swap: index with: newIndex ] ]! !

!OCKeyedSet methodsFor: 'testing' stamp: 'MarcusDenker 8/13/2010 11:38'!
includes: anObject
	^ (array at: (self findElementOrNil: (keyBlock value: anObject))) notNil! !

!OCKeyedSet methodsFor: 'testing' stamp: 'MarcusDenker 8/13/2010 11:38'!
includesKey: key
	^ (array at: (self findElementOrNil: key)) notNil! !

!OCKeyedSet methodsFor: 'initialization' stamp: 'MarcusDenker 8/20/2010 11:22'!
initialize: n
 	super initialize: n.
 	keyBlock := [:element | element key].
 ! !

!OCKeyedSet methodsFor: 'testing' stamp: 'CamilloBruni 7/3/2013 13:20'!
isHealthy
	"Opal developers plan to remove this class so for the moment we just return true/"

	^ true! !

!OCKeyedSet methodsFor: 'initialize' stamp: 'ajh 9/5/2000 03:36'!
keyBlock: oneArgBlock
 	"When evaluated return the key of the argument which will be an element of the set"
 
 	keyBlock := oneArgBlock! !

!OCKeyedSet methodsFor: 'accessing' stamp: 'ajh 7/3/2004 17:55'!
keys
 
 	| keys |
 	keys := Set new.
 	self keysDo: [:key | keys add: key].
 	^ keys! !

!OCKeyedSet methodsFor: 'accessing' stamp: 'ajh 7/3/2004 17:54'!
keysDo: block
 
 	self do: [:item | block value: (keyBlock value: item)]! !

!OCKeyedSet methodsFor: 'adding' stamp: 'MarcusDenker 5/12/2011 13:43'!
like: anObject
	"Answer an object in the receiver that is equal to anObject,
	nil if no such object is found. Relies heavily on hash properties"

	| index |

	^(index := self scanFor: (keyBlock value: anObject)) = 0
		ifFalse: [array at: index]
		ifTrue: [nil]! !

!OCKeyedSet methodsFor: 'adding' stamp: 'ajh 6/3/2002 10:11'!
member: newObject
 	"Include newObject as one of the receiver's elements, if already exists just return it"
 
 	| index |
 	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
 	index := self findElementOrNil: (keyBlock value: newObject).
 	(array at: index) ifNotNil: [^ array at: index].
 	self atNewIndex: index put: newObject.
 	^ newObject! !

!OCKeyedSet methodsFor: 'private' stamp: 'ajh 9/5/2000 03:46'!
noCheckAdd: anObject
 	array at: (self findElementOrNil: (keyBlock value: anObject)) put: anObject.
 	tally := tally + 1! !

!OCKeyedSet methodsFor: 'private' stamp: 'ajh 12/13/2001 00:17'!
rehash
 	| newSelf |
 	newSelf := self species new: self size.
 	newSelf keyBlock: keyBlock.
 	self do: [:each | newSelf noCheckAdd: each].
 	array := newSelf array! !

!OCKeyedSet methodsFor: 'removing' stamp: 'MarcusDenker 8/12/2010 15:55'!
remove: oldObject ifAbsent: aBlock
 
 	| index |
 	index := self findElementOrNil: (keyBlock value: oldObject).
 	(array at: index) ifNil: [ ^ aBlock value ].
 	array at: index put: nil.
 	tally := tally - 1.
 	self fixCollisionsFrom: index.
 	^ oldObject! !

!OCKeyedSet methodsFor: 'removing' stamp: 'nice 12/30/2008 19:01'!
removeAll
	"See super."
	
	| tmp |
	tmp := keyBlock.
	super removeAll.
	keyBlock := tmp! !

!OCKeyedSet methodsFor: 'removing' stamp: 'ajh 3/29/2001 19:03'!
removeKey: key 
 
 	^ self removeKey: key ifAbsent: [self errorKeyNotFound]! !

!OCKeyedSet methodsFor: 'removing' stamp: 'MarcusDenker 8/12/2010 15:55'!
removeKey: key ifAbsent: aBlock
 
 	| index obj |
 	index := self findElementOrNil: key.
 	(obj := array at: index) ifNil: [ ^ aBlock value ].
 	array at: index put: nil.
 	tally := tally - 1.
 	self fixCollisionsFrom: index.
 	^ obj! !

!OCKeyedSet methodsFor: 'private' stamp: 'MarcusDenker 8/12/2010 15:55'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	finish := array size.
	start := (anObject hash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) isNil or: [(keyBlock value: element) = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) isNil or: [(keyBlock value: element) = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

Set subclass: #OCLiteralSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Extras'!

!OCLiteralSet commentStamp: 'ajh 3/25/2003 00:33' prior: 0!
Holds a unique set of literals.  Literal objects are equal if they are #= plus they are the same class.  This set uses this rule for finding elements.

Example:
	Set new add: 'anthony'; add: #anthony; size  "= 1"
	LiteralSet new add: 'anthony'; add: #anthony; size  "= 2"
!

!OCLiteralSet methodsFor: 'adding' stamp: 'ajh 12/9/2001 16:03'!
add: newObject
	"Include newObject as one of the receiver's elements.  If equivalent is already present don't add and return equivalent object"

	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	^ (array at: index) 
		ifNil: [self atNewIndex: index put: newObject. newObject]
		ifNotNil: [array at: index]! !

!OCLiteralSet methodsFor: 'private' stamp: 'MarcusDenker 8/12/2010 15:54'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	start := (anObject hash \\ array size) + 1.
	finish := array size.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) isNil
					or: [element literalEqual: anObject])
					ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) isNil
					or: [element literalEqual: anObject])
					ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!Set methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 10/5/2015 09:45'!
parseOptions: anArray

	"parse an array, which is a sequence of options in a form of: 
	
	#( + option1 option2 - option3 ... )
	
	each time the #+ is seen, the options which follow it will be subject for inclusion
	and, correspondingly, if #- seen, then they will be excluded	.

	By default, (if none of #+ or #- specified initially), all options are subject for inclusion.
	"
	| include |
	
	include := true.
	anArray do: [:option |
		option == #+ 
			ifTrue: [ include := true ]
			ifFalse: [
				option == #- 
					ifTrue: [ include := false ]
					ifFalse: [ 
						include ifTrue: [ self add: option ] 
						ifFalse: [ self remove: option ifAbsent:[] ]]]
		].! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 5/12/2013 11:46'!
compiler
	^self methodClass 
		ifNil: [Smalltalk compiler] 
		ifNotNil: [:class | class compiler].! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 2/4/2013 16:01'!
compilerClass
	^self methodClass 
		ifNil: [Smalltalk compilerClass] 
		ifNotNil: [:class | class compilerClass].! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 3/4/2016 10:24'!
decompile
	^Smalltalk globals 
		at: #FBDDecompiler
		ifPresent: [ :decompiler | decompiler new  decompile: self]  
		ifAbsent: [ 'self noSourceAvailable' ]! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 11/6/2014 20:35'!
decompileIR
	
	^ IRBytecodeDecompiler new decompile: self! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 11/6/2014 15:22'!
ir
	"We as the AST for the IR... for decompiling ir from bytecode, look at IRBytecodeDecompiler"
	^ self ast ir! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 5/14/2013 17:06'!
irPrimitive

	| primNode n |
	primNode := IRPrimitive new num: (n := self primitive).
	(n = 117 or: [n = 120]) ifTrue: [
		primNode spec: (self literalAt: 1)].
	^ primNode! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 8/28/2013 10:45'!
methodNode
	"Return the parse tree that represents self"
	| aClass source methodNode |
	
	aClass := self methodClass.
	source := self sourceCode.
	methodNode := aClass compiler parse: source.
	methodNode source: source.
	^methodNode.
			! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'CamilloBruni 2/17/2012 14:33'!
recompile
	^ self methodClass recompile: self selector! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 4/27/2013 00:11'!
reformat
	self methodClass compile: self ast formattedCode classified:  self category.! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 4/19/2013 08:33'!
sourceNode
	^self ast! !

!CompiledMethod methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 4/19/2013 08:34'!
sourceNodeForPC: aPC
	^self sourceNode sourceNodeForPC: aPC! !

!TraitBehavior methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 7/23/2014 16:49'!
recompile: selector from: oldClass
	"Compile the method associated with selector in the receiver's method dictionary."

	| method methodNode |
	method := oldClass compiledMethodAt: selector.
	methodNode := self compiler
				source: (oldClass sourceCodeAt: selector);
				failBlock:  [^ self];
				translate.
	selector == methodNode selector ifFalse: [self error: 'selector changed!!'].
	self basicAddSelector: selector withMethod: (methodNode generate: method trailer).
	self notifyUsersOfChangedSelector: selector.
! !

!RBPragmaNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 5/14/2013 16:32'!
asPragma
	^ Pragma keyword: selector arguments: (arguments collect: [ :each | each value ]) asArray! !

!RBPragmaNode methodsFor: '*opalcompiler-core' stamp: 'CamilloBruni 2/26/2014 16:50'!
asPrimitive
	| args module name spec  |
	args := (self arguments collect: [ :each | each value ]) asArray.
	self isPrimitive
		ifFalse: [ IRPrimitive null ].
	args first isString
		ifTrue: [ 
			name := args first.
			module := self argumentAt: #module: ifAbsent: [ nil ].
			spec := {(module ifNotNil: [ module value asSymbol ]). (name asSymbol). 0. 0}.
			^ IRPrimitive new
				num: 117;
				spec: spec;
				yourself ]
		ifFalse: [ 
			^ IRPrimitive new
				num: args first;
				spec: nil;
				yourself ]! !

!RBPragmaNode methodsFor: '*opalcompiler-core' stamp: 'CamilloBruni 2/26/2014 16:20'!
isPrimitiveError
	^ #( primitive:error: primitive:module:error: primitive:error:module:) includes: self selector! !

!RBProgramNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 4/29/2015 17:46'!
doSemanticAnalysis
	self methodNode ifNil: [ ^self ].
	^ self methodNode doSemanticAnalysis.
	! !

!RBProgramNode methodsFor: '*opalcompiler-core' stamp: 'CamilleTeruel 2/14/2014 14:33'!
enclosingMethodOrBlockNode
	^ self methodOrBlockNode ! !

!RBProgramNode methodsFor: '*opalcompiler-core' stamp: 'MarcusDenker 12/18/2012 14:08'!
irInstruction
	"search for the first ir instruction that I generate"
	self methodNode ir sourceNode == self  ifTrue: [^self methodNode ir].
	^self methodNode ir firstInstructionMatching: [:instr | instr sourceNode == self ]
	
! !

!RBProgramNode methodsFor: '*opalcompiler-core' stamp: 'ClementBera 8/5/2013 11:03'!
isClean
	^ self children allSatisfy: [ :child | child isClean ]! !

!RBProgramNode methodsFor: '*opalcompiler-core' stamp: 'ClementBera 7/26/2013 15:24'!
methodOrBlockNode
	^ parent ifNotNil: [ parent methodOrBlockNode ]! !

!RBProgramNode methodsFor: '*opalcompiler-core' stamp: ''!
owningScope

	^ parent owningScope ! !

!RBProgramNode methodsFor: '*opalcompiler-core' stamp: 'ClementBera 7/26/2013 15:24'!
printAsIfCompiledOn: aStream 
	aStream nextPutAll: self formattedCode! !

!RBProgramNode methodsFor: '*opalcompiler-core' stamp: 'ClementBera 7/26/2013 15:24'!
scope
	^ self methodOrBlockNode scope! !

!RBBlockNode methodsFor: '*opalcompiler-core' stamp: 'CamilleTeruel 2/14/2014 14:37'!
enclosingMethodOrBlockNode
	^ parent ifNotNil: [ parent methodOrBlockNode ]! !

!RBBlockNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 11/18/2015 00:54'!
hasBlockReturn
	^ self body lastIsReturn! !

!RBBlockNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 11/18/2015 00:54'!
isClean
	"a block is clean if it has no escaping vars, has no non local return and its children are clean"
	self isInlined ifTrue: [ ^ false ].
	self scope hasEscapingVars ifTrue: [ ^ false ].
	self hasBlockReturn ifTrue: [ ^ false ].
	^ super isClean
	! !

!RBBlockNode methodsFor: '*opalcompiler-core' stamp: 'ClementBera 7/26/2013 15:11'!
isInlined
	parent isMessage ifFalse: [ ^ false ].
	parent isInlineAndOr ifTrue: [^ true].
	parent isInlineIf ifTrue: [^ true].
	parent isInlineIfNil ifTrue: [^ true].
	^ self isInlinedLoop! !

!RBBlockNode methodsFor: '*opalcompiler-core' stamp: 'KevinLanvin 7/17/2015 14:22'!
isInlinedLoop
	parent isMessage ifFalse: [ ^ false ].
	parent isInlineToDo ifTrue: [^ true].
	parent isInlineWhile ifTrue: [^ true].
	parent isInlineTimesRepeat ifTrue: [^ true].
	parent isInlineRepeat ifTrue: [ ^true ].
	(parent parent isArray and: [parent parent parent isMessage and: [parent parent parent isInlineCase]]) ifTrue: [^ true].
	parent isInlineCase ifTrue: [^ true].  "otherwise branch"
	^ false! !

!RBBlockNode methodsFor: '*opalcompiler-core' stamp: 'NicolaiHess 11/18/2015 00:54'!
lastIsReturn
	^ false! !

!RBBlockNode methodsFor: '*opalcompiler-core' stamp: 'ClementBera 7/26/2013 15:28'!
methodOrBlockNode
	"^ self"! !

!RBBlockNode methodsFor: '*opalcompiler-core' stamp: 'jorgeRessia 11/20/2009 16:40'!
owningScope

	^ self scope ifNil: ["inlined" ^ parent owningScope]! !

!RBBlockNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 4/30/2015 22:51'!
sourceNodeForPC: anInteger 
	^ self methodNode sourceNodeForPC: anInteger! !

!RBMethodNode class methodsFor: '*OpalCompiler-Core' stamp: 'ClementBera 11/18/2014 11:42'!
errorMethodNode: selector errorMessage: messageText	
	| message |
	message := RBMessageNode 
		receiver: (RBSelfNode named: 'self')
		selector: #error: 
		arguments: {RBLiteralNode value: messageText}.
	^ self 
		selector: selector 
		arguments: ((1 to: selector numArgs) collect: [ :i | RBArgumentNode named: 't' , i asString ]) 
		body: (RBSequenceNode statements: {message}) ! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 3/8/2015 09:20'!
compiledMethod
	^ self ir compiledMethod! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'ClementBera 7/26/2013 15:25'!
decompileString 

	^ self formattedCode 
! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 7/10/2013 15:55'!
doSemanticAnalysis

	self compilationContext ifNil: [ self methodClass: nil class ].

	self
		compilationContext semanticAnalyzerClass new
		compilationContext: self compilationContext;
		analyze: self! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'ClementBera 5/21/2013 14:30'!
doSemanticAnalysisIn: behavior
	self methodClass: behavior.
	self doSemanticAnalysis! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'ClementBera 7/26/2013 15:25'!
doSemanticAnalysisInContext: aCompilationContext
	self compilationContext: aCompilationContext.
	self doSemanticAnalysis.! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'ClementBera 7/26/2013 15:25'!
generate
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."

	^ self generate: CompiledMethodTrailer empty! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 11/20/2012 16:30'!
generate: trailer
	^ self generateIR compiledMethodWith: trailer.! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'ClementBera 7/26/2013 15:26'!
generateIR
	| ir |
	scope ifNil: [self doSemanticAnalysisInContext: self compilationContext ].
 	ir := (self compilationContext astTranslatorClass new
			visitNode: self)
			ir.
	^ self ir: ir! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 1/30/2013 13:13'!
generateWithSource
	"Answer a CompiledMethod with source encoded in trailer."

	
	"for doits, we need to store the source pretty printed from the 
	AST to get the return and methodName correct"
	self selector isDoIt ifTrue: [source := self formattedCode].
	
	^self generate: (CompiledMethodTrailer new sourceCode: source).! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'jorgeRessia 11/22/2009 10:30'!
ir

	^ self propertyAt: #ir ifAbsent: [self generateIR].! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'JorgeRessia 11/24/2009 19:05'!
ir: aIRMethodNode

	^ self propertyAt: #ir put: aIRMethodNode.! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'ClementBera 7/26/2013 15:27'!
methodOrBlockNode
	"^ self"! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'NicolaiHess 2/15/2016 11:18'!
notShadowedTemporaryNamesFrom: aContext
	| ownVariableNames |
	ownVariableNames := self allDefinedVariables collect: [ :var | var asString ].
	^ aContext tempNames difference: ownVariableNames
! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 6/29/2012 16:04'!
owningScope
	^ self scope! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'GabrielOmarCotelli 12/4/2013 09:27'!
primitiveFromPragma
	pragmas ifNil: [ ^ IRPrimitive null ].
	^ pragmas
		detect: [ :each | each isPrimitive ]
		ifFound: [ :aPragmaPrimitive | aPragmaPrimitive asPrimitive ]
		ifNone: [ IRPrimitive null ]! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 7/5/2013 17:03'!
properties
	^self propertyAt: #methodProperties ifAbsent: nil! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'JorgeRessia 11/24/2009 18:56'!
properties: aMethodeProperties 
	^self propertyAt: #methodProperties put: aMethodeProperties! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'NicolaiHess 2/18/2016 20:06'!
rewriteTempsForContext: aContext
	| rewriter contextOnlyTemps |
	rewriter := RBParseTreeRewriter new.
	contextOnlyTemps := self notShadowedTemporaryNamesFrom: aContext.
	aContext tempNames
		withIndexDo:
			[ :tempName :index | 
			(contextOnlyTemps includes: tempName)
				ifTrue:
					[ rewriter
						replace: tempName , ' := ``@object' with: 'ThisContext namedTempAt:' , index asString , 'put: ``@object';
						replace: tempName with: 'ThisContext namedTempAt:' , index asString ] ].
	^ rewriter
		executeTree: self;
		tree! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 4/19/2013 08:32'!
sourceNodeForPC: anInteger
	^(self ir instructionForPC: anInteger) sourceNode! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 4/29/2013 15:06'!
sourceText: aString
	self source: aString! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'cb 6/27/2013 16:55'!
startWithoutParentheses
	^ 1! !

!RBMethodNode methodsFor: '*OpalCompiler-Core' stamp: 'MarcusDenker 4/29/2013 15:25'!
tempNames
	"compatibility method to old MethodNode"
	self flag: #Clean.
	^ self argumentNames, self temporaryNames! !

OrderedCollection subclass: #OCLiteralList
	instanceVariableNames: 'equalitySet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpalCompiler-Core-Extras'!

!OCLiteralList commentStamp: 'ajh 3/25/2003 00:31' prior: 0!
Holds a unique ordered collection of literals!

!OCLiteralList methodsFor: 'adding' stamp: 'ajh 3/6/2003 18:00'!
addLast: object
	"Only add if not already in list"

	(equalitySet includes: object) ifTrue: [^ object].
	equalitySet add: object.
	super addLast: object.
	^ object
! !

!OCLiteralList methodsFor: 'accessing' stamp: 'ajh 1/21/2003 12:21'!
indexOf: anElement startingAt: start ifAbsent: exceptionBlock

	start to: self size do:
		[:index | ((self at: index) literalEqual: anElement) ifTrue: [^ index]].
	^ exceptionBlock value! !

!OCLiteralList methodsFor: 'private' stamp: 'MarcusDenker 8/21/2010 13:05'!
setCollection: anArray

	super setCollection: anArray.
	equalitySet := OCLiteralSet new: anArray size.
! !

CompilationContext initialize!

OCASTTranslator initialize!

CCompilationContext initialize!
